/* Generated from posixwin.scm by the CHICKEN compiler
   http://www.call-cc.org
   2014-02-02 01:19
   Version 4.8.3 (rev 8a16742)
   linux-unix-gnu-x86 [ manyargs ptables ]
   compiled 2014-02-02 on hd-t1179cl (Linux)
   command line: posixwin.scm -optimize-level 2 -include-path . -include-path ./ -inline -ignore-repository -feature chicken-bootstrap -no-warnings -specialize -types ./types.db -explicit-use -no-trace -output-file posixwin.c
   unit: posix
*/

#include "chicken.h"

#ifndef WIN32_LEAN_AND_MEAN
# define WIN32_LEAN_AND_MEAN
#endif

#include <direct.h>
#include <errno.h>
#include <fcntl.h>
#include <io.h>
#include <process.h>
#include <signal.h>
#include <utime.h>
#include <winsock2.h>

#define ARG_MAX		256
#define PIPE_BUF	512
#ifndef ENV_MAX
# define ENV_MAX	1024
#endif

static C_TLS char *C_exec_args[ ARG_MAX ];
static C_TLS char *C_exec_env[ ENV_MAX ];
static C_TLS struct group *C_group;
static C_TLS int C_pipefds[ 2 ];
static C_TLS time_t C_secs;

/* pipe handles */
static C_TLS HANDLE C_rd0, C_wr0, C_wr0_, C_rd1, C_wr1, C_rd1_;
static C_TLS HANDLE C_save0, C_save1; /* saved I/O handles */
static C_TLS char C_rdbuf; /* one-char buffer for read */
static C_TLS int C_exstatus;

/* platform information; initialized for cached testing */
static C_TLS char C_hostname[256] = "";
static C_TLS char C_osver[16] = "";
static C_TLS char C_osrel[16] = "";
static C_TLS char C_processor[16] = "";
static C_TLS char C_shlcmd[256] = "";

/* Windows NT or better */
static int C_isNT = 0;

/* Current user name */
static C_TLS TCHAR C_username[255 + 1] = "";

/* Directory Operations */

#define C_mkdir(str)	    C_fix(mkdir(C_c_string(str)))
#define C_chdir(str)	    C_fix(chdir(C_c_string(str)))
#define C_rmdir(str)	    C_fix(rmdir(C_c_string(str)))

#ifndef __WATCOMC__
/* DIRENT stuff */
struct dirent
{
    char *		d_name;
};

typedef struct
{
    struct _finddata_t	fdata;
    int			handle;
    struct dirent	current;
} DIR;

static DIR * C_fcall
opendir(const char *name)
{
    int name_len = strlen(name);
    DIR *dir = (DIR *)malloc(sizeof(DIR));
    char *what;
    if (!dir)
    {
	errno = ENOMEM;
	return NULL;
    }
    what = (char *)malloc(name_len + 3);
    if (!what)
    {
	free(dir);
	errno = ENOMEM;
	return NULL;
    }
    strcpy(what, name);
    if (strchr("\\/", name[name_len - 1]))
	strcat(what, "*");
    else
	strcat(what, "\\*");

    dir->handle = _findfirst(what, &dir->fdata);
    if (dir->handle == -1)
    {
	free(what);
	free(dir);
	return NULL;
    }
    dir->current.d_name = NULL; /* as the first-time indicator */
    free(what);
    return dir;
}

static int C_fcall
closedir(DIR * dir)
{
    if (dir)
    {
	int res = _findclose(dir->handle);
	free(dir);
	return res;
    }
    return -1;
}

static struct dirent * C_fcall
readdir(DIR * dir)
{
    if (dir)
    {
	if (!dir->current.d_name /* first time after opendir */
	     || _findnext(dir->handle, &dir->fdata) != -1)
	{
	    dir->current.d_name = dir->fdata.name;
	    return &dir->current;
	}
    }
    return NULL;
}
#endif /* ifndef __WATCOMC__ */

#ifdef __WATCOMC__
# define mktemp _mktemp
/* there is no P_DETACH in Watcom CRTL */
# define P_DETACH P_NOWAIT
#endif

#define C_opendir(x,h)		C_set_block_item(h, 0, (C_word) opendir(C_c_string(x)))
#define C_closedir(h)		(closedir((DIR *)C_block_item(h, 0)), C_SCHEME_UNDEFINED)
#define C_readdir(h,e)		C_set_block_item(e, 0, (C_word) readdir((DIR *)C_block_item(h, 0)))
#define C_foundfile(e,b)	(strcpy(C_c_string(b), ((struct dirent *) C_block_item(e, 0))->d_name), C_fix(strlen(((struct dirent *) C_block_item(e, 0))->d_name)))

#define open_binary_input_pipe(a, n, name)   C_mpointer(a, _popen(C_c_string(name), "r"))
#define open_text_input_pipe(a, n, name)     open_binary_input_pipe(a, n, name)
#define open_binary_output_pipe(a, n, name)  C_mpointer(a, _popen(C_c_string(name), "w"))
#define open_text_output_pipe(a, n, name)    open_binary_output_pipe(a, n, name)
#define close_pipe(p)			     C_fix(_pclose(C_port_file(p)))

#define C_chmod(fn, m)	    C_fix(chmod(C_data_pointer(fn), C_unfix(m)))
#define C_setvbuf(p, m, s)  C_fix(setvbuf(C_port_file(p), NULL, C_unfix(m), C_unfix(s)))
#define C_test_access(fn, m)	    C_fix(access((char *)C_data_pointer(fn), C_unfix(m)))
#define C_pipe(d, m)	    C_fix(_pipe(C_pipefds, PIPE_BUF, C_unfix(m)))
#define C_close(fd)	    C_fix(close(C_unfix(fd)))

#define C_getenventry(i)   environ[ i ]

#define C_putenv(s)	    C_fix(putenv((char *)C_data_pointer(s)))
#define C_lstat(fn)	    C_stat(fn)

static C_word C_fcall
C_setenv(C_word x, C_word y)
{
    char *sx = C_data_pointer(x),
	 *sy = C_data_pointer(y);
    int n1 = C_strlen(sx),
	n2 = C_strlen(sy);
    char *buf = (char *)C_malloc(n1 + n2 + 2);
    if (buf == NULL)
	return(C_fix(0));
    else
    {
	C_strcpy(buf, sx);
	buf[ n1 ] = '=';
	C_strcpy(buf + n1 + 1, sy);
	return(C_fix(putenv(buf)));
    }
}

static void C_fcall
C_set_arg_string(char **where, int i, char *dat, int len)
{
    char *ptr;
    if (dat)
    {
	ptr = (char *)C_malloc(len + 1);
	C_memcpy(ptr, dat, len);
	ptr[ len ] = '\0';
        /* Can't barf() here, so the NUL byte check happens in Scheme */
    }
    else
	ptr = NULL;
    where[ i ] = ptr;
}

static void C_fcall
C_free_arg_string(char **where) {
  while (*where) C_free(*(where++));
}

#define C_set_exec_arg(i, a, len)	C_set_arg_string(C_exec_args, i, a, len)
#define C_set_exec_env(i, a, len)	C_set_arg_string(C_exec_env, i, a, len)

#define C_free_exec_args()		(C_free_arg_string(C_exec_args), C_SCHEME_TRUE)
#define C_free_exec_env()		(C_free_arg_string(C_exec_env), C_SCHEME_TRUE)

#define C_execvp(f)	    C_fix(execvp(C_data_pointer(f), (const char *const *)C_exec_args))
#define C_execve(f)	    C_fix(execve(C_data_pointer(f), (const char *const *)C_exec_args, (const char *const *)C_exec_env))

/* MS replacement for the fork-exec pair */
#define C_spawnvp(m, f)	    C_fix(spawnvp(C_unfix(m), C_data_pointer(f), (const char *const *)C_exec_args))
#define C_spawnvpe(m, f)    C_fix(spawnvpe(C_unfix(m), C_data_pointer(f), (const char *const *)C_exec_args, (const char *const *)C_exec_env))

#define C_open(fn, fl, m)   C_fix(open(C_c_string(fn), C_unfix(fl), C_unfix(m)))
#define C_read(fd, b, n)    C_fix(read(C_unfix(fd), C_data_pointer(b), C_unfix(n)))
#define C_write(fd, b, n)   C_fix(write(C_unfix(fd), C_data_pointer(b), C_unfix(n)))
#define C_mkstemp(t)	    C_fix(mktemp(C_c_string(t)))

/* It is assumed that 'int' is-a 'long' */
#define C_ftell(p)          C_fix(ftell(C_port_file(p)))
#define C_fseek(p, n, w)    C_mk_nbool(fseek(C_port_file(p), C_num_to_int(n), C_unfix(w)))
#define C_lseek(fd, o, w)   C_fix(lseek(C_unfix(fd), C_unfix(o), C_unfix(w)))

#define C_flushall()	    C_fix(_flushall())

#define C_umask(m)          C_fix(_umask(C_unfix(m)))

#define C_ctime(n)	    (C_secs = (n), ctime(&C_secs))

#define TIME_STRING_MAXLENGTH 255
static char C_time_string [TIME_STRING_MAXLENGTH + 1];
#undef TIME_STRING_MAXLENGTH

/*
  mapping from Win32 error codes to errno
*/

typedef struct
{
    DWORD   win32;
    int	    libc;
} errmap_t;

static errmap_t errmap[] =
{
    {ERROR_INVALID_FUNCTION,	  EINVAL},
    {ERROR_FILE_NOT_FOUND,	  ENOENT},
    {ERROR_PATH_NOT_FOUND,	  ENOENT},
    {ERROR_TOO_MANY_OPEN_FILES,	  EMFILE},
    {ERROR_ACCESS_DENIED,	  EACCES},
    {ERROR_INVALID_HANDLE,	  EBADF},
    {ERROR_ARENA_TRASHED,	  ENOMEM},
    {ERROR_NOT_ENOUGH_MEMORY,	  ENOMEM},
    {ERROR_INVALID_BLOCK,	  ENOMEM},
    {ERROR_BAD_ENVIRONMENT,	  E2BIG},
    {ERROR_BAD_FORMAT,		  ENOEXEC},
    {ERROR_INVALID_ACCESS,	  EINVAL},
    {ERROR_INVALID_DATA,	  EINVAL},
    {ERROR_INVALID_DRIVE,	  ENOENT},
    {ERROR_CURRENT_DIRECTORY,	  EACCES},
    {ERROR_NOT_SAME_DEVICE,	  EXDEV},
    {ERROR_NO_MORE_FILES,	  ENOENT},
    {ERROR_LOCK_VIOLATION,	  EACCES},
    {ERROR_BAD_NETPATH,		  ENOENT},
    {ERROR_NETWORK_ACCESS_DENIED, EACCES},
    {ERROR_BAD_NET_NAME,	  ENOENT},
    {ERROR_FILE_EXISTS,		  EEXIST},
    {ERROR_CANNOT_MAKE,		  EACCES},
    {ERROR_FAIL_I24,		  EACCES},
    {ERROR_INVALID_PARAMETER,	  EINVAL},
    {ERROR_NO_PROC_SLOTS,	  EAGAIN},
    {ERROR_DRIVE_LOCKED,	  EACCES},
    {ERROR_BROKEN_PIPE,		  EPIPE},
    {ERROR_DISK_FULL,		  ENOSPC},
    {ERROR_INVALID_TARGET_HANDLE, EBADF},
    {ERROR_INVALID_HANDLE,	  EINVAL},
    {ERROR_WAIT_NO_CHILDREN,	  ECHILD},
    {ERROR_CHILD_NOT_COMPLETE,	  ECHILD},
    {ERROR_DIRECT_ACCESS_HANDLE,  EBADF},
    {ERROR_NEGATIVE_SEEK,	  EINVAL},
    {ERROR_SEEK_ON_DEVICE,	  EACCES},
    {ERROR_DIR_NOT_EMPTY,	  ENOTEMPTY},
    {ERROR_NOT_LOCKED,		  EACCES},
    {ERROR_BAD_PATHNAME,	  ENOENT},
    {ERROR_MAX_THRDS_REACHED,	  EAGAIN},
    {ERROR_LOCK_FAILED,		  EACCES},
    {ERROR_ALREADY_EXISTS,	  EEXIST},
    {ERROR_FILENAME_EXCED_RANGE,  ENOENT},
    {ERROR_NESTING_NOT_ALLOWED,	  EAGAIN},
    {ERROR_NOT_ENOUGH_QUOTA,	  ENOMEM},
    {0, 0}
};

static void C_fcall
set_errno(DWORD w32err)
{
    errmap_t *map;
    for (map = errmap; map->win32; ++map)
    {
	if (map->win32 == w32err)
	{
	    errno = map->libc;
	    return;
	}
    }
    errno = ENOSYS; /* For lack of anything better */
}

static int C_fcall
set_last_errno()
{
    set_errno(GetLastError());
    return 0;
}

static int C_fcall
process_wait(C_word h, C_word t)
{
    if (WaitForSingleObject((HANDLE)h, (t ? 0 : INFINITE)) == WAIT_OBJECT_0)
    {
	DWORD ret;
	if (GetExitCodeProcess((HANDLE)h, &ret))
	{
	    CloseHandle((HANDLE)h);
	    C_exstatus = ret;
	    return 1;
	}
    }
    return set_last_errno();
}

#define C_process_wait(p, t) (process_wait(C_unfix(p), C_truep(t)) ? C_SCHEME_TRUE : C_SCHEME_FALSE)
#define C_sleep(t) (Sleep(C_unfix(t) * 1000), C_fix(0))

static int C_fcall
get_hostname()
{
    /* Do we already have hostname? */
    if (strlen(C_hostname))
    {
	return 1;
    }
    else
    {
	WSADATA wsa;
	if (WSAStartup(MAKEWORD(1, 1), &wsa) == 0)
	{
	    int nok = gethostname(C_hostname, sizeof(C_hostname));
	    WSACleanup();
	    return !nok;
	}
	return 0;
    }
}

static int C_fcall
sysinfo()
{
    /* Do we need to build the sysinfo? */
    if (!strlen(C_osrel))
    {
	OSVERSIONINFO ovf;
	ZeroMemory(&ovf, sizeof(ovf));
	ovf.dwOSVersionInfoSize = sizeof(ovf);
	if (get_hostname() && GetVersionEx(&ovf))
	{
	    SYSTEM_INFO si;
	    _snprintf(C_osver, sizeof(C_osver) - 1, "%d.%d.%d",
			ovf.dwMajorVersion, ovf.dwMinorVersion, ovf.dwBuildNumber);
	    strncpy(C_osrel, "Win", sizeof(C_osrel) - 1);
	    switch (ovf.dwPlatformId)
	    {
	    case VER_PLATFORM_WIN32s:
		strncpy(C_osrel, "Win32s", sizeof(C_osrel) - 1);
		break;
	    case VER_PLATFORM_WIN32_WINDOWS:
		if (ovf.dwMajorVersion == 4)
		{
		    if (ovf.dwMinorVersion == 0)
			strncpy(C_osrel, "Win95", sizeof(C_osrel) - 1);
		    else if (ovf.dwMinorVersion == 10)
			strncpy(C_osrel, "Win98", sizeof(C_osrel) - 1);
		    else if (ovf.dwMinorVersion == 90)
			strncpy(C_osrel, "WinMe", sizeof(C_osrel) - 1);
		}
		break;
	    case VER_PLATFORM_WIN32_NT:
		C_isNT = 1;
		if (ovf.dwMajorVersion == 6)
		    strncpy(C_osrel, "WinVista", sizeof(C_osrel) - 1);
		else if (ovf.dwMajorVersion == 5)
		{
		    if (ovf.dwMinorVersion == 2)
			strncpy(C_osrel, "WinServer2003", sizeof(C_osrel) - 1);
		    else if (ovf.dwMinorVersion == 1)
			strncpy(C_osrel, "WinXP", sizeof(C_osrel) - 1);
		    else if ( ovf.dwMinorVersion == 0)
			strncpy(C_osrel, "Win2000", sizeof(C_osrel) - 1);
		}
		else if (ovf.dwMajorVersion <= 4)
		   strncpy(C_osrel, "WinNT", sizeof(C_osrel) - 1);
		break;
	    }
	    GetSystemInfo(&si);
	    strncpy(C_processor, "Unknown", sizeof(C_processor) - 1);
	    switch (si.wProcessorArchitecture)
	    {
	    case PROCESSOR_ARCHITECTURE_INTEL:
		strncpy(C_processor, "x86", sizeof(C_processor) - 1);
		break;
#	    ifdef PROCESSOR_ARCHITECTURE_IA64
	    case PROCESSOR_ARCHITECTURE_IA64:
		strncpy(C_processor, "IA64", sizeof(C_processor) - 1);
		break;
#	    endif
#	    ifdef PROCESSOR_ARCHITECTURE_AMD64
	    case PROCESSOR_ARCHITECTURE_AMD64:
		strncpy(C_processor, "x64", sizeof(C_processor) - 1);
		break;
#	    endif
#	    ifdef PROCESSOR_ARCHITECTURE_IA32_ON_WIN64
	    case PROCESSOR_ARCHITECTURE_IA32_ON_WIN64:
		strncpy(C_processor, "WOW64", sizeof(C_processor) - 1);
		break;
#	    endif
	    }
	}
	else
	    return set_last_errno();
    }
    return 1;
}

static int C_fcall
get_shlcmd()
{
    /* Do we need to build the shell command pathname? */
    if (!strlen(C_shlcmd))
    {
	if (sysinfo()) /* for C_isNT */
	{
	    char *cmdnam = C_isNT ? "\\cmd.exe" : "\\command.com";
	    UINT len = GetSystemDirectory(C_shlcmd, sizeof(C_shlcmd) - strlen(cmdnam));
	    if (len)
		strcpy(C_shlcmd + len, cmdnam);
	    else
		return set_last_errno();
	}
	else
	    return 0;
    }
    return 1;
}

#define C_get_hostname() (get_hostname() ? C_SCHEME_TRUE : C_SCHEME_FALSE)
#define C_sysinfo() (sysinfo() ? C_SCHEME_TRUE : C_SCHEME_FALSE)
#define C_get_shlcmd() (get_shlcmd() ? C_SCHEME_TRUE : C_SCHEME_FALSE)

/* GetUserName */

static int C_fcall
get_user_name()
{
    if (!strlen(C_username))
    {
	DWORD bufCharCount = sizeof(C_username) / sizeof(C_username[0]);
	if (!GetUserName(C_username, &bufCharCount))
	    return set_last_errno();
    }
    return 1;
}

#define C_get_user_name() (get_user_name() ? C_SCHEME_TRUE : C_SCHEME_FALSE)

/*
    Spawn a process directly.
    Params:
    app		Command to execute.
    cmdlin	Command line (arguments).
    env		Environment for the new process (may be NULL).
    handle, stdin, stdout, stderr
		Spawned process info are returned in integers.
		When spawned process shares standard io stream with the parent
		process the respective value in handle, stdin, stdout, stderr
		is -1.
    params	A bitmask controling operation.
		Bit 1: Child & parent share standard input if this bit is set.
		Bit 2: Share standard output if bit is set.
		Bit 3: Share standard error if bit is set.

    Returns: zero return value indicates failure.
*/
static int C_fcall
C_process(const char * app, const char * cmdlin, const char ** env,
	  C_word * phandle,
	  int * pstdin_fd, int * pstdout_fd, int * pstderr_fd,
	  int params)
{
    int i;
    int success = TRUE;
    const int f_share_io[3] = { params & 1, params & 2, params & 4};
    int io_fds[3] = { -1, -1, -1 };
    HANDLE
	child_io_handles[3] = { NULL, NULL, NULL },
	standard_io_handles[3] = {
	    GetStdHandle(STD_INPUT_HANDLE),
	    GetStdHandle(STD_OUTPUT_HANDLE),
	    GetStdHandle(STD_ERROR_HANDLE)};
    const char modes[3] = "rww";
    HANDLE cur_process = GetCurrentProcess(), child_process = NULL;
    void* envblk = NULL;

    /****** create io handles & fds ***/

    for (i=0; i<3 && success; ++i)
    {
	if (f_share_io[i])
	{
	    success = DuplicateHandle(
		cur_process, standard_io_handles[i],
		cur_process, &child_io_handles[i],
		0, FALSE, DUPLICATE_SAME_ACCESS);
	}
	else
	{
	    HANDLE a, b;
	    success = CreatePipe(&a,&b,NULL,0);
	    if(success)
	    {
		HANDLE parent_end;
		if (modes[i]=='r') { child_io_handles[i]=a; parent_end=b; }
		else		   { parent_end=a; child_io_handles[i]=b; }
		success = (io_fds[i] = _open_osfhandle((C_word)parent_end,0)) >= 0;
                /* Make new handle inheritable */
		if (success)
		  success = SetHandleInformation(child_io_handles[i], HANDLE_FLAG_INHERIT, -1);
	    }
	}
    }

#if 0 /* Requires a sorted list by key! */
    /****** create environment block if necessary ****/

    if (env && success)
    {
	char** p;
	int len = 0;

	for (p = env; *p; ++p) len += strlen(*p) + 1;

	if (envblk = C_malloc(len + 1))
	{
	    char* pb = (char*)envblk;
	    for (p = env; *p; ++p)
	    {
		strcpy(pb, *p);
		pb += strlen(*p) + 1;
	    }
	    *pb = '\0';
            /* This _should_ already have been checked for embedded NUL bytes */
	}
	else
	    success = FALSE;
    }
#endif

    /****** finally spawn process ****/

    if (success)
    {
	PROCESS_INFORMATION pi;
	STARTUPINFO si;

	ZeroMemory(&pi,sizeof pi);
	ZeroMemory(&si,sizeof si);
	si.cb = sizeof si;
	si.dwFlags = STARTF_USESTDHANDLES;
	si.hStdInput = child_io_handles[0];
	si.hStdOutput = child_io_handles[1];
	si.hStdError = child_io_handles[2];

	/* FIXME passing 'app' param causes failure & possible stack corruption */
	success = CreateProcess(
	    NULL, (char*)cmdlin, NULL, NULL, TRUE, 0, envblk, NULL, &si, &pi);

	if (success)
	{
	    child_process=pi.hProcess;
	    CloseHandle(pi.hThread);
	}
	else
	    set_last_errno();
    }
    else
	set_last_errno();

    /****** cleanup & return *********/

    /* parent must close child end */
    for (i=0; i<3; ++i) {
	if (child_io_handles[i] != NULL)
	    CloseHandle(child_io_handles[i]);
    }

    if (success)
    {
	*phandle = (C_word)child_process;
	*pstdin_fd = io_fds[0];
	*pstdout_fd = io_fds[1];
	*pstderr_fd = io_fds[2];
    }
    else
    {
	for (i=0; i<3; ++i) {
	    if (io_fds[i] != -1)
		_close(io_fds[i]);
	}
    }

    return success;
}

static int set_file_mtime(char *filename, C_word tm)
{
  struct _utimbuf tb;

  tb.actime = tb.modtime = C_num_to_int(tm);
  return _utime(filename, &tb);
}

#include <signal.h>
#include <errno.h>

#include <sys/stat.h>

static int C_not_implemented(void);
int C_not_implemented() { return -1; }

#define C_curdir(buf)       (getcwd(C_c_string(buf), 1024) ? C_fix(strlen(C_c_string(buf))) : C_SCHEME_FALSE)

static C_TLS struct stat C_statbuf;

#define C_stat_type         (C_statbuf.st_mode & S_IFMT)
#define C_stat(fn)          C_fix(stat((char *)C_data_pointer(fn), &C_statbuf))
#define C_fstat(f)          C_fix(fstat(C_unfix(f), &C_statbuf))

#ifndef S_IFSOCK
# define S_IFSOCK           0140000
#endif

#define cpy_tmvec_to_tmstc08(ptm, v) \
    ((ptm)->tm_sec = C_unfix(C_block_item((v), 0)), \
    (ptm)->tm_min = C_unfix(C_block_item((v), 1)), \
    (ptm)->tm_hour = C_unfix(C_block_item((v), 2)), \
    (ptm)->tm_mday = C_unfix(C_block_item((v), 3)), \
    (ptm)->tm_mon = C_unfix(C_block_item((v), 4)), \
    (ptm)->tm_year = C_unfix(C_block_item((v), 5)), \
    (ptm)->tm_wday = C_unfix(C_block_item((v), 6)), \
    (ptm)->tm_yday = C_unfix(C_block_item((v), 7)), \
    (ptm)->tm_isdst = (C_block_item((v), 8) != C_SCHEME_FALSE))

#define cpy_tmvec_to_tmstc9(ptm, v) \
    (((struct tm *)ptm)->tm_gmtoff = -C_unfix(C_block_item((v), 9)))

#define C_tm_set_08(v, tm)  cpy_tmvec_to_tmstc08( (tm), (v) )
#define C_tm_set_9(v, tm)   cpy_tmvec_to_tmstc9( (tm), (v) )

static struct tm *
C_tm_set( C_word v, void *tm )
{
  C_tm_set_08( v, (struct tm *)tm );
#if defined(C_GNU_ENV) && !defined(__CYGWIN__) && !defined(__uClinux__)
  C_tm_set_9( v, (struct tm *)tm );
#endif
  return tm;
}

#define TIME_STRING_MAXLENGTH 255
static char C_time_string [TIME_STRING_MAXLENGTH + 1];
#undef TIME_STRING_MAXLENGTH

#define C_strftime(v, f, tm) \
        (strftime(C_time_string, sizeof(C_time_string), C_c_string(f), C_tm_set((v), (tm))) ? C_time_string : NULL)
#define C_a_mktime(ptr, c, v, tm)  C_flonum(ptr, mktime(C_tm_set((v), C_data_pointer(tm))))
#define C_asctime(v, tm)    (asctime(C_tm_set((v), (tm))))

#define C_fdopen(a, n, fd, m) C_mpointer(a, fdopen(C_unfix(fd), C_c_string(m)))
#define C_C_fileno(p)       C_fix(fileno(C_port_file(p)))
#define C_dup(x)            C_fix(dup(C_unfix(x)))
#define C_dup2(x, y)        C_fix(dup2(C_unfix(x), C_unfix(y)))

#define C_set_file_ptr(port, ptr)  (C_set_block_item(port, 0, (C_block_item(ptr, 0))), C_SCHEME_UNDEFINED)

#ifndef S_IFLNK
#define S_IFLNK S_IFREG
#endif

#ifndef S_IFREG
#define S_IFREG S_IFREG
#endif

#ifndef S_IFDIR
#define S_IFDIR S_IFREG
#endif

#ifndef S_IFCHR
#define S_IFCHR S_IFREG
#endif

#ifndef S_IFBLK
#define S_IFBLK S_IFREG
#endif

#ifndef S_IFSOCK
#define S_IFSOCK S_IFREG
#endif

#ifndef S_IFIFO
#define S_IFIFO S_IFREG
#endif


#define PROT_NONE       0
#define PROT_READ       1
#define PROT_WRITE      2
#define PROT_EXEC       4
#define MAP_FILE        0
#define MAP_SHARED      1
#define MAP_PRIVATE     2
#define MAP_FIXED       0x10
#define MAP_ANONYMOUS   0x20

// This value is available starting with Windows XP with SP2 
// and Windows Server 2003 with SP1.
#ifndef FILE_MAP_EXECUTE
#define FILE_MAP_EXECUTE 0x20
#endif//FILE_MAP_EXECUTE

static int page_flags[] =
{
    0,
    PAGE_READONLY,
    PAGE_READWRITE,
    PAGE_READWRITE,
    PAGE_EXECUTE_READ,
    PAGE_EXECUTE_READ,
    PAGE_EXECUTE_READWRITE
};

static int file_flags[] =
{
    0,
    FILE_MAP_READ,
    FILE_MAP_READ|FILE_MAP_WRITE,
    FILE_MAP_READ|FILE_MAP_WRITE,
    FILE_MAP_READ|FILE_MAP_EXECUTE,
    FILE_MAP_READ|FILE_MAP_EXECUTE,
    FILE_MAP_READ|FILE_MAP_WRITE|FILE_MAP_EXECUTE
};

void* mmap(void* addr,int len,int prot,int flags,int fd,int off)
{
    HANDLE hMap;
    HANDLE hFile;

    void* ptr;

    if ((flags & MAP_FIXED) || (flags & MAP_PRIVATE) || (flags & MAP_ANONYMOUS))
    {
        errno = EINVAL;
        return (void*)-1;
    }

    /*
     * We must cast because _get_osfhandle returns intptr_t, but it must
     * be compared with INVALID_HANDLE_VALUE, which is a HANDLE type.
     * Who comes up with this shit?
     */
    hFile = (HANDLE)_get_osfhandle(fd);
    if (hFile == INVALID_HANDLE_VALUE)
    {
        return (void*)-1;
    }

    hMap = CreateFileMapping(
            hFile,
            NULL,
            page_flags[prot & (PROT_READ|PROT_WRITE|PROT_EXEC)],
            0,
            0,
            NULL);

    if (hMap == INVALID_HANDLE_VALUE)
    {
        set_last_errno();
        return (void*)-1;
    }

    ptr = MapViewOfFile(
            hMap,
            file_flags[prot & (PROT_READ|PROT_WRITE|PROT_EXEC)],
            0,
            off,
            len);

    if (ptr == NULL)
    {
        set_last_errno();
        ptr = (void*)-1;
    }

    CloseHandle(hMap);

    return ptr;
}

int munmap(void* addr,int len)
{
    if (UnmapViewOfFile(addr))
    {
        errno = 0;
        return 0;
    }
    set_last_errno();
    return -1;
}

int is_bad_mmap(void* p)
{
    void* bad_ptr;
    bad_ptr = (void*)-1;
    return p == bad_ptr;
}


static C_PTABLE_ENTRY *create_ptable(void);
C_noret_decl(C_scheduler_toplevel)
C_externimport void C_ccall C_scheduler_toplevel(C_word c,C_word d,C_word k) C_noret;
C_noret_decl(C_irregex_toplevel)
C_externimport void C_ccall C_irregex_toplevel(C_word c,C_word d,C_word k) C_noret;
C_noret_decl(C_extras_toplevel)
C_externimport void C_ccall C_extras_toplevel(C_word c,C_word d,C_word k) C_noret;
C_noret_decl(C_files_toplevel)
C_externimport void C_ccall C_files_toplevel(C_word c,C_word d,C_word k) C_noret;
C_noret_decl(C_ports_toplevel)
C_externimport void C_ccall C_ports_toplevel(C_word c,C_word d,C_word k) C_noret;

static C_TLS C_word lf[407];
static double C_possibly_force_alignment;
static C_char C_TLS li0[] C_aligned={C_lihdr(0,0,41),40,112,111,115,105,120,45,101,114,114,111,114,32,116,121,112,101,55,49,32,108,111,99,55,50,32,109,115,103,55,51,32,46,32,97,114,103,115,55,52,41,0,0,0,0,0,0,0};
static C_char C_TLS li1[] C_aligned={C_lihdr(0,0,38),40,35,35,115,121,115,35,115,116,97,116,32,102,105,108,101,56,54,32,108,105,110,107,56,55,32,101,114,114,56,56,32,108,111,99,56,57,41,0,0};
static C_char C_TLS li2[] C_aligned={C_lihdr(0,0,28),40,102,105,108,101,45,115,116,97,116,32,102,49,48,50,32,46,32,116,109,112,49,48,49,49,48,51,41,0,0,0,0};
static C_char C_TLS li3[] C_aligned={C_lihdr(0,0,23),40,102,105,108,101,45,97,99,99,101,115,115,45,116,105,109,101,32,102,49,50,56,41,0};
static C_char C_TLS li4[] C_aligned={C_lihdr(0,0,23),40,102,105,108,101,45,99,104,97,110,103,101,45,116,105,109,101,32,102,49,51,49,41,0};
static C_char C_TLS li5[] C_aligned={C_lihdr(0,0,17),40,102,105,108,101,45,111,119,110,101,114,32,102,49,51,52,41,0,0,0,0,0,0,0};
static C_char C_TLS li6[] C_aligned={C_lihdr(0,0,23),40,102,105,108,101,45,112,101,114,109,105,115,115,105,111,110,115,32,102,49,51,55,41,0};
static C_char C_TLS li7[] C_aligned={C_lihdr(0,0,16),40,102,105,108,101,45,115,105,122,101,32,102,49,52,48,41};
static C_char C_TLS li8[] C_aligned={C_lihdr(0,0,31),40,102,105,108,101,45,116,121,112,101,32,102,105,108,101,49,52,56,32,46,32,116,109,112,49,52,55,49,52,57,41,0};
static C_char C_TLS li9[] C_aligned={C_lihdr(0,0,23),40,114,101,103,117,108,97,114,45,102,105,108,101,63,32,102,105,108,101,49,54,55,41,0};
static C_char C_TLS li10[] C_aligned={C_lihdr(0,0,16),40,102,95,50,52,53,54,32,102,105,108,101,49,54,57,41};
static C_char C_TLS li11[] C_aligned={C_lihdr(0,0,16),40,102,95,50,52,54,54,32,102,105,108,101,49,55,49,41};
static C_char C_TLS li12[] C_aligned={C_lihdr(0,0,16),40,102,95,50,52,55,54,32,102,105,108,101,49,55,51,41};
static C_char C_TLS li13[] C_aligned={C_lihdr(0,0,16),40,102,95,50,52,56,54,32,102,105,108,101,49,55,53,41};
static C_char C_TLS li14[] C_aligned={C_lihdr(0,0,16),40,102,95,50,52,57,54,32,102,105,108,101,49,55,55,41};
static C_char C_TLS li15[] C_aligned={C_lihdr(0,0,20),40,100,105,114,101,99,116,111,114,121,63,32,102,105,108,101,49,55,57,41,0,0,0,0};
static C_char C_TLS li16[] C_aligned={C_lihdr(0,0,25),40,109,111,100,101,32,105,110,112,49,56,53,32,109,49,56,54,32,108,111,99,49,56,55,41,0,0,0,0,0,0,0};
static C_char C_TLS li17[] C_aligned={C_lihdr(0,0,32),40,99,104,101,99,107,32,108,111,99,49,57,57,32,102,100,50,48,48,32,105,110,112,50,48,49,32,114,50,48,50,41};
static C_char C_TLS li18[] C_aligned={C_lihdr(0,0,21),40,102,95,50,53,55,49,32,102,100,50,48,53,32,46,32,109,50,48,54,41,0,0,0};
static C_char C_TLS li19[] C_aligned={C_lihdr(0,0,21),40,102,95,50,53,56,53,32,102,100,50,48,56,32,46,32,109,50,48,57,41,0,0,0};
static C_char C_TLS li20[] C_aligned={C_lihdr(0,0,16),40,102,95,50,53,57,57,32,112,111,114,116,50,49,53,41};
static C_char C_TLS li21[] C_aligned={C_lihdr(0,0,24),40,102,95,50,54,52,55,32,111,108,100,50,50,52,32,46,32,110,101,119,50,50,53,41};
static C_char C_TLS li22[] C_aligned={C_lihdr(0,0,31),40,99,117,114,114,101,110,116,45,100,105,114,101,99,116,111,114,121,32,46,32,116,109,112,50,51,54,50,51,55,41,0};
static C_char C_TLS li23[] C_aligned={C_lihdr(0,0,14),40,114,109,100,105,114,32,100,105,114,50,54,52,41,0,0};
static C_char C_TLS li24[] C_aligned={C_lihdr(0,0,11),40,103,50,55,49,32,102,50,56,48,41,0,0,0,0,0};
static C_char C_TLS li25[] C_aligned={C_lihdr(0,0,26),40,102,111,114,45,101,97,99,104,45,108,111,111,112,50,55,48,32,103,50,55,55,50,56,56,41,0,0,0,0,0,0};
static C_char C_TLS li26[] C_aligned={C_lihdr(0,0,38),40,100,101,108,101,116,101,45,100,105,114,101,99,116,111,114,121,32,110,97,109,101,50,53,54,32,46,32,116,109,112,50,53,53,50,53,55,41,0,0};
static C_char C_TLS li27[] C_aligned={C_lihdr(0,0,6),40,108,111,111,112,41,0,0};
static C_char C_TLS li28[] C_aligned={C_lihdr(0,0,23),40,100,105,114,101,99,116,111,114,121,32,46,32,116,109,112,51,48,48,51,48,49,41,0};
static C_char C_TLS li29[] C_aligned={C_lihdr(0,0,7),40,97,50,57,53,56,41,0};
static C_char C_TLS li30[] C_aligned={C_lihdr(0,0,11),40,103,51,54,51,32,109,51,54,53,41,0,0,0,0,0};
static C_char C_TLS li31[] C_aligned={C_lihdr(0,0,13),40,108,111,111,112,32,102,110,115,51,53,54,41,0,0,0};
static C_char C_TLS li32[] C_aligned={C_lihdr(0,0,46),40,97,50,57,54,52,32,100,105,114,51,51,57,51,52,48,51,52,53,32,102,105,108,51,52,49,51,52,50,51,52,54,32,101,120,116,51,52,51,51,52,52,51,52,55,41,0,0};
static C_char C_TLS li33[] C_aligned={C_lihdr(0,0,20),40,99,111,110,99,45,108,111,111,112,32,112,97,116,104,115,51,51,55,41,0,0,0,0};
static C_char C_TLS li34[] C_aligned={C_lihdr(0,0,17),40,103,108,111,98,32,46,32,112,97,116,104,115,51,51,53,41,0,0,0,0,0,0,0};
static C_char C_TLS li35[] C_aligned={C_lihdr(0,0,7),40,97,51,49,50,56,41,0};
static C_char C_TLS li36[] C_aligned={C_lihdr(0,0,7),40,97,51,49,51,51,41,0};
static C_char C_TLS li37[] C_aligned={C_lihdr(0,0,7),40,97,51,49,54,49,41,0};
static C_char C_TLS li38[] C_aligned={C_lihdr(0,0,17),40,108,111,111,112,32,102,115,51,57,50,32,114,51,57,51,41,0,0,0,0,0,0,0};
static C_char C_TLS li39[] C_aligned={C_lihdr(0,0,13),40,102,95,51,50,49,57,32,120,51,57,48,41,0,0,0};
static C_char C_TLS li40[] C_aligned={C_lihdr(0,0,15),40,102,95,51,50,51,53,32,46,32,95,51,56,55,41,0};
static C_char C_TLS li41[] C_aligned={C_lihdr(0,0,15),40,102,95,51,50,50,55,32,46,32,95,51,56,54,41,0};
static C_char C_TLS li42[] C_aligned={C_lihdr(0,0,7),40,97,51,50,54,52,41,0};
static C_char C_TLS li43[] C_aligned={C_lihdr(0,0,7),40,97,51,50,54,55,41,0};
static C_char C_TLS li44[] C_aligned={C_lihdr(0,0,7),40,97,51,50,55,48,41,0};
static C_char C_TLS li45[] C_aligned={C_lihdr(0,0,7),40,97,51,50,55,51,41,0};
static C_char C_TLS li46[] C_aligned={C_lihdr(0,0,18),40,102,95,51,50,55,57,32,120,52,50,56,32,121,52,50,57,41,0,0,0,0,0,0};
static C_char C_TLS li47[] C_aligned={C_lihdr(0,0,7),40,97,51,50,55,54,41,0};
static C_char C_TLS li48[] C_aligned={C_lihdr(0,0,15),40,102,95,51,50,56,55,32,46,32,95,52,50,54,41,0};
static C_char C_TLS li49[] C_aligned={C_lihdr(0,0,7),40,97,51,50,56,52,41,0};
static C_char C_TLS li50[] C_aligned={C_lihdr(0,0,31),40,102,105,110,100,45,102,105,108,101,115,32,100,105,114,52,50,51,32,46,32,116,109,112,52,50,50,52,50,52,41,0};
static C_char C_TLS li51[] C_aligned={C_lihdr(0,0,32),40,99,104,101,99,107,45,116,105,109,101,45,118,101,99,116,111,114,32,108,111,99,52,53,53,32,116,109,52,53,54,41};
static C_char C_TLS li52[] C_aligned={C_lihdr(0,0,33),40,115,101,99,111,110,100,115,45,62,108,111,99,97,108,45,116,105,109,101,32,46,32,116,109,112,52,54,51,52,54,52,41,0,0,0,0,0,0,0};
static C_char C_TLS li53[] C_aligned={C_lihdr(0,0,31),40,115,101,99,111,110,100,115,45,62,117,116,99,45,116,105,109,101,32,46,32,116,109,112,52,55,54,52,55,55,41,0};
static C_char C_TLS li54[] C_aligned={C_lihdr(0,0,29),40,115,101,99,111,110,100,115,45,62,115,116,114,105,110,103,32,46,32,116,109,112,52,57,53,52,57,54,41,0,0,0};
static C_char C_TLS li55[] C_aligned={C_lihdr(0,0,27),40,108,111,99,97,108,45,116,105,109,101,45,62,115,101,99,111,110,100,115,32,116,109,53,48,55,41,0,0,0,0,0};
static C_char C_TLS li56[] C_aligned={C_lihdr(0,0,32),40,116,105,109,101,45,62,115,116,114,105,110,103,32,116,109,53,52,48,32,46,32,116,109,112,53,51,57,53,52,49,41};
static C_char C_TLS li57[] C_aligned={C_lihdr(0,0,36),40,115,101,116,45,115,105,103,110,97,108,45,104,97,110,100,108,101,114,33,32,115,105,103,53,53,52,32,112,114,111,99,53,53,53,41,0,0,0,0};
static C_char C_TLS li58[] C_aligned={C_lihdr(0,0,20),40,99,117,114,114,101,110,116,45,112,114,111,99,101,115,115,45,105,100,41,0,0,0,0};
static C_char C_TLS li59[] C_aligned={C_lihdr(0,0,7),40,97,51,53,53,54,41,0};
static C_char C_TLS li60[] C_aligned={C_lihdr(0,0,33),40,97,51,53,54,50,32,101,112,105,100,53,55,57,32,101,110,111,114,109,53,56,48,32,101,99,111,100,101,53,56,49,41,0,0,0,0,0,0,0};
static C_char C_TLS li61[] C_aligned={C_lihdr(0,0,24),40,112,114,111,99,101,115,115,45,119,97,105,116,32,46,32,97,114,103,115,53,54,52,41};
static C_char C_TLS li62[] C_aligned={C_lihdr(0,0,42),40,102,105,108,101,45,111,112,101,110,32,102,105,108,101,110,97,109,101,54,53,48,32,102,108,97,103,115,54,53,49,32,46,32,109,111,100,101,54,53,50,41,0,0,0,0,0,0};
static C_char C_TLS li63[] C_aligned={C_lihdr(0,0,18),40,102,105,108,101,45,99,108,111,115,101,32,102,100,54,54,49,41,0,0,0,0,0,0};
static C_char C_TLS li64[] C_aligned={C_lihdr(0,0,37),40,102,105,108,101,45,114,101,97,100,32,102,100,54,54,53,32,115,105,122,101,54,54,54,32,46,32,98,117,102,102,101,114,54,54,55,41,0,0,0};
static C_char C_TLS li65[] C_aligned={C_lihdr(0,0,38),40,102,105,108,101,45,119,114,105,116,101,32,102,100,54,55,55,32,98,117,102,102,101,114,54,55,56,32,46,32,115,105,122,101,54,55,57,41,0,0};
static C_char C_TLS li66[] C_aligned={C_lihdr(0,0,26),40,102,105,108,101,45,109,107,115,116,101,109,112,32,116,101,109,112,108,97,116,101,54,56,57,41,0,0,0,0,0,0};
static C_char C_TLS li67[] C_aligned={C_lihdr(0,0,25),40,115,121,109,98,111,108,105,99,45,108,105,110,107,63,32,102,110,97,109,101,55,48,48,41,0,0,0,0,0,0,0};
static C_char C_TLS li68[] C_aligned={C_lihdr(0,0,20),40,102,54,57,49,55,32,102,110,97,109,101,55,48,52,54,57,49,54,41,0,0,0,0};
static C_char C_TLS li69[] C_aligned={C_lihdr(0,0,20),40,102,54,57,49,49,32,102,110,97,109,101,55,48,52,54,57,49,48,41,0,0,0,0};
static C_char C_TLS li70[] C_aligned={C_lihdr(0,0,20),40,102,54,57,48,53,32,102,110,97,109,101,55,48,52,54,57,48,52,41,0,0,0,0};
static C_char C_TLS li71[] C_aligned={C_lihdr(0,0,20),40,102,54,56,57,57,32,102,110,97,109,101,55,48,52,54,56,57,56,41,0,0,0,0};
static C_char C_TLS li72[] C_aligned={C_lihdr(0,0,47),40,115,101,116,45,102,105,108,101,45,112,111,115,105,116,105,111,110,33,32,112,111,114,116,55,49,48,32,112,111,115,55,49,49,32,46,32,119,104,101,110,99,101,55,49,50,41,0};
static C_char C_TLS li73[] C_aligned={C_lihdr(0,0,11),40,103,55,53,50,32,120,55,54,49,41,0,0,0,0,0};
static C_char C_TLS li74[] C_aligned={C_lihdr(0,0,26),40,102,111,114,45,101,97,99,104,45,108,111,111,112,55,53,49,32,103,55,53,56,55,55,49,41,0,0,0,0,0,0};
static C_char C_TLS li75[] C_aligned={C_lihdr(0,0,38),40,99,114,101,97,116,101,45,100,105,114,101,99,116,111,114,121,32,110,97,109,101,55,51,54,32,46,32,116,109,112,55,51,53,55,51,55,41,0,0};
static C_char C_TLS li76[] C_aligned={C_lihdr(0,0,26),40,99,104,97,110,103,101,45,100,105,114,101,99,116,111,114,121,32,110,97,109,101,55,56,50,41,0,0,0,0,0,0};
static C_char C_TLS li77[] C_aligned={C_lihdr(0,0,26),40,99,104,101,99,107,32,99,109,100,55,57,50,32,105,110,112,55,57,51,32,114,55,57,52,41,0,0,0,0,0,0};
static C_char C_TLS li78[] C_aligned={C_lihdr(0,0,31),40,111,112,101,110,45,105,110,112,117,116,45,112,105,112,101,32,99,109,100,55,57,56,32,46,32,109,55,57,57,41,0};
static C_char C_TLS li79[] C_aligned={C_lihdr(0,0,32),40,111,112,101,110,45,111,117,116,112,117,116,45,112,105,112,101,32,99,109,100,56,48,56,32,46,32,109,56,48,57,41};
static C_char C_TLS li80[] C_aligned={C_lihdr(0,0,26),40,99,108,111,115,101,45,105,110,112,117,116,45,112,105,112,101,32,112,111,114,116,56,49,56,41,0,0,0,0,0,0};
static C_char C_TLS li81[] C_aligned={C_lihdr(0,0,27),40,99,108,111,115,101,45,111,117,116,112,117,116,45,112,105,112,101,32,112,111,114,116,56,50,51,41,0,0,0,0,0};
static C_char C_TLS li82[] C_aligned={C_lihdr(0,0,7),40,97,52,50,48,54,41,0};
static C_char C_TLS li83[] C_aligned={C_lihdr(0,0,20),40,97,52,50,49,50,32,46,32,114,101,115,117,108,116,115,56,51,57,41,0,0,0,0};
static C_char C_TLS li84[] C_aligned={C_lihdr(0,0,47),40,99,97,108,108,45,119,105,116,104,45,105,110,112,117,116,45,112,105,112,101,32,99,109,100,56,51,53,32,112,114,111,99,56,51,54,32,46,32,109,111,100,101,56,51,55,41,0};
static C_char C_TLS li85[] C_aligned={C_lihdr(0,0,7),40,97,52,50,51,48,41,0};
static C_char C_TLS li86[] C_aligned={C_lihdr(0,0,20),40,97,52,50,51,54,32,46,32,114,101,115,117,108,116,115,56,52,54,41,0,0,0,0};
static C_char C_TLS li87[] C_aligned={C_lihdr(0,0,48),40,99,97,108,108,45,119,105,116,104,45,111,117,116,112,117,116,45,112,105,112,101,32,99,109,100,56,52,50,32,112,114,111,99,56,52,51,32,46,32,109,111,100,101,56,52,52,41};
static C_char C_TLS li88[] C_aligned={C_lihdr(0,0,7),40,97,52,50,53,52,41,0};
static C_char C_TLS li89[] C_aligned={C_lihdr(0,0,20),40,97,52,50,54,53,32,46,32,114,101,115,117,108,116,115,56,54,49,41,0,0,0,0};
static C_char C_TLS li90[] C_aligned={C_lihdr(0,0,7),40,97,52,50,53,57,41,0};
static C_char C_TLS li91[] C_aligned={C_lihdr(0,0,7),40,97,52,50,55,52,41,0};
static C_char C_TLS li92[] C_aligned={C_lihdr(0,0,48),40,119,105,116,104,45,105,110,112,117,116,45,102,114,111,109,45,112,105,112,101,32,99,109,100,56,52,57,32,116,104,117,110,107,56,53,48,32,46,32,109,111,100,101,56,53,49,41};
static C_char C_TLS li93[] C_aligned={C_lihdr(0,0,7),40,97,52,50,56,56,41,0};
static C_char C_TLS li94[] C_aligned={C_lihdr(0,0,20),40,97,52,50,57,57,32,46,32,114,101,115,117,108,116,115,56,55,56,41,0,0,0,0};
static C_char C_TLS li95[] C_aligned={C_lihdr(0,0,7),40,97,52,50,57,51,41,0};
static C_char C_TLS li96[] C_aligned={C_lihdr(0,0,7),40,97,52,51,48,56,41,0};
static C_char C_TLS li97[] C_aligned={C_lihdr(0,0,47),40,119,105,116,104,45,111,117,116,112,117,116,45,116,111,45,112,105,112,101,32,99,109,100,56,54,54,32,116,104,117,110,107,56,54,55,32,46,32,109,111,100,101,56,54,56,41,0};
static C_char C_TLS li98[] C_aligned={C_lihdr(0,0,25),40,99,114,101,97,116,101,45,112,105,112,101,32,46,32,116,109,112,56,56,55,56,56,56,41,0,0,0,0,0,0,0};
static C_char C_TLS li99[] C_aligned={C_lihdr(0,0,32),40,99,104,97,110,103,101,45,102,105,108,101,45,109,111,100,101,32,102,110,97,109,101,57,54,50,32,109,57,54,51,41};
static C_char C_TLS li100[] C_aligned={C_lihdr(0,0,33),40,99,104,101,99,107,32,102,105,108,101,110,97,109,101,57,54,56,32,97,99,99,57,54,57,32,108,111,99,57,55,48,41,0,0,0,0,0,0,0};
static C_char C_TLS li101[] C_aligned={C_lihdr(0,0,31),40,102,105,108,101,45,114,101,97,100,45,97,99,99,101,115,115,63,32,102,105,108,101,110,97,109,101,57,55,52,41,0};
static C_char C_TLS li102[] C_aligned={C_lihdr(0,0,32),40,102,105,108,101,45,119,114,105,116,101,45,97,99,99,101,115,115,63,32,102,105,108,101,110,97,109,101,57,55,53,41};
static C_char C_TLS li103[] C_aligned={C_lihdr(0,0,34),40,102,105,108,101,45,101,120,101,99,117,116,101,45,97,99,99,101,115,115,63,32,102,105,108,101,110,97,109,101,57,55,54,41,0,0,0,0,0,0};
static C_char C_TLS li104[] C_aligned={C_lihdr(0,0,25),40,109,111,100,101,32,105,110,112,57,56,53,32,109,57,56,54,32,108,111,99,57,56,55,41,0,0,0,0,0,0,0};
static C_char C_TLS li105[] C_aligned={C_lihdr(0,0,27),40,99,104,101,99,107,32,102,100,57,57,57,32,105,110,112,49,48,48,48,32,114,49,48,48,49,41,0,0,0,0,0};
static C_char C_TLS li106[] C_aligned={C_lihdr(0,0,33),40,111,112,101,110,45,105,110,112,117,116,45,102,105,108,101,42,32,102,100,49,48,48,53,32,46,32,109,49,48,48,54,41,0,0,0,0,0,0,0};
static C_char C_TLS li107[] C_aligned={C_lihdr(0,0,34),40,111,112,101,110,45,111,117,116,112,117,116,45,102,105,108,101,42,32,102,100,49,48,48,56,32,46,32,109,49,48,48,57,41,0,0,0,0,0,0};
static C_char C_TLS li108[] C_aligned={C_lihdr(0,0,23),40,112,111,114,116,45,62,102,105,108,101,110,111,32,112,111,114,116,49,48,49,53,41,0};
static C_char C_TLS li109[] C_aligned={C_lihdr(0,0,36),40,100,117,112,108,105,99,97,116,101,45,102,105,108,101,110,111,32,111,108,100,49,48,50,49,32,46,32,110,101,119,49,48,50,50,41,0,0,0,0};
static C_char C_TLS li110[] C_aligned={C_lihdr(0,0,24),40,115,101,116,101,110,118,32,118,97,114,49,48,51,48,32,118,97,108,49,48,51,49,41};
static C_char C_TLS li111[] C_aligned={C_lihdr(0,0,18),40,117,110,115,101,116,101,110,118,32,118,97,114,49,48,51,54,41,0,0,0,0,0,0};
static C_char C_TLS li112[] C_aligned={C_lihdr(0,0,12),40,115,99,97,110,32,106,49,48,53,48,41,0,0,0,0};
static C_char C_TLS li113[] C_aligned={C_lihdr(0,0,12),40,108,111,111,112,32,105,49,48,52,55,41,0,0,0,0};
static C_char C_TLS li114[] C_aligned={C_lihdr(0,0,27),40,103,101,116,45,101,110,118,105,114,111,110,109,101,110,116,45,118,97,114,105,97,98,108,101,115,41,0,0,0,0,0};
static C_char C_TLS li115[] C_aligned={C_lihdr(0,0,29),40,108,111,99,97,108,45,116,105,109,101,122,111,110,101,45,97,98,98,114,101,118,105,97,116,105,111,110,41,0,0,0};
static C_char C_TLS li116[] C_aligned={C_lihdr(0,0,18),40,95,101,120,105,116,32,46,32,99,111,100,101,49,48,54,51,41,0,0,0,0,0,0};
static C_char C_TLS li117[] C_aligned={C_lihdr(0,0,25),40,116,101,114,109,105,110,97,108,45,112,111,114,116,63,32,112,111,114,116,49,48,54,53,41,0,0,0,0,0,0,0};
static C_char C_TLS li118[] C_aligned={C_lihdr(0,0,24),40,116,101,114,109,105,110,97,108,45,115,105,122,101,32,112,111,114,116,49,48,55,48,41};
static C_char C_TLS li119[] C_aligned={C_lihdr(0,0,50),40,115,101,116,45,98,117,102,102,101,114,105,110,103,45,109,111,100,101,33,32,112,111,114,116,49,48,55,50,32,109,111,100,101,49,48,55,51,32,46,32,115,105,122,101,49,48,55,52,41,0,0,0,0,0,0};
static C_char C_TLS li120[] C_aligned={C_lihdr(0,0,6),40,108,111,111,112,41,0,0};
static C_char C_TLS li121[] C_aligned={C_lihdr(0,0,24),40,108,111,111,112,32,105,108,115,116,49,49,48,52,32,111,108,115,116,49,49,48,53,41};
static C_char C_TLS li122[] C_aligned={C_lihdr(0,0,37),40,36,113,117,111,116,101,45,97,114,103,115,45,108,105,115,116,32,108,115,116,49,48,57,49,32,101,120,97,99,116,102,49,48,57,50,41,0,0,0};
static C_char C_TLS li123[] C_aligned={C_lihdr(0,0,49),40,115,101,116,97,114,103,32,105,110,116,49,49,49,50,49,49,49,56,32,99,45,115,116,114,105,110,103,49,49,49,51,49,49,49,57,32,105,110,116,49,49,49,52,49,49,50,48,41,0,0,0,0,0,0,0};
static C_char C_TLS li124[] C_aligned={C_lihdr(0,0,49),40,115,101,116,101,110,118,32,105,110,116,49,49,50,50,49,49,50,56,32,99,45,115,116,114,105,110,103,49,49,50,51,49,49,50,57,32,105,110,116,49,49,50,52,49,49,51,48,41,0,0,0,0,0,0,0};
static C_char C_TLS li125[] C_aligned={C_lihdr(0,0,24),40,100,111,108,111,111,112,49,49,51,54,32,108,49,49,51,56,32,105,49,49,51,57,41};
static C_char C_TLS li126[] C_aligned={C_lihdr(0,0,61),40,98,117,105,108,100,45,101,120,101,99,45,97,114,103,118,101,99,32,108,111,99,49,49,51,50,32,108,115,116,49,49,51,51,32,97,114,103,118,101,99,45,115,101,116,116,101,114,49,49,51,52,32,105,100,120,49,49,51,53,41,0,0,0};
static C_char C_TLS li127[] C_aligned={C_lihdr(0,0,67),40,36,101,120,101,99,45,115,101,116,117,112,32,108,111,99,49,49,52,53,32,102,105,108,101,110,97,109,101,49,49,52,54,32,97,114,103,108,115,116,49,49,52,55,32,101,110,118,108,115,116,49,49,52,56,32,101,120,97,99,116,102,49,49,52,57,41,0,0,0,0,0};
static C_char C_TLS li128[] C_aligned={C_lihdr(0,0,53),40,36,101,120,101,99,45,116,101,97,114,100,111,119,110,32,108,111,99,49,49,53,56,32,109,115,103,49,49,53,57,32,102,105,108,101,110,97,109,101,49,49,54,48,32,114,101,115,49,49,54,49,41,0,0,0};
static C_char C_TLS li129[] C_aligned={C_lihdr(0,0,44),40,112,114,111,99,101,115,115,45,101,120,101,99,117,116,101,32,102,105,108,101,110,97,109,101,49,49,55,49,32,46,32,116,109,112,49,49,55,48,49,49,55,50,41,0,0,0,0};
static C_char C_TLS li130[] C_aligned={C_lihdr(0,0,51),40,112,114,111,99,101,115,115,45,115,112,97,119,110,32,109,111,100,101,49,49,57,50,32,102,105,108,101,110,97,109,101,49,49,57,51,32,46,32,116,109,112,49,49,57,49,49,49,57,52,41,0,0,0,0,0};
static C_char C_TLS li131[] C_aligned={C_lihdr(0,0,21),40,35,35,115,121,115,35,115,104,101,108,108,45,99,111,109,109,97,110,100,41,0,0,0};
static C_char C_TLS li132[] C_aligned={C_lihdr(0,0,42),40,35,35,115,121,115,35,115,104,101,108,108,45,99,111,109,109,97,110,100,45,97,114,103,117,109,101,110,116,115,32,99,109,100,108,105,110,49,50,49,52,41,0,0,0,0,0,0};
static C_char C_TLS li133[] C_aligned={C_lihdr(0,0,30),40,112,114,111,99,101,115,115,45,114,117,110,32,102,49,50,49,54,32,46,32,97,114,103,115,49,50,49,55,41,0,0};
static C_char C_TLS li134[] C_aligned={C_lihdr(0,0,97),40,35,35,115,121,115,35,112,114,111,99,101,115,115,32,108,111,99,49,50,53,56,32,99,109,100,49,50,53,57,32,97,114,103,115,49,50,54,48,32,101,110,118,49,50,54,49,32,115,116,100,111,117,116,102,49,50,54,50,32,115,116,100,105,110,102,49,50,54,51,32,115,116,100,101,114,114,102,49,50,54,52,32,46,32,116,109,112,49,50,53,55,49,50,54,53,41,0,0,0,0,0,0,0};
static C_char C_TLS li135[] C_aligned={C_lihdr(0,0,7),40,103,49,51,50,55,41,0};
static C_char C_TLS li136[] C_aligned={C_lihdr(0,0,19),40,102,111,114,45,101,97,99,104,45,108,111,111,112,49,51,50,54,41,0,0,0,0,0};
static C_char C_TLS li137[] C_aligned={C_lihdr(0,0,19),40,99,104,107,115,116,114,108,115,116,32,108,115,116,49,51,50,51,41,0,0,0,0,0};
static C_char C_TLS li138[] C_aligned={C_lihdr(0,0,7),40,97,53,52,56,50,41,0};
static C_char C_TLS li139[] C_aligned={C_lihdr(0,0,38),40,97,53,52,56,56,32,105,110,49,51,53,50,32,111,117,116,49,51,53,51,32,112,105,100,49,51,53,52,32,101,114,114,49,51,53,53,41,0,0};
static C_char C_TLS li140[] C_aligned={C_lihdr(0,0,63),40,37,112,114,111,99,101,115,115,32,108,111,99,49,51,49,54,32,101,114,114,63,49,51,49,55,32,99,109,100,49,51,49,56,32,97,114,103,115,49,51,49,57,32,101,110,118,49,51,50,48,32,101,120,97,99,116,102,49,51,50,49,41,0};
static C_char C_TLS li141[] C_aligned={C_lihdr(0,0,31),40,112,114,111,99,101,115,115,32,99,109,100,49,51,54,52,32,46,32,116,109,112,49,51,54,51,49,51,54,53,41,0};
static C_char C_TLS li142[] C_aligned={C_lihdr(0,0,32),40,112,114,111,99,101,115,115,42,32,99,109,100,49,51,56,51,32,46,32,116,109,112,49,51,56,50,49,51,56,52,41};
static C_char C_TLS li143[] C_aligned={C_lihdr(0,0,39),40,35,35,115,121,115,35,112,114,111,99,101,115,115,45,119,97,105,116,32,112,105,100,49,51,57,57,32,110,111,104,97,110,103,49,52,48,48,41,0};
static C_char C_TLS li144[] C_aligned={C_lihdr(0,0,13),40,115,108,101,101,112,32,115,49,52,48,50,41,0,0,0};
static C_char C_TLS li145[] C_aligned={C_lihdr(0,0,15),40,103,101,116,45,104,111,115,116,45,110,97,109,101,41,0};
static C_char C_TLS li146[] C_aligned={C_lihdr(0,0,20),40,115,121,115,116,101,109,45,105,110,102,111,114,109,97,116,105,111,110,41,0,0,0,0};
static C_char C_TLS li147[] C_aligned={C_lihdr(0,0,19),40,99,117,114,114,101,110,116,45,117,115,101,114,45,110,97,109,101,41,0,0,0,0,0};
static C_char C_TLS li148[] C_aligned={C_lihdr(0,0,72),40,109,97,112,45,102,105,108,101,45,116,111,45,109,101,109,111,114,121,32,97,100,100,114,49,52,52,52,32,108,101,110,49,52,52,53,32,112,114,111,116,49,52,52,54,32,102,108,97,103,49,52,52,55,32,102,100,49,52,52,56,32,46,32,111,102,102,49,52,52,57,41};
static C_char C_TLS li149[] C_aligned={C_lihdr(0,0,43),40,117,110,109,97,112,45,102,105,108,101,45,102,114,111,109,45,109,101,109,111,114,121,32,109,109,97,112,49,52,54,54,32,46,32,108,101,110,49,52,54,55,41,0,0,0,0,0};
static C_char C_TLS li150[] C_aligned={C_lihdr(0,0,37),40,109,101,109,111,114,121,45,109,97,112,112,101,100,45,102,105,108,101,45,112,111,105,110,116,101,114,32,109,109,97,112,49,52,55,49,41,0,0,0};
static C_char C_TLS li151[] C_aligned={C_lihdr(0,0,27),40,109,101,109,111,114,121,45,109,97,112,112,101,100,45,102,105,108,101,63,32,120,49,52,55,52,41,0,0,0,0,0};
static C_char C_TLS li152[] C_aligned={C_lihdr(0,0,31),40,99,104,97,110,103,101,45,100,105,114,101,99,116,111,114,121,42,32,46,32,95,49,53,48,53,49,53,48,57,41,0};
static C_char C_TLS li153[] C_aligned={C_lihdr(0,0,31),40,99,104,97,110,103,101,45,102,105,108,101,45,111,119,110,101,114,32,46,32,95,49,53,49,50,49,53,49,54,41,0};
static C_char C_TLS li154[] C_aligned={C_lihdr(0,0,25),40,99,114,101,97,116,101,45,102,105,102,111,32,46,32,95,49,53,49,56,49,53,50,50,41,0,0,0,0,0,0,0};
static C_char C_TLS li155[] C_aligned={C_lihdr(0,0,28),40,99,114,101,97,116,101,45,115,101,115,115,105,111,110,32,46,32,95,49,53,50,52,49,53,50,56,41,0,0,0,0};
static C_char C_TLS li156[] C_aligned={C_lihdr(0,0,34),40,99,114,101,97,116,101,45,115,121,109,98,111,108,105,99,45,108,105,110,107,32,46,32,95,49,53,51,48,49,53,51,52,41,0,0,0,0,0,0};
static C_char C_TLS li157[] C_aligned={C_lihdr(0,0,40),40,99,117,114,114,101,110,116,45,101,102,102,101,99,116,105,118,101,45,103,114,111,117,112,45,105,100,32,46,32,95,49,53,51,54,49,53,52,48,41};
static C_char C_TLS li158[] C_aligned={C_lihdr(0,0,39),40,99,117,114,114,101,110,116,45,101,102,102,101,99,116,105,118,101,45,117,115,101,114,45,105,100,32,46,32,95,49,53,52,50,49,53,52,54,41,0};
static C_char C_TLS li159[] C_aligned={C_lihdr(0,0,41),40,99,117,114,114,101,110,116,45,101,102,102,101,99,116,105,118,101,45,117,115,101,114,45,110,97,109,101,32,46,32,95,49,53,52,56,49,53,53,50,41,0,0,0,0,0,0,0};
static C_char C_TLS li160[] C_aligned={C_lihdr(0,0,30),40,99,117,114,114,101,110,116,45,103,114,111,117,112,45,105,100,32,46,32,95,49,53,53,52,49,53,53,56,41,0,0};
static C_char C_TLS li161[] C_aligned={C_lihdr(0,0,29),40,99,117,114,114,101,110,116,45,117,115,101,114,45,105,100,32,46,32,95,49,53,54,48,49,53,54,52,41,0,0,0};
static C_char C_TLS li162[] C_aligned={C_lihdr(0,0,23),40,102,105,108,101,45,108,105,110,107,32,46,32,95,49,53,54,54,49,53,55,48,41,0};
static C_char C_TLS li163[] C_aligned={C_lihdr(0,0,23),40,102,105,108,101,45,108,111,99,107,32,46,32,95,49,53,55,50,49,53,55,54,41,0};
static C_char C_TLS li164[] C_aligned={C_lihdr(0,0,32),40,102,105,108,101,45,108,111,99,107,47,98,108,111,99,107,105,110,103,32,46,32,95,49,53,55,56,49,53,56,50,41};
static C_char C_TLS li165[] C_aligned={C_lihdr(0,0,25),40,102,105,108,101,45,115,101,108,101,99,116,32,46,32,95,49,53,56,52,49,53,56,56,41,0,0,0,0,0,0,0};
static C_char C_TLS li166[] C_aligned={C_lihdr(0,0,28),40,102,105,108,101,45,116,101,115,116,45,108,111,99,107,32,46,32,95,49,53,57,48,49,53,57,52,41,0,0,0,0};
static C_char C_TLS li167[] C_aligned={C_lihdr(0,0,27),40,102,105,108,101,45,116,114,117,110,99,97,116,101,32,46,32,95,49,53,57,54,49,54,48,48,41,0,0,0,0,0};
static C_char C_TLS li168[] C_aligned={C_lihdr(0,0,25),40,102,105,108,101,45,117,110,108,111,99,107,32,46,32,95,49,54,48,50,49,54,48,54,41,0,0,0,0,0,0,0};
static C_char C_TLS li169[] C_aligned={C_lihdr(0,0,24),40,103,101,116,45,103,114,111,117,112,115,32,46,32,95,49,54,48,56,49,54,49,50,41};
static C_char C_TLS li170[] C_aligned={C_lihdr(0,0,31),40,103,114,111,117,112,45,105,110,102,111,114,109,97,116,105,111,110,32,46,32,95,49,54,49,52,49,54,49,56,41,0};
static C_char C_TLS li171[] C_aligned={C_lihdr(0,0,31),40,105,110,105,116,105,97,108,105,122,101,45,103,114,111,117,112,115,32,46,32,95,49,54,50,48,49,54,50,52,41,0};
static C_char C_TLS li172[] C_aligned={C_lihdr(0,0,31),40,112,97,114,101,110,116,45,112,114,111,99,101,115,115,45,105,100,32,46,32,95,49,54,50,54,49,54,51,48,41,0};
static C_char C_TLS li173[] C_aligned={C_lihdr(0,0,26),40,112,114,111,99,101,115,115,45,102,111,114,107,32,46,32,95,49,54,51,50,49,54,51,54,41,0,0,0,0,0,0};
static C_char C_TLS li174[] C_aligned={C_lihdr(0,0,30),40,112,114,111,99,101,115,115,45,103,114,111,117,112,45,105,100,32,46,32,95,49,54,51,56,49,54,52,50,41,0,0};
static C_char C_TLS li175[] C_aligned={C_lihdr(0,0,28),40,112,114,111,99,101,115,115,45,115,105,103,110,97,108,32,46,32,95,49,54,52,52,49,54,52,56,41,0,0,0,0};
static C_char C_TLS li176[] C_aligned={C_lihdr(0,0,32),40,114,101,97,100,45,115,121,109,98,111,108,105,99,45,108,105,110,107,32,46,32,95,49,54,53,48,49,54,53,52,41};
static C_char C_TLS li177[] C_aligned={C_lihdr(0,0,24),40,115,101,116,45,97,108,97,114,109,33,32,46,32,95,49,54,53,54,49,54,54,48,41};
static C_char C_TLS li178[] C_aligned={C_lihdr(0,0,27),40,115,101,116,45,103,114,111,117,112,45,105,100,33,32,46,32,95,49,54,54,50,49,54,54,54,41,0,0,0,0,0};
static C_char C_TLS li179[] C_aligned={C_lihdr(0,0,25),40,115,101,116,45,103,114,111,117,112,115,33,32,46,32,95,49,54,54,56,49,54,55,50,41,0,0,0,0,0,0,0};
static C_char C_TLS li180[] C_aligned={C_lihdr(0,0,35),40,115,101,116,45,112,114,111,99,101,115,115,45,103,114,111,117,112,45,105,100,33,32,46,32,95,49,54,55,52,49,54,55,56,41,0,0,0,0,0};
static C_char C_TLS li181[] C_aligned={C_lihdr(0,0,33),40,115,101,116,45,114,111,111,116,45,100,105,114,101,99,116,111,114,121,33,32,46,32,95,49,54,56,48,49,54,56,52,41,0,0,0,0,0,0,0};
static C_char C_TLS li182[] C_aligned={C_lihdr(0,0,30),40,115,101,116,45,115,105,103,110,97,108,45,109,97,115,107,33,32,46,32,95,49,54,56,54,49,54,57,48,41,0,0};
static C_char C_TLS li183[] C_aligned={C_lihdr(0,0,26),40,115,101,116,45,117,115,101,114,45,105,100,33,32,46,32,95,49,54,57,50,49,54,57,54,41,0,0,0,0,0,0};
static C_char C_TLS li184[] C_aligned={C_lihdr(0,0,25),40,115,105,103,110,97,108,45,109,97,115,107,32,46,32,95,49,54,57,56,49,55,48,50,41,0,0,0,0,0,0,0};
static C_char C_TLS li185[] C_aligned={C_lihdr(0,0,26),40,115,105,103,110,97,108,45,109,97,115,107,33,32,46,32,95,49,55,48,52,49,55,48,56,41,0,0,0,0,0,0};
static C_char C_TLS li186[] C_aligned={C_lihdr(0,0,28),40,115,105,103,110,97,108,45,109,97,115,107,101,100,63,32,46,32,95,49,55,49,48,49,55,49,52,41,0,0,0,0};
static C_char C_TLS li187[] C_aligned={C_lihdr(0,0,28),40,115,105,103,110,97,108,45,117,110,109,97,115,107,33,32,46,32,95,49,55,49,54,49,55,50,48,41,0,0,0,0};
static C_char C_TLS li188[] C_aligned={C_lihdr(0,0,27),40,116,101,114,109,105,110,97,108,45,110,97,109,101,32,46,32,95,49,55,50,50,49,55,50,54,41,0,0,0,0,0};
static C_char C_TLS li189[] C_aligned={C_lihdr(0,0,30),40,117,115,101,114,45,105,110,102,111,114,109,97,116,105,111,110,32,46,32,95,49,55,50,56,49,55,51,50,41,0,0};
static C_char C_TLS li190[] C_aligned={C_lihdr(0,0,31),40,117,116,99,45,116,105,109,101,45,62,115,101,99,111,110,100,115,32,46,32,95,49,55,51,52,49,55,51,56,41,0};
static C_char C_TLS li191[] C_aligned={C_lihdr(0,0,26),40,115,116,114,105,110,103,45,62,116,105,109,101,32,46,32,95,49,55,52,48,49,55,52,52,41,0,0,0,0,0,0};
static C_char C_TLS li192[] C_aligned={C_lihdr(0,0,13),40,102,105,102,111,63,32,95,49,55,52,55,41,0,0,0};
static C_char C_TLS li193[] C_aligned={C_lihdr(0,0,15),40,97,54,49,49,51,32,112,111,114,116,55,50,51,41,0};
static C_char C_TLS li194[] C_aligned={C_lihdr(0,0,14),40,97,54,49,53,52,32,115,105,103,53,54,48,41,0,0};
static C_char C_TLS li195[] C_aligned={C_lihdr(0,0,19),40,97,54,49,54,51,32,46,32,116,109,112,52,51,57,52,52,48,41,0,0,0,0,0};
static C_char C_TLS li196[] C_aligned={C_lihdr(0,0,13),40,97,54,49,56,56,32,117,109,52,53,50,41,0,0,0};
static C_char C_TLS li197[] C_aligned={C_lihdr(0,0,12),40,97,54,49,57,52,32,102,49,49,49,41,0,0,0,0};
static C_char C_TLS li198[] C_aligned={C_lihdr(0,0,17),40,97,54,50,48,48,32,102,49,49,51,32,116,49,49,52,41,0,0,0,0,0,0,0};
static C_char C_TLS li199[] C_aligned={C_lihdr(0,0,10),40,116,111,112,108,101,118,101,108,41,0,0,0,0,0,0};


/* from k5809 */
static C_word C_fcall stub1460(C_word C_buf,C_word C_a0,C_word C_a1) C_regparm;
C_regparm static C_word C_fcall stub1460(C_word C_buf,C_word C_a0,C_word C_a1){
C_word C_r=C_SCHEME_UNDEFINED,*C_a=(C_word*)C_buf;
void * t0=(void * )C_c_pointer_or_null(C_a0);
int t1=(int )C_num_to_int(C_a1);
C_r=C_fix((C_word)munmap(t0,t1));
return C_r;}

/* from k5753 */
static C_word C_fcall stub1439(C_word C_buf,C_word C_a0) C_regparm;
C_regparm static C_word C_fcall stub1439(C_word C_buf,C_word C_a0){
C_word C_r=C_SCHEME_UNDEFINED,*C_a=(C_word*)C_buf;
void * t0=(void * )C_c_pointer_or_null(C_a0);
C_r=C_mk_bool(is_bad_mmap(t0));
return C_r;}

/* from k5744 */
static C_word C_fcall stub1427(C_word C_buf,C_word C_a0,C_word C_a1,C_word C_a2,C_word C_a3,C_word C_a4,C_word C_a5) C_regparm;
C_regparm static C_word C_fcall stub1427(C_word C_buf,C_word C_a0,C_word C_a1,C_word C_a2,C_word C_a3,C_word C_a4,C_word C_a5){
C_word C_r=C_SCHEME_UNDEFINED,*C_a=(C_word*)C_buf;
void * t0=(void * )C_c_pointer_or_null(C_a0);
int t1=(int )C_num_to_int(C_a1);
int t2=(int )C_unfix(C_a2);
int t3=(int )C_unfix(C_a3);
int t4=(int )C_unfix(C_a4);
int t5=(int )C_num_to_int(C_a5);
C_r=C_mpointer_or_false(&C_a,(void*)mmap(t0,t1,t2,t3,t4,t5));
return C_r;}

/* from k5306 */
static C_word C_fcall stub1229(C_word C_buf,C_word C_a0,C_word C_a1,C_word C_a2,C_word C_a3,C_word C_a4,C_word C_a5,C_word C_a6,C_word C_a7) C_regparm;
C_regparm static C_word C_fcall stub1229(C_word C_buf,C_word C_a0,C_word C_a1,C_word C_a2,C_word C_a3,C_word C_a4,C_word C_a5,C_word C_a6,C_word C_a7){
C_word C_r=C_SCHEME_UNDEFINED,*C_a=(C_word*)C_buf;
char * t0=(char * )C_string_or_null(C_a0);
char * t1=(char * )C_string_or_null(C_a1);
void * t2=(void * )C_c_pointer_or_null(C_a2);
int *t3=(int *)C_c_pointer_or_null(C_a3);
int *t4=(int *)C_c_pointer_or_null(C_a4);
int *t5=(int *)C_c_pointer_or_null(C_a5);
int *t6=(int *)C_c_pointer_or_null(C_a6);
int t7=(int )C_unfix(C_a7);
C_r=C_mk_bool(C_process(t0,t1,t2,t3,t4,t5,t6,t7));
return C_r;}

/* from k4978 */
static C_word C_fcall stub1125(C_word C_buf,C_word C_a0,C_word C_a1,C_word C_a2) C_regparm;
C_regparm static C_word C_fcall stub1125(C_word C_buf,C_word C_a0,C_word C_a1,C_word C_a2){
C_word C_r=C_SCHEME_UNDEFINED,*C_a=(C_word*)C_buf;
int t0=(int )C_unfix(C_a0);
char * t1=(char * )C_string_or_null(C_a1);
int t2=(int )C_unfix(C_a2);
C_set_exec_env(t0,t1,t2);
return C_r;}

/* from k4957 */
static C_word C_fcall stub1115(C_word C_buf,C_word C_a0,C_word C_a1,C_word C_a2) C_regparm;
C_regparm static C_word C_fcall stub1115(C_word C_buf,C_word C_a0,C_word C_a1,C_word C_a2){
C_word C_r=C_SCHEME_UNDEFINED,*C_a=(C_word*)C_buf;
int t0=(int )C_unfix(C_a0);
char * t1=(char * )C_string_or_null(C_a1);
int t2=(int )C_unfix(C_a2);
C_set_exec_arg(t0,t1,t2);
return C_r;}

/* from k4752 */
static C_word C_fcall stub1060(C_word C_buf,C_word C_a0) C_regparm;
C_regparm static C_word C_fcall stub1060(C_word C_buf,C_word C_a0){
C_word C_r=C_SCHEME_UNDEFINED,*C_a=(C_word*)C_buf;
int t0=(int )C_unfix(C_a0);
_exit(t0);
return C_r;}

#define return(x) C_cblock C_r = (C_mpointer(&C_a,(void*)(x))); goto C_ret; C_cblockend
static C_word C_fcall stub1054(C_word C_buf) C_regparm;
C_regparm static C_word C_fcall stub1054(C_word C_buf){
C_word C_r=C_SCHEME_UNDEFINED,*C_a=(C_word*)C_buf;
char *z = (_daylight ? _tzname[1] : _tzname[0]);
C_return(z);
C_ret:
#undef return

return C_r;}

/* from k4673 */
static C_word C_fcall stub1042(C_word C_buf,C_word C_a0) C_regparm;
C_regparm static C_word C_fcall stub1042(C_word C_buf,C_word C_a0){
C_word C_r=C_SCHEME_UNDEFINED,*C_a=(C_word*)C_buf;
int t0=(int )C_unfix(C_a0);
C_r=C_mpointer(&C_a,(void*)C_getenventry(t0));
return C_r;}

/* from k3442 */
static C_word C_fcall stub526(C_word C_buf,C_word C_a0,C_word C_a1,C_word C_a2) C_regparm;
C_regparm static C_word C_fcall stub526(C_word C_buf,C_word C_a0,C_word C_a1,C_word C_a2){
C_word C_r=C_SCHEME_UNDEFINED,*C_a=(C_word*)C_buf;
C_word t0=(C_word )(C_a0);
C_word t1=(C_word )(C_a1);
void * t2=(void * )C_data_pointer_or_null(C_a2);
C_r=C_mpointer(&C_a,(void*)C_strftime(t0,t1,t2));
return C_r;}

/* from k3429 */
static C_word C_fcall stub516(C_word C_buf,C_word C_a0,C_word C_a1) C_regparm;
C_regparm static C_word C_fcall stub516(C_word C_buf,C_word C_a0,C_word C_a1){
C_word C_r=C_SCHEME_UNDEFINED,*C_a=(C_word*)C_buf;
C_word t0=(C_word )(C_a0);
void * t1=(void * )C_data_pointer_or_null(C_a1);
C_r=C_mpointer(&C_a,(void*)C_asctime(t0,t1));
return C_r;}

/* from k3362 */
static C_word C_fcall stub487(C_word C_buf,C_word C_a0) C_regparm;
C_regparm static C_word C_fcall stub487(C_word C_buf,C_word C_a0){
C_word C_r=C_SCHEME_UNDEFINED,*C_a=(C_word*)C_buf;
int t0=(int )C_num_to_int(C_a0);
C_r=C_mpointer(&C_a,(void*)C_ctime(t0));
return C_r;}

/* from k6209 in k6232 in a6200 in k2231 in k2228 in k2225 in k2222 in k2219 */
static C_word C_fcall stub120(C_word C_buf,C_word C_a0,C_word C_a1) C_regparm;
C_regparm static C_word C_fcall stub120(C_word C_buf,C_word C_a0,C_word C_a1){
C_word C_r=C_SCHEME_UNDEFINED,*C_a=(C_word*)C_buf;
char * t0=(char * )C_string_or_null(C_a0);
C_word t1=(C_word )(C_a1);
C_r=C_fix((C_word)set_file_mtime(t0,t1));
return C_r;}

/* from k2242 */
static C_word C_fcall stub67(C_word C_buf,C_word C_a0) C_regparm;
C_regparm static C_word C_fcall stub67(C_word C_buf,C_word C_a0){
C_word C_r=C_SCHEME_UNDEFINED,*C_a=(C_word*)C_buf;
int t0=(int )C_unfix(C_a0);
C_r=C_mpointer(&C_a,(void*)strerror(t0));
return C_r;}

C_noret_decl(f_4557)
static void C_ccall f_4557(C_word c,C_word t0,C_word t1,C_word t2,...) C_noret;
C_noret_decl(f_4557)
static void C_ccall f_4557r(C_word t0,C_word t1,C_word t2,C_word t4) C_noret;
C_noret_decl(f_4467)
static void C_ccall f_4467(C_word c,C_word t0,C_word t1,C_word t2) C_noret;
C_noret_decl(f_2329)
static void C_ccall f_2329(C_word c,C_word t0,C_word t1,C_word t2) C_noret;
C_noret_decl(f_2327)
static void C_ccall f_2327(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_4321)
static void C_ccall f_4321(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_4583)
static void C_ccall f_4583(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_2757)
static void C_ccall f_2757(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_2751)
static void C_ccall f_2751(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_4461)
static void C_ccall f_4461(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_4465)
static void C_ccall f_4465(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_4589)
static void C_ccall f_4589(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_4712)
static void C_ccall f_4712(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_4314)
static void C_ccall f_4314(C_word c,C_word t0,C_word t1,...) C_noret;
C_noret_decl(f_4314)
static void C_ccall f_4314r(C_word t0,C_word t1,C_word t3) C_noret;
C_noret_decl(f_2965)
static void C_ccall f_2965(C_word c,C_word t0,C_word t1,C_word t2,C_word t3,C_word t4) C_noret;
C_noret_decl(f_2314)
static void C_ccall f_2314(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_4571)
static void C_ccall f_4571(C_word c,C_word t0,C_word t1,C_word t2) C_noret;
C_noret_decl(f_5284)
static void C_ccall f_5284(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_2969)
static void C_ccall f_2969(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_2740)
static void C_ccall f_2740(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_2741)
static void C_fcall f_2741(C_word t0,C_word t1,C_word t2) C_noret;
C_noret_decl(f_5280)
static void C_ccall f_5280(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_4453)
static void C_ccall f_4453(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_4787)
static void C_ccall f_4787(C_word c,C_word t0,C_word t1,C_word t2) C_noret;
C_noret_decl(f_2959)
static void C_ccall f_2959(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_2734)
static void C_ccall f_2734(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_2378)
static void C_ccall f_2378(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_2944)
static void C_fcall f_2944(C_word t0,C_word t1,C_word t2) C_noret;
C_noret_decl(f_4330)
static void C_ccall f_4330(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_4720)
static void C_ccall f_4720(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_4724)
static void C_ccall f_4724(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_2938)
static void C_ccall f_2938(C_word c,C_word t0,C_word t1,...) C_noret;
C_noret_decl(f_2938)
static void C_ccall f_2938r(C_word t0,C_word t1,C_word t3) C_noret;
C_noret_decl(f_4755)
static void C_ccall f_4755(C_word c,C_word t0,C_word t1,...) C_noret;
C_noret_decl(f_4755)
static void C_ccall f_4755r(C_word t0,C_word t1,C_word t3) C_noret;
C_noret_decl(f_2995)
static void C_ccall f_2995(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_2999)
static void C_fcall f_2999(C_word t0,C_word t1,C_word t2) C_noret;
C_noret_decl(f_2778)
static void C_ccall f_2778(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_4775)
static void C_ccall f_4775(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_4769)
static void C_ccall f_4769(C_word c,C_word t0,C_word t1,C_word t2) C_noret;
C_noret_decl(f_2976)
static void C_ccall f_2976(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_2978)
static void C_fcall f_2978(C_word t0,C_word t1,C_word t2) C_noret;
C_noret_decl(f_4794)
static void C_ccall f_4794(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_3779)
static void C_ccall f_3779(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_3772)
static void C_ccall f_3772(C_word c,C_word t0,C_word t1,C_word t2) C_noret;
C_noret_decl(f_4525)
static void C_fcall f_4525(C_word t0,C_word t1,C_word t2,C_word t3) C_noret;
C_noret_decl(f_4529)
static void C_ccall f_4529(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_3754)
static void C_ccall f_3754(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_3742)
static void C_fcall f_3742(C_word t0,C_word t1) C_noret;
C_noret_decl(f_3748)
static void C_ccall f_3748(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_3732)
static void C_ccall f_3732(C_word c,C_word t0,C_word t1,C_word t2,C_word t3,...) C_noret;
C_noret_decl(f_3732)
static void C_ccall f_3732r(C_word t0,C_word t1,C_word t2,C_word t3,C_word t5) C_noret;
C_noret_decl(f_3739)
static void C_ccall f_3739(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_4742)
static void C_ccall f_4742(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_3907)
static void C_ccall f_3907(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_3919)
static void C_fcall f_3919(C_word t0,C_word t1,C_word t2) C_noret;
C_noret_decl(f_3910)
static void C_ccall f_3910(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_3915)
static void C_ccall f_3915(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_4946)
static void C_ccall f_4946(C_word c,C_word t0,C_word t1,C_word t2,C_word t3,C_word t4) C_noret;
C_noret_decl(f_3924)
static void C_ccall f_3924(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_4938)
static void C_ccall f_4938(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_6234)
static void C_ccall f_6234(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_3502)
static void C_ccall f_3502(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_4967)
static void C_ccall f_4967(C_word c,C_word t0,C_word t1,C_word t2,C_word t3,C_word t4) C_noret;
C_noret_decl(f_3510)
static void C_ccall f_3510(C_word c,C_word t0,C_word t1,C_word t2,C_word t3) C_noret;
C_noret_decl(f_3932)
static void C_ccall f_3932(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_6221)
static void C_ccall f_6221(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_4955)
static void C_ccall f_4955(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_3943)
static void C_ccall f_3943(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_6211)
static void C_ccall f_6211(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_4988)
static void C_fcall f_4988(C_word t0,C_word t1,C_word t2,C_word t3,C_word t4) C_noret;
C_noret_decl(f_3338)
static void C_ccall f_3338(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_3334)
static void C_ccall f_3334(C_word c,C_word t0,C_word t1,...) C_noret;
C_noret_decl(f_3334)
static void C_ccall f_3334r(C_word t0,C_word t1,C_word t3) C_noret;
C_noret_decl(f_3105)
static void C_ccall f_3105(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_3108)
static void C_ccall f_3108(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_4976)
static void C_ccall f_4976(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_5707)
static void C_ccall f_5707(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_3317)
static void C_ccall f_3317(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_3313)
static void C_ccall f_3313(C_word c,C_word t0,C_word t1,...) C_noret;
C_noret_decl(f_3313)
static void C_ccall f_3313r(C_word t0,C_word t1,C_word t3) C_noret;
C_noret_decl(f_3792)
static void C_ccall f_3792(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_3064)
static void C_fcall f_3064(C_word t0,C_word t1,C_word t2,C_word t3) C_noret;
C_noret_decl(f_3062)
static void C_ccall f_3062(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_6091)
static void C_ccall f_6091(C_word c,C_word t0,C_word t1,...) C_noret;
C_noret_decl(f_6097)
static void C_ccall f_6097(C_word c,C_word t0,C_word t1,...) C_noret;
C_noret_decl(f_3785)
static void C_ccall f_3785(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_3055)
static void C_fcall f_3055(C_word t0,C_word t1) C_noret;
C_noret_decl(f_3052)
static void C_fcall f_3052(C_word t0,C_word t1) C_noret;
C_noret_decl(f_6085)
static void C_ccall f_6085(C_word c,C_word t0,C_word t1,...) C_noret;
C_noret_decl(f_6079)
static void C_ccall f_6079(C_word c,C_word t0,C_word t1,...) C_noret;
C_noret_decl(f_6073)
static void C_ccall f_6073(C_word c,C_word t0,C_word t1,...) C_noret;
C_noret_decl(f_3039)
static void C_ccall f_3039(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_5516)
static void C_ccall f_5516(C_word c,C_word t0,C_word t1,C_word t2,...) C_noret;
C_noret_decl(f_5516)
static void C_ccall f_5516r(C_word t0,C_word t1,C_word t2,C_word t4) C_noret;
C_noret_decl(f_5514)
static void C_ccall f_5514(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_5510)
static void C_ccall f_5510(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_5775)
static void C_ccall f_5775(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_6201)
static void C_ccall f_6201(C_word c,C_word t0,C_word t1,C_word t2,C_word t3) C_noret;
C_noret_decl(f_3563)
static void C_ccall f_3563(C_word c,C_word t0,C_word t1,C_word t2,C_word t3,C_word t4) C_noret;
C_noret_decl(f_5911)
static void C_ccall f_5911(C_word c,C_word t0,C_word t1,...) C_noret;
C_noret_decl(f_5917)
static void C_ccall f_5917(C_word c,C_word t0,C_word t1,...) C_noret;
C_noret_decl(f_4068)
static void C_ccall f_4068(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_5781)
static void C_fcall f_5781(C_word t0,C_word t1) C_noret;
C_noret_decl(f_4064)
static void C_fcall f_4064(C_word t0,C_word t1,C_word t2,C_word t3) C_noret;
C_noret_decl(f_3365)
static void C_ccall f_3365(C_word c,C_word t0,C_word t1,...) C_noret;
C_noret_decl(f_3365)
static void C_ccall f_3365r(C_word t0,C_word t1,C_word t3) C_noret;
C_noret_decl(f_3369)
static void C_ccall f_3369(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_3083)
static void C_ccall f_3083(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_5923)
static void C_ccall f_5923(C_word c,C_word t0,C_word t1,...) C_noret;
C_noret_decl(f_5929)
static void C_ccall f_5929(C_word c,C_word t0,C_word t1,...) C_noret;
C_noret_decl(f_5576)
static void C_ccall f_5576(C_word c,C_word t0,C_word t1,C_word t2,...) C_noret;
C_noret_decl(f_5576)
static void C_ccall f_5576r(C_word t0,C_word t1,C_word t2,C_word t4) C_noret;
C_noret_decl(f6899)
static void C_ccall f6899(C_word c,C_word t0,C_word t1,C_word t2) C_noret;
C_noret_decl(f_5046)
static void C_ccall f_5046(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_5043)
static void C_ccall f_5043(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_6025)
static void C_ccall f_6025(C_word c,C_word t0,C_word t1,...) C_noret;
C_noret_decl(f_5049)
static void C_ccall f_5049(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_5769)
static void C_ccall f_5769(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_5766)
static void C_fcall f_5766(C_word t0,C_word t1) C_noret;
C_noret_decl(f_5763)
static void C_ccall f_5763(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_4009)
static void C_ccall f_4009(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_4001)
static void C_ccall f_4001(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_5076)
static void C_ccall f_5076(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_5905)
static void C_ccall f_5905(C_word c,C_word t0,C_word t1,...) C_noret;
C_noret_decl(f_5072)
static void C_fcall f_5072(C_word t0,C_word t1,C_word t2,C_word t3,C_word t4) C_noret;
C_noret_decl(f_6013)
static void C_ccall f_6013(C_word c,C_word t0,C_word t1,...) C_noret;
C_noret_decl(f_6019)
static void C_ccall f_6019(C_word c,C_word t0,C_word t1,...) C_noret;
C_noret_decl(f_3375)
static void C_ccall f_3375(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_5063)
static void C_ccall f_5063(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_6007)
static void C_ccall f_6007(C_word c,C_word t0,C_word t1,...) C_noret;
C_noret_decl(f_6001)
static void C_ccall f_6001(C_word c,C_word t0,C_word t1,...) C_noret;
C_noret_decl(f_5019)
static void C_ccall f_5019(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_4096)
static void C_ccall f_4096(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_3704)
static void C_ccall f_3704(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_3701)
static void C_ccall f_3701(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_5087)
static void C_ccall f_5087(C_word c,C_word t0,C_word t1,C_word t2,...) C_noret;
C_noret_decl(f_5087)
static void C_ccall f_5087r(C_word t0,C_word t1,C_word t2,C_word t4) C_noret;
C_noret_decl(f_6061)
static void C_ccall f_6061(C_word c,C_word t0,C_word t1,...) C_noret;
C_noret_decl(f_6067)
static void C_ccall f_6067(C_word c,C_word t0,C_word t1,...) C_noret;
C_noret_decl(f_4044)
static void C_ccall f_4044(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_3713)
static void C_ccall f_3713(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_6055)
static void C_ccall f_6055(C_word c,C_word t0,C_word t1,...) C_noret;
C_noret_decl(f_6043)
static void C_ccall f_6043(C_word c,C_word t0,C_word t1,...) C_noret;
C_noret_decl(f_2800)
static void C_ccall f_2800(C_word c,C_word t0,C_word t1,...) C_noret;
C_noret_decl(f_2800)
static void C_ccall f_2800r(C_word t0,C_word t1,C_word t3) C_noret;
C_noret_decl(f_6049)
static void C_ccall f_6049(C_word c,C_word t0,C_word t1,...) C_noret;
C_noret_decl(f_2804)
static void C_ccall f_2804(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_3557)
static void C_ccall f_3557(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_5052)
static void C_ccall f_5052(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_6037)
static void C_ccall f_6037(C_word c,C_word t0,C_word t1,...) C_noret;
C_noret_decl(f_5059)
static void C_ccall f_5059(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_6031)
static void C_ccall f_6031(C_word c,C_word t0,C_word t1,...) C_noret;
C_noret_decl(f_5759)
static void C_ccall f_5759(C_word c,C_word t0,C_word t1,C_word t2,C_word t3,C_word t4,C_word t5,C_word t6,...) C_noret;
C_noret_decl(f_5759)
static void C_ccall f_5759r(C_word t0,C_word t1,C_word t2,C_word t3,C_word t4,C_word t5,C_word t6,C_word t8) C_noret;
C_noret_decl(f_4103)
static void C_ccall f_4103(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_4082)
static void C_ccall f_4082(C_word c,C_word t0,C_word t1,C_word t2,...) C_noret;
C_noret_decl(f_4082)
static void C_ccall f_4082r(C_word t0,C_word t1,C_word t2,C_word t4) C_noret;
C_noret_decl(f_4080)
static void C_ccall f_4080(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_3533)
static void C_ccall f_3533(C_word c,C_word t0,C_word t1,...) C_noret;
C_noret_decl(f_3533)
static void C_ccall f_3533r(C_word t0,C_word t1,C_word t3) C_noret;
C_noret_decl(f_2819)
static void C_ccall f_2819(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_3525)
static void C_ccall f_3525(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_3527)
static void C_ccall f_3527(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_2615)
static void C_ccall f_2615(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_2843)
static void C_fcall f_2843(C_word t0,C_word t1) C_noret;
C_noret_decl(f_3149)
static void C_ccall f_3149(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_3146)
static void C_ccall f_3146(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_3142)
static void C_ccall f_3142(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_2875)
static void C_ccall f_2875(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_5109)
static void C_ccall f_5109(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_3134)
static void C_ccall f_3134(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_2829)
static void C_ccall f_2829(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_2822)
static void C_ccall f_2822(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_2825)
static void C_ccall f_2825(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_3129)
static void C_ccall f_3129(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_3127)
static void C_ccall f_3127(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_2853)
static void C_ccall f_2853(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_3117)
static void C_ccall f_3117(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_4612)
static void C_fcall f_4612(C_word t0,C_word t1) C_noret;
C_noret_decl(f_5397)
static void C_ccall f_5397(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_5393)
static void C_ccall f_5393(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_3188)
static void C_ccall f_3188(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_4615)
static void C_ccall f_4615(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_3172)
static void C_ccall f_3172(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_3175)
static void C_ccall f_3175(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_2865)
static void C_fcall f_2865(C_word t0,C_word t1) C_noret;
C_noret_decl(f_5370)
static void C_ccall f_5370(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_4605)
static void C_ccall f_4605(C_word c,C_word t0,C_word t1,C_word t2,...) C_noret;
C_noret_decl(f_4605)
static void C_ccall f_4605r(C_word t0,C_word t1,C_word t2,C_word t4) C_noret;
C_noret_decl(f_4603)
static void C_ccall f_4603(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_3162)
static void C_ccall f_3162(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_4811)
static void C_ccall f_4811(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_2624)
static void C_ccall f_2624(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_5382)
static void C_ccall f_5382(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_5389)
static void C_ccall f_5389(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_3156)
static void C_ccall f_3156(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_4650)
static void C_ccall f_4650(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_4652)
static void C_ccall f_4652(C_word c,C_word t0,C_word t1,C_word t2) C_noret;
C_noret_decl(f_2690)
static void C_ccall f_2690(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_5959)
static void C_ccall f_5959(C_word c,C_word t0,C_word t1,...) C_noret;
C_noret_decl(f_5953)
static void C_ccall f_5953(C_word c,C_word t0,C_word t1,...) C_noret;
C_noret_decl(f_2687)
static void C_ccall f_2687(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_5965)
static void C_ccall f_5965(C_word c,C_word t0,C_word t1,...) C_noret;
C_noret_decl(f_2674)
static void C_ccall f_2674(C_word c,C_word t0,C_word t1,...) C_noret;
C_noret_decl(f_2674)
static void C_ccall f_2674r(C_word t0,C_word t1,C_word t3) C_noret;
C_noret_decl(f_5154)
static void C_ccall f_5154(C_word c,C_word t0,C_word t1,C_word t2,C_word t3,...) C_noret;
C_noret_decl(f_5154)
static void C_ccall f_5154r(C_word t0,C_word t1,C_word t2,C_word t3,C_word t5) C_noret;
C_noret_decl(f_4646)
static void C_ccall f_4646(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_5935)
static void C_ccall f_5935(C_word c,C_word t0,C_word t1,...) C_noret;
C_noret_decl(f_3181)
static void C_ccall f_3181(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_4664)
static void C_ccall f_4664(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f6911)
static void C_ccall f6911(C_word c,C_word t0,C_word t1,C_word t2) C_noret;
C_noret_decl(f_4660)
static void C_ccall f_4660(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_5941)
static void C_ccall f_5941(C_word c,C_word t0,C_word t1,...) C_noret;
C_noret_decl(f_5947)
static void C_ccall f_5947(C_word c,C_word t0,C_word t1,...) C_noret;
C_noret_decl(f_4676)
static void C_ccall f_4676(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_3011)
static void C_ccall f_3011(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_3194)
static void C_ccall f_3194(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_4808)
static void C_fcall f_4808(C_word t0,C_word t1) C_noret;
C_noret_decl(f_4162)
static void C_ccall f_4162(C_word c,C_word t0,C_word t1,C_word t2) C_noret;
C_noret_decl(f_3019)
static void C_ccall f_3019(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_4169)
static void C_ccall f_4169(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_4802)
static void C_ccall f_4802(C_word c,C_word t0,C_word t1,C_word t2,C_word t3,...) C_noret;
C_noret_decl(f_4802)
static void C_ccall f_4802r(C_word t0,C_word t1,C_word t2,C_word t3,C_word t5) C_noret;
C_noret_decl(f_4694)
static void C_fcall f_4694(C_word t0,C_word t1,C_word t2) C_noret;
C_noret_decl(f_5995)
static void C_ccall f_5995(C_word c,C_word t0,C_word t1,...) C_noret;
C_noret_decl(f_4153)
static void C_ccall f_4153(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_3007)
static void C_ccall f_3007(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_4682)
static void C_fcall f_4682(C_word t0,C_word t1,C_word t2) C_noret;
C_noret_decl(f_4820)
static void C_fcall f_4820(C_word t0,C_word t1) C_noret;
C_noret_decl(f_5971)
static void C_ccall f_5971(C_word c,C_word t0,C_word t1,...) C_noret;
C_noret_decl(f_5977)
static void C_ccall f_5977(C_word c,C_word t0,C_word t1,...) C_noret;
C_noret_decl(f_4686)
static void C_ccall f_4686(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_5983)
static void C_ccall f_5983(C_word c,C_word t0,C_word t1,...) C_noret;
C_noret_decl(f_5989)
static void C_ccall f_5989(C_word c,C_word t0,C_word t1,...) C_noret;
C_noret_decl(f_4027)
static void C_ccall f_4027(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_5352)
static void C_ccall f_5352(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_4020)
static void C_ccall f_4020(C_word c,C_word t0,C_word t1,C_word t2) C_noret;
C_noret_decl(f_4190)
static void C_ccall f_4190(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_4198)
static void C_ccall f_4198(C_word c,C_word t0,C_word t1,C_word t2,C_word t3,...) C_noret;
C_noret_decl(f_4198)
static void C_ccall f_4198r(C_word t0,C_word t1,C_word t2,C_word t3,C_word t5) C_noret;
C_noret_decl(f_5362)
static void C_ccall f_5362(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_5366)
static void C_ccall f_5366(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_5000)
static void C_fcall f_5000(C_word t0,C_word t1,C_word t2,C_word t3) C_noret;
C_noret_decl(f_4869)
static void C_fcall f_4869(C_word t0,C_word t1,C_word t2) C_noret;
C_noret_decl(f_4143)
static void C_ccall f_4143(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_5338)
static void C_ccall f_5338(C_word c,C_word t0,C_word t1,C_word t2,C_word t3,C_word t4,C_word t5,C_word t6,C_word t7,C_word t8,...) C_noret;
C_noret_decl(f_5338)
static void C_ccall f_5338r(C_word t0,C_word t1,C_word t2,C_word t3,C_word t4,C_word t5,C_word t6,C_word t7,C_word t8,C_word t10) C_noret;
C_noret_decl(f_5036)
static void C_fcall f_5036(C_word t0,C_word t1,C_word t2,C_word t3,C_word t4,C_word t5,C_word t6) C_noret;
C_noret_decl(f_4036)
static void C_ccall f_4036(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_4136)
static void C_ccall f_4136(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_5345)
static void C_ccall f_5345(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_4030)
static void C_ccall f_4030(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_2657)
static void C_ccall f_2657(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_4883)
static C_word C_fcall f_4883(C_word t0,C_word t1);
C_noret_decl(f_2654)
static void C_fcall f_2654(C_word t0,C_word t1) C_noret;
C_noret_decl(f_2647)
static void C_ccall f_2647(C_word c,C_word t0,C_word t1,C_word t2,...) C_noret;
C_noret_decl(f_2647)
static void C_ccall f_2647r(C_word t0,C_word t1,C_word t2,C_word t4) C_noret;
C_noret_decl(f_2641)
static void C_ccall f_2641(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_4180)
static void C_ccall f_4180(C_word c,C_word t0,C_word t1,C_word t2) C_noret;
C_noret_decl(f_4187)
static void C_ccall f_4187(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_4635)
static void C_ccall f_4635(C_word c,C_word t0,C_word t1,C_word t2,C_word t3) C_noret;
C_noret_decl(f_4172)
static void C_ccall f_4172(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_4621)
static void C_ccall f_4621(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_4122)
static void C_ccall f_4122(C_word c,C_word t0,C_word t1,C_word t2,...) C_noret;
C_noret_decl(f_4122)
static void C_ccall f_4122r(C_word t0,C_word t1,C_word t2,C_word t4) C_noret;
C_noret_decl(f_5176)
static void C_ccall f_5176(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_4113)
static void C_ccall f_4113(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f6917)
static void C_ccall f6917(C_word c,C_word t0,C_word t1,C_word t2) C_noret;
C_noret_decl(f_3852)
static void C_ccall f_3852(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_3858)
static void C_ccall f_3858(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_3843)
static void C_fcall f_3843(C_word t0,C_word t1) C_noret;
C_noret_decl(f_6155)
static void C_ccall f_6155(C_word c,C_word t0,C_word t1,C_word t2) C_noret;
C_noret_decl(f6905)
static void C_ccall f6905(C_word c,C_word t0,C_word t1,C_word t2) C_noret;
C_noret_decl(f_3864)
static void C_ccall f_3864(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_3976)
static void C_ccall f_3976(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_3951)
static void C_ccall f_3951(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_6164)
static void C_ccall f_6164(C_word c,C_word t0,C_word t1,...) C_noret;
C_noret_decl(f_6164)
static void C_ccall f_6164r(C_word t0,C_word t1,C_word t3) C_noret;
C_noret_decl(f_3966)
static void C_fcall f_3966(C_word t0,C_word t1,C_word t2) C_noret;
C_noret_decl(f_6114)
static void C_ccall f_6114(C_word c,C_word t0,C_word t1,C_word t2) C_noret;
C_noret_decl(f_6118)
static void C_ccall f_6118(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_3839)
static void C_ccall f_3839(C_word c,C_word t0,C_word t1,C_word t2,C_word t3,...) C_noret;
C_noret_decl(f_3839)
static void C_ccall f_3839r(C_word t0,C_word t1,C_word t2,C_word t3,C_word t5) C_noret;
C_noret_decl(f_6104)
static void C_ccall f_6104(C_word c,C_word t0,C_word t1,C_word t2) C_noret;
C_noret_decl(f_6130)
static void C_ccall f_6130(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_6121)
static void C_ccall f_6121(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_5815)
static void C_ccall f_5815(C_word c,C_word t0,C_word t1,C_word t2,...) C_noret;
C_noret_decl(f_5815)
static void C_ccall f_5815r(C_word t0,C_word t1,C_word t2,C_word t4) C_noret;
C_noret_decl(f_3897)
static void C_ccall f_3897(C_word c,C_word t0,C_word t1,C_word t2,...) C_noret;
C_noret_decl(f_3897)
static void C_ccall f_3897r(C_word t0,C_word t1,C_word t2,C_word t4) C_noret;
C_noret_decl(f_3895)
static void C_ccall f_3895(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_6195)
static void C_ccall f_6195(C_word c,C_word t0,C_word t1,C_word t2) C_noret;
C_noret_decl(f_6199)
static void C_ccall f_6199(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_3448)
static void C_ccall f_3448(C_word c,C_word t0,C_word t1,C_word t2,...) C_noret;
C_noret_decl(f_3448)
static void C_ccall f_3448r(C_word t0,C_word t1,C_word t2,C_word t4) C_noret;
C_noret_decl(f_5822)
static void C_fcall f_5822(C_word t0,C_word t1) C_noret;
C_noret_decl(f_6189)
static void C_ccall f_6189(C_word c,C_word t0,C_word t1,C_word t2) C_noret;
C_noret_decl(f_3698)
static void C_ccall f_3698(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_3802)
static void C_ccall f_3802(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_3201)
static void C_ccall f_3201(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_5887)
static void C_ccall f_5887(C_word c,C_word t0,C_word t1,...) C_noret;
C_noret_decl(f_5881)
static void C_ccall f_5881(C_word c,C_word t0,C_word t1,...) C_noret;
C_noret_decl(f_3208)
static void C_ccall f_3208(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_3688)
static void C_ccall f_3688(C_word c,C_word t0,C_word t1,C_word t2,C_word t3,...) C_noret;
C_noret_decl(f_3688)
static void C_ccall f_3688r(C_word t0,C_word t1,C_word t2,C_word t3,C_word t5) C_noret;
C_noret_decl(f_3682)
static void C_ccall f_3682(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_5893)
static void C_ccall f_5893(C_word c,C_word t0,C_word t1,...) C_noret;
C_noret_decl(f_3634)
static void C_fcall f_3634(C_word t0,C_word t1) C_noret;
C_noret_decl(f_3630)
static void C_ccall f_3630(C_word c,C_word t0,C_word t1,C_word t2,C_word t3,...) C_noret;
C_noret_decl(f_3630)
static void C_ccall f_3630r(C_word t0,C_word t1,C_word t2,C_word t3,C_word t5) C_noret;
C_noret_decl(f_5899)
static void C_ccall f_5899(C_word c,C_word t0,C_word t1,...) C_noret;
C_noret_decl(f_5863)
static void C_ccall f_5863(C_word c,C_word t0,C_word t1,...) C_noret;
C_noret_decl(f_5869)
static void C_ccall f_5869(C_word c,C_word t0,C_word t1,...) C_noret;
C_noret_decl(f_5875)
static void C_ccall f_5875(C_word c,C_word t0,C_word t1,...) C_noret;
C_noret_decl(f_5654)
static void C_ccall f_5654(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_3656)
static void C_ccall f_3656(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_3650)
static void C_ccall f_3650(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_5666)
static void C_ccall f_5666(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_3455)
static void C_ccall f_3455(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_3647)
static void C_ccall f_3647(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_3403)
static void C_ccall f_3403(C_word c,C_word t0,C_word t1,C_word t2) C_noret;
C_noret_decl(f_3407)
static void C_ccall f_3407(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_5636)
static void C_ccall f_5636(C_word c,C_word t0,C_word t1,C_word t2,C_word t3) C_noret;
C_noret_decl(f_5648)
static void C_ccall f_5648(C_word c,C_word t0,C_word t1,C_word t2) C_noret;
C_noret_decl(f_3474)
static void C_ccall f_3474(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_3478)
static void C_ccall f_3478(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(C_posix_toplevel)
C_externexport void C_ccall C_posix_toplevel(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_4207)
static void C_ccall f_4207(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_5697)
static void C_ccall f_5697(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_5692)
static void C_ccall f_5692(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_3464)
static void C_ccall f_3464(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_3417)
static void C_ccall f_3417(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_3411)
static void C_ccall f_3411(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_3810)
static void C_ccall f_3810(C_word c,C_word t0,C_word t1,C_word t2) C_noret;
C_noret_decl(f_5677)
static void C_ccall f_5677(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_3481)
static void C_ccall f_3481(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_5685)
static void C_ccall f_5685(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_5681)
static void C_ccall f_5681(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_2466)
static void C_ccall f_2466(C_word c,C_word t0,C_word t1,C_word t2) C_noret;
C_noret_decl(f_2464)
static void C_ccall f_2464(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_5689)
static void C_ccall f_5689(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_2456)
static void C_ccall f_2456(C_word c,C_word t0,C_word t1,C_word t2) C_noret;
C_noret_decl(f_2454)
static void C_ccall f_2454(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_3227)
static void C_ccall f_3227(C_word c,C_word t0,C_word t1,...) C_noret;
C_noret_decl(f_5848)
static void C_ccall f_5848(C_word c,C_word t0,C_word t1,C_word t2) C_noret;
C_noret_decl(f_3219)
static void C_ccall f_3219(C_word c,C_word t0,C_word t1,C_word t2) C_noret;
C_noret_decl(f_3218)
static void C_ccall f_3218(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_5857)
static void C_ccall f_5857(C_word c,C_word t0,C_word t1,C_word t2) C_noret;
C_noret_decl(f_3245)
static void C_ccall f_3245(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_3248)
static void C_ccall f_3248(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_3241)
static void C_ccall f_3241(C_word c,C_word t0,C_word t1,C_word t2,...) C_noret;
C_noret_decl(f_3241)
static void C_ccall f_3241r(C_word t0,C_word t1,C_word t2,C_word t4) C_noret;
C_noret_decl(f_3669)
static void C_ccall f_3669(C_word c,C_word t0,C_word t1,C_word t2) C_noret;
C_noret_decl(f_2504)
static void C_ccall f_2504(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_3663)
static void C_ccall f_3663(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_2506)
static void C_ccall f_2506(C_word c,C_word t0,C_word t1,C_word t2) C_noret;
C_noret_decl(f_2494)
static void C_ccall f_2494(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_2496)
static void C_ccall f_2496(C_word c,C_word t0,C_word t1,C_word t2) C_noret;
C_noret_decl(f_2302)
static void C_ccall f_2302(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_2307)
static void C_ccall f_2307(C_word c,C_word t0,C_word t1,C_word t2,...) C_noret;
C_noret_decl(f_2307)
static void C_ccall f_2307r(C_word t0,C_word t1,C_word t2,C_word t4) C_noret;
C_noret_decl(f_2291)
static void C_ccall f_2291(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_2298)
static void C_ccall f_2298(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_2519)
static void C_fcall f_2519(C_word t0,C_word t1,C_word t2,C_word t3) C_noret;
C_noret_decl(f_2514)
static void C_ccall f_2514(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_3274)
static void C_ccall f_3274(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_3277)
static void C_ccall f_3277(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_3279)
static void C_ccall f_3279(C_word c,C_word t0,C_word t1,C_word t2,C_word t3) C_noret;
C_noret_decl(f_3271)
static void C_ccall f_3271(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_2267)
static void C_ccall f_2267(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_4260)
static void C_ccall f_4260(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_2260)
static void C_ccall f_2260(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_2263)
static void C_fcall f_2263(C_word t0,C_word t1,C_word t2,C_word t3,C_word t4) C_noret;
C_noret_decl(f_2527)
static void C_ccall f_2527(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_5475)
static void C_ccall f_5475(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_5478)
static void C_ccall f_5478(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_2446)
static void C_ccall f_2446(C_word c,C_word t0,C_word t1,C_word t2) C_noret;
C_noret_decl(f_4250)
static void C_ccall f_4250(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_4255)
static void C_ccall f_4255(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_3294)
static void C_fcall f_3294(C_word t0,C_word t1,C_word t2) C_noret;
C_noret_decl(f_4266)
static void C_ccall f_4266(C_word c,C_word t0,C_word t1,...) C_noret;
C_noret_decl(f_4266)
static void C_ccall f_4266r(C_word t0,C_word t1,C_word t3) C_noret;
C_noret_decl(f_3292)
static void C_ccall f_3292(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_2556)
static void C_fcall f_2556(C_word t0,C_word t1,C_word t2,C_word t3,C_word t4) C_noret;
C_noret_decl(f_5483)
static void C_ccall f_5483(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_5489)
static void C_ccall f_5489(C_word c,C_word t0,C_word t1,C_word t2,C_word t3,C_word t4,C_word t5) C_noret;
C_noret_decl(f_4280)
static void C_ccall f_4280(C_word c,C_word t0,C_word t1,C_word t2,C_word t3,...) C_noret;
C_noret_decl(f_4280)
static void C_ccall f_4280r(C_word t0,C_word t1,C_word t2,C_word t3,C_word t5) C_noret;
C_noret_decl(f_4284)
static void C_ccall f_4284(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_2908)
static void C_ccall f_2908(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_2585)
static void C_ccall f_2585(C_word c,C_word t0,C_word t1,C_word t2,...) C_noret;
C_noret_decl(f_2585)
static void C_ccall f_2585r(C_word t0,C_word t1,C_word t2,C_word t4) C_noret;
C_noret_decl(f_2583)
static void C_ccall f_2583(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_3235)
static void C_ccall f_3235(C_word c,C_word t0,C_word t1,...) C_noret;
C_noret_decl(f_3265)
static void C_ccall f_3265(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_3268)
static void C_ccall f_3268(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_3260)
static void C_ccall f_3260(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_4488)
static void C_fcall f_4488(C_word t0,C_word t1,C_word t2,C_word t3) C_noret;
C_noret_decl(f_2569)
static void C_ccall f_2569(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_2486)
static void C_ccall f_2486(C_word c,C_word t0,C_word t1,C_word t2) C_noret;
C_noret_decl(f_5252)
static void C_fcall f_5252(C_word t0,C_word t1) C_noret;
C_noret_decl(f_2484)
static void C_ccall f_2484(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_4294)
static void C_ccall f_4294(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_3254)
static void C_ccall f_3254(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_3257)
static void C_ccall f_3257(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_3251)
static void C_ccall f_3251(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_4479)
static void C_ccall f_4479(C_word c,C_word t0,C_word t1,C_word t2) C_noret;
C_noret_decl(f_2599)
static void C_ccall f_2599(C_word c,C_word t0,C_word t1,C_word t2) C_noret;
C_noret_decl(f_2597)
static void C_ccall f_2597(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_2476)
static void C_ccall f_2476(C_word c,C_word t0,C_word t1,C_word t2) C_noret;
C_noret_decl(f_5265)
static void C_ccall f_5265(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_2474)
static void C_ccall f_2474(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_5269)
static void C_ccall f_5269(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_4473)
static void C_ccall f_4473(C_word c,C_word t0,C_word t1,C_word t2) C_noret;
C_noret_decl(f_3285)
static void C_ccall f_3285(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_3287)
static void C_ccall f_3287(C_word c,C_word t0,C_word t1,...) C_noret;
C_noret_decl(f_4231)
static void C_ccall f_4231(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_4246)
static void C_ccall f_4246(C_word c,C_word t0,C_word t1,C_word t2,C_word t3,...) C_noret;
C_noret_decl(f_4246)
static void C_ccall f_4246r(C_word t0,C_word t1,C_word t2,C_word t3,C_word t5) C_noret;
C_noret_decl(f_2357)
static void C_ccall f_2357(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_2359)
static void C_ccall f_2359(C_word c,C_word t0,C_word t1,C_word t2,...) C_noret;
C_noret_decl(f_2359)
static void C_ccall f_2359r(C_word t0,C_word t1,C_word t2,C_word t4) C_noret;
C_noret_decl(f_2571)
static void C_ccall f_2571(C_word c,C_word t0,C_word t1,C_word t2,...) C_noret;
C_noret_decl(f_2571)
static void C_ccall f_2571r(C_word t0,C_word t1,C_word t2,C_word t4) C_noret;
C_noret_decl(f_2351)
static void C_ccall f_2351(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_2353)
static void C_ccall f_2353(C_word c,C_word t0,C_word t1,C_word t2) C_noret;
C_noret_decl(f_5421)
static void C_ccall f_5421(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_4496)
static void C_ccall f_4496(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_4237)
static void C_ccall f_4237(C_word c,C_word t0,C_word t1,...) C_noret;
C_noret_decl(f_4237)
static void C_ccall f_4237r(C_word t0,C_word t1,C_word t3) C_noret;
C_noret_decl(f_2256)
static void C_ccall f_2256(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_5401)
static void C_ccall f_5401(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_5405)
static void C_ccall f_5405(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_4202)
static void C_ccall f_4202(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_2249)
static void C_ccall f_2249(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_2245)
static void C_ccall f_2245(C_word c,C_word t0,C_word t1,C_word t2,C_word t3,C_word t4,...) C_noret;
C_noret_decl(f_2245)
static void C_ccall f_2245r(C_word t0,C_word t1,C_word t2,C_word t3,C_word t4,C_word t6) C_noret;
C_noret_decl(f_4270)
static void C_ccall f_4270(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_4275)
static void C_ccall f_4275(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_2233)
static void C_ccall f_2233(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_2230)
static void C_ccall f_2230(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_4289)
static void C_ccall f_4289(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_2227)
static void C_ccall f_2227(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_4222)
static void C_ccall f_4222(C_word c,C_word t0,C_word t1,C_word t2,C_word t3,...) C_noret;
C_noret_decl(f_4222)
static void C_ccall f_4222r(C_word t0,C_word t1,C_word t2,C_word t3,C_word t5) C_noret;
C_noret_decl(f_2224)
static void C_ccall f_2224(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_2221)
static void C_ccall f_2221(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_5432)
static void C_fcall f_5432(C_word t0,C_word t1,C_word t2,C_word t3,C_word t4,C_word t5,C_word t6) C_noret;
C_noret_decl(f_5434)
static void C_fcall f_5434(C_word t0,C_word t1,C_word t2) C_noret;
C_noret_decl(f_4213)
static void C_ccall f_4213(C_word c,C_word t0,C_word t1,...) C_noret;
C_noret_decl(f_4213)
static void C_ccall f_4213r(C_word t0,C_word t1,C_word t3) C_noret;
C_noret_decl(f_4226)
static void C_ccall f_4226(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_5439)
static C_word C_fcall f_5439(C_word t0,C_word t1);
C_noret_decl(f_5448)
static C_word C_fcall f_5448(C_word t0,C_word t1);
C_noret_decl(f_4241)
static void C_ccall f_4241(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_4217)
static void C_ccall f_4217(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_4429)
static void C_ccall f_4429(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_4541)
static void C_ccall f_4541(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_4543)
static void C_ccall f_4543(C_word c,C_word t0,C_word t1,C_word t2,...) C_noret;
C_noret_decl(f_4543)
static void C_ccall f_4543r(C_word t0,C_word t1,C_word t2,C_word t4) C_noret;
C_noret_decl(f_5237)
static void C_ccall f_5237(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_2718)
static void C_ccall f_2718(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_2714)
static void C_fcall f_2714(C_word t0,C_word t1) C_noret;
C_noret_decl(f_5248)
static void C_ccall f_5248(C_word c,C_word t0,C_word t1,C_word t2,...) C_noret;
C_noret_decl(f_5248)
static void C_ccall f_5248r(C_word t0,C_word t1,C_word t2,C_word t4) C_noret;
C_noret_decl(f_5242)
static void C_ccall f_5242(C_word c,C_word t0,C_word t1,C_word t2) C_noret;
C_noret_decl(f_4413)
static void C_ccall f_4413(C_word c,C_word t0,C_word t1,C_word t2,C_word t3) C_noret;
C_noret_decl(f_2708)
static void C_ccall f_2708(C_word c,C_word t0,C_word t1,C_word t2,...) C_noret;
C_noret_decl(f_2708)
static void C_ccall f_2708r(C_word t0,C_word t1,C_word t2,C_word t4) C_noret;
C_noret_decl(f_4304)
static void C_ccall f_4304(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_2347)
static void C_ccall f_2347(C_word c,C_word t0,C_word t1,C_word t2) C_noret;
C_noret_decl(f_2345)
static void C_ccall f_2345(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_4309)
static void C_ccall f_4309(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_2341)
static void C_ccall f_2341(C_word c,C_word t0,C_word t1,C_word t2) C_noret;
C_noret_decl(f_4441)
static void C_ccall f_4441(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_4443)
static void C_fcall f_4443(C_word t0,C_word t1,C_word t2,C_word t3) C_noret;
C_noret_decl(f_4300)
static void C_ccall f_4300(C_word c,C_word t0,C_word t1,...) C_noret;
C_noret_decl(f_4300)
static void C_ccall f_4300r(C_word t0,C_word t1,C_word t3) C_noret;
C_noret_decl(f_4912)
static void C_fcall f_4912(C_word t0,C_word t1,C_word t2,C_word t3) C_noret;
C_noret_decl(f_4569)
static void C_ccall f_4569(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_4437)
static void C_ccall f_4437(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_2339)
static void C_ccall f_2339(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_2335)
static void C_ccall f_2335(C_word c,C_word t0,C_word t1,C_word t2) C_noret;
C_noret_decl(f_2333)
static void C_ccall f_2333(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_4555)
static void C_ccall f_4555(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_2768)
static void C_fcall f_2768(C_word t0,C_word t1,C_word t2) C_noret;
C_noret_decl(f_5225)
static void C_ccall f_5225(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_2763)
static void C_ccall f_2763(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_5221)
static void C_ccall f_5221(C_word c,C_word t0,C_word t1) C_noret;

C_noret_decl(trf_2741)
static void C_fcall trf_2741(void *dummy) C_regparm C_noret;
C_regparm static void C_fcall trf_2741(void *dummy){
C_word t2=C_pick(0);
C_word t1=C_pick(1);
C_word t0=C_pick(2);
C_adjust_stack(-3);
f_2741(t0,t1,t2);}

C_noret_decl(trf_2944)
static void C_fcall trf_2944(void *dummy) C_regparm C_noret;
C_regparm static void C_fcall trf_2944(void *dummy){
C_word t2=C_pick(0);
C_word t1=C_pick(1);
C_word t0=C_pick(2);
C_adjust_stack(-3);
f_2944(t0,t1,t2);}

C_noret_decl(trf_2999)
static void C_fcall trf_2999(void *dummy) C_regparm C_noret;
C_regparm static void C_fcall trf_2999(void *dummy){
C_word t2=C_pick(0);
C_word t1=C_pick(1);
C_word t0=C_pick(2);
C_adjust_stack(-3);
f_2999(t0,t1,t2);}

C_noret_decl(trf_2978)
static void C_fcall trf_2978(void *dummy) C_regparm C_noret;
C_regparm static void C_fcall trf_2978(void *dummy){
C_word t2=C_pick(0);
C_word t1=C_pick(1);
C_word t0=C_pick(2);
C_adjust_stack(-3);
f_2978(t0,t1,t2);}

C_noret_decl(trf_4525)
static void C_fcall trf_4525(void *dummy) C_regparm C_noret;
C_regparm static void C_fcall trf_4525(void *dummy){
C_word t3=C_pick(0);
C_word t2=C_pick(1);
C_word t1=C_pick(2);
C_word t0=C_pick(3);
C_adjust_stack(-4);
f_4525(t0,t1,t2,t3);}

C_noret_decl(trf_3742)
static void C_fcall trf_3742(void *dummy) C_regparm C_noret;
C_regparm static void C_fcall trf_3742(void *dummy){
C_word t1=C_pick(0);
C_word t0=C_pick(1);
C_adjust_stack(-2);
f_3742(t0,t1);}

C_noret_decl(trf_3919)
static void C_fcall trf_3919(void *dummy) C_regparm C_noret;
C_regparm static void C_fcall trf_3919(void *dummy){
C_word t2=C_pick(0);
C_word t1=C_pick(1);
C_word t0=C_pick(2);
C_adjust_stack(-3);
f_3919(t0,t1,t2);}

C_noret_decl(trf_4988)
static void C_fcall trf_4988(void *dummy) C_regparm C_noret;
C_regparm static void C_fcall trf_4988(void *dummy){
C_word t4=C_pick(0);
C_word t3=C_pick(1);
C_word t2=C_pick(2);
C_word t1=C_pick(3);
C_word t0=C_pick(4);
C_adjust_stack(-5);
f_4988(t0,t1,t2,t3,t4);}

C_noret_decl(trf_3064)
static void C_fcall trf_3064(void *dummy) C_regparm C_noret;
C_regparm static void C_fcall trf_3064(void *dummy){
C_word t3=C_pick(0);
C_word t2=C_pick(1);
C_word t1=C_pick(2);
C_word t0=C_pick(3);
C_adjust_stack(-4);
f_3064(t0,t1,t2,t3);}

C_noret_decl(trf_3055)
static void C_fcall trf_3055(void *dummy) C_regparm C_noret;
C_regparm static void C_fcall trf_3055(void *dummy){
C_word t1=C_pick(0);
C_word t0=C_pick(1);
C_adjust_stack(-2);
f_3055(t0,t1);}

C_noret_decl(trf_3052)
static void C_fcall trf_3052(void *dummy) C_regparm C_noret;
C_regparm static void C_fcall trf_3052(void *dummy){
C_word t1=C_pick(0);
C_word t0=C_pick(1);
C_adjust_stack(-2);
f_3052(t0,t1);}

C_noret_decl(trf_5781)
static void C_fcall trf_5781(void *dummy) C_regparm C_noret;
C_regparm static void C_fcall trf_5781(void *dummy){
C_word t1=C_pick(0);
C_word t0=C_pick(1);
C_adjust_stack(-2);
f_5781(t0,t1);}

C_noret_decl(trf_4064)
static void C_fcall trf_4064(void *dummy) C_regparm C_noret;
C_regparm static void C_fcall trf_4064(void *dummy){
C_word t3=C_pick(0);
C_word t2=C_pick(1);
C_word t1=C_pick(2);
C_word t0=C_pick(3);
C_adjust_stack(-4);
f_4064(t0,t1,t2,t3);}

C_noret_decl(trf_5766)
static void C_fcall trf_5766(void *dummy) C_regparm C_noret;
C_regparm static void C_fcall trf_5766(void *dummy){
C_word t1=C_pick(0);
C_word t0=C_pick(1);
C_adjust_stack(-2);
f_5766(t0,t1);}

C_noret_decl(trf_5072)
static void C_fcall trf_5072(void *dummy) C_regparm C_noret;
C_regparm static void C_fcall trf_5072(void *dummy){
C_word t4=C_pick(0);
C_word t3=C_pick(1);
C_word t2=C_pick(2);
C_word t1=C_pick(3);
C_word t0=C_pick(4);
C_adjust_stack(-5);
f_5072(t0,t1,t2,t3,t4);}

C_noret_decl(trf_2843)
static void C_fcall trf_2843(void *dummy) C_regparm C_noret;
C_regparm static void C_fcall trf_2843(void *dummy){
C_word t1=C_pick(0);
C_word t0=C_pick(1);
C_adjust_stack(-2);
f_2843(t0,t1);}

C_noret_decl(trf_4612)
static void C_fcall trf_4612(void *dummy) C_regparm C_noret;
C_regparm static void C_fcall trf_4612(void *dummy){
C_word t1=C_pick(0);
C_word t0=C_pick(1);
C_adjust_stack(-2);
f_4612(t0,t1);}

C_noret_decl(trf_2865)
static void C_fcall trf_2865(void *dummy) C_regparm C_noret;
C_regparm static void C_fcall trf_2865(void *dummy){
C_word t1=C_pick(0);
C_word t0=C_pick(1);
C_adjust_stack(-2);
f_2865(t0,t1);}

C_noret_decl(trf_4808)
static void C_fcall trf_4808(void *dummy) C_regparm C_noret;
C_regparm static void C_fcall trf_4808(void *dummy){
C_word t1=C_pick(0);
C_word t0=C_pick(1);
C_adjust_stack(-2);
f_4808(t0,t1);}

C_noret_decl(trf_4694)
static void C_fcall trf_4694(void *dummy) C_regparm C_noret;
C_regparm static void C_fcall trf_4694(void *dummy){
C_word t2=C_pick(0);
C_word t1=C_pick(1);
C_word t0=C_pick(2);
C_adjust_stack(-3);
f_4694(t0,t1,t2);}

C_noret_decl(trf_4682)
static void C_fcall trf_4682(void *dummy) C_regparm C_noret;
C_regparm static void C_fcall trf_4682(void *dummy){
C_word t2=C_pick(0);
C_word t1=C_pick(1);
C_word t0=C_pick(2);
C_adjust_stack(-3);
f_4682(t0,t1,t2);}

C_noret_decl(trf_4820)
static void C_fcall trf_4820(void *dummy) C_regparm C_noret;
C_regparm static void C_fcall trf_4820(void *dummy){
C_word t1=C_pick(0);
C_word t0=C_pick(1);
C_adjust_stack(-2);
f_4820(t0,t1);}

C_noret_decl(trf_5000)
static void C_fcall trf_5000(void *dummy) C_regparm C_noret;
C_regparm static void C_fcall trf_5000(void *dummy){
C_word t3=C_pick(0);
C_word t2=C_pick(1);
C_word t1=C_pick(2);
C_word t0=C_pick(3);
C_adjust_stack(-4);
f_5000(t0,t1,t2,t3);}

C_noret_decl(trf_4869)
static void C_fcall trf_4869(void *dummy) C_regparm C_noret;
C_regparm static void C_fcall trf_4869(void *dummy){
C_word t2=C_pick(0);
C_word t1=C_pick(1);
C_word t0=C_pick(2);
C_adjust_stack(-3);
f_4869(t0,t1,t2);}

C_noret_decl(trf_5036)
static void C_fcall trf_5036(void *dummy) C_regparm C_noret;
C_regparm static void C_fcall trf_5036(void *dummy){
C_word t6=C_pick(0);
C_word t5=C_pick(1);
C_word t4=C_pick(2);
C_word t3=C_pick(3);
C_word t2=C_pick(4);
C_word t1=C_pick(5);
C_word t0=C_pick(6);
C_adjust_stack(-7);
f_5036(t0,t1,t2,t3,t4,t5,t6);}

C_noret_decl(trf_2654)
static void C_fcall trf_2654(void *dummy) C_regparm C_noret;
C_regparm static void C_fcall trf_2654(void *dummy){
C_word t1=C_pick(0);
C_word t0=C_pick(1);
C_adjust_stack(-2);
f_2654(t0,t1);}

C_noret_decl(trf_3843)
static void C_fcall trf_3843(void *dummy) C_regparm C_noret;
C_regparm static void C_fcall trf_3843(void *dummy){
C_word t1=C_pick(0);
C_word t0=C_pick(1);
C_adjust_stack(-2);
f_3843(t0,t1);}

C_noret_decl(trf_3966)
static void C_fcall trf_3966(void *dummy) C_regparm C_noret;
C_regparm static void C_fcall trf_3966(void *dummy){
C_word t2=C_pick(0);
C_word t1=C_pick(1);
C_word t0=C_pick(2);
C_adjust_stack(-3);
f_3966(t0,t1,t2);}

C_noret_decl(trf_5822)
static void C_fcall trf_5822(void *dummy) C_regparm C_noret;
C_regparm static void C_fcall trf_5822(void *dummy){
C_word t1=C_pick(0);
C_word t0=C_pick(1);
C_adjust_stack(-2);
f_5822(t0,t1);}

C_noret_decl(trf_3634)
static void C_fcall trf_3634(void *dummy) C_regparm C_noret;
C_regparm static void C_fcall trf_3634(void *dummy){
C_word t1=C_pick(0);
C_word t0=C_pick(1);
C_adjust_stack(-2);
f_3634(t0,t1);}

C_noret_decl(trf_2519)
static void C_fcall trf_2519(void *dummy) C_regparm C_noret;
C_regparm static void C_fcall trf_2519(void *dummy){
C_word t3=C_pick(0);
C_word t2=C_pick(1);
C_word t1=C_pick(2);
C_word t0=C_pick(3);
C_adjust_stack(-4);
f_2519(t0,t1,t2,t3);}

C_noret_decl(trf_2263)
static void C_fcall trf_2263(void *dummy) C_regparm C_noret;
C_regparm static void C_fcall trf_2263(void *dummy){
C_word t4=C_pick(0);
C_word t3=C_pick(1);
C_word t2=C_pick(2);
C_word t1=C_pick(3);
C_word t0=C_pick(4);
C_adjust_stack(-5);
f_2263(t0,t1,t2,t3,t4);}

C_noret_decl(trf_3294)
static void C_fcall trf_3294(void *dummy) C_regparm C_noret;
C_regparm static void C_fcall trf_3294(void *dummy){
C_word t2=C_pick(0);
C_word t1=C_pick(1);
C_word t0=C_pick(2);
C_adjust_stack(-3);
f_3294(t0,t1,t2);}

C_noret_decl(trf_2556)
static void C_fcall trf_2556(void *dummy) C_regparm C_noret;
C_regparm static void C_fcall trf_2556(void *dummy){
C_word t4=C_pick(0);
C_word t3=C_pick(1);
C_word t2=C_pick(2);
C_word t1=C_pick(3);
C_word t0=C_pick(4);
C_adjust_stack(-5);
f_2556(t0,t1,t2,t3,t4);}

C_noret_decl(trf_4488)
static void C_fcall trf_4488(void *dummy) C_regparm C_noret;
C_regparm static void C_fcall trf_4488(void *dummy){
C_word t3=C_pick(0);
C_word t2=C_pick(1);
C_word t1=C_pick(2);
C_word t0=C_pick(3);
C_adjust_stack(-4);
f_4488(t0,t1,t2,t3);}

C_noret_decl(trf_5252)
static void C_fcall trf_5252(void *dummy) C_regparm C_noret;
C_regparm static void C_fcall trf_5252(void *dummy){
C_word t1=C_pick(0);
C_word t0=C_pick(1);
C_adjust_stack(-2);
f_5252(t0,t1);}

C_noret_decl(trf_5432)
static void C_fcall trf_5432(void *dummy) C_regparm C_noret;
C_regparm static void C_fcall trf_5432(void *dummy){
C_word t6=C_pick(0);
C_word t5=C_pick(1);
C_word t4=C_pick(2);
C_word t3=C_pick(3);
C_word t2=C_pick(4);
C_word t1=C_pick(5);
C_word t0=C_pick(6);
C_adjust_stack(-7);
f_5432(t0,t1,t2,t3,t4,t5,t6);}

C_noret_decl(trf_5434)
static void C_fcall trf_5434(void *dummy) C_regparm C_noret;
C_regparm static void C_fcall trf_5434(void *dummy){
C_word t2=C_pick(0);
C_word t1=C_pick(1);
C_word t0=C_pick(2);
C_adjust_stack(-3);
f_5434(t0,t1,t2);}

C_noret_decl(trf_2714)
static void C_fcall trf_2714(void *dummy) C_regparm C_noret;
C_regparm static void C_fcall trf_2714(void *dummy){
C_word t1=C_pick(0);
C_word t0=C_pick(1);
C_adjust_stack(-2);
f_2714(t0,t1);}

C_noret_decl(trf_4443)
static void C_fcall trf_4443(void *dummy) C_regparm C_noret;
C_regparm static void C_fcall trf_4443(void *dummy){
C_word t3=C_pick(0);
C_word t2=C_pick(1);
C_word t1=C_pick(2);
C_word t0=C_pick(3);
C_adjust_stack(-4);
f_4443(t0,t1,t2,t3);}

C_noret_decl(trf_4912)
static void C_fcall trf_4912(void *dummy) C_regparm C_noret;
C_regparm static void C_fcall trf_4912(void *dummy){
C_word t3=C_pick(0);
C_word t2=C_pick(1);
C_word t1=C_pick(2);
C_word t0=C_pick(3);
C_adjust_stack(-4);
f_4912(t0,t1,t2,t3);}

C_noret_decl(trf_2768)
static void C_fcall trf_2768(void *dummy) C_regparm C_noret;
C_regparm static void C_fcall trf_2768(void *dummy){
C_word t2=C_pick(0);
C_word t1=C_pick(1);
C_word t0=C_pick(2);
C_adjust_stack(-3);
f_2768(t0,t1,t2);}

C_noret_decl(tr6)
static void C_fcall tr6(C_proc6 k) C_regparm C_noret;
C_regparm static void C_fcall tr6(C_proc6 k){
C_word t5=C_pick(0);
C_word t4=C_pick(1);
C_word t3=C_pick(2);
C_word t2=C_pick(3);
C_word t1=C_pick(4);
C_word t0=C_pick(5);
C_adjust_stack(-6);
(k)(6,t0,t1,t2,t3,t4,t5);}

C_noret_decl(tr4)
static void C_fcall tr4(C_proc4 k) C_regparm C_noret;
C_regparm static void C_fcall tr4(C_proc4 k){
C_word t3=C_pick(0);
C_word t2=C_pick(1);
C_word t1=C_pick(2);
C_word t0=C_pick(3);
C_adjust_stack(-4);
(k)(4,t0,t1,t2,t3);}

C_noret_decl(tr5)
static void C_fcall tr5(C_proc5 k) C_regparm C_noret;
C_regparm static void C_fcall tr5(C_proc5 k){
C_word t4=C_pick(0);
C_word t3=C_pick(1);
C_word t2=C_pick(2);
C_word t1=C_pick(3);
C_word t0=C_pick(4);
C_adjust_stack(-5);
(k)(5,t0,t1,t2,t3,t4);}

C_noret_decl(tr2)
static void C_fcall tr2(C_proc2 k) C_regparm C_noret;
C_regparm static void C_fcall tr2(C_proc2 k){
C_word t1=C_pick(0);
C_word t0=C_pick(1);
C_adjust_stack(-2);
(k)(2,t0,t1);}

C_noret_decl(tr3)
static void C_fcall tr3(C_proc3 k) C_regparm C_noret;
C_regparm static void C_fcall tr3(C_proc3 k){
C_word t2=C_pick(0);
C_word t1=C_pick(1);
C_word t0=C_pick(2);
C_adjust_stack(-3);
(k)(3,t0,t1,t2);}

C_noret_decl(tr5r)
static void C_fcall tr5r(C_proc5 k) C_regparm C_noret;
C_regparm static void C_fcall tr5r(C_proc5 k){
int n;
C_word *a,t5;
C_word t4=C_pick(0);
C_word t3=C_pick(1);
C_word t2=C_pick(2);
C_word t1=C_pick(3);
C_word t0=C_pick(4);
C_adjust_stack(-5);
n=C_rest_count(0);
a=C_alloc(n*3);
t5=C_restore_rest(a,n);
(k)(t0,t1,t2,t3,t4,t5);}

C_noret_decl(tr9r)
static void C_fcall tr9r(C_proc9 k) C_regparm C_noret;
C_regparm static void C_fcall tr9r(C_proc9 k){
int n;
C_word *a,t9;
C_word t8=C_pick(0);
C_word t7=C_pick(1);
C_word t6=C_pick(2);
C_word t5=C_pick(3);
C_word t4=C_pick(4);
C_word t3=C_pick(5);
C_word t2=C_pick(6);
C_word t1=C_pick(7);
C_word t0=C_pick(8);
C_adjust_stack(-9);
n=C_rest_count(0);
a=C_alloc(n*3);
t9=C_restore_rest(a,n);
(k)(t0,t1,t2,t3,t4,t5,t6,t7,t8,t9);}

C_noret_decl(tr7r)
static void C_fcall tr7r(C_proc7 k) C_regparm C_noret;
C_regparm static void C_fcall tr7r(C_proc7 k){
int n;
C_word *a,t7;
C_word t6=C_pick(0);
C_word t5=C_pick(1);
C_word t4=C_pick(2);
C_word t3=C_pick(3);
C_word t2=C_pick(4);
C_word t1=C_pick(5);
C_word t0=C_pick(6);
C_adjust_stack(-7);
n=C_rest_count(0);
a=C_alloc(n*3);
t7=C_restore_rest(a,n);
(k)(t0,t1,t2,t3,t4,t5,t6,t7);}

C_noret_decl(tr4r)
static void C_fcall tr4r(C_proc4 k) C_regparm C_noret;
C_regparm static void C_fcall tr4r(C_proc4 k){
int n;
C_word *a,t4;
C_word t3=C_pick(0);
C_word t2=C_pick(1);
C_word t1=C_pick(2);
C_word t0=C_pick(3);
C_adjust_stack(-4);
n=C_rest_count(0);
a=C_alloc(n*3);
t4=C_restore_rest(a,n);
(k)(t0,t1,t2,t3,t4);}

C_noret_decl(tr2r)
static void C_fcall tr2r(C_proc2 k) C_regparm C_noret;
C_regparm static void C_fcall tr2r(C_proc2 k){
int n;
C_word *a,t2;
C_word t1=C_pick(0);
C_word t0=C_pick(1);
C_adjust_stack(-2);
n=C_rest_count(0);
a=C_alloc(n*3);
t2=C_restore_rest(a,n);
(k)(t0,t1,t2);}

C_noret_decl(tr3r)
static void C_fcall tr3r(C_proc3 k) C_regparm C_noret;
C_regparm static void C_fcall tr3r(C_proc3 k){
int n;
C_word *a,t3;
C_word t2=C_pick(0);
C_word t1=C_pick(1);
C_word t0=C_pick(2);
C_adjust_stack(-3);
n=C_rest_count(0);
a=C_alloc(n*3);
t3=C_restore_rest(a,n);
(k)(t0,t1,t2,t3);}

/* open-output-file* in k3893 in k3523 in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_4557(C_word c,C_word t0,C_word t1,C_word t2,...){
C_word tmp;
C_word t3;
va_list v;
C_word *a,c2=c;
C_save_rest(t2,c2,3);
if(c<3) C_bad_min_argc_2(c,3,t0);
if(!C_demand(c*C_SIZEOF_PAIR+5)){
C_save_and_reclaim((void*)tr3r,(void*)f_4557r,3,t0,t1,t2);}
else{
a=C_alloc((c-3)*3);
t3=C_restore_rest(a,C_rest_count(0));
f_4557r(t0,t1,t2,t3);}}

static void C_ccall f_4557r(C_word t0,C_word t1,C_word t2,C_word t3){
C_word tmp;
C_word t4;
C_word t5;
C_word t6;
C_word *a=C_alloc(5);
t4=C_i_check_exact_2(t2,lf[57]);
t5=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_4569,a[2]=t2,a[3]=((C_word*)t0)[2],a[4]=t1,tmp=(C_word)a,a+=5,tmp);
/* posixwin.scm:1166: mode */
f_4488(t5,C_SCHEME_FALSE,t3,lf[57]);}

/* file-read-access? in k3893 in k3523 in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_4467(C_word c,C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr3,(void*)f_4467,3,t0,t1,t2);}
/* posixwin.scm:1125: check */
f_4443(t1,t2,C_fix((C_word)2),lf[265]);}

/* file-access-time in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_2329(C_word c,C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word t4;
C_word ab[3],*a=ab;
if(c!=3) C_bad_argc_2(c,3,t0);
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr3,(void*)f_2329,3,t0,t1,t2);}
t3=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_2333,a[2]=t1,tmp=(C_word)a,a+=3,tmp);
/* posix-common.scm:228: ##sys#stat */
f_2263(t3,t2,C_SCHEME_FALSE,C_SCHEME_TRUE,lf[21]);}

/* k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_2327(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word t11;
C_word t12;
C_word t13;
C_word t14;
C_word t15;
C_word t16;
C_word t17;
C_word t18;
C_word t19;
C_word t20;
C_word t21;
C_word t22;
C_word t23;
C_word t24;
C_word t25;
C_word t26;
C_word t27;
C_word t28;
C_word t29;
C_word t30;
C_word t31;
C_word t32;
C_word t33;
C_word t34;
C_word t35;
C_word t36;
C_word t37;
C_word ab[89],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_2327,2,t0,t1);}
t2=C_mutate2((C_word*)lf[20]+1 /* (set! file-modification-time ...) */,t1);
t3=C_mutate2((C_word*)lf[21]+1 /* (set! file-access-time ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_2329,a[2]=((C_word)li3),tmp=(C_word)a,a+=3,tmp));
t4=C_mutate2((C_word*)lf[22]+1 /* (set! file-change-time ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_2335,a[2]=((C_word)li4),tmp=(C_word)a,a+=3,tmp));
t5=C_mutate2((C_word*)lf[23]+1 /* (set! file-owner ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_2341,a[2]=((C_word)li5),tmp=(C_word)a,a+=3,tmp));
t6=C_mutate2((C_word*)lf[24]+1 /* (set! file-permissions ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_2347,a[2]=((C_word)li6),tmp=(C_word)a,a+=3,tmp));
t7=C_mutate2((C_word*)lf[25]+1 /* (set! file-size ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_2353,a[2]=((C_word)li7),tmp=(C_word)a,a+=3,tmp));
t8=C_mutate2((C_word*)lf[26]+1 /* (set! file-type ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_2359,a[2]=((C_word)li8),tmp=(C_word)a,a+=3,tmp));
t9=C_mutate2((C_word*)lf[34]+1 /* (set! regular-file? ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_2446,a[2]=((C_word)li9),tmp=(C_word)a,a+=3,tmp));
t10=C_mutate2((C_word*)lf[35]+1 /* (set! symbolic-link? ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_2456,a[2]=((C_word)li10),tmp=(C_word)a,a+=3,tmp));
t11=C_mutate2((C_word*)lf[36]+1 /* (set! block-device? ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_2466,a[2]=((C_word)li11),tmp=(C_word)a,a+=3,tmp));
t12=C_mutate2((C_word*)lf[37]+1 /* (set! character-device? ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_2476,a[2]=((C_word)li12),tmp=(C_word)a,a+=3,tmp));
t13=C_mutate2((C_word*)lf[38]+1 /* (set! fifo? ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_2486,a[2]=((C_word)li13),tmp=(C_word)a,a+=3,tmp));
t14=C_mutate2((C_word*)lf[39]+1 /* (set! socket? ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_2496,a[2]=((C_word)li14),tmp=(C_word)a,a+=3,tmp));
t15=C_mutate2((C_word*)lf[40]+1 /* (set! directory? ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_2506,a[2]=((C_word)li15),tmp=(C_word)a,a+=3,tmp));
t16=C_mutate2((C_word*)lf[41]+1 /* (set! fileno/stdin ...) */,C_fix((C_word)STDIN_FILENO));
t17=C_mutate2((C_word*)lf[42]+1 /* (set! fileno/stdout ...) */,C_fix((C_word)STDOUT_FILENO));
t18=C_mutate2((C_word*)lf[43]+1 /* (set! fileno/stderr ...) */,C_fix((C_word)STDERR_FILENO));
t19=C_SCHEME_UNDEFINED;
t20=(*a=C_VECTOR_TYPE|1,a[1]=t19,tmp=(C_word)a,a+=2,tmp);
t21=C_SCHEME_UNDEFINED;
t22=(*a=C_VECTOR_TYPE|1,a[1]=t21,tmp=(C_word)a,a+=2,tmp);
t23=C_set_block_item(t20,0,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_2519,a[2]=((C_word)li16),tmp=(C_word)a,a+=3,tmp));
t24=C_set_block_item(t22,0,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_2556,a[2]=((C_word)li17),tmp=(C_word)a,a+=3,tmp));
t25=C_mutate2((C_word*)lf[56]+1 /* (set! open-input-file* ...) */,(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_2571,a[2]=t22,a[3]=t20,a[4]=((C_word)li18),tmp=(C_word)a,a+=5,tmp));
t26=C_mutate2((C_word*)lf[57]+1 /* (set! open-output-file* ...) */,(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_2585,a[2]=t22,a[3]=t20,a[4]=((C_word)li19),tmp=(C_word)a,a+=5,tmp));
t27=C_mutate2((C_word*)lf[58]+1 /* (set! port->fileno ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_2599,a[2]=((C_word)li20),tmp=(C_word)a,a+=3,tmp));
t28=C_mutate2((C_word*)lf[63]+1 /* (set! duplicate-fileno ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_2647,a[2]=((C_word)li21),tmp=(C_word)a,a+=3,tmp));
t29=C_mutate2((C_word*)lf[65]+1 /* (set! current-directory ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_2674,a[2]=((C_word)li22),tmp=(C_word)a,a+=3,tmp));
t30=C_mutate2((C_word*)lf[70]+1 /* (set! delete-directory ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_2708,a[2]=((C_word)li26),tmp=(C_word)a,a+=3,tmp));
t31=C_mutate2((C_word*)lf[29]+1 /* (set! directory ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_2800,a[2]=((C_word)li28),tmp=(C_word)a,a+=3,tmp));
t32=C_mutate2((C_word*)lf[79]+1 /* (set! glob ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_2938,a[2]=((C_word)li34),tmp=(C_word)a,a+=3,tmp));
t33=C_mutate2((C_word*)lf[74]+1 /* (set! find-files ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_3241,a[2]=((C_word)li50),tmp=(C_word)a,a+=3,tmp));
t34=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_3292,a[2]=((C_word*)t0)[2],tmp=(C_word)a,a+=3,tmp);
t35=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_6164,a[2]=((C_word)li195),tmp=(C_word)a,a+=3,tmp);
t36=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_6189,a[2]=((C_word)li196),tmp=(C_word)a,a+=3,tmp);
/* posix-common.scm:466: getter-with-setter */
t37=*((C_word*)lf[401]+1);
((C_proc5)(void*)(*((C_word*)t37+1)))(5,t37,t34,t35,t36,lf[403]);}

/* k4319 in create-pipe in k3893 in k3523 in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_4321(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word *a;
/* posixwin.scm:1017: values */
C_values(4,0,((C_word*)t0)[2],C_fix((C_word)C_pipefds[ 0 ]),C_fix((C_word)C_pipefds[ 1 ]));}

/* k4581 in k4601 in port->fileno in k3893 in k3523 in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_4583(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word *a;
t2=((C_word*)t0)[2];
((C_proc2)(void*)(*((C_word*)t2+1)))(2,t2,((C_word*)t0)[3]);}

/* k2755 in k2749 in g271 in k2738 in k2732 in delete-directory in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_2757(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word *a;
if(C_truep(t1)){
/* posix-common.scm:362: g281 */
f_2714(((C_word*)t0)[3],((C_word*)t0)[4]);}
else{
t2=*((C_word*)lf[72]+1);
t3=*((C_word*)lf[72]+1);
/* posix-common.scm:362: g281 */
((C_proc3)C_fast_retrieve_proc(*((C_word*)lf[72]+1)))(3,*((C_word*)lf[72]+1),((C_word*)t0)[3],((C_word*)t0)[4]);}}

/* k2749 in g271 in k2738 in k2732 in delete-directory in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_2751(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word ab[5],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_2751,2,t0,t1);}
if(C_truep(t1)){
t2=*((C_word*)lf[72]+1);
t3=*((C_word*)lf[72]+1);
/* posix-common.scm:362: g281 */
((C_proc3)C_fast_retrieve_proc(*((C_word*)lf[72]+1)))(3,*((C_word*)lf[72]+1),((C_word*)t0)[2],((C_word*)t0)[3]);}
else{
t2=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_2757,a[2]=((C_word*)t0)[4],a[3]=((C_word*)t0)[2],a[4]=((C_word*)t0)[3],tmp=(C_word)a,a+=5,tmp);
/* posix-common.scm:364: directory? */
t3=*((C_word*)lf[40]+1);
((C_proc3)(void*)(*((C_word*)t3+1)))(3,t3,t2,((C_word*)t0)[3]);}}

/* k4459 in check in k3893 in k3523 in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_4461(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word ab[4],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_4461,2,t0,t1);}
t2=C_test_access(t1,((C_word*)t0)[2]);
t3=C_eqp(C_fix(0),t2);
t4=t3;
t5=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_4453,a[2]=((C_word*)t0)[3],a[3]=t4,tmp=(C_word)a,a+=4,tmp);
if(C_truep(t4)){
t6=((C_word*)t0)[3];
((C_proc2)(void*)(*((C_word*)t6+1)))(2,t6,t4);}
else{
/* posixwin.scm:1123: ##sys#update-errno */
((C_proc2)C_fast_retrieve_proc(*((C_word*)lf[7]+1)))(2,*((C_word*)lf[7]+1),t5);}}

/* k4463 in check in k3893 in k3523 in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_4465(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word *a;
/* posixwin.scm:1122: ##sys#make-c-string */
((C_proc4)C_fast_retrieve_proc(*((C_word*)lf[12]+1)))(4,*((C_word*)lf[12]+1),((C_word*)t0)[2],t1,((C_word*)t0)[3]);}

/* k4587 in k4601 in port->fileno in k3893 in k3523 in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_4589(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word *a;
/* posixwin.scm:1175: ##sys#signal-hook */
t2=*((C_word*)lf[3]+1);
((C_proc6)(void*)(*((C_word*)t2+1)))(6,t2,((C_word*)t0)[2],lf[10],lf[58],lf[276],((C_word*)t0)[3]);}

/* k4710 in k4722 in k4718 in scan in k4684 in loop in get-environment-variables in k3893 in k3523 in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_4712(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word ab[3],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_4712,2,t0,t1);}
t2=((C_word*)t0)[2];
((C_proc2)(void*)(*((C_word*)t2+1)))(2,t2,C_a_i_cons(&a,2,((C_word*)t0)[3],t1));}

/* create-pipe in k3893 in k3523 in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_4314(C_word c,C_word t0,C_word t1,...){
C_word tmp;
C_word t2;
va_list v;
C_word *a,c2=c;
C_save_rest(t1,c2,2);
if(!C_demand(c*C_SIZEOF_PAIR+6)){
C_save_and_reclaim((void*)tr2r,(void*)f_4314r,2,t0,t1);}
else{
a=C_alloc((c-2)*3);
t2=C_restore_rest(a,C_rest_count(0));
f_4314r(t0,t1,t2);}}

static void C_ccall f_4314r(C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word *a=C_alloc(6);
t3=C_i_nullp(t2);
t4=(C_truep(t3)?C_fixnum_or(*((C_word*)lf[135]+1),*((C_word*)lf[137]+1)):C_i_car(t2));
t5=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_4321,a[2]=t1,tmp=(C_word)a,a+=3,tmp);
t6=C_pipe(C_SCHEME_FALSE,t4);
if(C_truep(C_fixnum_lessp(t6,C_fix(0)))){
t7=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_4330,a[2]=t5,tmp=(C_word)a,a+=3,tmp);
/* posixwin.scm:1015: ##sys#update-errno */
((C_proc2)C_fast_retrieve_proc(*((C_word*)lf[7]+1)))(2,*((C_word*)lf[7]+1),t7);}
else{
/* posixwin.scm:1017: values */
C_values(4,0,t1,C_fix((C_word)C_pipefds[ 0 ]),C_fix((C_word)C_pipefds[ 1 ]));}}

/* a2964 in conc-loop in glob in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_2965(C_word c,C_word t0,C_word t1,C_word t2,C_word t3,C_word t4){
C_word tmp;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word ab[9],*a=ab;
if(c!=5) C_bad_argc_2(c,5,t0);
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr5,(void*)f_2965,5,t0,t1,t2,t3,t4);}
t5=t2;
t6=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_2969,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=t5,a[5]=t1,tmp=(C_word)a,a+=6,tmp);
t7=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_3039,a[2]=t6,tmp=(C_word)a,a+=3,tmp);
if(C_truep(t3)){
t8=t3;
/* posix-common.scm:409: make-pathname */
t9=*((C_word*)lf[81]+1);
((C_proc5)(void*)(*((C_word*)t9+1)))(5,t9,t7,C_SCHEME_FALSE,t8,t4);}
else{
/* posix-common.scm:409: make-pathname */
t8=*((C_word*)lf[81]+1);
((C_proc5)(void*)(*((C_word*)t8+1)))(5,t8,t7,C_SCHEME_FALSE,lf[86],t4);}}

/* k2312 in file-stat in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_2314(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word ab[30],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_2314,2,t0,t1);}
t2=((C_word*)t0)[2];
((C_proc2)(void*)(*((C_word*)t2+1)))(2,t2,C_a_i_vector(&a,13,C_fix(C_MOST_POSITIVE_FIXNUM&(C_word)C_statbuf.st_ino),C_fix(C_MOST_POSITIVE_FIXNUM&(C_word)C_statbuf.st_mode),C_fix(C_MOST_POSITIVE_FIXNUM&(C_word)C_statbuf.st_nlink),C_fix(C_MOST_POSITIVE_FIXNUM&(C_word)C_statbuf.st_uid),C_fix(C_MOST_POSITIVE_FIXNUM&(C_word)C_statbuf.st_gid),C_a_double_to_num(&a,C_statbuf.st_size),C_flonum(&a,C_statbuf.st_atime),C_flonum(&a,C_statbuf.st_ctime),C_flonum(&a,C_statbuf.st_mtime),C_fix(C_MOST_POSITIVE_FIXNUM&(C_word)C_statbuf.st_dev),C_fix(C_MOST_POSITIVE_FIXNUM&(C_word)C_statbuf.st_rdev),*((C_word*)lf[18]+1),*((C_word*)lf[19]+1)));}

/* port->fileno in k3893 in k3523 in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_4571(C_word c,C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word ab[4],*a=ab;
if(c!=3) C_bad_argc_2(c,3,t0);
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr3,(void*)f_4571,3,t0,t1,t2);}
t3=t2;
t4=C_i_check_port_2(t3,C_fix(0),C_SCHEME_TRUE,lf[58]);
t5=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_4603,a[2]=t1,a[3]=t2,tmp=(C_word)a,a+=4,tmp);
/* posixwin.scm:1171: ##sys#peek-unsigned-integer */
((C_proc4)C_fast_retrieve_proc(*((C_word*)lf[62]+1)))(4,*((C_word*)lf[62]+1),t5,t2,C_fix(0));}

/* k5282 in k5278 in k5403 in k5399 in k5395 in k5391 in k5387 in k5343 in process in k3893 in k3523 in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_5284(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word *a;
t2=(C_truep(((C_word*)t0)[2])?C_i_foreign_pointer_argumentp(((C_word*)t0)[2]):C_SCHEME_FALSE);
t3=(C_truep(((C_word*)t0)[3])?C_i_foreign_pointer_argumentp(((C_word*)t0)[3]):C_SCHEME_FALSE);
t4=(C_truep(((C_word*)t0)[4])?C_i_foreign_pointer_argumentp(((C_word*)t0)[4]):C_SCHEME_FALSE);
t5=(C_truep(((C_word*)t0)[5])?C_i_foreign_pointer_argumentp(((C_word*)t0)[5]):C_SCHEME_FALSE);
t6=C_i_foreign_fixnum_argumentp(((C_word*)t0)[6]);
t7=((C_word*)t0)[7];
((C_proc2)(void*)(*((C_word*)t7+1)))(2,t7,stub1229(C_SCHEME_UNDEFINED,((C_word*)t0)[8],t1,C_SCHEME_FALSE,t2,t3,t4,t5,t6));}

/* k2967 in a2964 in conc-loop in glob in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_2969(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word ab[7],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_2969,2,t0,t1);}
t2=t1;
t3=(*a=C_CLOSURE_TYPE|6,a[1]=(C_word)f_2976,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[4],a[5]=t2,a[6]=((C_word*)t0)[5],tmp=(C_word)a,a+=7,tmp);
if(C_truep(((C_word*)t0)[4])){
/* posix-common.scm:410: directory */
t4=*((C_word*)lf[29]+1);
((C_proc4)(void*)(*((C_word*)t4+1)))(4,t4,t3,((C_word*)t0)[4],C_SCHEME_TRUE);}
else{
/* posix-common.scm:410: directory */
t4=*((C_word*)lf[29]+1);
((C_proc4)(void*)(*((C_word*)t4+1)))(4,t4,t3,lf[84],C_SCHEME_TRUE);}}

/* k2738 in k2732 in delete-directory in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_2740(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word ab[16],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_2740,2,t0,t1);}
t2=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_2741,a[2]=((C_word*)t0)[2],a[3]=((C_word)li24),tmp=(C_word)a,a+=4,tmp);
t3=C_i_check_list_2(t1,lf[73]);
t4=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_2763,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[4],tmp=(C_word)a,a+=5,tmp);
t5=C_SCHEME_UNDEFINED;
t6=(*a=C_VECTOR_TYPE|1,a[1]=t5,tmp=(C_word)a,a+=2,tmp);
t7=C_set_block_item(t6,0,(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_2768,a[2]=t6,a[3]=t2,a[4]=((C_word)li25),tmp=(C_word)a,a+=5,tmp));
t8=((C_word*)t6)[1];
f_2768(t8,t4,t1);}

/* g271 in k2738 in k2732 in delete-directory in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_fcall f_2741(C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word t4;
C_word ab[5],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)trf_2741,NULL,3,t0,t1,t2);}
t3=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_2751,a[2]=t1,a[3]=t2,a[4]=((C_word*)t0)[2],tmp=(C_word)a,a+=5,tmp);
/* posix-common.scm:363: symbolic-link? */
t4=*((C_word*)lf[35]+1);
((C_proc3)(void*)(*((C_word*)t4+1)))(3,t4,t3,t2);}

/* k5278 in k5403 in k5399 in k5395 in k5391 in k5387 in k5343 in process in k3893 in k3523 in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_5280(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word ab[9],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_5280,2,t0,t1);}
t2=t1;
t3=(*a=C_CLOSURE_TYPE|8,a[1]=(C_word)f_5284,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[4],a[5]=((C_word*)t0)[5],a[6]=((C_word*)t0)[6],a[7]=((C_word*)t0)[7],a[8]=t2,tmp=(C_word)a,a+=9,tmp);
if(C_truep(((C_word*)t0)[8])){
t4=C_i_foreign_string_argumentp(((C_word*)t0)[8]);
/* posixwin.scm:1396: ##sys#make-c-string */
((C_proc3)C_fast_retrieve_proc(*((C_word*)lf[12]+1)))(3,*((C_word*)lf[12]+1),t3,t4);}
else{
t4=t3;
f_5284(2,t4,C_SCHEME_FALSE);}}

/* k4451 in k4459 in check in k3893 in k3523 in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_4453(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word *a;
t2=((C_word*)t0)[2];
((C_proc2)(void*)(*((C_word*)t2+1)))(2,t2,((C_word*)t0)[3]);}

/* terminal-size in k3893 in k3523 in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_4787(C_word c,C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word t4;
C_word ab[4],*a=ab;
if(c!=3) C_bad_argc_2(c,3,t0);
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr3,(void*)f_4787,3,t0,t1,t2);}
t3=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_4794,a[2]=t1,a[3]=t2,tmp=(C_word)a,a+=4,tmp);
/* posixwin.scm:1244: terminal-port? */
t4=*((C_word*)lf[285]+1);
((C_proc3)(void*)(*((C_word*)t4+1)))(3,t4,t3,t2);}

/* a2958 in conc-loop in glob in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_2959(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word *a;
if(c!=2) C_bad_argc_2(c,2,t0);
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_2959,2,t0,t1);}
/* posix-common.scm:408: decompose-pathname */
t2=*((C_word*)lf[80]+1);
((C_proc3)(void*)(*((C_word*)t2+1)))(3,t2,t1,((C_word*)t0)[2]);}

/* k2732 in delete-directory in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_2734(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word ab[5],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_2734,2,t0,t1);}
t2=t1;
if(C_truep(((C_word*)t0)[2])){
t3=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_2740,a[2]=((C_word*)t0)[3],a[3]=((C_word*)t0)[4],a[4]=t2,tmp=(C_word)a,a+=5,tmp);
/* posix-common.scm:357: find-files */
t4=*((C_word*)lf[74]+1);
((C_proc7)(void*)(*((C_word*)t4+1)))(7,t4,t3,t2,lf[75],C_SCHEME_TRUE,lf[76],C_SCHEME_FALSE);}
else{
/* posix-common.scm:369: rmdir */
f_2714(((C_word*)t0)[4],t2);}}

/* k2376 in file-type in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_2378(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word *a;
if(C_truep(t1)){
t2=C_fix(C_MOST_POSITIVE_FIXNUM&(C_word)C_stat_type);
if(C_truep(C_i_eqvp(t2,C_fix(C_MOST_POSITIVE_FIXNUM&(C_word)S_IFREG)))){
t3=((C_word*)t0)[2];
((C_proc2)(void*)(*((C_word*)t3+1)))(2,t3,lf[27]);}
else{
if(C_truep(C_i_eqvp(t2,C_fix(C_MOST_POSITIVE_FIXNUM&(C_word)S_IFLNK)))){
t3=((C_word*)t0)[2];
((C_proc2)(void*)(*((C_word*)t3+1)))(2,t3,lf[28]);}
else{
if(C_truep(C_i_eqvp(t2,C_fix(C_MOST_POSITIVE_FIXNUM&(C_word)S_IFDIR)))){
t3=((C_word*)t0)[2];
((C_proc2)(void*)(*((C_word*)t3+1)))(2,t3,lf[29]);}
else{
if(C_truep(C_i_eqvp(t2,C_fix(C_MOST_POSITIVE_FIXNUM&(C_word)S_IFCHR)))){
t3=((C_word*)t0)[2];
((C_proc2)(void*)(*((C_word*)t3+1)))(2,t3,lf[30]);}
else{
if(C_truep(C_i_eqvp(t2,C_fix(C_MOST_POSITIVE_FIXNUM&(C_word)S_IFBLK)))){
t3=((C_word*)t0)[2];
((C_proc2)(void*)(*((C_word*)t3+1)))(2,t3,lf[31]);}
else{
if(C_truep(C_i_eqvp(t2,C_fix(C_MOST_POSITIVE_FIXNUM&(C_word)S_IFIFO)))){
t3=((C_word*)t0)[2];
((C_proc2)(void*)(*((C_word*)t3+1)))(2,t3,lf[32]);}
else{
t3=C_i_eqvp(t2,C_fix(C_MOST_POSITIVE_FIXNUM&(C_word)S_IFSOCK));
t4=((C_word*)t0)[2];
((C_proc2)(void*)(*((C_word*)t4+1)))(2,t4,(C_truep(t3)?lf[33]:lf[27]));}}}}}}}
else{
t2=((C_word*)t0)[2];
((C_proc2)(void*)(*((C_word*)t2+1)))(2,t2,C_SCHEME_FALSE);}}

/* conc-loop in glob in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_fcall f_2944(C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word ab[9],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)trf_2944,NULL,3,t0,t1,t2);}
if(C_truep(C_i_nullp(t2))){
t3=t1;
((C_proc2)(void*)(*((C_word*)t3+1)))(2,t3,C_SCHEME_END_OF_LIST);}
else{
t3=C_i_car(t2);
t4=t3;
t5=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_2959,a[2]=t4,a[3]=((C_word)li29),tmp=(C_word)a,a+=4,tmp);
t6=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_2965,a[2]=t2,a[3]=((C_word*)t0)[2],a[4]=((C_word)li32),tmp=(C_word)a,a+=5,tmp);
/* posix-common.scm:407: ##sys#call-with-values */
C_call_with_values(4,0,t1,t5,t6);}}

/* k4328 in create-pipe in k3893 in k3523 in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_4330(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word *a;
/* posixwin.scm:1016: ##sys#signal-hook */
t2=*((C_word*)lf[3]+1);
((C_proc5)(void*)(*((C_word*)t2+1)))(5,t2,((C_word*)t0)[2],lf[10],lf[196],lf[197]);}

/* k4718 in scan in k4684 in loop in get-environment-variables in k3893 in k3523 in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_4720(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word ab[6],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_4720,2,t0,t1);}
t2=t1;
t3=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_4724,a[2]=t2,a[3]=((C_word*)t0)[2],a[4]=((C_word*)t0)[3],a[5]=((C_word*)t0)[4],tmp=(C_word)a,a+=6,tmp);
t4=C_fixnum_plus(((C_word*)t0)[5],C_fix(1));
t5=C_block_size(((C_word*)t0)[6]);
/* posixwin.scm:1218: substring */
t6=*((C_word*)lf[282]+1);
((C_proc5)(void*)(*((C_word*)t6+1)))(5,t6,t3,((C_word*)t0)[6],t4,t5);}

/* k4722 in k4718 in scan in k4684 in loop in get-environment-variables in k3893 in k3523 in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_4724(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word ab[7],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_4724,2,t0,t1);}
t2=C_a_i_cons(&a,2,((C_word*)t0)[2],t1);
t3=t2;
t4=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_4712,a[2]=((C_word*)t0)[3],a[3]=t3,tmp=(C_word)a,a+=4,tmp);
t5=C_fixnum_plus(((C_word*)t0)[4],C_fix(1));
/* posixwin.scm:1218: loop */
t6=((C_word*)((C_word*)t0)[5])[1];
f_4682(t6,t4,t5);}

/* glob in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_2938(C_word c,C_word t0,C_word t1,...){
C_word tmp;
C_word t2;
va_list v;
C_word *a,c2=c;
C_save_rest(t1,c2,2);
if(!C_demand(c*C_SIZEOF_PAIR+6)){
C_save_and_reclaim((void*)tr2r,(void*)f_2938r,2,t0,t1);}
else{
a=C_alloc((c-2)*3);
t2=C_restore_rest(a,C_rest_count(0));
f_2938r(t0,t1,t2);}}

static void C_ccall f_2938r(C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word *a=C_alloc(6);
t3=C_SCHEME_UNDEFINED;
t4=(*a=C_VECTOR_TYPE|1,a[1]=t3,tmp=(C_word)a,a+=2,tmp);
t5=C_set_block_item(t4,0,(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_2944,a[2]=t4,a[3]=((C_word)li33),tmp=(C_word)a,a+=4,tmp));
t6=((C_word*)t4)[1];
f_2944(t6,t1,t2);}

/* _exit in k3893 in k3523 in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_4755(C_word c,C_word t0,C_word t1,...){
C_word tmp;
C_word t2;
va_list v;
C_word *a,c2=c;
C_save_rest(t1,c2,2);
if(!C_demand(c*C_SIZEOF_PAIR+0)){
C_save_and_reclaim((void*)tr2r,(void*)f_4755r,2,t0,t1);}
else{
a=C_alloc((c-2)*3);
t2=C_restore_rest(a,C_rest_count(0));
f_4755r(t0,t1,t2);}}

static void C_ccall f_4755r(C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
if(C_truep(C_i_pairp(t2))){
t3=t2;
t4=C_u_i_car(t3);
t5=t1;
t6=C_i_foreign_fixnum_argumentp(t4);
t7=t5;
((C_proc2)(void*)(*((C_word*)t7+1)))(2,t7,stub1060(C_SCHEME_UNDEFINED,t6));}
else{
t3=t1;
t4=C_i_foreign_fixnum_argumentp(C_fix(0));
t5=t3;
((C_proc2)(void*)(*((C_word*)t5+1)))(2,t5,stub1060(C_SCHEME_UNDEFINED,t4));}}

/* k2993 in loop in k2974 in k2967 in a2964 in conc-loop in glob in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_2995(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word ab[6],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_2995,2,t0,t1);}
if(C_truep(t1)){
t2=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_2999,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[4],a[5]=((C_word)li30),tmp=(C_word)a,a+=6,tmp);
/* posix-common.scm:407: g363 */
t3=t2;
f_2999(t3,((C_word*)t0)[5],t1);}
else{
t2=((C_word*)t0)[2];
t3=C_u_i_cdr(t2);
/* posix-common.scm:417: loop */
t4=((C_word*)((C_word*)t0)[3])[1];
f_2978(t4,((C_word*)t0)[5],t3);}}

/* g363 in k2993 in loop in k2974 in k2967 in a2964 in conc-loop in glob in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_fcall f_2999(C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word t4;
C_word t5;
C_word ab[9],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)trf_2999,NULL,3,t0,t1,t2);}
t3=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_3007,a[2]=t1,a[3]=((C_word*)t0)[2],a[4]=((C_word*)t0)[3],tmp=(C_word)a,a+=5,tmp);
t4=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_3019,a[2]=t3,a[3]=((C_word*)t0)[4],tmp=(C_word)a,a+=4,tmp);
/* posix-common.scm:415: irregex-match-substring */
t5=*((C_word*)lf[82]+1);
((C_proc3)(void*)(*((C_word*)t5+1)))(3,t5,t4,t2);}

/* k2776 in for-each-loop270 in k2738 in k2732 in delete-directory in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_2778(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word *a;
t2=C_slot(((C_word*)t0)[2],C_fix(1));
t3=((C_word*)((C_word*)t0)[3])[1];
f_2768(t3,((C_word*)t0)[4],t2);}

/* k4773 in terminal-port? in k3893 in k3523 in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_4775(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word *a;
t2=C_eqp(C_fix(0),t1);
if(C_truep(t2)){
t3=((C_word*)t0)[2];
((C_proc2)(void*)(*((C_word*)t3+1)))(2,t3,C_SCHEME_FALSE);}
else{
t3=C_tty_portp(((C_word*)t0)[3]);
t4=((C_word*)t0)[2];
((C_proc2)(void*)(*((C_word*)t4+1)))(2,t4,t3);}}

/* terminal-port? in k3893 in k3523 in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_4769(C_word c,C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word ab[4],*a=ab;
if(c!=3) C_bad_argc_2(c,3,t0);
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr3,(void*)f_4769,3,t0,t1,t2);}
t3=t2;
t4=C_i_check_port_2(t3,C_fix(0),C_SCHEME_TRUE,lf[285]);
t5=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_4775,a[2]=t1,a[3]=t2,tmp=(C_word)a,a+=4,tmp);
/* posixwin.scm:1240: ##sys#peek-unsigned-integer */
((C_proc4)C_fast_retrieve_proc(*((C_word*)lf[62]+1)))(4,*((C_word*)lf[62]+1),t5,t2,C_fix(0));}

/* k2974 in k2967 in a2964 in conc-loop in glob in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_2976(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word ab[10],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_2976,2,t0,t1);}
t2=C_SCHEME_UNDEFINED;
t3=(*a=C_VECTOR_TYPE|1,a[1]=t2,tmp=(C_word)a,a+=2,tmp);
t4=C_set_block_item(t3,0,(*a=C_CLOSURE_TYPE|7,a[1]=(C_word)f_2978,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=t3,a[5]=((C_word*)t0)[4],a[6]=((C_word*)t0)[5],a[7]=((C_word)li31),tmp=(C_word)a,a+=8,tmp));
t5=((C_word*)t3)[1];
f_2978(t5,((C_word*)t0)[6],t1);}

/* loop in k2974 in k2967 in a2964 in conc-loop in glob in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_fcall f_2978(C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word ab[6],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)trf_2978,NULL,3,t0,t1,t2);}
if(C_truep(C_i_nullp(t2))){
t3=C_i_cdr(((C_word*)t0)[2]);
/* posix-common.scm:411: conc-loop */
t4=((C_word*)((C_word*)t0)[3])[1];
f_2944(t4,t1,t3);}
else{
t3=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_2995,a[2]=t2,a[3]=((C_word*)t0)[4],a[4]=((C_word*)t0)[5],a[5]=t1,tmp=(C_word)a,a+=6,tmp);
t4=C_i_car(t2);
/* posix-common.scm:412: irregex-match */
t5=*((C_word*)lf[83]+1);
((C_proc4)(void*)(*((C_word*)t5+1)))(4,t5,t3,((C_word*)t0)[6],t4);}}

/* k4792 in terminal-size in k3893 in k3523 in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_4794(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word *a;
if(C_truep(t1)){
/* posixwin.scm:1245: values */
C_values(4,0,((C_word*)t0)[2],C_fix(0),C_fix(0));}
else{
/* posixwin.scm:1246: ##sys#error */
t2=*((C_word*)lf[45]+1);
((C_proc5)(void*)(*((C_word*)t2+1)))(5,t2,((C_word*)t0)[2],lf[286],lf[287],((C_word*)t0)[3]);}}

/* k3777 in file-mkstemp in k3523 in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_3779(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word ab[10],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_3779,2,t0,t1);}
t2=t1;
t3=C_mkstemp(t2);
t4=C_i_string_length(t2);
t5=t4;
t6=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_3785,a[2]=((C_word*)t0)[2],a[3]=t3,a[4]=t5,a[5]=t2,tmp=(C_word)a,a+=6,tmp);
t7=C_eqp(C_fix(-1),t3);
if(C_truep(t7)){
t8=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_3802,a[2]=t6,a[3]=((C_word*)t0)[3],tmp=(C_word)a,a+=4,tmp);
/* posixwin.scm:815: ##sys#update-errno */
((C_proc2)C_fast_retrieve_proc(*((C_word*)lf[7]+1)))(2,*((C_word*)lf[7]+1),t8);}
else{
t8=t6;
f_3785(2,t8,C_SCHEME_UNDEFINED);}}

/* file-mkstemp in k3523 in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_3772(C_word c,C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word t4;
C_word t5;
C_word ab[4],*a=ab;
if(c!=3) C_bad_argc_2(c,3,t0);
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr3,(void*)f_3772,3,t0,t1,t2);}
t3=C_i_check_string_2(t2,lf[160]);
t4=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_3779,a[2]=t1,a[3]=t2,tmp=(C_word)a,a+=4,tmp);
/* posixwin.scm:811: ##sys#make-c-string */
((C_proc4)C_fast_retrieve_proc(*((C_word*)lf[12]+1)))(4,*((C_word*)lf[12]+1),t4,t2,lf[160]);}

/* check in k3893 in k3523 in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_fcall f_4525(C_word t1,C_word t2,C_word t3,C_word t4){
C_word tmp;
C_word t5;
C_word t6;
C_word ab[6],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)trf_4525,NULL,4,t1,t2,t3,t4);}
t5=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_4529,a[2]=t4,a[3]=t1,a[4]=t2,a[5]=t3,tmp=(C_word)a,a+=6,tmp);
/* posixwin.scm:1153: ##sys#update-errno */
((C_proc2)C_fast_retrieve_proc(*((C_word*)lf[7]+1)))(2,*((C_word*)lf[7]+1),t5);}

/* k4527 in check in k3893 in k3523 in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_4529(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word ab[4],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_4529,2,t0,t1);}
if(C_truep(C_null_pointerp(((C_word*)t0)[2]))){
/* posixwin.scm:1155: ##sys#signal-hook */
t2=*((C_word*)lf[3]+1);
((C_proc5)(void*)(*((C_word*)t2+1)))(5,t2,((C_word*)t0)[3],lf[10],lf[273],((C_word*)t0)[4]);}
else{
t2=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_4541,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],tmp=(C_word)a,a+=4,tmp);
/* posixwin.scm:1156: ##sys#make-port */
((C_proc6)C_fast_retrieve_proc(*((C_word*)lf[52]+1)))(6,*((C_word*)lf[52]+1),t2,((C_word*)t0)[5],*((C_word*)lf[53]+1),lf[274],lf[55]);}}

/* k3752 in k3740 in k3737 in file-write in k3523 in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_3754(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word *a;
/* posixwin.scm:805: ##sys#signal-hook */
t2=*((C_word*)lf[3]+1);
((C_proc7)(void*)(*((C_word*)t2+1)))(7,t2,((C_word*)t0)[2],lf[10],lf[157],lf[158],((C_word*)t0)[3],((C_word*)t0)[4]);}

/* k3740 in k3737 in file-write in k3523 in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_fcall f_3742(C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word ab[9],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)trf_3742,NULL,2,t0,t1);}
t2=t1;
t3=C_i_check_exact_2(t2,lf[157]);
t4=C_write(((C_word*)t0)[2],((C_word*)t0)[3],t2);
t5=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_3748,a[2]=((C_word*)t0)[4],a[3]=t4,tmp=(C_word)a,a+=4,tmp);
t6=C_eqp(C_fix(-1),t4);
if(C_truep(t6)){
t7=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_3754,a[2]=t5,a[3]=((C_word*)t0)[2],a[4]=t2,tmp=(C_word)a,a+=5,tmp);
/* posixwin.scm:804: ##sys#update-errno */
((C_proc2)C_fast_retrieve_proc(*((C_word*)lf[7]+1)))(2,*((C_word*)lf[7]+1),t7);}
else{
t7=((C_word*)t0)[4];
((C_proc2)(void*)(*((C_word*)t7+1)))(2,t7,t4);}}

/* k3746 in k3740 in k3737 in file-write in k3523 in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_3748(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word *a;
t2=((C_word*)t0)[2];
((C_proc2)(void*)(*((C_word*)t2+1)))(2,t2,((C_word*)t0)[3]);}

/* file-write in k3523 in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_3732(C_word c,C_word t0,C_word t1,C_word t2,C_word t3,...){
C_word tmp;
C_word t4;
va_list v;
C_word *a,c2=c;
C_save_rest(t3,c2,4);
if(c<4) C_bad_min_argc_2(c,4,t0);
if(!C_demand(c*C_SIZEOF_PAIR+6)){
C_save_and_reclaim((void*)tr4r,(void*)f_3732r,4,t0,t1,t2,t3);}
else{
a=C_alloc((c-4)*3);
t4=C_restore_rest(a,C_rest_count(0));
f_3732r(t0,t1,t2,t3,t4);}}

static void C_ccall f_3732r(C_word t0,C_word t1,C_word t2,C_word t3,C_word t4){
C_word tmp;
C_word t5;
C_word t6;
C_word t7;
C_word *a=C_alloc(6);
t5=C_i_check_exact_2(t2,lf[157]);
t6=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_3739,a[2]=t2,a[3]=t3,a[4]=t1,a[5]=t4,tmp=(C_word)a,a+=6,tmp);
if(C_truep(C_blockp(t3))){
if(C_truep(C_byteblockp(t3))){
t7=t6;
f_3739(2,t7,C_SCHEME_UNDEFINED);}
else{
/* posixwin.scm:799: ##sys#signal-hook */
t7=*((C_word*)lf[3]+1);
((C_proc6)(void*)(*((C_word*)t7+1)))(6,t7,t6,lf[15],lf[157],lf[159],t3);}}
else{
/* posixwin.scm:799: ##sys#signal-hook */
t7=*((C_word*)lf[3]+1);
((C_proc6)(void*)(*((C_word*)t7+1)))(6,t7,t6,lf[15],lf[157],lf[159],t3);}}

/* k3737 in file-write in k3523 in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_3739(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word ab[5],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_3739,2,t0,t1);}
t2=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_3742,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[4],tmp=(C_word)a,a+=5,tmp);
if(C_truep(C_i_pairp(((C_word*)t0)[5]))){
t3=((C_word*)t0)[5];
t4=t2;
f_3742(t4,C_u_i_car(t3));}
else{
t3=t2;
f_3742(t3,C_block_size(((C_word*)t0)[3]));}}

/* local-timezone-abbreviation in k3893 in k3523 in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_4742(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word ab[5],*a=ab;
if(c!=2) C_bad_argc_2(c,2,t0);
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_4742,2,t0,t1);}
t2=C_a_i_bytevector(&a,1,C_fix(3));
t3=stub1054(t2);
/* posixwin.scm:1226: ##sys#peek-c-string */
t4=*((C_word*)lf[6]+1);
((C_proc4)(void*)(*((C_word*)t4+1)))(4,t4,t1,t3,C_fix(0));}

/* k3905 in create-directory in k3893 in k3523 in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_3907(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word ab[8],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_3907,2,t0,t1);}
t2=t1;
t3=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_3910,a[2]=((C_word*)t0)[2],a[3]=t2,tmp=(C_word)a,a+=4,tmp);
if(C_truep(((C_word*)t0)[3])){
t4=t3;
t5=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_3915,a[2]=t4,tmp=(C_word)a,a+=3,tmp);
/* posixwin.scm:891: string-split */
t6=*((C_word*)lf[176]+1);
((C_proc4)(void*)(*((C_word*)t6+1)))(4,t6,t5,t2,lf[177]);}
else{
t4=t3;
t5=t2;
t6=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_4009,a[2]=t4,a[3]=t5,tmp=(C_word)a,a+=4,tmp);
/* posixwin.scm:881: ##sys#make-c-string */
((C_proc4)C_fast_retrieve_proc(*((C_word*)lf[12]+1)))(4,*((C_word*)lf[12]+1),t6,t5,lf[172]);}}

/* g752 in k3913 in k3905 in create-directory in k3893 in k3523 in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_fcall f_3919(C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word t4;
C_word ab[4],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)trf_3919,NULL,3,t0,t1,t2);}
t3=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_3924,a[2]=((C_word*)t0)[2],a[3]=t1,tmp=(C_word)a,a+=4,tmp);
/* posixwin.scm:895: string-append */
t4=*((C_word*)lf[4]+1);
((C_proc5)(void*)(*((C_word*)t4+1)))(5,t4,t3,((C_word*)((C_word*)t0)[2])[1],lf[175],t2);}

/* k3908 in k3905 in create-directory in k3893 in k3523 in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_3910(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word *a;
t2=((C_word*)t0)[2];
((C_proc2)(void*)(*((C_word*)t2+1)))(2,t2,((C_word*)t0)[3]);}

/* k3913 in k3905 in create-directory in k3893 in k3523 in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_3915(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word t11;
C_word ab[13],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_3915,2,t0,t1);}
t2=C_i_car(t1);
t3=t2;
t4=(*a=C_VECTOR_TYPE|1,a[1]=t3,tmp=(C_word)a,a+=2,tmp);
t5=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_3919,a[2]=t4,a[3]=((C_word)li73),tmp=(C_word)a,a+=4,tmp);
t6=C_u_i_cdr(t1);
t7=C_i_check_list_2(t6,lf[73]);
t8=C_SCHEME_UNDEFINED;
t9=(*a=C_VECTOR_TYPE|1,a[1]=t8,tmp=(C_word)a,a+=2,tmp);
t10=C_set_block_item(t9,0,(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_3966,a[2]=t9,a[3]=t5,a[4]=((C_word)li74),tmp=(C_word)a,a+=5,tmp));
t11=((C_word*)t9)[1];
f_3966(t11,((C_word*)t0)[2],t6);}

/* setarg in k3893 in k3523 in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_4946(C_word c,C_word t0,C_word t1,C_word t2,C_word t3,C_word t4){
C_word tmp;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word ab[5],*a=ab;
if(c!=5) C_bad_argc_2(c,5,t0);
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr5,(void*)f_4946,5,t0,t1,t2,t3,t4);}
t5=C_i_foreign_fixnum_argumentp(t2);
t6=t5;
t7=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_4955,a[2]=t4,a[3]=t1,a[4]=t6,tmp=(C_word)a,a+=5,tmp);
if(C_truep(t3)){
t8=C_i_foreign_string_argumentp(t3);
/* posixwin.scm:1314: ##sys#make-c-string */
((C_proc3)C_fast_retrieve_proc(*((C_word*)lf[12]+1)))(3,*((C_word*)lf[12]+1),t7,t8);}
else{
t8=C_i_foreign_fixnum_argumentp(t4);
t9=t1;
((C_proc2)(void*)(*((C_word*)t9+1)))(2,t9,stub1115(C_SCHEME_UNDEFINED,t6,C_SCHEME_FALSE,t8));}}

/* k3922 in g752 in k3913 in k3905 in create-directory in k3893 in k3523 in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_3924(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word ab[4],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_3924,2,t0,t1);}
t2=C_mutate2(((C_word *)((C_word*)t0)[2])+1,t1);
t3=((C_word*)t0)[3];
t4=((C_word*)((C_word*)t0)[2])[1];
t5=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_3932,a[2]=t3,a[3]=t4,tmp=(C_word)a,a+=4,tmp);
/* posixwin.scm:887: ##sys#file-exists? */
((C_proc6)C_fast_retrieve_proc(*((C_word*)lf[174]+1)))(6,*((C_word*)lf[174]+1),t5,t4,C_SCHEME_FALSE,C_SCHEME_TRUE,C_SCHEME_FALSE);}

/* k4936 in loop in $quote-args-list in k3893 in k3523 in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_4938(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word ab[3],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_4938,2,t0,t1);}
t2=C_a_i_cons(&a,2,t1,((C_word*)t0)[2]);
/* posixwin.scm:1304: loop */
t3=((C_word*)((C_word*)t0)[3])[1];
f_4912(t3,((C_word*)t0)[4],((C_word*)t0)[5],t2);}

/* k6232 in a6200 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_6234(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word ab[4],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_6234,2,t0,t1);}
t2=((C_word*)t0)[2];
t3=((C_word*)t0)[3];
t4=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_6211,a[2]=t2,a[3]=t3,tmp=(C_word)a,a+=4,tmp);
if(C_truep(t1)){
t5=C_i_foreign_string_argumentp(t1);
/* posix-common.scm:220: ##sys#make-c-string */
((C_proc3)C_fast_retrieve_proc(*((C_word*)lf[12]+1)))(3,*((C_word*)lf[12]+1),t4,t5);}
else{
t5=t2;
((C_proc2)(void*)(*((C_word*)t5+1)))(2,t5,stub120(C_SCHEME_UNDEFINED,C_SCHEME_FALSE,t3));}}

/* k3500 in k3453 in time->string in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_3502(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word ab[5],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_3502,2,t0,t1);}
t2=((C_word*)t0)[2];
t3=C_a_i_bytevector(&a,1,C_fix(3));
if(C_truep(t1)){
t4=C_i_foreign_block_argumentp(t1);
t5=stub516(t3,t2,t4);
/* posix-common.scm:512: ##sys#peek-c-string */
t6=*((C_word*)lf[6]+1);
((C_proc4)(void*)(*((C_word*)t6+1)))(4,t6,((C_word*)t0)[3],t5,C_fix(0));}
else{
t4=stub516(t3,t2,C_SCHEME_FALSE);
/* posix-common.scm:512: ##sys#peek-c-string */
t5=*((C_word*)lf[6]+1);
((C_proc4)(void*)(*((C_word*)t5+1)))(4,t5,((C_word*)t0)[3],t4,C_fix(0));}}

/* setenv in k3893 in k3523 in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_4967(C_word c,C_word t0,C_word t1,C_word t2,C_word t3,C_word t4){
C_word tmp;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word ab[5],*a=ab;
if(c!=5) C_bad_argc_2(c,5,t0);
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr5,(void*)f_4967,5,t0,t1,t2,t3,t4);}
t5=C_i_foreign_fixnum_argumentp(t2);
t6=t5;
t7=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_4976,a[2]=t4,a[3]=t1,a[4]=t6,tmp=(C_word)a,a+=5,tmp);
if(C_truep(t3)){
t8=C_i_foreign_string_argumentp(t3);
/* posixwin.scm:1315: ##sys#make-c-string */
((C_proc3)C_fast_retrieve_proc(*((C_word*)lf[12]+1)))(3,*((C_word*)lf[12]+1),t7,t8);}
else{
t8=C_i_foreign_fixnum_argumentp(t4);
t9=t1;
((C_proc2)(void*)(*((C_word*)t9+1)))(2,t9,stub1125(C_SCHEME_UNDEFINED,t6,C_SCHEME_FALSE,t8));}}

/* set-signal-handler! in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_3510(C_word c,C_word t0,C_word t1,C_word t2,C_word t3){
C_word tmp;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word *a;
if(c!=4) C_bad_argc_2(c,4,t0);
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr4,(void*)f_3510,4,t0,t1,t2,t3);}
t4=C_i_check_exact_2(t2,lf[117]);
if(C_truep(t3)){
t5=t2;
t6=C_establish_signal_handler(t2,t5);
t7=t1;
((C_proc2)(void*)(*((C_word*)t7+1)))(2,t7,C_i_vector_set(*((C_word*)lf[118]+1),t2,t3));}
else{
t5=C_establish_signal_handler(t2,C_SCHEME_FALSE);
t6=t1;
((C_proc2)(void*)(*((C_word*)t6+1)))(2,t6,C_i_vector_set(*((C_word*)lf[118]+1),t2,t3));}}

/* k3930 in k3922 in g752 in k3913 in k3905 in create-directory in k3893 in k3523 in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_3932(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word ab[4],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_3932,2,t0,t1);}
if(C_truep(t1)){
t2=C_SCHEME_UNDEFINED;
t3=((C_word*)t0)[2];
((C_proc2)(void*)(*((C_word*)t3+1)))(2,t3,t2);}
else{
t2=((C_word*)t0)[2];
t3=((C_word*)t0)[3];
t4=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_3951,a[2]=t2,a[3]=t3,tmp=(C_word)a,a+=4,tmp);
/* posixwin.scm:881: ##sys#make-c-string */
((C_proc4)C_fast_retrieve_proc(*((C_word*)lf[12]+1)))(4,*((C_word*)lf[12]+1),t4,t3,lf[172]);}}

/* k6219 in a6200 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_6221(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word *a;
if(C_truep(C_fixnum_lessp(t1,C_fix(0)))){
/* posix-common.scm:223: posix-error */
t2=lf[2];
f_2245(7,t2,((C_word*)t0)[2],lf[10],lf[404],lf[405],((C_word*)t0)[3],((C_word*)t0)[4]);}
else{
t2=C_SCHEME_UNDEFINED;
t3=((C_word*)t0)[2];
((C_proc2)(void*)(*((C_word*)t3+1)))(2,t3,t2);}}

/* k4953 in setarg in k3893 in k3523 in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_4955(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word *a;
t2=C_i_foreign_fixnum_argumentp(((C_word*)t0)[2]);
t3=((C_word*)t0)[3];
((C_proc2)(void*)(*((C_word*)t3+1)))(2,t3,stub1115(C_SCHEME_UNDEFINED,((C_word*)t0)[4],t1,t2));}

/* k3941 in k3949 in k3930 in k3922 in g752 in k3913 in k3905 in create-directory in k3893 in k3523 in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_3943(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word *a;
/* posixwin.scm:883: ##sys#signal-hook */
t2=*((C_word*)lf[3]+1);
((C_proc6)(void*)(*((C_word*)t2+1)))(6,t2,((C_word*)t0)[2],lf[10],lf[172],lf[173],((C_word*)t0)[3]);}

/* k6209 in k6232 in a6200 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_6211(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word *a;
t2=((C_word*)t0)[2];
((C_proc2)(void*)(*((C_word*)t2+1)))(2,t2,stub120(C_SCHEME_UNDEFINED,t1,((C_word*)t0)[3]));}

/* build-exec-argvec in k3893 in k3523 in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_fcall f_4988(C_word t1,C_word t2,C_word t3,C_word t4,C_word t5){
C_word tmp;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word ab[8],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)trf_4988,NULL,5,t1,t2,t3,t4,t5);}
if(C_truep(t3)){
t6=C_i_check_list_2(t3,t2);
t7=C_SCHEME_UNDEFINED;
t8=(*a=C_VECTOR_TYPE|1,a[1]=t7,tmp=(C_word)a,a+=2,tmp);
t9=C_set_block_item(t8,0,(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_5000,a[2]=t4,a[3]=t2,a[4]=t8,a[5]=((C_word)li125),tmp=(C_word)a,a+=6,tmp));
t10=((C_word*)t8)[1];
f_5000(t10,t1,t3,t5);}
else{
/* posixwin.scm:1327: argvec-setter */
t6=t4;
((C_proc5)C_fast_retrieve_proc(t6))(5,t6,t1,t5,C_SCHEME_FALSE,C_fix(0));}}

/* k3336 in seconds->utc-time in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_3338(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word *a;
t2=C_i_check_number_2(t1,lf[107]);
/* posix-common.scm:491: ##sys#decode-seconds */
((C_proc4)C_fast_retrieve_proc(*((C_word*)lf[105]+1)))(4,*((C_word*)lf[105]+1),((C_word*)t0)[2],t1,C_SCHEME_TRUE);}

/* seconds->utc-time in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_3334(C_word c,C_word t0,C_word t1,...){
C_word tmp;
C_word t2;
va_list v;
C_word *a,c2=c;
C_save_rest(t1,c2,2);
if(!C_demand(c*C_SIZEOF_PAIR+3)){
C_save_and_reclaim((void*)tr2r,(void*)f_3334r,2,t0,t1);}
else{
a=C_alloc((c-2)*3);
t2=C_restore_rest(a,C_rest_count(0));
f_3334r(t0,t1,t2);}}

static void C_ccall f_3334r(C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word *a=C_alloc(3);
t3=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_3338,a[2]=t1,tmp=(C_word)a,a+=3,tmp);
if(C_truep(C_i_nullp(t2))){
/* posix-common.scm:489: current-seconds */
t4=*((C_word*)lf[106]+1);
((C_proc2)(void*)(*((C_word*)t4+1)))(2,t4,t3);}
else{
t4=C_i_car(t2);
t5=C_i_check_number_2(t4,lf[107]);
/* posix-common.scm:491: ##sys#decode-seconds */
((C_proc4)C_fast_retrieve_proc(*((C_word*)lf[105]+1)))(4,*((C_word*)lf[105]+1),t1,t4,C_SCHEME_TRUE);}}

/* k3103 in k3179 in k3186 in k3081 in loop in k3060 in k3053 in k3050 in k3258 in k3255 in k3252 in k3249 in k3246 in k3243 in find-files in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_3105(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word *a;
/* posix-common.scm:444: loop */
t2=((C_word*)((C_word*)t0)[2])[1];
f_3064(t2,((C_word*)t0)[3],((C_word*)t0)[4],t1);}

/* k3106 in k3179 in k3186 in k3081 in loop in k3060 in k3053 in k3050 in k3258 in k3255 in k3252 in k3249 in k3246 in k3243 in find-files in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_3108(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word *a;
if(C_truep(t1)){
/* posix-common.scm:444: action */
t2=((C_word*)t0)[2];
((C_proc4)C_fast_retrieve_proc(t2))(4,t2,((C_word*)t0)[3],((C_word*)t0)[4],((C_word*)t0)[5]);}
else{
t2=((C_word*)t0)[5];
/* posix-common.scm:444: loop */
t3=((C_word*)((C_word*)t0)[6])[1];
f_3064(t3,((C_word*)t0)[7],((C_word*)t0)[8],t2);}}

/* k4974 in setenv in k3893 in k3523 in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_4976(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word *a;
t2=C_i_foreign_fixnum_argumentp(((C_word*)t0)[2]);
t3=((C_word*)t0)[3];
((C_proc2)(void*)(*((C_word*)t3+1)))(2,t3,stub1125(C_SCHEME_UNDEFINED,((C_word*)t0)[4],t1,t2));}

/* k5705 in current-user-name in k3893 in k3523 in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_5707(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word *a;
/* posixwin.scm:1488: ##sys#error */
t2=*((C_word*)lf[45]+1);
((C_proc4)(void*)(*((C_word*)t2+1)))(4,t2,((C_word*)t0)[2],lf[330],lf[331]);}

/* k3315 in seconds->local-time in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_3317(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word *a;
t2=C_i_check_number_2(t1,lf[104]);
/* posix-common.scm:487: ##sys#decode-seconds */
((C_proc4)C_fast_retrieve_proc(*((C_word*)lf[105]+1)))(4,*((C_word*)lf[105]+1),((C_word*)t0)[2],t1,C_SCHEME_FALSE);}

/* seconds->local-time in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_3313(C_word c,C_word t0,C_word t1,...){
C_word tmp;
C_word t2;
va_list v;
C_word *a,c2=c;
C_save_rest(t1,c2,2);
if(!C_demand(c*C_SIZEOF_PAIR+3)){
C_save_and_reclaim((void*)tr2r,(void*)f_3313r,2,t0,t1);}
else{
a=C_alloc((c-2)*3);
t2=C_restore_rest(a,C_rest_count(0));
f_3313r(t0,t1,t2);}}

static void C_ccall f_3313r(C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word *a=C_alloc(3);
t3=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_3317,a[2]=t1,tmp=(C_word)a,a+=3,tmp);
if(C_truep(C_i_nullp(t2))){
/* posix-common.scm:485: current-seconds */
t4=*((C_word*)lf[106]+1);
((C_proc2)(void*)(*((C_word*)t4+1)))(2,t4,t3);}
else{
t4=C_i_car(t2);
t5=C_i_check_number_2(t4,lf[104]);
/* posix-common.scm:487: ##sys#decode-seconds */
((C_proc4)C_fast_retrieve_proc(*((C_word*)lf[105]+1)))(4,*((C_word*)lf[105]+1),t1,t4,C_SCHEME_FALSE);}}

/* k3790 in k3783 in k3777 in file-mkstemp in k3523 in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_3792(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word *a;
/* posixwin.scm:817: values */
C_values(4,0,((C_word*)t0)[2],((C_word*)t0)[3],t1);}

/* loop in k3060 in k3053 in k3050 in k3258 in k3255 in k3252 in k3249 in k3246 in k3243 in find-files in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_fcall f_3064(C_word t0,C_word t1,C_word t2,C_word t3){
C_word tmp;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word ab[13],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)trf_3064,NULL,4,t0,t1,t2,t3);}
if(C_truep(C_i_nullp(t2))){
t4=t3;
t5=t1;
((C_proc2)(void*)(*((C_word*)t5+1)))(2,t5,t4);}
else{
t4=C_slot(t2,C_fix(0));
t5=t4;
t6=C_slot(t2,C_fix(1));
t7=t6;
t8=(*a=C_CLOSURE_TYPE|12,a[1]=(C_word)f_3083,a[2]=((C_word*)t0)[2],a[3]=t1,a[4]=t7,a[5]=t3,a[6]=((C_word*)t0)[3],a[7]=((C_word*)t0)[4],a[8]=t5,a[9]=((C_word*)t0)[5],a[10]=((C_word*)t0)[6],a[11]=((C_word*)t0)[7],a[12]=((C_word*)t0)[8],tmp=(C_word)a,a+=13,tmp);
/* posix-common.scm:441: directory? */
t9=*((C_word*)lf[40]+1);
((C_proc3)(void*)(*((C_word*)t9+1)))(3,t9,t8,t5);}}

/* k3060 in k3053 in k3050 in k3258 in k3255 in k3252 in k3249 in k3246 in k3243 in find-files in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_3062(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word ab[12],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_3062,2,t0,t1);}
t2=C_SCHEME_UNDEFINED;
t3=(*a=C_VECTOR_TYPE|1,a[1]=t2,tmp=(C_word)a,a+=2,tmp);
t4=C_set_block_item(t3,0,(*a=C_CLOSURE_TYPE|9,a[1]=(C_word)f_3064,a[2]=t3,a[3]=((C_word*)t0)[2],a[4]=((C_word*)t0)[3],a[5]=((C_word*)t0)[4],a[6]=((C_word*)t0)[5],a[7]=((C_word*)t0)[6],a[8]=((C_word*)t0)[7],a[9]=((C_word)li38),tmp=(C_word)a,a+=10,tmp));
t5=((C_word*)t3)[1];
f_3064(t5,((C_word*)t0)[8],t1,((C_word*)t0)[9]);}

/* utc-time->seconds in k3893 in k3523 in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_6091(C_word c,C_word t0,C_word t1,...){
C_word tmp;
C_word t2;
C_word *a;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_6091,2,t0,t1);}
/* posixwin.scm:1701: error */
t2=*((C_word*)lf[351]+1);
((C_proc4)(void*)(*((C_word*)t2+1)))(4,t2,t1,lf[389],lf[0]);}

/* string->time in k3893 in k3523 in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_6097(C_word c,C_word t0,C_word t1,...){
C_word tmp;
C_word t2;
C_word *a;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_6097,2,t0,t1);}
/* posixwin.scm:1702: error */
t2=*((C_word*)lf[351]+1);
((C_proc4)(void*)(*((C_word*)t2+1)))(4,t2,t1,lf[390],lf[0]);}

/* k3783 in k3777 in file-mkstemp in k3523 in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_3785(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word ab[4],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_3785,2,t0,t1);}
t2=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_3792,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],tmp=(C_word)a,a+=4,tmp);
t3=C_fixnum_difference(((C_word*)t0)[4],C_fix(1));
/* posixwin.scm:817: ##sys#substring */
((C_proc5)C_fast_retrieve_proc(*((C_word*)lf[67]+1)))(5,*((C_word*)lf[67]+1),t2,((C_word*)t0)[5],C_fix(0),t3);}

/* k3053 in k3050 in k3258 in k3255 in k3252 in k3249 in k3246 in k3243 in find-files in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_fcall f_3055(C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word ab[13],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)trf_3055,NULL,2,t0,t1);}
t2=t1;
t3=(*a=C_CLOSURE_TYPE|9,a[1]=(C_word)f_3062,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=t2,a[5]=((C_word*)t0)[4],a[6]=((C_word*)t0)[5],a[7]=((C_word*)t0)[6],a[8]=((C_word*)t0)[7],a[9]=((C_word*)t0)[8],tmp=(C_word)a,a+=10,tmp);
t4=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_3208,a[2]=t3,tmp=(C_word)a,a+=3,tmp);
if(C_truep(((C_word*)t0)[5])){
/* posix-common.scm:435: make-pathname */
t5=*((C_word*)lf[81]+1);
((C_proc4)(void*)(*((C_word*)t5+1)))(4,t5,t4,((C_word*)t0)[9],lf[93]);}
else{
/* posix-common.scm:435: make-pathname */
t5=*((C_word*)lf[81]+1);
((C_proc4)(void*)(*((C_word*)t5+1)))(4,t5,t4,((C_word*)t0)[9],lf[94]);}}

/* k3050 in k3258 in k3255 in k3252 in k3249 in k3246 in k3243 in find-files in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_fcall f_3052(C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word ab[13],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)trf_3052,NULL,2,t0,t1);}
t2=t1;
t3=(*a=C_CLOSURE_TYPE|9,a[1]=(C_word)f_3055,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[4],a[5]=((C_word*)t0)[5],a[6]=t2,a[7]=((C_word*)t0)[6],a[8]=((C_word*)t0)[7],a[9]=((C_word*)t0)[8],tmp=(C_word)a,a+=10,tmp);
if(C_truep(C_i_closurep(((C_word*)t0)[9]))){
t4=t3;
f_3055(t4,((C_word*)t0)[9]);}
else{
t4=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_3218,a[2]=t3,tmp=(C_word)a,a+=3,tmp);
/* posix-common.scm:433: irregex */
t5=*((C_word*)lf[95]+1);
((C_proc3)(void*)(*((C_word*)t5+1)))(3,t5,t4,((C_word*)t0)[9]);}}

/* user-information in k3893 in k3523 in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_6085(C_word c,C_word t0,C_word t1,...){
C_word tmp;
C_word t2;
C_word *a;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_6085,2,t0,t1);}
/* posixwin.scm:1700: error */
t2=*((C_word*)lf[351]+1);
((C_proc4)(void*)(*((C_word*)t2+1)))(4,t2,t1,lf[388],lf[0]);}

/* terminal-name in k3893 in k3523 in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_6079(C_word c,C_word t0,C_word t1,...){
C_word tmp;
C_word t2;
C_word *a;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_6079,2,t0,t1);}
/* posixwin.scm:1699: error */
t2=*((C_word*)lf[351]+1);
((C_proc4)(void*)(*((C_word*)t2+1)))(4,t2,t1,lf[387],lf[0]);}

/* signal-unmask! in k3893 in k3523 in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_6073(C_word c,C_word t0,C_word t1,...){
C_word tmp;
C_word t2;
C_word *a;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_6073,2,t0,t1);}
/* posixwin.scm:1698: error */
t2=*((C_word*)lf[351]+1);
((C_proc4)(void*)(*((C_word*)t2+1)))(4,t2,t1,lf[386],lf[0]);}

/* k3037 in a2964 in conc-loop in glob in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_3039(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word *a;
/* posix-common.scm:409: ##sys#glob->regexp */
((C_proc3)C_fast_retrieve_proc(*((C_word*)lf[85]+1)))(3,*((C_word*)lf[85]+1),((C_word*)t0)[2],t1);}

/* process in k3893 in k3523 in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_5516(C_word c,C_word t0,C_word t1,C_word t2,...){
C_word tmp;
C_word t3;
va_list v;
C_word *a,c2=c;
C_save_rest(t2,c2,3);
if(c<3) C_bad_min_argc_2(c,3,t0);
if(!C_demand(c*C_SIZEOF_PAIR+0)){
C_save_and_reclaim((void*)tr3r,(void*)f_5516r,3,t0,t1,t2);}
else{
a=C_alloc((c-3)*3);
t3=C_restore_rest(a,C_rest_count(0));
f_5516r(t0,t1,t2,t3);}}

static void C_ccall f_5516r(C_word t0,C_word t1,C_word t2,C_word t3){
C_word tmp;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word t11;
C_word t12;
C_word t13;
C_word t14;
C_word t15;
t4=C_i_nullp(t3);
t5=(C_truep(t4)?C_SCHEME_FALSE:C_i_car(t3));
t6=C_i_nullp(t3);
t7=(C_truep(t6)?C_SCHEME_END_OF_LIST:C_i_cdr(t3));
t8=C_i_nullp(t7);
t9=(C_truep(t8)?C_SCHEME_FALSE:C_i_car(t7));
t10=C_i_nullp(t7);
t11=(C_truep(t10)?C_SCHEME_END_OF_LIST:C_i_cdr(t7));
t12=C_i_nullp(t11);
t13=(C_truep(t12)?C_SCHEME_FALSE:C_i_car(t11));
if(C_truep(C_i_nullp(t11))){
/* posixwin.scm:1443: %process */
f_5432(t1,lf[322],C_SCHEME_FALSE,t2,t5,t9,t13);}
else{
t14=C_i_cdr(t11);
/* posixwin.scm:1443: %process */
f_5432(t1,lf[322],C_SCHEME_FALSE,t2,t5,t9,t13);}}

/* k5512 in k5508 in %process in k3893 in k3523 in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_5514(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word *a;
t2=C_mutate2(((C_word *)((C_word*)t0)[2])+1,t1);
t3=((C_word*)t0)[3];
f_5475(2,t3,t2);}

/* k5508 in %process in k3893 in k3523 in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_5510(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word ab[4],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_5510,2,t0,t1);}
t2=C_mutate2(((C_word *)((C_word*)t0)[2])+1,t1);
t3=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_5514,a[2]=((C_word*)t0)[3],a[3]=((C_word*)t0)[4],tmp=(C_word)a,a+=4,tmp);
/* posixwin.scm:1435: ##sys#shell-command */
t4=*((C_word*)lf[310]+1);
((C_proc2)(void*)(*((C_word*)t4+1)))(2,t4,t3);}

/* k5773 in k5767 in k5764 in k5761 in map-file-to-memory in k3893 in k3523 in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_5775(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word ab[4],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_5775,2,t0,t1);}
t2=((C_word*)t0)[2];
((C_proc2)(void*)(*((C_word*)t2+1)))(2,t2,C_a_i_record3(&a,3,lf[342],((C_word*)t0)[3],((C_word*)t0)[4]));}

/* a6200 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_6201(C_word c,C_word t0,C_word t1,C_word t2,C_word t3){
C_word tmp;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word ab[9],*a=ab;
if(c!=4) C_bad_argc_2(c,4,t0);
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr4,(void*)f_6201,4,t0,t1,t2,t3);}
t4=C_i_check_number_2(t3,lf[404]);
t5=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_6221,a[2]=t1,a[3]=t2,a[4]=t3,tmp=(C_word)a,a+=5,tmp);
t6=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_6234,a[2]=t5,a[3]=t3,tmp=(C_word)a,a+=4,tmp);
/* posix-common.scm:221: ##sys#expand-home-path */
((C_proc3)C_fast_retrieve_proc(*((C_word*)lf[14]+1)))(3,*((C_word*)lf[14]+1),t6,t2);}

/* a3562 in process-wait in k3523 in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_3563(C_word c,C_word t0,C_word t1,C_word t2,C_word t3,C_word t4){
C_word tmp;
C_word t5;
C_word t6;
C_word *a;
if(c!=5) C_bad_argc_2(c,5,t0);
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr5,(void*)f_3563,5,t0,t1,t2,t3,t4);}
t5=C_eqp(t2,C_fix(-1));
if(C_truep(t5)){
/* posix-common.scm:554: posix-error */
t6=lf[2];
f_2245(6,t6,t1,lf[123],lf[121],lf[124],((C_word*)t0)[2]);}
else{
/* posix-common.scm:555: values */
C_values(5,0,t1,t2,t3,t4);}}

/* current-group-id in k3893 in k3523 in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_5911(C_word c,C_word t0,C_word t1,...){
C_word tmp;
C_word t2;
C_word *a;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_5911,2,t0,t1);}
/* posixwin.scm:1671: error */
t2=*((C_word*)lf[351]+1);
((C_proc4)(void*)(*((C_word*)t2+1)))(4,t2,t1,lf[359],lf[0]);}

/* current-user-id in k3893 in k3523 in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_5917(C_word c,C_word t0,C_word t1,...){
C_word tmp;
C_word t2;
C_word *a;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_5917,2,t0,t1);}
/* posixwin.scm:1672: error */
t2=*((C_word*)lf[351]+1);
((C_proc4)(void*)(*((C_word*)t2+1)))(4,t2,t1,lf[360],lf[0]);}

/* k4066 in check in k3893 in k3523 in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_4068(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word ab[4],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_4068,2,t0,t1);}
if(C_truep(C_null_pointerp(((C_word*)t0)[2]))){
/* posixwin.scm:927: ##sys#signal-hook */
t2=*((C_word*)lf[3]+1);
((C_proc5)(void*)(*((C_word*)t2+1)))(5,t2,((C_word*)t0)[3],lf[10],lf[179],((C_word*)t0)[4]);}
else{
t2=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_4080,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],tmp=(C_word)a,a+=4,tmp);
/* posixwin.scm:928: ##sys#make-port */
((C_proc6)C_fast_retrieve_proc(*((C_word*)lf[52]+1)))(6,*((C_word*)lf[52]+1),t2,((C_word*)t0)[5],*((C_word*)lf[53]+1),lf[180],lf[55]);}}

/* k5779 in k5767 in k5764 in k5761 in map-file-to-memory in k3893 in k3523 in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_fcall f_5781(C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word ab[4],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)trf_5781,NULL,2,t0,t1);}
if(C_truep(t1)){
/* posixwin.scm:1637: posix-error */
t2=lf[2];
f_2245(11,t2,((C_word*)t0)[2],lf[10],lf[341],lf[343],((C_word*)t0)[3],((C_word*)t0)[4],((C_word*)t0)[5],((C_word*)t0)[6],((C_word*)t0)[7],((C_word*)t0)[8]);}
else{
t2=((C_word*)t0)[9];
((C_proc2)(void*)(*((C_word*)t2+1)))(2,t2,C_a_i_record3(&a,3,lf[342],((C_word*)t0)[10],((C_word*)t0)[4]));}}

/* check in k3893 in k3523 in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_fcall f_4064(C_word t1,C_word t2,C_word t3,C_word t4){
C_word tmp;
C_word t5;
C_word t6;
C_word ab[6],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)trf_4064,NULL,4,t1,t2,t3,t4);}
t5=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_4068,a[2]=t4,a[3]=t1,a[4]=t2,a[5]=t3,tmp=(C_word)a,a+=6,tmp);
/* posixwin.scm:925: ##sys#update-errno */
((C_proc2)C_fast_retrieve_proc(*((C_word*)lf[7]+1)))(2,*((C_word*)lf[7]+1),t5);}

/* seconds->string in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_3365(C_word c,C_word t0,C_word t1,...){
C_word tmp;
C_word t2;
va_list v;
C_word *a,c2=c;
C_save_rest(t1,c2,2);
if(!C_demand(c*C_SIZEOF_PAIR+3)){
C_save_and_reclaim((void*)tr2r,(void*)f_3365r,2,t0,t1);}
else{
a=C_alloc((c-2)*3);
t2=C_restore_rest(a,C_rest_count(0));
f_3365r(t0,t1,t2);}}

static void C_ccall f_3365r(C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word t4;
C_word *a=C_alloc(3);
t3=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_3369,a[2]=t1,tmp=(C_word)a,a+=3,tmp);
if(C_truep(C_i_nullp(t2))){
/* posix-common.scm:495: current-seconds */
t4=*((C_word*)lf[106]+1);
((C_proc2)(void*)(*((C_word*)t4+1)))(2,t4,t3);}
else{
t4=t3;
f_3369(2,t4,C_i_car(t2));}}

/* k3367 in seconds->string in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_3369(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word ab[9],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_3369,2,t0,t1);}
t2=t1;
t3=C_i_check_number_2(t2,lf[108]);
t4=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_3375,a[2]=((C_word*)t0)[2],a[3]=t2,tmp=(C_word)a,a+=4,tmp);
t5=C_a_i_bytevector(&a,1,C_fix(3));
t6=C_i_foreign_integer_argumentp(t2);
t7=stub487(t5,t6);
/* posix-common.scm:494: ##sys#peek-c-string */
t8=*((C_word*)lf[6]+1);
((C_proc4)(void*)(*((C_word*)t8+1)))(4,t8,t4,t7,C_fix(0));}

/* k3081 in loop in k3060 in k3053 in k3050 in k3258 in k3255 in k3252 in k3249 in k3246 in k3243 in find-files in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_3083(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word ab[13],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_3083,2,t0,t1);}
if(C_truep(t1)){
t2=(*a=C_CLOSURE_TYPE|12,a[1]=(C_word)f_3188,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[4],a[5]=((C_word*)t0)[5],a[6]=((C_word*)t0)[6],a[7]=((C_word*)t0)[7],a[8]=((C_word*)t0)[8],a[9]=((C_word*)t0)[9],a[10]=((C_word*)t0)[10],a[11]=((C_word*)t0)[11],a[12]=((C_word*)t0)[12],tmp=(C_word)a,a+=13,tmp);
/* posix-common.scm:442: pathname-file */
t3=*((C_word*)lf[92]+1);
((C_proc3)(void*)(*((C_word*)t3+1)))(3,t3,t2,((C_word*)t0)[8]);}
else{
t2=(*a=C_CLOSURE_TYPE|7,a[1]=(C_word)f_3194,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[4],a[5]=((C_word*)t0)[7],a[6]=((C_word*)t0)[8],a[7]=((C_word*)t0)[5],tmp=(C_word)a,a+=8,tmp);
/* posix-common.scm:451: pproc */
t3=((C_word*)t0)[9];
((C_proc3)(void*)(*((C_word*)t3+1)))(3,t3,t2,((C_word*)t0)[8]);}}

/* file-link in k3893 in k3523 in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_5923(C_word c,C_word t0,C_word t1,...){
C_word tmp;
C_word t2;
C_word *a;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_5923,2,t0,t1);}
/* posixwin.scm:1673: error */
t2=*((C_word*)lf[351]+1);
((C_proc4)(void*)(*((C_word*)t2+1)))(4,t2,t1,lf[361],lf[0]);}

/* file-lock in k3893 in k3523 in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_5929(C_word c,C_word t0,C_word t1,...){
C_word tmp;
C_word t2;
C_word *a;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_5929,2,t0,t1);}
/* posixwin.scm:1674: error */
t2=*((C_word*)lf[351]+1);
((C_proc4)(void*)(*((C_word*)t2+1)))(4,t2,t1,lf[362],lf[0]);}

/* process* in k3893 in k3523 in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_5576(C_word c,C_word t0,C_word t1,C_word t2,...){
C_word tmp;
C_word t3;
va_list v;
C_word *a,c2=c;
C_save_rest(t2,c2,3);
if(c<3) C_bad_min_argc_2(c,3,t0);
if(!C_demand(c*C_SIZEOF_PAIR+0)){
C_save_and_reclaim((void*)tr3r,(void*)f_5576r,3,t0,t1,t2);}
else{
a=C_alloc((c-3)*3);
t3=C_restore_rest(a,C_rest_count(0));
f_5576r(t0,t1,t2,t3);}}

static void C_ccall f_5576r(C_word t0,C_word t1,C_word t2,C_word t3){
C_word tmp;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word t11;
C_word t12;
C_word t13;
C_word t14;
C_word t15;
t4=C_i_nullp(t3);
t5=(C_truep(t4)?C_SCHEME_FALSE:C_i_car(t3));
t6=C_i_nullp(t3);
t7=(C_truep(t6)?C_SCHEME_END_OF_LIST:C_i_cdr(t3));
t8=C_i_nullp(t7);
t9=(C_truep(t8)?C_SCHEME_FALSE:C_i_car(t7));
t10=C_i_nullp(t7);
t11=(C_truep(t10)?C_SCHEME_END_OF_LIST:C_i_cdr(t7));
t12=C_i_nullp(t11);
t13=(C_truep(t12)?C_SCHEME_FALSE:C_i_car(t11));
if(C_truep(C_i_nullp(t11))){
/* posixwin.scm:1446: %process */
f_5432(t1,lf[323],C_SCHEME_TRUE,t2,t5,t9,t13);}
else{
t14=C_i_cdr(t11);
/* posixwin.scm:1446: %process */
f_5432(t1,lf[323],C_SCHEME_TRUE,t2,t5,t9,t13);}}

/* f6899 in k3523 in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f6899(C_word c,C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word t4;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr3,(void*)f6899,3,t0,t1,t2);}
t3=C_i_check_string_2(t2,lf[39]);
t4=t1;
((C_proc2)(void*)(*((C_word*)t4+1)))(2,t4,C_SCHEME_FALSE);}

/* k5044 in k5041 in $exec-setup in k3893 in k3523 in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_5046(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word ab[14],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_5046,2,t0,t1);}
t2=(*a=C_CLOSURE_TYPE|7,a[1]=(C_word)f_5049,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[4],a[5]=((C_word*)t0)[5],a[6]=((C_word*)t0)[6],a[7]=((C_word*)t0)[7],tmp=(C_word)a,a+=8,tmp);
t3=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_5063,a[2]=((C_word*)t0)[5],a[3]=t2,a[4]=((C_word*)t0)[3],a[5]=((C_word*)t0)[8],tmp=(C_word)a,a+=6,tmp);
if(C_truep(((C_word*)t0)[9])){
/* posixwin.scm:1332: $quote-args-list */
f_4869(t3,((C_word*)t0)[9],((C_word*)t0)[10]);}
else{
/* posixwin.scm:1332: build-exec-argvec */
f_4988(t2,((C_word*)t0)[3],C_SCHEME_FALSE,((C_word*)t0)[8],C_fix(1));}}

/* k5041 in $exec-setup in k3893 in k3523 in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_5043(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word ab[11],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_5043,2,t0,t1);}
t2=(*a=C_CLOSURE_TYPE|10,a[1]=(C_word)f_5046,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[4],a[5]=((C_word*)t0)[5],a[6]=((C_word*)t0)[6],a[7]=((C_word*)t0)[7],a[8]=((C_word*)t0)[8],a[9]=((C_word*)t0)[9],a[10]=((C_word*)t0)[10],tmp=(C_word)a,a+=11,tmp);
t3=C_block_size(t1);
/* posixwin.scm:1331: setarg */
t4=((C_word*)t0)[8];
f_4946(5,t4,t2,C_fix(0),t1,t3);}

/* set-groups! in k3893 in k3523 in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_6025(C_word c,C_word t0,C_word t1,...){
C_word tmp;
C_word t2;
C_word *a;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_6025,2,t0,t1);}
/* posixwin.scm:1690: error */
t2=*((C_word*)lf[351]+1);
((C_proc4)(void*)(*((C_word*)t2+1)))(4,t2,t1,lf[378],lf[0]);}

/* k5047 in k5044 in k5041 in $exec-setup in k3893 in k3523 in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_5049(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word ab[5],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_5049,2,t0,t1);}
t2=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_5052,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[4],tmp=(C_word)a,a+=5,tmp);
/* posixwin.scm:1333: build-exec-argvec */
f_4988(t2,((C_word*)t0)[3],((C_word*)t0)[6],((C_word*)t0)[7],C_fix(0));}

/* k5767 in k5764 in k5761 in map-file-to-memory in k3893 in k3523 in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_5769(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word t11;
C_word t12;
C_word t13;
C_word t14;
C_word t15;
C_word t16;
C_word t17;
C_word t18;
C_word ab[21],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_5769,2,t0,t1);}
t2=((C_word*)t0)[2];
t3=((C_word*)t0)[3];
t4=((C_word*)t0)[4];
t5=((C_word*)t0)[5];
t6=C_a_i_bytevector(&a,1,C_fix(3));
t7=(C_truep(((C_word*)t0)[6])?C_i_foreign_pointer_argumentp(((C_word*)t0)[6]):C_SCHEME_FALSE);
t8=C_i_foreign_integer_argumentp(t2);
t9=C_i_foreign_fixnum_argumentp(t3);
t10=C_i_foreign_fixnum_argumentp(t4);
t11=C_i_foreign_fixnum_argumentp(t5);
t12=C_i_foreign_integer_argumentp(((C_word*)t0)[7]);
t13=stub1427(t6,t7,t8,t9,t10,t11,t12);
t14=t13;
t15=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_5775,a[2]=((C_word*)t0)[8],a[3]=t14,a[4]=((C_word*)t0)[2],tmp=(C_word)a,a+=5,tmp);
t16=(*a=C_CLOSURE_TYPE|10,a[1]=(C_word)f_5781,a[2]=t15,a[3]=((C_word*)t0)[6],a[4]=((C_word*)t0)[2],a[5]=((C_word*)t0)[3],a[6]=((C_word*)t0)[4],a[7]=((C_word*)t0)[5],a[8]=((C_word*)t0)[7],a[9]=((C_word*)t0)[8],a[10]=t14,tmp=(C_word)a,a+=11,tmp);
if(C_truep(t14)){
t17=C_i_foreign_pointer_argumentp(t14);
t18=t16;
f_5781(t18,stub1439(C_SCHEME_UNDEFINED,t17));}
else{
t17=t16;
f_5781(t17,stub1439(C_SCHEME_UNDEFINED,C_SCHEME_FALSE));}}

/* k5764 in k5761 in map-file-to-memory in k3893 in k3523 in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_fcall f_5766(C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word ab[9],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)trf_5766,NULL,2,t0,t1);}
t2=t1;
t3=(*a=C_CLOSURE_TYPE|8,a[1]=(C_word)f_5769,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[4],a[5]=((C_word*)t0)[5],a[6]=((C_word*)t0)[6],a[7]=t2,a[8]=((C_word*)t0)[7],tmp=(C_word)a,a+=9,tmp);
if(C_truep(C_blockp(((C_word*)t0)[6]))){
if(C_truep(C_specialp(((C_word*)t0)[6]))){
t4=t3;
f_5769(2,t4,C_SCHEME_UNDEFINED);}
else{
/* posixwin.scm:1634: ##sys#signal-hook */
t4=*((C_word*)lf[3]+1);
((C_proc6)(void*)(*((C_word*)t4+1)))(6,t4,t3,lf[15],lf[341],lf[344],((C_word*)t0)[6]);}}
else{
/* posixwin.scm:1634: ##sys#signal-hook */
t4=*((C_word*)lf[3]+1);
((C_proc6)(void*)(*((C_word*)t4+1)))(6,t4,t3,lf[15],lf[341],lf[344],((C_word*)t0)[6]);}}

/* k5761 in map-file-to-memory in k3893 in k3523 in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_5763(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word ab[8],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_5763,2,t0,t1);}
t2=t1;
t3=(*a=C_CLOSURE_TYPE|7,a[1]=(C_word)f_5766,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[4],a[5]=((C_word*)t0)[5],a[6]=t2,a[7]=((C_word*)t0)[6],tmp=(C_word)a,a+=8,tmp);
if(C_truep(C_i_pairp(((C_word*)t0)[7]))){
t4=((C_word*)t0)[7];
t5=t3;
f_5766(t5,C_u_i_car(t4));}
else{
t4=t3;
f_5766(t4,C_fix(0));}}

/* k4007 in k3905 in create-directory in k3893 in k3523 in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_4009(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word ab[4],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_4009,2,t0,t1);}
t2=C_mkdir(t1);
t3=C_eqp(C_fix(0),t2);
if(C_truep(t3)){
t4=C_SCHEME_UNDEFINED;
t5=((C_word*)t0)[2];
((C_proc2)(void*)(*((C_word*)t5+1)))(2,t5,t4);}
else{
t4=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_4001,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],tmp=(C_word)a,a+=4,tmp);
/* posixwin.scm:882: ##sys#update-errno */
((C_proc2)C_fast_retrieve_proc(*((C_word*)lf[7]+1)))(2,*((C_word*)lf[7]+1),t4);}}

/* k3999 in k4007 in k3905 in create-directory in k3893 in k3523 in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_4001(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word *a;
/* posixwin.scm:883: ##sys#signal-hook */
t2=*((C_word*)lf[3]+1);
((C_proc6)(void*)(*((C_word*)t2+1)))(6,t2,((C_word*)t0)[2],lf[10],lf[172],lf[173],((C_word*)t0)[3]);}

/* k5074 in $exec-teardown in k3893 in k3523 in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_5076(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word *a;
t2=C_free_exec_args();
t3=C_free_exec_env();
t4=C_eqp(((C_word*)t0)[2],C_fix(-1));
if(C_truep(t4)){
/* posixwin.scm:1342: ##sys#error */
t5=*((C_word*)lf[45]+1);
((C_proc5)(void*)(*((C_word*)t5+1)))(5,t5,((C_word*)t0)[3],((C_word*)t0)[4],((C_word*)t0)[5],((C_word*)t0)[6]);}
else{
t5=((C_word*)t0)[2];
t6=((C_word*)t0)[3];
((C_proc2)(void*)(*((C_word*)t6+1)))(2,t6,t5);}}

/* current-effective-user-name in k3893 in k3523 in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_5905(C_word c,C_word t0,C_word t1,...){
C_word tmp;
C_word t2;
C_word *a;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_5905,2,t0,t1);}
/* posixwin.scm:1670: error */
t2=*((C_word*)lf[351]+1);
((C_proc4)(void*)(*((C_word*)t2+1)))(4,t2,t1,lf[358],lf[0]);}

/* $exec-teardown in k3893 in k3523 in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_fcall f_5072(C_word t1,C_word t2,C_word t3,C_word t4,C_word t5){
C_word tmp;
C_word t6;
C_word t7;
C_word ab[7],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)trf_5072,NULL,5,t1,t2,t3,t4,t5);}
t6=(*a=C_CLOSURE_TYPE|6,a[1]=(C_word)f_5076,a[2]=t5,a[3]=t1,a[4]=t2,a[5]=t3,a[6]=t4,tmp=(C_word)a,a+=7,tmp);
/* posixwin.scm:1338: ##sys#update-errno */
((C_proc2)C_fast_retrieve_proc(*((C_word*)lf[7]+1)))(2,*((C_word*)lf[7]+1),t6);}

/* set-alarm! in k3893 in k3523 in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_6013(C_word c,C_word t0,C_word t1,...){
C_word tmp;
C_word t2;
C_word *a;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_6013,2,t0,t1);}
/* posixwin.scm:1688: error */
t2=*((C_word*)lf[351]+1);
((C_proc4)(void*)(*((C_word*)t2+1)))(4,t2,t1,lf[376],lf[0]);}

/* set-group-id! in k3893 in k3523 in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_6019(C_word c,C_word t0,C_word t1,...){
C_word tmp;
C_word t2;
C_word *a;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_6019,2,t0,t1);}
/* posixwin.scm:1689: error */
t2=*((C_word*)lf[351]+1);
((C_proc4)(void*)(*((C_word*)t2+1)))(4,t2,t1,lf[377],lf[0]);}

/* k3373 in k3367 in seconds->string in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_3375(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word *a;
if(C_truep(t1)){
t2=C_block_size(t1);
t3=C_fixnum_difference(t2,C_fix(1));
/* posix-common.scm:499: ##sys#substring */
((C_proc5)C_fast_retrieve_proc(*((C_word*)lf[67]+1)))(5,*((C_word*)lf[67]+1),((C_word*)t0)[2],t1,C_fix(0),t3);}
else{
/* posix-common.scm:500: ##sys#error */
t2=*((C_word*)lf[45]+1);
((C_proc5)(void*)(*((C_word*)t2+1)))(5,t2,((C_word*)t0)[2],lf[108],lf[109],((C_word*)t0)[3]);}}

/* k5061 in k5044 in k5041 in $exec-setup in k3893 in k3523 in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_5063(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word *a;
/* posixwin.scm:1332: build-exec-argvec */
f_4988(((C_word*)t0)[3],((C_word*)t0)[4],t1,((C_word*)t0)[5],C_fix(1));}

/* read-symbolic-link in k3893 in k3523 in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_6007(C_word c,C_word t0,C_word t1,...){
C_word tmp;
C_word t2;
C_word *a;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_6007,2,t0,t1);}
/* posixwin.scm:1687: error */
t2=*((C_word*)lf[351]+1);
((C_proc4)(void*)(*((C_word*)t2+1)))(4,t2,t1,lf[375],lf[0]);}

/* process-signal in k3893 in k3523 in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_6001(C_word c,C_word t0,C_word t1,...){
C_word tmp;
C_word t2;
C_word *a;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_6001,2,t0,t1);}
/* posixwin.scm:1686: error */
t2=*((C_word*)lf[351]+1);
((C_proc4)(void*)(*((C_word*)t2+1)))(4,t2,t1,lf[374],lf[0]);}

/* k5017 in doloop1136 in build-exec-argvec in k3893 in k3523 in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_5019(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word *a;
t2=((C_word*)t0)[2];
t3=C_u_i_cdr(t2);
t4=C_fixnum_plus(((C_word*)t0)[3],C_fix(1));
t5=((C_word*)((C_word*)t0)[4])[1];
f_5000(t5,((C_word*)t0)[5],t3,t4);}

/* k4094 in open-input-pipe in k3893 in k3523 in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_4096(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word *a;
/* posixwin.scm:935: check */
f_4064(((C_word*)t0)[3],((C_word*)t0)[4],C_SCHEME_TRUE,t1);}

/* k3702 in k3699 in k3696 in file-read in k3523 in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_3704(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word ab[6],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_3704,2,t0,t1);}
t2=((C_word*)t0)[2];
((C_proc2)(void*)(*((C_word*)t2+1)))(2,t2,C_a_i_list2(&a,2,((C_word*)t0)[3],((C_word*)t0)[4]));}

/* k3699 in k3696 in file-read in k3523 in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_3701(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word ab[11],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_3701,2,t0,t1);}
t2=C_read(((C_word*)t0)[2],((C_word*)t0)[3],((C_word*)t0)[4]);
t3=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_3704,a[2]=((C_word*)t0)[5],a[3]=((C_word*)t0)[3],a[4]=t2,tmp=(C_word)a,a+=5,tmp);
t4=C_eqp(C_fix(-1),t2);
if(C_truep(t4)){
t5=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_3713,a[2]=t3,a[3]=((C_word*)t0)[2],a[4]=((C_word*)t0)[4],tmp=(C_word)a,a+=5,tmp);
/* posixwin.scm:791: ##sys#update-errno */
((C_proc2)C_fast_retrieve_proc(*((C_word*)lf[7]+1)))(2,*((C_word*)lf[7]+1),t5);}
else{
t5=((C_word*)t0)[5];
((C_proc2)(void*)(*((C_word*)t5+1)))(2,t5,C_a_i_list2(&a,2,((C_word*)t0)[3],t2));}}

/* process-execute in k3893 in k3523 in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_5087(C_word c,C_word t0,C_word t1,C_word t2,...){
C_word tmp;
C_word t3;
va_list v;
C_word *a,c2=c;
C_save_rest(t2,c2,3);
if(c<3) C_bad_min_argc_2(c,3,t0);
if(!C_demand(c*C_SIZEOF_PAIR+5)){
C_save_and_reclaim((void*)tr3r,(void*)f_5087r,3,t0,t1,t2);}
else{
a=C_alloc((c-3)*3);
t3=C_restore_rest(a,C_rest_count(0));
f_5087r(t0,t1,t2,t3);}}

static void C_ccall f_5087r(C_word t0,C_word t1,C_word t2,C_word t3){
C_word tmp;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word t11;
C_word t12;
C_word t13;
C_word t14;
C_word t15;
C_word t16;
C_word t17;
C_word t18;
C_word *a=C_alloc(5);
t4=C_i_nullp(t3);
t5=(C_truep(t4)?C_SCHEME_FALSE:C_i_car(t3));
t6=C_i_nullp(t3);
t7=(C_truep(t6)?C_SCHEME_END_OF_LIST:C_i_cdr(t3));
t8=C_i_nullp(t7);
t9=(C_truep(t8)?C_SCHEME_FALSE:C_i_car(t7));
t10=t9;
t11=C_i_nullp(t7);
t12=(C_truep(t11)?C_SCHEME_END_OF_LIST:C_i_cdr(t7));
t13=C_i_nullp(t12);
t14=(C_truep(t13)?C_SCHEME_FALSE:C_i_car(t12));
t15=C_i_nullp(t12);
t16=(C_truep(t15)?C_SCHEME_END_OF_LIST:C_i_cdr(t12));
t17=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_5109,a[2]=t10,a[3]=t1,a[4]=t2,tmp=(C_word)a,a+=5,tmp);
/* posixwin.scm:1346: $exec-setup */
t18=lf[303];
f_5036(t18,t17,lf[306],t2,t5,t10,t14);}

/* signal-mask! in k3893 in k3523 in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_6061(C_word c,C_word t0,C_word t1,...){
C_word tmp;
C_word t2;
C_word *a;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_6061,2,t0,t1);}
/* posixwin.scm:1696: error */
t2=*((C_word*)lf[351]+1);
((C_proc4)(void*)(*((C_word*)t2+1)))(4,t2,t1,lf[384],lf[0]);}

/* signal-masked? in k3893 in k3523 in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_6067(C_word c,C_word t0,C_word t1,...){
C_word tmp;
C_word t2;
C_word *a;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_6067,2,t0,t1);}
/* posixwin.scm:1697: error */
t2=*((C_word*)lf[351]+1);
((C_proc4)(void*)(*((C_word*)t2+1)))(4,t2,t1,lf[385],lf[0]);}

/* k4042 in change-directory in k3893 in k3523 in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_4044(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word *a;
/* posixwin.scm:911: ##sys#make-c-string */
((C_proc4)C_fast_retrieve_proc(*((C_word*)lf[12]+1)))(4,*((C_word*)lf[12]+1),((C_word*)t0)[2],t1,lf[66]);}

/* k3711 in k3699 in k3696 in file-read in k3523 in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_3713(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word *a;
/* posixwin.scm:792: ##sys#signal-hook */
t2=*((C_word*)lf[3]+1);
((C_proc7)(void*)(*((C_word*)t2+1)))(7,t2,((C_word*)t0)[2],lf[10],lf[154],lf[155],((C_word*)t0)[3],((C_word*)t0)[4]);}

/* signal-mask in k3893 in k3523 in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_6055(C_word c,C_word t0,C_word t1,...){
C_word tmp;
C_word t2;
C_word *a;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_6055,2,t0,t1);}
/* posixwin.scm:1695: error */
t2=*((C_word*)lf[351]+1);
((C_proc4)(void*)(*((C_word*)t2+1)))(4,t2,t1,lf[383],lf[0]);}

/* set-signal-mask! in k3893 in k3523 in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_6043(C_word c,C_word t0,C_word t1,...){
C_word tmp;
C_word t2;
C_word *a;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_6043,2,t0,t1);}
/* posixwin.scm:1693: error */
t2=*((C_word*)lf[351]+1);
((C_proc4)(void*)(*((C_word*)t2+1)))(4,t2,t1,lf[381],lf[0]);}

/* directory in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_2800(C_word c,C_word t0,C_word t1,...){
C_word tmp;
C_word t2;
va_list v;
C_word *a,c2=c;
C_save_rest(t1,c2,2);
if(!C_demand(c*C_SIZEOF_PAIR+4)){
C_save_and_reclaim((void*)tr2r,(void*)f_2800r,2,t0,t1);}
else{
a=C_alloc((c-2)*3);
t2=C_restore_rest(a,C_rest_count(0));
f_2800r(t0,t1,t2);}}

static void C_ccall f_2800r(C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word t4;
C_word t5;
C_word *a=C_alloc(4);
t3=t2;
t4=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_2804,a[2]=t3,a[3]=t1,tmp=(C_word)a,a+=4,tmp);
if(C_truep(C_i_nullp(t3))){
/* posix-common.scm:372: current-directory */
t5=*((C_word*)lf[65]+1);
((C_proc2)(void*)(*((C_word*)t5+1)))(2,t5,t4);}
else{
t5=t4;
f_2804(2,t5,C_i_car(t3));}}

/* set-user-id! in k3893 in k3523 in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_6049(C_word c,C_word t0,C_word t1,...){
C_word tmp;
C_word t2;
C_word *a;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_6049,2,t0,t1);}
/* posixwin.scm:1694: error */
t2=*((C_word*)lf[351]+1);
((C_proc4)(void*)(*((C_word*)t2+1)))(4,t2,t1,lf[382],lf[0]);}

/* k2802 in directory in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_2804(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word t11;
C_word t12;
C_word ab[5],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_2804,2,t0,t1);}
t2=t1;
t3=C_i_nullp(((C_word*)t0)[2]);
t4=(C_truep(t3)?C_SCHEME_END_OF_LIST:C_i_cdr(((C_word*)t0)[2]));
t5=C_i_nullp(t4);
t6=(C_truep(t5)?C_SCHEME_FALSE:C_i_car(t4));
t7=t6;
t8=C_i_nullp(t4);
t9=(C_truep(t8)?C_SCHEME_END_OF_LIST:C_i_cdr(t4));
t10=C_i_check_string_2(t2,lf[29]);
t11=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_2819,a[2]=((C_word*)t0)[3],a[3]=t2,a[4]=t7,tmp=(C_word)a,a+=5,tmp);
/* ##sys#make-string */
((C_proc4)C_fast_retrieve_proc(*((C_word*)lf[69]+1)))(4,*((C_word*)lf[69]+1),t11,C_fix(256),C_make_character(32));}

/* a3556 in process-wait in k3523 in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_3557(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word *a;
if(c!=2) C_bad_argc_2(c,2,t0);
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_3557,2,t0,t1);}
/* posix-common.scm:552: ##sys#process-wait */
t2=*((C_word*)lf[122]+1);
((C_proc4)(void*)(*((C_word*)t2+1)))(4,t2,t1,((C_word*)t0)[2],((C_word*)t0)[3]);}

/* k5050 in k5047 in k5044 in k5041 in $exec-setup in k3893 in k3523 in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_5052(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word ab[4],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_5052,2,t0,t1);}
t2=C_flushall();
t3=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_5059,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],tmp=(C_word)a,a+=4,tmp);
/* posixwin.scm:1335: ##sys#expand-home-path */
((C_proc3)C_fast_retrieve_proc(*((C_word*)lf[14]+1)))(3,*((C_word*)lf[14]+1),t3,((C_word*)t0)[4]);}

/* set-root-directory! in k3893 in k3523 in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_6037(C_word c,C_word t0,C_word t1,...){
C_word tmp;
C_word t2;
C_word *a;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_6037,2,t0,t1);}
/* posixwin.scm:1692: error */
t2=*((C_word*)lf[351]+1);
((C_proc4)(void*)(*((C_word*)t2+1)))(4,t2,t1,lf[380],lf[0]);}

/* k5057 in k5050 in k5047 in k5044 in k5041 in $exec-setup in k3893 in k3523 in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_5059(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word *a;
/* posixwin.scm:1335: ##sys#make-c-string */
((C_proc4)C_fast_retrieve_proc(*((C_word*)lf[12]+1)))(4,*((C_word*)lf[12]+1),((C_word*)t0)[2],t1,((C_word*)t0)[3]);}

/* set-process-group-id! in k3893 in k3523 in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_6031(C_word c,C_word t0,C_word t1,...){
C_word tmp;
C_word t2;
C_word *a;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_6031,2,t0,t1);}
/* posixwin.scm:1691: error */
t2=*((C_word*)lf[351]+1);
((C_proc4)(void*)(*((C_word*)t2+1)))(4,t2,t1,lf[379],lf[0]);}

/* map-file-to-memory in k3893 in k3523 in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_5759(C_word c,C_word t0,C_word t1,C_word t2,C_word t3,C_word t4,C_word t5,C_word t6,...){
C_word tmp;
C_word t7;
va_list v;
C_word *a,c2=c;
C_save_rest(t6,c2,7);
if(c<7) C_bad_min_argc_2(c,7,t0);
if(!C_demand(c*C_SIZEOF_PAIR+8)){
C_save_and_reclaim((void*)tr7r,(void*)f_5759r,7,t0,t1,t2,t3,t4,t5,t6);}
else{
a=C_alloc((c-7)*3);
t7=C_restore_rest(a,C_rest_count(0));
f_5759r(t0,t1,t2,t3,t4,t5,t6,t7);}}

static void C_ccall f_5759r(C_word t0,C_word t1,C_word t2,C_word t3,C_word t4,C_word t5,C_word t6,C_word t7){
C_word tmp;
C_word t8;
C_word t9;
C_word t10;
C_word *a=C_alloc(8);
t8=(*a=C_CLOSURE_TYPE|7,a[1]=(C_word)f_5763,a[2]=t3,a[3]=t4,a[4]=t5,a[5]=t6,a[6]=t1,a[7]=t7,tmp=(C_word)a,a+=8,tmp);
t9=t2;
if(C_truep(t9)){
t10=t8;
f_5763(2,t10,t2);}
else{
/* posixwin.scm:1631: ##sys#null-pointer */
((C_proc2)C_fast_retrieve_proc(*((C_word*)lf[345]+1)))(2,*((C_word*)lf[345]+1),t8);}}

/* k4101 in open-input-pipe in k3893 in k3523 in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_4103(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word ab[2],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_4103,2,t0,t1);}
t2=open_text_input_pipe(&a,1,t1);
/* posixwin.scm:935: check */
f_4064(((C_word*)t0)[3],((C_word*)t0)[4],C_SCHEME_TRUE,t2);}

/* open-input-pipe in k3893 in k3523 in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_4082(C_word c,C_word t0,C_word t1,C_word t2,...){
C_word tmp;
C_word t3;
va_list v;
C_word *a,c2=c;
C_save_rest(t2,c2,3);
if(c<3) C_bad_min_argc_2(c,3,t0);
if(!C_demand(c*C_SIZEOF_PAIR+10)){
C_save_and_reclaim((void*)tr3r,(void*)f_4082r,3,t0,t1,t2);}
else{
a=C_alloc((c-3)*3);
t3=C_restore_rest(a,C_rest_count(0));
f_4082r(t0,t1,t2,t3);}}

static void C_ccall f_4082r(C_word t0,C_word t1,C_word t2,C_word t3){
C_word tmp;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word t11;
C_word t12;
C_word *a=C_alloc(10);
t4=C_i_check_string_2(t2,lf[181]);
t5=C_i_pairp(t3);
t6=(C_truep(t5)?C_slot(t3,C_fix(0)):lf[182]);
t7=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_4096,a[2]=((C_word*)t0)[2],a[3]=t1,a[4]=t2,tmp=(C_word)a,a+=5,tmp);
t8=C_eqp(t6,lf[182]);
if(C_truep(t8)){
t9=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_4103,a[2]=((C_word*)t0)[2],a[3]=t1,a[4]=t2,tmp=(C_word)a,a+=5,tmp);
/* posixwin.scm:938: ##sys#make-c-string */
((C_proc4)C_fast_retrieve_proc(*((C_word*)lf[12]+1)))(4,*((C_word*)lf[12]+1),t9,t2,lf[181]);}
else{
t9=C_eqp(t6,lf[183]);
if(C_truep(t9)){
t10=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_4113,a[2]=((C_word*)t0)[2],a[3]=t1,a[4]=t2,tmp=(C_word)a,a+=5,tmp);
/* posixwin.scm:939: ##sys#make-c-string */
((C_proc4)C_fast_retrieve_proc(*((C_word*)lf[12]+1)))(4,*((C_word*)lf[12]+1),t10,t2,lf[181]);}
else{
/* posixwin.scm:923: ##sys#error */
t10=*((C_word*)lf[45]+1);
((C_proc4)(void*)(*((C_word*)t10+1)))(4,t10,t7,lf[184],t6);}}}

/* k4078 in k4066 in check in k3893 in k3523 in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_4080(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word *a;
t2=C_set_file_ptr(t1,((C_word*)t0)[2]);
t3=t1;
t4=((C_word*)t0)[3];
((C_proc2)(void*)(*((C_word*)t4+1)))(2,t4,t3);}

/* process-wait in k3523 in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_3533(C_word c,C_word t0,C_word t1,...){
C_word tmp;
C_word t2;
va_list v;
C_word *a,c2=c;
C_save_rest(t1,c2,2);
if(!C_demand(c*C_SIZEOF_PAIR+9)){
C_save_and_reclaim((void*)tr2r,(void*)f_3533r,2,t0,t1);}
else{
a=C_alloc((c-2)*3);
t2=C_restore_rest(a,C_rest_count(0));
f_3533r(t0,t1,t2);}}

static void C_ccall f_3533r(C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word t11;
C_word t12;
C_word t13;
C_word t14;
C_word t15;
C_word t16;
C_word t17;
C_word *a=C_alloc(9);
t3=C_i_nullp(t2);
t4=(C_truep(t3)?C_SCHEME_FALSE:C_i_car(t2));
t5=C_i_nullp(t2);
t6=(C_truep(t5)?C_SCHEME_END_OF_LIST:C_i_cdr(t2));
t7=C_i_nullp(t6);
t8=(C_truep(t7)?C_SCHEME_FALSE:C_i_car(t6));
t9=t8;
t10=C_i_nullp(t6);
t11=(C_truep(t10)?C_SCHEME_END_OF_LIST:C_i_cdr(t6));
t12=(C_truep(t4)?t4:C_fix(-1));
t13=t12;
t14=C_i_check_exact_2(t13,lf[121]);
t15=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_3557,a[2]=t13,a[3]=t9,a[4]=((C_word)li59),tmp=(C_word)a,a+=5,tmp);
t16=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_3563,a[2]=t13,a[3]=((C_word)li60),tmp=(C_word)a,a+=4,tmp);
/* posix-common.scm:552: ##sys#call-with-values */
C_call_with_values(4,0,t1,t15,t16);}

/* k2817 in k2802 in directory in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_2819(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word ab[6],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_2819,2,t0,t1);}
t2=t1;
t3=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_2822,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=t2,a[5]=((C_word*)t0)[4],tmp=(C_word)a,a+=6,tmp);
/* posix-common.scm:375: ##sys#make-pointer */
((C_proc2)C_fast_retrieve_proc(*((C_word*)lf[78]+1)))(2,*((C_word*)lf[78]+1),t3);}

/* k3523 in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_3525(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word t11;
C_word t12;
C_word t13;
C_word t14;
C_word t15;
C_word t16;
C_word t17;
C_word t18;
C_word t19;
C_word t20;
C_word t21;
C_word t22;
C_word t23;
C_word t24;
C_word t25;
C_word t26;
C_word t27;
C_word t28;
C_word t29;
C_word t30;
C_word t31;
C_word t32;
C_word t33;
C_word t34;
C_word t35;
C_word t36;
C_word t37;
C_word t38;
C_word t39;
C_word t40;
C_word t41;
C_word t42;
C_word t43;
C_word t44;
C_word t45;
C_word t46;
C_word t47;
C_word t48;
C_word t49;
C_word t50;
C_word t51;
C_word t52;
C_word t53;
C_word ab[50],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_3525,2,t0,t1);}
t2=C_mutate2((C_word*)lf[119]+1 /* (set! signal-handler ...) */,t1);
t3=C_mutate2((C_word*)lf[120]+1 /* (set! current-process-id ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_3527,a[2]=((C_word)li58),tmp=(C_word)a,a+=3,tmp));
t4=C_mutate2((C_word*)lf[121]+1 /* (set! process-wait ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_3533,a[2]=((C_word)li61),tmp=(C_word)a,a+=3,tmp));
t5=C_mutate2((C_word*)lf[125]+1 /* (set! pipe/buf ...) */,C_fix((C_word)PIPE_BUF));
t6=C_mutate2((C_word*)lf[126]+1 /* (set! open/rdonly ...) */,C_fix((C_word)O_RDONLY));
t7=C_mutate2((C_word*)lf[127]+1 /* (set! open/wronly ...) */,C_fix((C_word)O_WRONLY));
t8=C_mutate2((C_word*)lf[128]+1 /* (set! open/rdwr ...) */,C_fix((C_word)O_RDWR));
t9=C_mutate2((C_word*)lf[129]+1 /* (set! open/read ...) */,C_fix((C_word)O_RDWR));
t10=C_mutate2((C_word*)lf[130]+1 /* (set! open/write ...) */,C_fix((C_word)O_WRONLY));
t11=C_mutate2((C_word*)lf[131]+1 /* (set! open/creat ...) */,C_fix((C_word)O_CREAT));
t12=C_mutate2((C_word*)lf[132]+1 /* (set! open/append ...) */,C_fix((C_word)O_APPEND));
t13=C_mutate2((C_word*)lf[133]+1 /* (set! open/excl ...) */,C_fix((C_word)O_EXCL));
t14=C_mutate2((C_word*)lf[134]+1 /* (set! open/trunc ...) */,C_fix((C_word)O_TRUNC));
t15=C_mutate2((C_word*)lf[135]+1 /* (set! open/binary ...) */,C_fix((C_word)O_BINARY));
t16=C_mutate2((C_word*)lf[136]+1 /* (set! open/text ...) */,C_fix((C_word)O_TEXT));
t17=C_mutate2((C_word*)lf[137]+1 /* (set! open/noinherit ...) */,C_fix((C_word)O_NOINHERIT));
t18=C_mutate2((C_word*)lf[138]+1 /* (set! perm/irusr ...) */,C_fix((C_word)S_IREAD));
t19=C_mutate2((C_word*)lf[139]+1 /* (set! perm/iwusr ...) */,C_fix((C_word)S_IWRITE));
t20=C_mutate2((C_word*)lf[140]+1 /* (set! perm/ixusr ...) */,C_fix((C_word)S_IEXEC));
t21=C_mutate2((C_word*)lf[141]+1 /* (set! perm/irgrp ...) */,C_fix((C_word)S_IREAD));
t22=C_mutate2((C_word*)lf[142]+1 /* (set! perm/iwgrp ...) */,C_fix((C_word)S_IWRITE));
t23=C_mutate2((C_word*)lf[143]+1 /* (set! perm/ixgrp ...) */,C_fix((C_word)S_IEXEC));
t24=C_mutate2((C_word*)lf[144]+1 /* (set! perm/iroth ...) */,C_fix((C_word)S_IREAD));
t25=C_mutate2((C_word*)lf[145]+1 /* (set! perm/iwoth ...) */,C_fix((C_word)S_IWRITE));
t26=C_mutate2((C_word*)lf[146]+1 /* (set! perm/ixoth ...) */,C_fix((C_word)S_IEXEC));
t27=C_mutate2((C_word*)lf[147]+1 /* (set! perm/irwxu ...) */,C_fix((C_word)S_IREAD | S_IWRITE | S_IEXEC));
t28=C_mutate2((C_word*)lf[148]+1 /* (set! perm/irwxg ...) */,C_fix((C_word)S_IREAD | S_IWRITE | S_IEXEC));
t29=C_mutate2((C_word*)lf[149]+1 /* (set! perm/irwxo ...) */,C_fix((C_word)S_IREAD | S_IWRITE | S_IEXEC));
t30=C_fixnum_or(C_fix((C_word)S_IREAD),C_fix((C_word)S_IREAD));
t31=C_a_i_bitwise_ior(&a,2,C_fix((C_word)S_IREAD | S_IWRITE | S_IEXEC),t30);
t32=t31;
t33=C_mutate2((C_word*)lf[150]+1 /* (set! file-open ...) */,(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_3630,a[2]=t32,a[3]=((C_word)li62),tmp=(C_word)a,a+=4,tmp));
t34=C_mutate2((C_word*)lf[152]+1 /* (set! file-close ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_3669,a[2]=((C_word)li63),tmp=(C_word)a,a+=3,tmp));
t35=C_mutate2((C_word*)lf[154]+1 /* (set! file-read ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_3688,a[2]=((C_word)li64),tmp=(C_word)a,a+=3,tmp));
t36=C_mutate2((C_word*)lf[157]+1 /* (set! file-write ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_3732,a[2]=((C_word)li65),tmp=(C_word)a,a+=3,tmp));
t37=C_mutate2((C_word*)lf[160]+1 /* (set! file-mkstemp ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_3772,a[2]=((C_word)li66),tmp=(C_word)a,a+=3,tmp));
t38=C_mutate2((C_word*)lf[162]+1 /* (set! seek/set ...) */,C_fix((C_word)SEEK_SET));
t39=C_mutate2((C_word*)lf[163]+1 /* (set! seek/end ...) */,C_fix((C_word)SEEK_END));
t40=C_mutate2((C_word*)lf[164]+1 /* (set! seek/cur ...) */,C_fix((C_word)SEEK_CUR));
t41=C_mutate2((C_word*)lf[35]+1 /* (set! symbolic-link? ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_3810,a[2]=((C_word)li67),tmp=(C_word)a,a+=3,tmp));
t42=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f6917,a[2]=((C_word)li68),tmp=(C_word)a,a+=3,tmp);
t43=C_mutate2((C_word*)lf[37]+1 /* (set! character-device? ...) */,t42);
t44=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f6911,a[2]=((C_word)li69),tmp=(C_word)a,a+=3,tmp);
t45=C_mutate2((C_word*)lf[36]+1 /* (set! block-device? ...) */,t44);
t46=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f6905,a[2]=((C_word)li70),tmp=(C_word)a,a+=3,tmp);
t47=C_mutate2((C_word*)lf[38]+1 /* (set! fifo? ...) */,t46);
t48=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f6899,a[2]=((C_word)li71),tmp=(C_word)a,a+=3,tmp);
t49=C_mutate2((C_word*)lf[39]+1 /* (set! socket? ...) */,t48);
t50=C_mutate2((C_word*)lf[165]+1 /* (set! set-file-position! ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_3839,a[2]=((C_word)li72),tmp=(C_word)a,a+=3,tmp));
t51=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_3895,a[2]=((C_word*)t0)[2],tmp=(C_word)a,a+=3,tmp);
t52=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_6114,a[2]=((C_word)li193),tmp=(C_word)a,a+=3,tmp);
/* posixwin.scm:861: getter-with-setter */
t53=*((C_word*)lf[401]+1);
((C_proc5)(void*)(*((C_word*)t53+1)))(5,t53,t51,t52,*((C_word*)lf[165]+1),lf[402]);}

/* current-process-id in k3523 in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_3527(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word *a;
if(c!=2) C_bad_argc_2(c,2,t0);
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_3527,2,t0,t1);}
t2=t1;
((C_proc2)(void*)(*((C_word*)t2+1)))(2,t2,C_fudge(C_fix(33)));}

/* k2613 */
static void C_ccall f_2615(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word *a;
t2=((C_word*)t0)[2];
((C_proc2)(void*)(*((C_word*)t2+1)))(2,t2,C_slot(t1,C_fix(0)));}

/* loop in k2827 in k2823 in k2820 in k2817 in k2802 in directory in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_fcall f_2843(C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word ab[6],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)trf_2843,NULL,2,t0,t1);}
t2=C_readdir(((C_word*)t0)[2],((C_word*)t0)[3]);
if(C_truep(C_null_pointerp(((C_word*)t0)[3]))){
t3=C_closedir(((C_word*)t0)[2]);
t4=t1;
((C_proc2)(void*)(*((C_word*)t4+1)))(2,t4,C_SCHEME_END_OF_LIST);}
else{
t3=C_foundfile(((C_word*)t0)[3],((C_word*)t0)[4]);
t4=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_2853,a[2]=t3,a[3]=((C_word*)t0)[5],a[4]=t1,a[5]=((C_word*)t0)[6],tmp=(C_word)a,a+=6,tmp);
/* posix-common.scm:389: ##sys#substring */
((C_proc5)C_fast_retrieve_proc(*((C_word*)lf[67]+1)))(5,*((C_word*)lf[67]+1),t4,((C_word*)t0)[4],C_fix(0),t3);}}

/* k3147 in k3140 in a3133 in k3115 in k3179 in k3186 in k3081 in loop in k3060 in k3053 in k3050 in k3258 in k3255 in k3252 in k3249 in k3246 in k3243 in find-files in k2325 in k2231 in k2228 in k2225 in ... */
static void C_ccall f_3149(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word *a;
if(C_truep(t1)){
/* posix-common.scm:449: action */
t2=((C_word*)t0)[2];
((C_proc4)C_fast_retrieve_proc(t2))(4,t2,((C_word*)t0)[3],((C_word*)t0)[4],((C_word*)t0)[5]);}
else{
t2=((C_word*)t0)[5];
/* posix-common.scm:448: loop */
t3=((C_word*)((C_word*)t0)[6])[1];
f_3064(t3,((C_word*)t0)[7],((C_word*)t0)[8],t2);}}

/* k3144 in k3140 in a3133 in k3115 in k3179 in k3186 in k3081 in loop in k3060 in k3053 in k3050 in k3258 in k3255 in k3252 in k3249 in k3246 in k3243 in find-files in k2325 in k2231 in k2228 in k2225 in ... */
static void C_ccall f_3146(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word *a;
/* posix-common.scm:448: loop */
t2=((C_word*)((C_word*)t0)[2])[1];
f_3064(t2,((C_word*)t0)[3],((C_word*)t0)[4],t1);}

/* k3140 in a3133 in k3115 in k3179 in k3186 in k3081 in loop in k3060 in k3053 in k3050 in k3258 in k3255 in k3252 in k3249 in k3246 in k3243 in find-files in k2325 in k2231 in k2228 in k2225 in k2222 in ... */
static void C_ccall f_3142(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word ab[14],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_3142,2,t0,t1);}
t2=t1;
t3=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_3146,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=t2,tmp=(C_word)a,a+=5,tmp);
t4=(*a=C_CLOSURE_TYPE|8,a[1]=(C_word)f_3149,a[2]=((C_word*)t0)[4],a[3]=t3,a[4]=((C_word*)t0)[5],a[5]=((C_word*)t0)[6],a[6]=((C_word*)t0)[2],a[7]=((C_word*)t0)[3],a[8]=t2,tmp=(C_word)a,a+=9,tmp);
/* posix-common.scm:449: pproc */
t5=((C_word*)t0)[7];
((C_proc3)(void*)(*((C_word*)t5+1)))(3,t5,t4,((C_word*)t0)[5]);}

/* k2873 in k2863 in k2851 in loop in k2827 in k2823 in k2820 in k2817 in k2802 in directory in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_2875(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word ab[3],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_2875,2,t0,t1);}
t2=((C_word*)t0)[2];
((C_proc2)(void*)(*((C_word*)t2+1)))(2,t2,C_a_i_cons(&a,2,((C_word*)t0)[3],t1));}

/* k5107 in process-execute in k3893 in k3523 in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_5109(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word *a;
if(C_truep(((C_word*)t0)[2])){
t2=C_execve(t1);
/* posixwin.scm:1347: $exec-teardown */
f_5072(((C_word*)t0)[3],lf[306],lf[307],((C_word*)t0)[4],t2);}
else{
t2=C_execvp(t1);
/* posixwin.scm:1347: $exec-teardown */
f_5072(((C_word*)t0)[3],lf[306],lf[307],((C_word*)t0)[4],t2);}}

/* a3133 in k3115 in k3179 in k3186 in k3081 in loop in k3060 in k3053 in k3050 in k3258 in k3255 in k3252 in k3249 in k3246 in k3243 in find-files in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 in ... */
static void C_ccall f_3134(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word ab[11],*a=ab;
if(c!=2) C_bad_argc_2(c,2,t0);
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_3134,2,t0,t1);}
t2=(*a=C_CLOSURE_TYPE|7,a[1]=(C_word)f_3142,a[2]=((C_word*)t0)[2],a[3]=t1,a[4]=((C_word*)t0)[3],a[5]=((C_word*)t0)[4],a[6]=((C_word*)t0)[5],a[7]=((C_word*)t0)[6],tmp=(C_word)a,a+=8,tmp);
t3=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_3156,a[2]=t2,tmp=(C_word)a,a+=3,tmp);
if(C_truep(((C_word*)t0)[7])){
/* posix-common.scm:448: make-pathname */
t4=*((C_word*)lf[81]+1);
((C_proc4)(void*)(*((C_word*)t4+1)))(4,t4,t3,((C_word*)t0)[4],lf[89]);}
else{
/* posix-common.scm:448: make-pathname */
t4=*((C_word*)lf[81]+1);
((C_proc4)(void*)(*((C_word*)t4+1)))(4,t4,t3,((C_word*)t0)[4],lf[90]);}}

/* k2827 in k2823 in k2820 in k2817 in k2802 in directory in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_2829(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word ab[10],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_2829,2,t0,t1);}
t2=C_opendir(t1,((C_word*)t0)[2]);
if(C_truep(C_null_pointerp(((C_word*)t0)[2]))){
/* posix-common.scm:381: posix-error */
t3=lf[2];
f_2245(6,t3,((C_word*)t0)[3],lf[10],lf[29],lf[77],((C_word*)t0)[4]);}
else{
t3=C_SCHEME_UNDEFINED;
t4=(*a=C_VECTOR_TYPE|1,a[1]=t3,tmp=(C_word)a,a+=2,tmp);
t5=C_set_block_item(t4,0,(*a=C_CLOSURE_TYPE|7,a[1]=(C_word)f_2843,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[5],a[4]=((C_word*)t0)[6],a[5]=t4,a[6]=((C_word*)t0)[7],a[7]=((C_word)li27),tmp=(C_word)a,a+=8,tmp));
t6=((C_word*)t4)[1];
f_2843(t6,((C_word*)t0)[3]);}}

/* k2820 in k2817 in k2802 in directory in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_2822(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word ab[7],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_2822,2,t0,t1);}
t2=t1;
t3=(*a=C_CLOSURE_TYPE|6,a[1]=(C_word)f_2825,a[2]=t2,a[3]=((C_word*)t0)[2],a[4]=((C_word*)t0)[3],a[5]=((C_word*)t0)[4],a[6]=((C_word*)t0)[5],tmp=(C_word)a,a+=7,tmp);
/* posix-common.scm:376: ##sys#make-pointer */
((C_proc2)C_fast_retrieve_proc(*((C_word*)lf[78]+1)))(2,*((C_word*)lf[78]+1),t3);}

/* k2823 in k2820 in k2817 in k2802 in directory in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_2825(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word ab[11],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_2825,2,t0,t1);}
t2=t1;
t3=(*a=C_CLOSURE_TYPE|7,a[1]=(C_word)f_2829,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[4],a[5]=t2,a[6]=((C_word*)t0)[5],a[7]=((C_word*)t0)[6],tmp=(C_word)a,a+=8,tmp);
t4=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_2908,a[2]=t3,tmp=(C_word)a,a+=3,tmp);
/* posix-common.scm:379: ##sys#expand-home-path */
((C_proc3)C_fast_retrieve_proc(*((C_word*)lf[14]+1)))(3,*((C_word*)lf[14]+1),t4,((C_word*)t0)[4]);}

/* a3128 in k3115 in k3179 in k3186 in k3081 in loop in k3060 in k3053 in k3050 in k3258 in k3255 in k3252 in k3249 in k3246 in k3243 in find-files in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 in ... */
static void C_ccall f_3129(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word *a;
if(c!=2) C_bad_argc_2(c,2,t0);
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_3129,2,t0,t1);}
t2=C_mutate2(((C_word *)((C_word*)t0)[2])+1,((C_word*)((C_word*)t0)[3])[1]);
t3=C_mutate2(((C_word *)((C_word*)t0)[3])+1,((C_word*)((C_word*)t0)[4])[1]);
t4=t1;
((C_proc2)(void*)(*((C_word*)t4+1)))(2,t4,C_SCHEME_UNDEFINED);}

/* k3125 in k3115 in k3179 in k3186 in k3081 in loop in k3060 in k3053 in k3050 in k3258 in k3255 in k3252 in k3249 in k3246 in k3243 in find-files in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 in ... */
static void C_ccall f_3127(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word *a;
/* posix-common.scm:446: loop */
t2=((C_word*)((C_word*)t0)[2])[1];
f_3064(t2,((C_word*)t0)[3],((C_word*)t0)[4],t1);}

/* k2851 in loop in k2827 in k2823 in k2820 in k2817 in k2802 in directory in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_2853(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word t11;
C_word ab[5],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_2853,2,t0,t1);}
t2=t1;
t3=C_i_string_ref(t2,C_fix(0));
t4=C_fixnum_greaterp(((C_word*)t0)[2],C_fix(1));
t5=(C_truep(t4)?C_subchar(t2,C_fix(1)):C_SCHEME_FALSE);
t6=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_2865,a[2]=((C_word*)t0)[3],a[3]=((C_word*)t0)[4],a[4]=t2,tmp=(C_word)a,a+=5,tmp);
t7=C_eqp(C_make_character(46),t3);
if(C_truep(t7)){
t8=C_i_not(t5);
if(C_truep(t8)){
t9=t6;
f_2865(t9,t8);}
else{
t9=C_eqp(C_make_character(46),t5);
if(C_truep(t9)){
t10=C_eqp(C_fix(2),((C_word*)t0)[2]);
t11=t6;
f_2865(t11,(C_truep(t10)?t10:C_i_not(((C_word*)t0)[5])));}
else{
t10=t6;
f_2865(t10,C_i_not(((C_word*)t0)[5]));}}}
else{
t8=t6;
f_2865(t8,C_SCHEME_FALSE);}}

/* k3115 in k3179 in k3186 in k3081 in loop in k3060 in k3053 in k3050 in k3258 in k3255 in k3252 in k3249 in k3246 in k3243 in find-files in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_3117(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word t11;
C_word t12;
C_word t13;
C_word ab[30],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_3117,2,t0,t1);}
if(C_truep(t1)){
t2=C_fixnum_plus(((C_word*)((C_word*)t0)[2])[1],C_fix(1));
t3=t2;
t4=(*a=C_VECTOR_TYPE|1,a[1]=t3,tmp=(C_word)a,a+=2,tmp);
t5=C_SCHEME_FALSE;
t6=(*a=C_VECTOR_TYPE|1,a[1]=t5,tmp=(C_word)a,a+=2,tmp);
t7=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_3127,a[2]=((C_word*)t0)[3],a[3]=((C_word*)t0)[4],a[4]=((C_word*)t0)[5],tmp=(C_word)a,a+=5,tmp);
t8=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_3129,a[2]=t6,a[3]=((C_word*)t0)[2],a[4]=t4,a[5]=((C_word)li35),tmp=(C_word)a,a+=6,tmp);
t9=(*a=C_CLOSURE_TYPE|8,a[1]=(C_word)f_3134,a[2]=((C_word*)t0)[3],a[3]=((C_word*)t0)[6],a[4]=((C_word*)t0)[7],a[5]=((C_word*)t0)[8],a[6]=((C_word*)t0)[9],a[7]=((C_word*)t0)[10],a[8]=((C_word)li36),tmp=(C_word)a,a+=9,tmp);
t10=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_3162,a[2]=t4,a[3]=((C_word*)t0)[2],a[4]=t6,a[5]=((C_word)li37),tmp=(C_word)a,a+=6,tmp);
/* posix-common.scm:447: ##sys#dynamic-wind */
t11=*((C_word*)lf[91]+1);
((C_proc5)(void*)(*((C_word*)t11+1)))(5,t11,t7,t8,t9,t10);}
else{
t2=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_3172,a[2]=((C_word*)t0)[3],a[3]=((C_word*)t0)[4],a[4]=((C_word*)t0)[5],tmp=(C_word)a,a+=5,tmp);
t3=(*a=C_CLOSURE_TYPE|8,a[1]=(C_word)f_3175,a[2]=((C_word*)t0)[6],a[3]=t2,a[4]=((C_word*)t0)[7],a[5]=((C_word*)t0)[8],a[6]=((C_word*)t0)[3],a[7]=((C_word*)t0)[4],a[8]=((C_word*)t0)[5],tmp=(C_word)a,a+=9,tmp);
/* posix-common.scm:450: pproc */
t4=((C_word*)t0)[9];
((C_proc3)(void*)(*((C_word*)t4+1)))(3,t4,t3,((C_word*)t0)[7]);}}

/* k4610 in duplicate-fileno in k3893 in k3523 in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_fcall f_4612(C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word ab[8],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)trf_4612,NULL,2,t0,t1);}
t2=t1;
t3=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_4615,a[2]=((C_word*)t0)[2],a[3]=t2,tmp=(C_word)a,a+=4,tmp);
if(C_truep(C_fixnum_lessp(t2,C_fix(0)))){
t4=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_4621,a[2]=t3,a[3]=((C_word*)t0)[3],tmp=(C_word)a,a+=4,tmp);
/* posixwin.scm:1188: ##sys#update-errno */
((C_proc2)C_fast_retrieve_proc(*((C_word*)lf[7]+1)))(2,*((C_word*)lf[7]+1),t4);}
else{
t4=((C_word*)t0)[2];
((C_proc2)(void*)(*((C_word*)t4+1)))(2,t4,t2);}}

/* k5395 in k5391 in k5387 in k5343 in process in k3893 in k3523 in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_5397(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word ab[11],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_5397,2,t0,t1);}
t2=t1;
t3=(*a=C_CLOSURE_TYPE|10,a[1]=(C_word)f_5401,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[4],a[5]=((C_word*)t0)[5],a[6]=((C_word*)t0)[6],a[7]=t2,a[8]=((C_word*)t0)[7],a[9]=((C_word*)t0)[8],a[10]=((C_word*)t0)[9],tmp=(C_word)a,a+=11,tmp);
/* posixwin.scm:1408: ##sys#make-locative */
((C_proc6)C_fast_retrieve_proc(*((C_word*)lf[319]+1)))(6,*((C_word*)lf[319]+1),t3,((C_word*)t0)[10],C_fix(0),C_SCHEME_FALSE,lf[320]);}

/* k5391 in k5387 in k5343 in process in k3893 in k3523 in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_5393(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word ab[11],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_5393,2,t0,t1);}
t2=t1;
t3=(*a=C_CLOSURE_TYPE|10,a[1]=(C_word)f_5397,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[4],a[5]=((C_word*)t0)[5],a[6]=t2,a[7]=((C_word*)t0)[6],a[8]=((C_word*)t0)[7],a[9]=((C_word*)t0)[8],a[10]=((C_word*)t0)[9],tmp=(C_word)a,a+=11,tmp);
/* posixwin.scm:1408: ##sys#make-locative */
((C_proc6)C_fast_retrieve_proc(*((C_word*)lf[319]+1)))(6,*((C_word*)lf[319]+1),t3,((C_word*)t0)[10],C_fix(0),C_SCHEME_FALSE,lf[320]);}

/* k3186 in k3081 in loop in k3060 in k3053 in k3050 in k3258 in k3255 in k3252 in k3249 in k3246 in k3243 in find-files in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_3188(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word ab[13],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_3188,2,t0,t1);}
if(C_truep((C_truep(C_i_equalp(t1,lf[87]))?C_SCHEME_TRUE:(C_truep(C_i_equalp(t1,lf[88]))?C_SCHEME_TRUE:C_SCHEME_FALSE)))){
/* posix-common.scm:442: loop */
t2=((C_word*)((C_word*)t0)[2])[1];
f_3064(t2,((C_word*)t0)[3],((C_word*)t0)[4],((C_word*)t0)[5]);}
else{
t2=(*a=C_CLOSURE_TYPE|12,a[1]=(C_word)f_3181,a[2]=((C_word*)t0)[6],a[3]=((C_word*)t0)[2],a[4]=((C_word*)t0)[3],a[5]=((C_word*)t0)[4],a[6]=((C_word*)t0)[7],a[7]=((C_word*)t0)[8],a[8]=((C_word*)t0)[5],a[9]=((C_word*)t0)[9],a[10]=((C_word*)t0)[10],a[11]=((C_word*)t0)[11],a[12]=((C_word*)t0)[12],tmp=(C_word)a,a+=13,tmp);
/* posix-common.scm:443: symbolic-link? */
t3=*((C_word*)lf[35]+1);
((C_proc3)(void*)(*((C_word*)t3+1)))(3,t3,t2,((C_word*)t0)[8]);}}

/* k4613 in k4610 in duplicate-fileno in k3893 in k3523 in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_4615(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word *a;
t2=((C_word*)t0)[2];
((C_proc2)(void*)(*((C_word*)t2+1)))(2,t2,((C_word*)t0)[3]);}

/* k3170 in k3115 in k3179 in k3186 in k3081 in loop in k3060 in k3053 in k3050 in k3258 in k3255 in k3252 in k3249 in k3246 in k3243 in find-files in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 in ... */
static void C_ccall f_3172(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word *a;
/* posix-common.scm:450: loop */
t2=((C_word*)((C_word*)t0)[2])[1];
f_3064(t2,((C_word*)t0)[3],((C_word*)t0)[4],t1);}

/* k3173 in k3115 in k3179 in k3186 in k3081 in loop in k3060 in k3053 in k3050 in k3258 in k3255 in k3252 in k3249 in k3246 in k3243 in find-files in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 in ... */
static void C_ccall f_3175(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word *a;
if(C_truep(t1)){
/* posix-common.scm:450: action */
t2=((C_word*)t0)[2];
((C_proc4)C_fast_retrieve_proc(t2))(4,t2,((C_word*)t0)[3],((C_word*)t0)[4],((C_word*)t0)[5]);}
else{
t2=((C_word*)t0)[5];
/* posix-common.scm:450: loop */
t3=((C_word*)((C_word*)t0)[6])[1];
f_3064(t3,((C_word*)t0)[7],((C_word*)t0)[8],t2);}}

/* k2863 in k2851 in loop in k2827 in k2823 in k2820 in k2817 in k2802 in directory in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_fcall f_2865(C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word ab[4],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)trf_2865,NULL,2,t0,t1);}
if(C_truep(t1)){
/* posix-common.scm:396: loop */
t2=((C_word*)((C_word*)t0)[2])[1];
f_2843(t2,((C_word*)t0)[3]);}
else{
t2=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_2875,a[2]=((C_word*)t0)[3],a[3]=((C_word*)t0)[4],tmp=(C_word)a,a+=4,tmp);
/* posix-common.scm:397: loop */
t3=((C_word*)((C_word*)t0)[2])[1];
f_2843(t3,t2);}}

/* k5368 in k5364 in k5360 in k5350 in k5343 in process in k3893 in k3523 in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_5370(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word *a;
/* posixwin.scm:1411: values */
C_values(6,0,((C_word*)t0)[2],((C_word*)t0)[3],((C_word*)t0)[4],C_fix((C_word)*((int *)C_data_pointer(((C_word*)t0)[5]))),t1);}

/* duplicate-fileno in k3893 in k3523 in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_4605(C_word c,C_word t0,C_word t1,C_word t2,...){
C_word tmp;
C_word t3;
va_list v;
C_word *a,c2=c;
C_save_rest(t2,c2,3);
if(c<3) C_bad_min_argc_2(c,3,t0);
if(!C_demand(c*C_SIZEOF_PAIR+4)){
C_save_and_reclaim((void*)tr3r,(void*)f_4605r,3,t0,t1,t2);}
else{
a=C_alloc((c-3)*3);
t3=C_restore_rest(a,C_rest_count(0));
f_4605r(t0,t1,t2,t3);}}

static void C_ccall f_4605r(C_word t0,C_word t1,C_word t2,C_word t3){
C_word tmp;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word *a=C_alloc(4);
t4=C_i_check_exact_2(t2,*((C_word*)lf[63]+1));
t5=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_4612,a[2]=t1,a[3]=t2,tmp=(C_word)a,a+=4,tmp);
if(C_truep(C_i_nullp(t3))){
t6=t5;
f_4612(t6,C_dup(t2));}
else{
t6=C_i_car(t3);
t7=C_i_check_exact_2(t6,lf[63]);
t8=t5;
f_4612(t8,C_dup2(t2,t6));}}

/* k4601 in port->fileno in k3893 in k3523 in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_4603(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word ab[8],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_4603,2,t0,t1);}
if(C_truep(C_i_zerop(t1))){
/* posixwin.scm:1177: ##sys#signal-hook */
t2=*((C_word*)lf[3]+1);
((C_proc6)(void*)(*((C_word*)t2+1)))(6,t2,((C_word*)t0)[2],lf[15],lf[58],lf[275],((C_word*)t0)[3]);}
else{
t2=C_C_fileno(((C_word*)t0)[3]);
t3=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_4583,a[2]=((C_word*)t0)[2],a[3]=t2,tmp=(C_word)a,a+=4,tmp);
if(C_truep(C_fixnum_lessp(t2,C_fix(0)))){
t4=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_4589,a[2]=t3,a[3]=((C_word*)t0)[3],tmp=(C_word)a,a+=4,tmp);
/* posixwin.scm:1174: ##sys#update-errno */
((C_proc2)C_fast_retrieve_proc(*((C_word*)lf[7]+1)))(2,*((C_word*)lf[7]+1),t4);}
else{
t4=((C_word*)t0)[2];
((C_proc2)(void*)(*((C_word*)t4+1)))(2,t4,t2);}}}

/* a3161 in k3115 in k3179 in k3186 in k3081 in loop in k3060 in k3053 in k3050 in k3258 in k3255 in k3252 in k3249 in k3246 in k3243 in find-files in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 in ... */
static void C_ccall f_3162(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word *a;
if(c!=2) C_bad_argc_2(c,2,t0);
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_3162,2,t0,t1);}
t2=C_mutate2(((C_word *)((C_word*)t0)[2])+1,((C_word*)((C_word*)t0)[3])[1]);
t3=C_mutate2(((C_word *)((C_word*)t0)[3])+1,((C_word*)((C_word*)t0)[4])[1]);
t4=t1;
((C_proc2)(void*)(*((C_word*)t4+1)))(2,t4,C_SCHEME_UNDEFINED);}

/* k4809 in k4806 in set-buffering-mode! in k3893 in k3523 in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_4811(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word ab[6],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_4811,2,t0,t1);}
t2=t1;
t3=C_i_check_exact_2(((C_word*)t0)[2],lf[288]);
t4=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_4820,a[2]=((C_word*)t0)[3],a[3]=((C_word*)t0)[4],a[4]=t2,a[5]=((C_word*)t0)[2],tmp=(C_word)a,a+=6,tmp);
t5=C_slot(((C_word*)t0)[4],C_fix(7));
t6=C_eqp(lf[55],t5);
if(C_truep(t6)){
t7=C_setvbuf(((C_word*)t0)[4],t2,((C_word*)t0)[2]);
t8=t4;
f_4820(t8,C_fixnum_lessp(t7,C_fix(0)));}
else{
t7=t4;
f_4820(t7,C_SCHEME_TRUE);}}

/* k2622 in k2639 */
static void C_ccall f_2624(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word *a;
t2=((C_word*)t0)[2];
((C_proc2)(void*)(*((C_word*)t2+1)))(2,t2,((C_word*)t0)[3]);}

/* k5380 in k5350 in k5343 in process in k3893 in k3523 in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_5382(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word *a;
/* posixwin.scm:1418: ##sys#signal-hook */
t2=*((C_word*)lf[3]+1);
((C_proc6)(void*)(*((C_word*)t2+1)))(6,t2,((C_word*)t0)[2],lf[123],((C_word*)t0)[3],lf[318],((C_word*)t0)[4]);}

/* k5387 in k5343 in process in k3893 in k3523 in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_5389(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word ab[11],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_5389,2,t0,t1);}
t2=t1;
t3=(*a=C_CLOSURE_TYPE|10,a[1]=(C_word)f_5393,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[4],a[5]=t2,a[6]=((C_word*)t0)[5],a[7]=((C_word*)t0)[6],a[8]=((C_word*)t0)[7],a[9]=((C_word*)t0)[8],a[10]=((C_word*)t0)[9],tmp=(C_word)a,a+=11,tmp);
/* posixwin.scm:1408: ##sys#make-locative */
((C_proc6)C_fast_retrieve_proc(*((C_word*)lf[319]+1)))(6,*((C_word*)lf[319]+1),t3,((C_word*)t0)[10],C_fix(0),C_SCHEME_FALSE,lf[320]);}

/* k3154 in a3133 in k3115 in k3179 in k3186 in k3081 in loop in k3060 in k3053 in k3050 in k3258 in k3255 in k3252 in k3249 in k3246 in k3243 in find-files in k2325 in k2231 in k2228 in k2225 in k2222 in ... */
static void C_ccall f_3156(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word *a;
/* posix-common.scm:448: glob */
t2=*((C_word*)lf[79]+1);
((C_proc3)(void*)(*((C_word*)t2+1)))(3,t2,((C_word*)t0)[2],t1);}

/* k4648 in k4644 in setenv in k3893 in k3523 in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_4650(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word *a;
t2=C_setenv(((C_word*)t0)[2],t1);
t3=((C_word*)t0)[3];
((C_proc2)(void*)(*((C_word*)t3+1)))(2,t3,C_SCHEME_UNDEFINED);}

/* unsetenv in k3893 in k3523 in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_4652(C_word c,C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word t4;
C_word t5;
C_word ab[3],*a=ab;
if(c!=3) C_bad_argc_2(c,3,t0);
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr3,(void*)f_4652,3,t0,t1,t2);}
t3=C_i_check_string_2(t2,lf[279]);
t4=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_4660,a[2]=t1,tmp=(C_word)a,a+=3,tmp);
/* posixwin.scm:1206: ##sys#make-c-string */
((C_proc4)C_fast_retrieve_proc(*((C_word*)lf[12]+1)))(4,*((C_word*)lf[12]+1),t4,t2,lf[278]);}

/* k2688 in k2685 in current-directory in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_2690(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word *a;
if(C_truep(((C_word*)t0)[2])){
/* posix-common.scm:343: ##sys#substring */
((C_proc5)C_fast_retrieve_proc(*((C_word*)lf[67]+1)))(5,*((C_word*)lf[67]+1),((C_word*)t0)[3],((C_word*)t0)[4],C_fix(0),((C_word*)t0)[2]);}
else{
/* posix-common.scm:344: ##sys#signal-hook */
t2=*((C_word*)lf[3]+1);
((C_proc5)(void*)(*((C_word*)t2+1)))(5,t2,((C_word*)t0)[3],lf[10],lf[65],lf[68]);}}

/* file-unlock in k3893 in k3523 in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_5959(C_word c,C_word t0,C_word t1,...){
C_word tmp;
C_word t2;
C_word *a;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_5959,2,t0,t1);}
/* posixwin.scm:1679: error */
t2=*((C_word*)lf[351]+1);
((C_proc4)(void*)(*((C_word*)t2+1)))(4,t2,t1,lf[367],lf[0]);}

/* file-truncate in k3893 in k3523 in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_5953(C_word c,C_word t0,C_word t1,...){
C_word tmp;
C_word t2;
C_word *a;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_5953,2,t0,t1);}
/* posixwin.scm:1678: error */
t2=*((C_word*)lf[351]+1);
((C_proc4)(void*)(*((C_word*)t2+1)))(4,t2,t1,lf[366],lf[0]);}

/* k2685 in current-directory in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_2687(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word ab[5],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_2687,2,t0,t1);}
t2=t1;
t3=C_curdir(t2);
t4=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_2690,a[2]=t3,a[3]=((C_word*)t0)[2],a[4]=t2,tmp=(C_word)a,a+=5,tmp);
/* posix-common.scm:341: ##sys#update-errno */
((C_proc2)C_fast_retrieve_proc(*((C_word*)lf[7]+1)))(2,*((C_word*)lf[7]+1),t4);}

/* get-groups in k3893 in k3523 in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_5965(C_word c,C_word t0,C_word t1,...){
C_word tmp;
C_word t2;
C_word *a;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_5965,2,t0,t1);}
/* posixwin.scm:1680: error */
t2=*((C_word*)lf[351]+1);
((C_proc4)(void*)(*((C_word*)t2+1)))(4,t2,t1,lf[368],lf[0]);}

/* current-directory in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_2674(C_word c,C_word t0,C_word t1,...){
C_word tmp;
C_word t2;
va_list v;
C_word *a,c2=c;
C_save_rest(t1,c2,2);
if(!C_demand(c*C_SIZEOF_PAIR+3)){
C_save_and_reclaim((void*)tr2r,(void*)f_2674r,2,t0,t1);}
else{
a=C_alloc((c-2)*3);
t2=C_restore_rest(a,C_rest_count(0));
f_2674r(t0,t1,t2);}}

static void C_ccall f_2674r(C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word *a=C_alloc(3);
t3=C_i_nullp(t2);
t4=(C_truep(t3)?C_SCHEME_FALSE:C_i_car(t2));
if(C_truep(t4)){
/* posix-common.scm:337: change-directory */
t5=*((C_word*)lf[66]+1);
((C_proc3)(void*)(*((C_word*)t5+1)))(3,t5,t1,t4);}
else{
t5=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_2687,a[2]=t1,tmp=(C_word)a,a+=3,tmp);
/* ##sys#make-string */
((C_proc4)C_fast_retrieve_proc(*((C_word*)lf[69]+1)))(4,*((C_word*)lf[69]+1),t5,C_fix(1024),C_make_character(32));}}

/* process-spawn in k3893 in k3523 in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_5154(C_word c,C_word t0,C_word t1,C_word t2,C_word t3,...){
C_word tmp;
C_word t4;
va_list v;
C_word *a,c2=c;
C_save_rest(t3,c2,4);
if(c<4) C_bad_min_argc_2(c,4,t0);
if(!C_demand(c*C_SIZEOF_PAIR+6)){
C_save_and_reclaim((void*)tr4r,(void*)f_5154r,4,t0,t1,t2,t3);}
else{
a=C_alloc((c-4)*3);
t4=C_restore_rest(a,C_rest_count(0));
f_5154r(t0,t1,t2,t3,t4);}}

static void C_ccall f_5154r(C_word t0,C_word t1,C_word t2,C_word t3,C_word t4){
C_word tmp;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word t11;
C_word t12;
C_word t13;
C_word t14;
C_word t15;
C_word t16;
C_word t17;
C_word t18;
C_word t19;
C_word *a=C_alloc(6);
t5=C_i_nullp(t4);
t6=(C_truep(t5)?C_SCHEME_FALSE:C_i_car(t4));
t7=C_i_nullp(t4);
t8=(C_truep(t7)?C_SCHEME_END_OF_LIST:C_i_cdr(t4));
t9=C_i_nullp(t8);
t10=(C_truep(t9)?C_SCHEME_FALSE:C_i_car(t8));
t11=t10;
t12=C_i_nullp(t8);
t13=(C_truep(t12)?C_SCHEME_END_OF_LIST:C_i_cdr(t8));
t14=C_i_nullp(t13);
t15=(C_truep(t14)?C_SCHEME_FALSE:C_i_car(t13));
t16=C_i_nullp(t13);
t17=(C_truep(t16)?C_SCHEME_END_OF_LIST:C_i_cdr(t13));
t18=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_5176,a[2]=t11,a[3]=t2,a[4]=t1,a[5]=t3,tmp=(C_word)a,a+=6,tmp);
/* posixwin.scm:1351: $exec-setup */
t19=lf[303];
f_5036(t19,t18,lf[308],t3,t6,t11,t15);}

/* k4644 in setenv in k3893 in k3523 in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_4646(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word ab[4],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_4646,2,t0,t1);}
t2=t1;
t3=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_4650,a[2]=t2,a[3]=((C_word*)t0)[2],tmp=(C_word)a,a+=4,tmp);
/* posixwin.scm:1199: ##sys#make-c-string */
((C_proc4)C_fast_retrieve_proc(*((C_word*)lf[12]+1)))(4,*((C_word*)lf[12]+1),t3,((C_word*)t0)[3],lf[278]);}

/* file-lock/blocking in k3893 in k3523 in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_5935(C_word c,C_word t0,C_word t1,...){
C_word tmp;
C_word t2;
C_word *a;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_5935,2,t0,t1);}
/* posixwin.scm:1675: error */
t2=*((C_word*)lf[351]+1);
((C_proc4)(void*)(*((C_word*)t2+1)))(4,t2,t1,lf[363],lf[0]);}

/* k3179 in k3186 in k3081 in loop in k3060 in k3053 in k3050 in k3258 in k3255 in k3252 in k3249 in k3246 in k3243 in find-files in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_3181(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word ab[14],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_3181,2,t0,t1);}
t2=(C_truep(t1)?C_i_not(((C_word*)t0)[2]):C_SCHEME_FALSE);
if(C_truep(t2)){
t3=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_3105,a[2]=((C_word*)t0)[3],a[3]=((C_word*)t0)[4],a[4]=((C_word*)t0)[5],tmp=(C_word)a,a+=5,tmp);
t4=(*a=C_CLOSURE_TYPE|8,a[1]=(C_word)f_3108,a[2]=((C_word*)t0)[6],a[3]=t3,a[4]=((C_word*)t0)[7],a[5]=((C_word*)t0)[8],a[6]=((C_word*)t0)[3],a[7]=((C_word*)t0)[4],a[8]=((C_word*)t0)[5],tmp=(C_word)a,a+=9,tmp);
/* posix-common.scm:444: pproc */
t5=((C_word*)t0)[9];
((C_proc3)(void*)(*((C_word*)t5+1)))(3,t5,t4,((C_word*)t0)[7]);}
else{
t3=(*a=C_CLOSURE_TYPE|10,a[1]=(C_word)f_3117,a[2]=((C_word*)t0)[10],a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[4],a[5]=((C_word*)t0)[5],a[6]=((C_word*)t0)[6],a[7]=((C_word*)t0)[7],a[8]=((C_word*)t0)[8],a[9]=((C_word*)t0)[9],a[10]=((C_word*)t0)[11],tmp=(C_word)a,a+=11,tmp);
/* posix-common.scm:445: lproc */
t4=((C_word*)t0)[12];
((C_proc3)C_fast_retrieve_proc(t4))(3,t4,t3,((C_word*)t0)[7]);}}

/* k4662 in k4658 in unsetenv in k3893 in k3523 in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_4664(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word *a;
t2=C_setenv(((C_word*)t0)[2],t1);
t3=((C_word*)t0)[3];
((C_proc2)(void*)(*((C_word*)t3+1)))(2,t3,C_SCHEME_UNDEFINED);}

/* f6911 in k3523 in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f6911(C_word c,C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word t4;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr3,(void*)f6911,3,t0,t1,t2);}
t3=C_i_check_string_2(t2,lf[36]);
t4=t1;
((C_proc2)(void*)(*((C_word*)t4+1)))(2,t4,C_SCHEME_FALSE);}

/* k4658 in unsetenv in k3893 in k3523 in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_4660(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word ab[4],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_4660,2,t0,t1);}
t2=t1;
t3=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_4664,a[2]=t2,a[3]=((C_word*)t0)[2],tmp=(C_word)a,a+=4,tmp);
/* posixwin.scm:1207: ##sys#make-c-string */
((C_proc3)C_fast_retrieve_proc(*((C_word*)lf[12]+1)))(3,*((C_word*)lf[12]+1),t3,lf[280]);}

/* file-select in k3893 in k3523 in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_5941(C_word c,C_word t0,C_word t1,...){
C_word tmp;
C_word t2;
C_word *a;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_5941,2,t0,t1);}
/* posixwin.scm:1676: error */
t2=*((C_word*)lf[351]+1);
((C_proc4)(void*)(*((C_word*)t2+1)))(4,t2,t1,lf[364],lf[0]);}

/* file-test-lock in k3893 in k3523 in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_5947(C_word c,C_word t0,C_word t1,...){
C_word tmp;
C_word t2;
C_word *a;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_5947,2,t0,t1);}
/* posixwin.scm:1677: error */
t2=*((C_word*)lf[351]+1);
((C_proc4)(void*)(*((C_word*)t2+1)))(4,t2,t1,lf[365],lf[0]);}

/* get-environment-variables in k3893 in k3523 in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_4676(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word ab[6],*a=ab;
if(c!=2) C_bad_argc_2(c,2,t0);
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_4676,2,t0,t1);}
t2=C_SCHEME_UNDEFINED;
t3=(*a=C_VECTOR_TYPE|1,a[1]=t2,tmp=(C_word)a,a+=2,tmp);
t4=C_set_block_item(t3,0,(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_4682,a[2]=t3,a[3]=((C_word)li113),tmp=(C_word)a,a+=4,tmp));
t5=((C_word*)t3)[1];
f_4682(t5,t1,C_fix(0));}

/* k3009 in k3005 in g363 in k2993 in loop in k2974 in k2967 in a2964 in conc-loop in glob in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_3011(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word ab[3],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_3011,2,t0,t1);}
t2=((C_word*)t0)[2];
((C_proc2)(void*)(*((C_word*)t2+1)))(2,t2,C_a_i_cons(&a,2,((C_word*)t0)[3],t1));}

/* k3192 in k3081 in loop in k3060 in k3053 in k3050 in k3258 in k3255 in k3252 in k3249 in k3246 in k3243 in find-files in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_3194(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word ab[5],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_3194,2,t0,t1);}
if(C_truep(t1)){
t2=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_3201,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[4],tmp=(C_word)a,a+=5,tmp);
/* posix-common.scm:451: action */
t3=((C_word*)t0)[5];
((C_proc4)C_fast_retrieve_proc(t3))(4,t3,t2,((C_word*)t0)[6],((C_word*)t0)[7]);}
else{
/* posix-common.scm:452: loop */
t2=((C_word*)((C_word*)t0)[2])[1];
f_3064(t2,((C_word*)t0)[3],((C_word*)t0)[4],((C_word*)t0)[7]);}}

/* k4806 in set-buffering-mode! in k3893 in k3523 in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_fcall f_4808(C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word ab[5],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)trf_4808,NULL,2,t0,t1);}
t2=t1;
t3=((C_word*)t0)[2];
t4=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_4811,a[2]=t2,a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[4],tmp=(C_word)a,a+=5,tmp);
t5=C_eqp(t3,lf[290]);
if(C_truep(t5)){
t6=t4;
f_4811(2,t6,C_fix((C_word)_IOFBF));}
else{
t6=C_eqp(t3,lf[291]);
if(C_truep(t6)){
t7=C_fix((C_word)_IOLBF);
t8=t4;
f_4811(2,t8,t7);}
else{
t7=C_eqp(t3,lf[292]);
if(C_truep(t7)){
t8=t4;
f_4811(2,t8,C_fix((C_word)_IONBF));}
else{
/* posixwin.scm:1261: ##sys#error */
t8=*((C_word*)lf[45]+1);
((C_proc6)(void*)(*((C_word*)t8+1)))(6,t8,t4,lf[288],lf[293],((C_word*)t0)[2],((C_word*)t0)[4]);}}}}

/* close-input-pipe in k3893 in k3523 in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_4162(C_word c,C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word ab[5],*a=ab;
if(c!=3) C_bad_argc_2(c,3,t0);
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr3,(void*)f_4162,3,t0,t1,t2);}
t3=t2;
t4=C_i_check_port_2(t3,C_SCHEME_TRUE,C_SCHEME_TRUE,lf[186]);
t5=close_pipe(t2);
t6=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_4169,a[2]=t1,a[3]=t5,a[4]=t2,tmp=(C_word)a,a+=5,tmp);
/* posixwin.scm:955: ##sys#update-errno */
((C_proc2)C_fast_retrieve_proc(*((C_word*)lf[7]+1)))(2,*((C_word*)lf[7]+1),t6);}

/* k3017 in g363 in k2993 in loop in k2974 in k2967 in a2964 in conc-loop in glob in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_3019(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word *a;
/* posix-common.scm:415: make-pathname */
t2=*((C_word*)lf[81]+1);
((C_proc4)(void*)(*((C_word*)t2+1)))(4,t2,((C_word*)t0)[2],((C_word*)t0)[3],t1);}

/* k4167 in close-input-pipe in k3893 in k3523 in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_4169(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word ab[4],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_4169,2,t0,t1);}
t2=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_4172,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],tmp=(C_word)a,a+=4,tmp);
t3=C_eqp(C_fix(-1),((C_word*)t0)[3]);
if(C_truep(t3)){
/* posixwin.scm:957: ##sys#signal-hook */
t4=*((C_word*)lf[3]+1);
((C_proc6)(void*)(*((C_word*)t4+1)))(6,t4,t2,lf[10],lf[186],lf[187],((C_word*)t0)[4]);}
else{
t4=((C_word*)t0)[2];
((C_proc2)(void*)(*((C_word*)t4+1)))(2,t4,((C_word*)t0)[3]);}}

/* set-buffering-mode! in k3893 in k3523 in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_4802(C_word c,C_word t0,C_word t1,C_word t2,C_word t3,...){
C_word tmp;
C_word t4;
va_list v;
C_word *a,c2=c;
C_save_rest(t3,c2,4);
if(c<4) C_bad_min_argc_2(c,4,t0);
if(!C_demand(c*C_SIZEOF_PAIR+5)){
C_save_and_reclaim((void*)tr4r,(void*)f_4802r,4,t0,t1,t2,t3);}
else{
a=C_alloc((c-4)*3);
t4=C_restore_rest(a,C_rest_count(0));
f_4802r(t0,t1,t2,t3,t4);}}

static void C_ccall f_4802r(C_word t0,C_word t1,C_word t2,C_word t3,C_word t4){
C_word tmp;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word *a=C_alloc(5);
t5=t2;
t6=C_i_check_port_2(t5,C_fix(0),C_SCHEME_TRUE,lf[288]);
t7=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_4808,a[2]=t3,a[3]=t1,a[4]=t2,tmp=(C_word)a,a+=5,tmp);
if(C_truep(C_i_pairp(t4))){
t8=t4;
t9=t7;
f_4808(t9,C_u_i_car(t8));}
else{
t8=t7;
f_4808(t8,C_fix((C_word)BUFSIZ));}}

/* scan in k4684 in loop in get-environment-variables in k3893 in k3523 in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_fcall f_4694(C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word *a;
loop:
a=C_alloc(7);
if(!C_stack_probe(a)){
C_save_and_reclaim((void*)trf_4694,NULL,3,t0,t1,t2);}
t3=C_subchar(((C_word*)t0)[2],t2);
if(C_truep(C_i_char_equalp(C_make_character(61),t3))){
t4=(*a=C_CLOSURE_TYPE|6,a[1]=(C_word)f_4720,a[2]=t1,a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[4],a[5]=t2,a[6]=((C_word*)t0)[2],tmp=(C_word)a,a+=7,tmp);
/* posixwin.scm:1218: substring */
t5=*((C_word*)lf[282]+1);
((C_proc5)(void*)(*((C_word*)t5+1)))(5,t5,t4,((C_word*)t0)[2],C_fix(0),t2);}
else{
t4=C_fixnum_plus(t2,C_fix(1));
/* posixwin.scm:1219: scan */
t7=t1;
t8=t4;
t1=t7;
t2=t8;
goto loop;}}

/* process-group-id in k3893 in k3523 in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_5995(C_word c,C_word t0,C_word t1,...){
C_word tmp;
C_word t2;
C_word *a;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_5995,2,t0,t1);}
/* posixwin.scm:1685: error */
t2=*((C_word*)lf[351]+1);
((C_proc4)(void*)(*((C_word*)t2+1)))(4,t2,t1,lf[373],lf[0]);}

/* k4151 in open-output-pipe in k3893 in k3523 in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_4153(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word ab[2],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_4153,2,t0,t1);}
t2=open_binary_output_pipe(&a,1,t1);
/* posixwin.scm:945: check */
f_4064(((C_word*)t0)[3],((C_word*)t0)[4],C_SCHEME_FALSE,t2);}

/* k3005 in g363 in k2993 in loop in k2974 in k2967 in a2964 in conc-loop in glob in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_3007(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word ab[4],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_3007,2,t0,t1);}
t2=t1;
t3=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_3011,a[2]=((C_word*)t0)[2],a[3]=t2,tmp=(C_word)a,a+=4,tmp);
t4=C_i_cdr(((C_word*)t0)[3]);
/* posix-common.scm:416: loop */
t5=((C_word*)((C_word*)t0)[4])[1];
f_2978(t5,t3,t4);}

/* loop in get-environment-variables in k3893 in k3523 in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_fcall f_4682(C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word ab[10],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)trf_4682,NULL,3,t0,t1,t2);}
t3=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_4686,a[2]=t2,a[3]=((C_word*)t0)[2],a[4]=t1,tmp=(C_word)a,a+=5,tmp);
t4=t2;
t5=C_a_i_bytevector(&a,1,C_fix(3));
t6=C_i_foreign_fixnum_argumentp(t4);
t7=stub1042(t5,t6);
/* posixwin.scm:1211: ##sys#peek-c-string */
t8=*((C_word*)lf[6]+1);
((C_proc4)(void*)(*((C_word*)t8+1)))(4,t8,t3,t7,C_fix(0));}

/* k4818 in k4809 in k4806 in set-buffering-mode! in k3893 in k3523 in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_fcall f_4820(C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word *a;
if(C_truep(t1)){
/* posixwin.scm:1267: ##sys#error */
t2=*((C_word*)lf[45]+1);
((C_proc7)(void*)(*((C_word*)t2+1)))(7,t2,((C_word*)t0)[2],lf[288],lf[289],((C_word*)t0)[3],((C_word*)t0)[4],((C_word*)t0)[5]);}
else{
t2=C_SCHEME_UNDEFINED;
t3=((C_word*)t0)[2];
((C_proc2)(void*)(*((C_word*)t3+1)))(2,t3,t2);}}

/* group-information in k3893 in k3523 in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_5971(C_word c,C_word t0,C_word t1,...){
C_word tmp;
C_word t2;
C_word *a;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_5971,2,t0,t1);}
/* posixwin.scm:1681: error */
t2=*((C_word*)lf[351]+1);
((C_proc4)(void*)(*((C_word*)t2+1)))(4,t2,t1,lf[369],lf[0]);}

/* initialize-groups in k3893 in k3523 in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_5977(C_word c,C_word t0,C_word t1,...){
C_word tmp;
C_word t2;
C_word *a;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_5977,2,t0,t1);}
/* posixwin.scm:1682: error */
t2=*((C_word*)lf[351]+1);
((C_proc4)(void*)(*((C_word*)t2+1)))(4,t2,t1,lf[370],lf[0]);}

/* k4684 in loop in get-environment-variables in k3893 in k3523 in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_4686(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word ab[9],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_4686,2,t0,t1);}
t2=t1;
if(C_truep(t2)){
t3=C_SCHEME_UNDEFINED;
t4=(*a=C_VECTOR_TYPE|1,a[1]=t3,tmp=(C_word)a,a+=2,tmp);
t5=C_set_block_item(t4,0,(*a=C_CLOSURE_TYPE|6,a[1]=(C_word)f_4694,a[2]=t2,a[3]=((C_word*)t0)[2],a[4]=((C_word*)t0)[3],a[5]=t4,a[6]=((C_word)li112),tmp=(C_word)a,a+=7,tmp));
t6=((C_word*)t4)[1];
f_4694(t6,((C_word*)t0)[4],C_fix(0));}
else{
t3=((C_word*)t0)[4];
((C_proc2)(void*)(*((C_word*)t3+1)))(2,t3,C_SCHEME_END_OF_LIST);}}

/* parent-process-id in k3893 in k3523 in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_5983(C_word c,C_word t0,C_word t1,...){
C_word tmp;
C_word t2;
C_word *a;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_5983,2,t0,t1);}
/* posixwin.scm:1683: error */
t2=*((C_word*)lf[351]+1);
((C_proc4)(void*)(*((C_word*)t2+1)))(4,t2,t1,lf[371],lf[0]);}

/* process-fork in k3893 in k3523 in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_5989(C_word c,C_word t0,C_word t1,...){
C_word tmp;
C_word t2;
C_word *a;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_5989,2,t0,t1);}
/* posixwin.scm:1684: error */
t2=*((C_word*)lf[351]+1);
((C_proc4)(void*)(*((C_word*)t2+1)))(4,t2,t1,lf[372],lf[0]);}

/* k4025 in change-directory in k3893 in k3523 in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_4027(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word ab[8],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_4027,2,t0,t1);}
t2=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_4030,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],tmp=(C_word)a,a+=4,tmp);
t3=C_chdir(t1);
t4=C_eqp(C_fix(0),t3);
if(C_truep(t4)){
t5=((C_word*)t0)[2];
((C_proc2)(void*)(*((C_word*)t5+1)))(2,t5,((C_word*)t0)[3]);}
else{
t5=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_4036,a[2]=t2,a[3]=((C_word*)t0)[3],tmp=(C_word)a,a+=4,tmp);
/* posixwin.scm:913: ##sys#update-errno */
((C_proc2)C_fast_retrieve_proc(*((C_word*)lf[7]+1)))(2,*((C_word*)lf[7]+1),t5);}}

/* k5350 in k5343 in process in k3893 in k3523 in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_5352(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word ab[8],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_5352,2,t0,t1);}
if(C_truep(t1)){
t2=(*a=C_CLOSURE_TYPE|7,a[1]=(C_word)f_5362,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[4],a[5]=((C_word*)t0)[5],a[6]=((C_word*)t0)[6],a[7]=((C_word*)t0)[7],tmp=(C_word)a,a+=8,tmp);
if(C_truep(((C_word*)t0)[8])){
/* posixwin.scm:1412: open-input-file* */
t3=*((C_word*)lf[56]+1);
((C_proc3)(void*)(*((C_word*)t3+1)))(3,t3,t2,C_fix((C_word)*((int *)C_data_pointer(((C_word*)t0)[9]))));}
else{
t3=t2;
f_5362(2,t3,C_SCHEME_FALSE);}}
else{
t2=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_5382,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[10],a[4]=((C_word*)t0)[11],tmp=(C_word)a,a+=5,tmp);
/* posixwin.scm:1417: ##sys#update-errno */
((C_proc2)C_fast_retrieve_proc(*((C_word*)lf[7]+1)))(2,*((C_word*)lf[7]+1),t2);}}

/* change-directory in k3893 in k3523 in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_4020(C_word c,C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word ab[7],*a=ab;
if(c!=3) C_bad_argc_2(c,3,t0);
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr3,(void*)f_4020,3,t0,t1,t2);}
t3=C_i_check_string_2(t2,lf[66]);
t4=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_4027,a[2]=t1,a[3]=t2,tmp=(C_word)a,a+=4,tmp);
t5=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_4044,a[2]=t4,tmp=(C_word)a,a+=3,tmp);
/* posixwin.scm:911: ##sys#expand-home-path */
((C_proc3)C_fast_retrieve_proc(*((C_word*)lf[14]+1)))(3,*((C_word*)lf[14]+1),t5,t2);}

/* k4188 in k4185 in close-output-pipe in k3893 in k3523 in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_4190(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word *a;
t2=((C_word*)t0)[2];
((C_proc2)(void*)(*((C_word*)t2+1)))(2,t2,((C_word*)t0)[3]);}

/* call-with-input-pipe in k3893 in k3523 in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_4198(C_word c,C_word t0,C_word t1,C_word t2,C_word t3,...){
C_word tmp;
C_word t4;
va_list v;
C_word *a,c2=c;
C_save_rest(t3,c2,4);
if(c<4) C_bad_min_argc_2(c,4,t0);
if(!C_demand(c*C_SIZEOF_PAIR+4)){
C_save_and_reclaim((void*)tr4r,(void*)f_4198r,4,t0,t1,t2,t3);}
else{
a=C_alloc((c-4)*3);
t4=C_restore_rest(a,C_rest_count(0));
f_4198r(t0,t1,t2,t3,t4);}}

static void C_ccall f_4198r(C_word t0,C_word t1,C_word t2,C_word t3,C_word t4){
C_word tmp;
C_word t5;
C_word t6;
C_word *a=C_alloc(4);
t5=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_4202,a[2]=t3,a[3]=t1,tmp=(C_word)a,a+=4,tmp);
C_apply(5,0,t5,*((C_word*)lf[181]+1),t2,t4);}

/* k5360 in k5350 in k5343 in process in k3893 in k3523 in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_5362(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word ab[7],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_5362,2,t0,t1);}
t2=t1;
t3=(*a=C_CLOSURE_TYPE|6,a[1]=(C_word)f_5366,a[2]=((C_word*)t0)[2],a[3]=t2,a[4]=((C_word*)t0)[3],a[5]=((C_word*)t0)[4],a[6]=((C_word*)t0)[5],tmp=(C_word)a,a+=7,tmp);
if(C_truep(((C_word*)t0)[6])){
/* posixwin.scm:1413: open-output-file* */
t4=*((C_word*)lf[57]+1);
((C_proc3)(void*)(*((C_word*)t4+1)))(3,t4,t3,C_fix((C_word)*((int *)C_data_pointer(((C_word*)t0)[7]))));}
else{
t4=t3;
f_5366(2,t4,C_SCHEME_FALSE);}}

/* k5364 in k5360 in k5350 in k5343 in process in k3893 in k3523 in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_5366(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word ab[6],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_5366,2,t0,t1);}
t2=t1;
t3=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_5370,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=t2,a[5]=((C_word*)t0)[4],tmp=(C_word)a,a+=6,tmp);
if(C_truep(((C_word*)t0)[5])){
/* posixwin.scm:1415: open-input-file* */
t4=*((C_word*)lf[56]+1);
((C_proc3)(void*)(*((C_word*)t4+1)))(3,t4,t3,C_fix((C_word)*((int *)C_data_pointer(((C_word*)t0)[6]))));}
else{
/* posixwin.scm:1411: values */
C_values(6,0,((C_word*)t0)[2],((C_word*)t0)[3],t2,C_fix((C_word)*((int *)C_data_pointer(((C_word*)t0)[4]))),C_SCHEME_FALSE);}}

/* doloop1136 in build-exec-argvec in k3893 in k3523 in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_fcall f_5000(C_word t0,C_word t1,C_word t2,C_word t3){
C_word tmp;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word ab[6],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)trf_5000,NULL,4,t0,t1,t2,t3);}
if(C_truep(C_i_nullp(t2))){
/* posixwin.scm:1323: argvec-setter */
t4=((C_word*)t0)[2];
((C_proc5)C_fast_retrieve_proc(t4))(5,t4,t1,t3,C_SCHEME_FALSE,C_fix(0));}
else{
t4=C_i_car(t2);
t5=C_i_check_string_2(t4,((C_word*)t0)[3]);
t6=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_5019,a[2]=t2,a[3]=t3,a[4]=((C_word*)t0)[4],a[5]=t1,tmp=(C_word)a,a+=6,tmp);
t7=C_block_size(t4);
/* posixwin.scm:1326: argvec-setter */
t8=((C_word*)t0)[2];
((C_proc5)C_fast_retrieve_proc(t8))(5,t8,t6,t3,t4,t7);}}

/* $quote-args-list in k3893 in k3523 in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_fcall f_4869(C_word t1,C_word t2,C_word t3){
C_word tmp;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word ab[6],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)trf_4869,NULL,3,t1,t2,t3);}
if(C_truep(t3)){
t4=t2;
t5=t1;
((C_proc2)(void*)(*((C_word*)t5+1)))(2,t5,t4);}
else{
t4=C_SCHEME_UNDEFINED;
t5=(*a=C_VECTOR_TYPE|1,a[1]=t4,tmp=(C_word)a,a+=2,tmp);
t6=C_set_block_item(t5,0,(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_4912,a[2]=t5,a[3]=((C_word)li121),tmp=(C_word)a,a+=4,tmp));
t7=((C_word*)t5)[1];
f_4912(t7,t1,t2,C_SCHEME_END_OF_LIST);}}

/* k4141 in open-output-pipe in k3893 in k3523 in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_4143(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word ab[2],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_4143,2,t0,t1);}
t2=open_text_output_pipe(&a,1,t1);
/* posixwin.scm:945: check */
f_4064(((C_word*)t0)[3],((C_word*)t0)[4],C_SCHEME_FALSE,t2);}

/* ##sys#process in k3893 in k3523 in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_5338(C_word c,C_word t0,C_word t1,C_word t2,C_word t3,C_word t4,C_word t5,C_word t6,C_word t7,C_word t8,...){
C_word tmp;
C_word t9;
va_list v;
C_word *a,c2=c;
C_save_rest(t8,c2,9);
if(c<9) C_bad_min_argc_2(c,9,t0);
if(!C_demand(c*C_SIZEOF_PAIR+14)){
C_save_and_reclaim((void*)tr9r,(void*)f_5338r,9,t0,t1,t2,t3,t4,t5,t6,t7,t8);}
else{
a=C_alloc((c-9)*3);
t9=C_restore_rest(a,C_rest_count(0));
f_5338r(t0,t1,t2,t3,t4,t5,t6,t7,t8,t9);}}

static void C_ccall f_5338r(C_word t0,C_word t1,C_word t2,C_word t3,C_word t4,C_word t5,C_word t6,C_word t7,C_word t8,C_word t9){
C_word tmp;
C_word t10;
C_word t11;
C_word t12;
C_word t13;
C_word t14;
C_word t15;
C_word *a=C_alloc(14);
t10=C_i_nullp(t9);
t11=(C_truep(t10)?C_SCHEME_FALSE:C_i_car(t9));
t12=(*a=C_CLOSURE_TYPE|7,a[1]=(C_word)f_5345,a[2]=t1,a[3]=t8,a[4]=t7,a[5]=t6,a[6]=t2,a[7]=t3,tmp=(C_word)a,a+=8,tmp);
t13=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_5421,a[2]=t12,tmp=(C_word)a,a+=3,tmp);
t14=C_a_i_cons(&a,2,t3,t4);
/* posixwin.scm:1402: $quote-args-list */
f_4869(t13,t14,t11);}

/* $exec-setup in k3893 in k3523 in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_fcall f_5036(C_word t0,C_word t1,C_word t2,C_word t3,C_word t4,C_word t5,C_word t6){
C_word tmp;
C_word t7;
C_word t8;
C_word t9;
C_word ab[11],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)trf_5036,NULL,7,t0,t1,t2,t3,t4,t5,t6);}
t7=C_i_check_string_2(t3,t2);
t8=(*a=C_CLOSURE_TYPE|10,a[1]=(C_word)f_5043,a[2]=t1,a[3]=t2,a[4]=t3,a[5]=((C_word*)t0)[2],a[6]=t5,a[7]=((C_word*)t0)[3],a[8]=((C_word*)t0)[4],a[9]=t4,a[10]=t6,tmp=(C_word)a,a+=11,tmp);
/* posixwin.scm:1330: pathname-strip-directory */
t9=*((C_word*)lf[304]+1);
((C_proc3)(void*)(*((C_word*)t9+1)))(3,t9,t8,t3);}

/* k4034 in k4025 in change-directory in k3893 in k3523 in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_4036(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word *a;
/* posixwin.scm:914: ##sys#signal-hook */
t2=*((C_word*)lf[3]+1);
((C_proc6)(void*)(*((C_word*)t2+1)))(6,t2,((C_word*)t0)[2],lf[10],lf[66],lf[178],((C_word*)t0)[3]);}

/* k4134 in open-output-pipe in k3893 in k3523 in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_4136(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word *a;
/* posixwin.scm:945: check */
f_4064(((C_word*)t0)[3],((C_word*)t0)[4],C_SCHEME_FALSE,t1);}

/* k5343 in process in k3893 in k3523 in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_5345(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word t11;
C_word t12;
C_word t13;
C_word ab[35],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_5345,2,t0,t1);}
t2=t1;
t3=C_a_i_bytevector(&a,1,C_fix(1));
t4=((*(int *)C_data_pointer(t3))=C_unfix(C_fix(-1)),C_SCHEME_UNDEFINED);
t5=C_a_i_bytevector(&a,1,C_fix(1));
t6=((*(int *)C_data_pointer(t5))=C_unfix(C_fix(-1)),C_SCHEME_UNDEFINED);
t7=C_a_i_bytevector(&a,1,C_fix(1));
t8=((*(int *)C_data_pointer(t7))=C_unfix(C_fix(-1)),C_SCHEME_UNDEFINED);
t9=C_a_i_bytevector(&a,1,C_fix(1));
t10=((*(int *)C_data_pointer(t9))=C_unfix(C_fix(-1)),C_SCHEME_UNDEFINED);
t11=(*a=C_CLOSURE_TYPE|11,a[1]=(C_word)f_5352,a[2]=((C_word*)t0)[2],a[3]=t3,a[4]=((C_word*)t0)[3],a[5]=t9,a[6]=((C_word*)t0)[4],a[7]=t5,a[8]=((C_word*)t0)[5],a[9]=t7,a[10]=((C_word*)t0)[6],a[11]=t2,tmp=(C_word)a,a+=12,tmp);
t12=(*a=C_CLOSURE_TYPE|10,a[1]=(C_word)f_5389,a[2]=t11,a[3]=((C_word*)t0)[7],a[4]=t2,a[5]=((C_word*)t0)[4],a[6]=((C_word*)t0)[5],a[7]=((C_word*)t0)[3],a[8]=t9,a[9]=t7,a[10]=t5,tmp=(C_word)a,a+=11,tmp);
/* posixwin.scm:1407: ##sys#make-locative */
((C_proc6)C_fast_retrieve_proc(*((C_word*)lf[319]+1)))(6,*((C_word*)lf[319]+1),t12,t3,C_fix(0),C_SCHEME_FALSE,lf[320]);}

/* k4028 in k4025 in change-directory in k3893 in k3523 in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_4030(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word *a;
t2=((C_word*)t0)[2];
((C_proc2)(void*)(*((C_word*)t2+1)))(2,t2,((C_word*)t0)[3]);}

/* k2655 in k2652 */
static void C_ccall f_2657(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word *a;
t2=((C_word*)t0)[2];
((C_proc2)(void*)(*((C_word*)t2+1)))(2,t2,((C_word*)t0)[3]);}

/* loop in loop in $quote-args-list in k3893 in k3523 in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static C_word C_fcall f_4883(C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_stack_overflow_check;
loop:
t2=C_eqp(t1,((C_word*)t0)[2]);
if(C_truep(t2)){
return(C_SCHEME_FALSE);}
else{
t3=C_i_string_ref(((C_word*)t0)[3],t1);
if(C_truep(C_u_i_char_whitespacep(t3))){
return(C_SCHEME_TRUE);}
else{
t4=C_fixnum_plus(t1,C_fix(1));
t6=t4;
t1=t6;
goto loop;}}}

/* k2652 */
static void C_fcall f_2654(C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word ab[4],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)trf_2654,NULL,2,t0,t1);}
t2=t1;
t3=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_2657,a[2]=((C_word*)t0)[2],a[3]=t2,tmp=(C_word)a,a+=4,tmp);
if(C_truep(C_fixnum_lessp(t2,C_fix(0)))){
/* posix-common.scm:329: posix-error */
t4=lf[2];
f_2245(6,t4,t3,lf[10],lf[63],lf[64],((C_word*)t0)[3]);}
else{
t4=((C_word*)t0)[2];
((C_proc2)(void*)(*((C_word*)t4+1)))(2,t4,t2);}}

/* f_2647 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_2647(C_word c,C_word t0,C_word t1,C_word t2,...){
C_word tmp;
C_word t3;
va_list v;
C_word *a,c2=c;
C_save_rest(t2,c2,3);
if(c<3) C_bad_min_argc_2(c,3,t0);
if(!C_demand(c*C_SIZEOF_PAIR+4)){
C_save_and_reclaim((void*)tr3r,(void*)f_2647r,3,t0,t1,t2);}
else{
a=C_alloc((c-3)*3);
t3=C_restore_rest(a,C_rest_count(0));
f_2647r(t0,t1,t2,t3);}}

static void C_ccall f_2647r(C_word t0,C_word t1,C_word t2,C_word t3){
C_word tmp;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word *a=C_alloc(4);
t4=C_i_check_exact_2(t2,*((C_word*)lf[63]+1));
t5=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_2654,a[2]=t1,a[3]=t2,tmp=(C_word)a,a+=4,tmp);
if(C_truep(C_i_nullp(t3))){
t6=t5;
f_2654(t6,C_dup(t2));}
else{
t6=C_i_car(t3);
t7=C_i_check_exact_2(t6,lf[63]);
t8=t5;
f_2654(t8,C_dup2(t2,t6));}}

/* k2639 */
static void C_ccall f_2641(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word ab[4],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_2641,2,t0,t1);}
if(C_truep(C_i_zerop(t1))){
/* posix-common.scm:318: posix-error */
t2=lf[2];
f_2245(6,t2,((C_word*)t0)[2],lf[15],lf[58],lf[60],((C_word*)t0)[3]);}
else{
t2=C_C_fileno(((C_word*)t0)[3]);
t3=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_2624,a[2]=((C_word*)t0)[2],a[3]=t2,tmp=(C_word)a,a+=4,tmp);
if(C_truep(C_fixnum_lessp(t2,C_fix(0)))){
/* posix-common.scm:316: posix-error */
t4=lf[2];
f_2245(6,t4,t3,lf[10],lf[58],lf[61],((C_word*)t0)[3]);}
else{
t4=((C_word*)t0)[2];
((C_proc2)(void*)(*((C_word*)t4+1)))(2,t4,t2);}}}

/* close-output-pipe in k3893 in k3523 in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_4180(C_word c,C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word ab[5],*a=ab;
if(c!=3) C_bad_argc_2(c,3,t0);
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr3,(void*)f_4180,3,t0,t1,t2);}
t3=t2;
t4=C_i_check_port_2(t3,C_SCHEME_FALSE,C_SCHEME_TRUE,lf[188]);
t5=close_pipe(t2);
t6=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_4187,a[2]=t1,a[3]=t5,a[4]=t2,tmp=(C_word)a,a+=5,tmp);
/* posixwin.scm:963: ##sys#update-errno */
((C_proc2)C_fast_retrieve_proc(*((C_word*)lf[7]+1)))(2,*((C_word*)lf[7]+1),t6);}

/* k4185 in close-output-pipe in k3893 in k3523 in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_4187(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word ab[4],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_4187,2,t0,t1);}
t2=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_4190,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],tmp=(C_word)a,a+=4,tmp);
t3=C_eqp(C_fix(-1),((C_word*)t0)[3]);
if(C_truep(t3)){
/* posixwin.scm:965: ##sys#signal-hook */
t4=*((C_word*)lf[3]+1);
((C_proc6)(void*)(*((C_word*)t4+1)))(6,t4,t2,lf[10],lf[188],lf[189],((C_word*)t0)[4]);}
else{
t4=((C_word*)t0)[2];
((C_proc2)(void*)(*((C_word*)t4+1)))(2,t4,((C_word*)t0)[3]);}}

/* setenv in k3893 in k3523 in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_4635(C_word c,C_word t0,C_word t1,C_word t2,C_word t3){
C_word tmp;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word ab[4],*a=ab;
if(c!=4) C_bad_argc_2(c,4,t0);
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr4,(void*)f_4635,4,t0,t1,t2,t3);}
t4=C_i_check_string_2(t2,lf[278]);
t5=C_i_check_string_2(t3,lf[278]);
t6=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_4646,a[2]=t1,a[3]=t3,tmp=(C_word)a,a+=4,tmp);
/* posixwin.scm:1199: ##sys#make-c-string */
((C_proc4)C_fast_retrieve_proc(*((C_word*)lf[12]+1)))(4,*((C_word*)lf[12]+1),t6,t2,lf[278]);}

/* k4170 in k4167 in close-input-pipe in k3893 in k3523 in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_4172(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word *a;
t2=((C_word*)t0)[2];
((C_proc2)(void*)(*((C_word*)t2+1)))(2,t2,((C_word*)t0)[3]);}

/* k4619 in k4610 in duplicate-fileno in k3893 in k3523 in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_4621(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word *a;
/* posixwin.scm:1189: ##sys#signal-hook */
t2=*((C_word*)lf[3]+1);
((C_proc6)(void*)(*((C_word*)t2+1)))(6,t2,((C_word*)t0)[2],lf[10],lf[63],lf[277],((C_word*)t0)[3]);}

/* open-output-pipe in k3893 in k3523 in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_4122(C_word c,C_word t0,C_word t1,C_word t2,...){
C_word tmp;
C_word t3;
va_list v;
C_word *a,c2=c;
C_save_rest(t2,c2,3);
if(c<3) C_bad_min_argc_2(c,3,t0);
if(!C_demand(c*C_SIZEOF_PAIR+10)){
C_save_and_reclaim((void*)tr3r,(void*)f_4122r,3,t0,t1,t2);}
else{
a=C_alloc((c-3)*3);
t3=C_restore_rest(a,C_rest_count(0));
f_4122r(t0,t1,t2,t3);}}

static void C_ccall f_4122r(C_word t0,C_word t1,C_word t2,C_word t3){
C_word tmp;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word t11;
C_word t12;
C_word *a=C_alloc(10);
t4=C_i_check_string_2(t2,lf[185]);
t5=C_i_pairp(t3);
t6=(C_truep(t5)?C_slot(t3,C_fix(0)):lf[182]);
t7=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_4136,a[2]=((C_word*)t0)[2],a[3]=t1,a[4]=t2,tmp=(C_word)a,a+=5,tmp);
t8=C_eqp(t6,lf[182]);
if(C_truep(t8)){
t9=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_4143,a[2]=((C_word*)t0)[2],a[3]=t1,a[4]=t2,tmp=(C_word)a,a+=5,tmp);
/* posixwin.scm:948: ##sys#make-c-string */
((C_proc4)C_fast_retrieve_proc(*((C_word*)lf[12]+1)))(4,*((C_word*)lf[12]+1),t9,t2,lf[185]);}
else{
t9=C_eqp(t6,lf[183]);
if(C_truep(t9)){
t10=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_4153,a[2]=((C_word*)t0)[2],a[3]=t1,a[4]=t2,tmp=(C_word)a,a+=5,tmp);
/* posixwin.scm:949: ##sys#make-c-string */
((C_proc4)C_fast_retrieve_proc(*((C_word*)lf[12]+1)))(4,*((C_word*)lf[12]+1),t10,t2,lf[185]);}
else{
/* posixwin.scm:923: ##sys#error */
t10=*((C_word*)lf[45]+1);
((C_proc4)(void*)(*((C_word*)t10+1)))(4,t10,t7,lf[184],t6);}}}

/* k5174 in process-spawn in k3893 in k3523 in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_5176(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word *a;
if(C_truep(((C_word*)t0)[2])){
t2=C_spawnvpe(((C_word*)t0)[3],t1);
/* posixwin.scm:1352: $exec-teardown */
f_5072(((C_word*)t0)[4],lf[308],lf[309],((C_word*)t0)[5],t2);}
else{
t2=C_spawnvp(((C_word*)t0)[3],t1);
/* posixwin.scm:1352: $exec-teardown */
f_5072(((C_word*)t0)[4],lf[308],lf[309],((C_word*)t0)[5],t2);}}

/* k4111 in open-input-pipe in k3893 in k3523 in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_4113(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word ab[2],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_4113,2,t0,t1);}
t2=open_binary_input_pipe(&a,1,t1);
/* posixwin.scm:935: check */
f_4064(((C_word*)t0)[3],((C_word*)t0)[4],C_SCHEME_TRUE,t2);}

/* f6917 in k3523 in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f6917(C_word c,C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word t4;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr3,(void*)f6917,3,t0,t1,t2);}
t3=C_i_check_string_2(t2,lf[37]);
t4=t1;
((C_proc2)(void*)(*((C_word*)t4+1)))(2,t4,C_SCHEME_FALSE);}

/* k3850 in k3841 in set-file-position! in k3523 in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_3852(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word ab[11],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_3852,2,t0,t1);}
t2=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_3858,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[4],tmp=(C_word)a,a+=5,tmp);
t3=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_3864,a[2]=((C_word*)t0)[3],a[3]=((C_word*)t0)[4],a[4]=((C_word*)t0)[5],a[5]=t2,tmp=(C_word)a,a+=6,tmp);
/* posixwin.scm:851: port? */
t4=*((C_word*)lf[168]+1);
((C_proc3)(void*)(*((C_word*)t4+1)))(3,t4,t3,((C_word*)t0)[3]);}

/* k3856 in k3850 in k3841 in set-file-position! in k3523 in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_3858(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word *a;
if(C_truep(t1)){
t2=C_SCHEME_UNDEFINED;
t3=((C_word*)t0)[2];
((C_proc2)(void*)(*((C_word*)t3+1)))(2,t3,t2);}
else{
/* posixwin.scm:858: posix-error */
t2=lf[2];
f_2245(7,t2,((C_word*)t0)[2],lf[10],lf[165],lf[166],((C_word*)t0)[3],((C_word*)t0)[4]);}}

/* k3841 in set-file-position! in k3523 in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_fcall f_3843(C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word ab[6],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)trf_3843,NULL,2,t0,t1);}
t2=t1;
t3=C_i_check_exact_2(((C_word*)t0)[2],lf[165]);
t4=C_i_check_exact_2(t2,lf[165]);
t5=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_3852,a[2]=((C_word*)t0)[3],a[3]=((C_word*)t0)[4],a[4]=((C_word*)t0)[2],a[5]=t2,tmp=(C_word)a,a+=6,tmp);
t6=((C_word*)t0)[2];
if(C_truep(C_fixnum_lessp(t6,C_fix(0)))){
/* posixwin.scm:850: ##sys#signal-hook */
t7=*((C_word*)lf[3]+1);
((C_proc7)(void*)(*((C_word*)t7+1)))(7,t7,t5,lf[169],lf[165],lf[170],((C_word*)t0)[2],((C_word*)t0)[4]);}
else{
t7=t5;
f_3852(2,t7,C_SCHEME_UNDEFINED);}}

/* a6154 in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_6155(C_word c,C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word t4;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr3,(void*)f_6155,3,t0,t1,t2);}
t3=C_i_check_exact_2(t2,lf[119]);
t4=t1;
((C_proc2)(void*)(*((C_word*)t4+1)))(2,t4,C_slot(*((C_word*)lf[118]+1),t2));}

/* f6905 in k3523 in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f6905(C_word c,C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word t4;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr3,(void*)f6905,3,t0,t1,t2);}
t3=C_i_check_string_2(t2,lf[38]);
t4=t1;
((C_proc2)(void*)(*((C_word*)t4+1)))(2,t4,C_SCHEME_FALSE);}

/* k3862 in k3850 in k3841 in set-file-position! in k3523 in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_3864(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word *a;
if(C_truep(t1)){
t2=C_slot(((C_word*)t0)[2],C_fix(7));
t3=C_eqp(t2,lf[55]);
if(C_truep(t3)){
t4=C_fseek(((C_word*)t0)[2],((C_word*)t0)[3],((C_word*)t0)[4]);
t5=((C_word*)t0)[5];
f_3858(2,t5,t4);}
else{
t4=((C_word*)t0)[5];
f_3858(2,t4,C_SCHEME_FALSE);}}
else{
if(C_truep(C_fixnump(((C_word*)t0)[2]))){
t2=C_lseek(((C_word*)t0)[2],((C_word*)t0)[3],((C_word*)t0)[4]);
t3=((C_word*)t0)[5];
f_3858(2,t3,t2);}
else{
/* posixwin.scm:857: ##sys#signal-hook */
t2=*((C_word*)lf[3]+1);
((C_proc6)(void*)(*((C_word*)t2+1)))(6,t2,((C_word*)t0)[5],lf[15],lf[165],lf[167],((C_word*)t0)[2]);}}}

/* k3974 in for-each-loop751 in k3913 in k3905 in create-directory in k3893 in k3523 in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_3976(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word *a;
t2=C_slot(((C_word*)t0)[2],C_fix(1));
t3=((C_word*)((C_word*)t0)[3])[1];
f_3966(t3,((C_word*)t0)[4],t2);}

/* k3949 in k3930 in k3922 in g752 in k3913 in k3905 in create-directory in k3893 in k3523 in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_3951(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word ab[4],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_3951,2,t0,t1);}
t2=C_mkdir(t1);
t3=C_eqp(C_fix(0),t2);
if(C_truep(t3)){
t4=C_SCHEME_UNDEFINED;
t5=((C_word*)t0)[2];
((C_proc2)(void*)(*((C_word*)t5+1)))(2,t5,t4);}
else{
t4=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_3943,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],tmp=(C_word)a,a+=4,tmp);
/* posixwin.scm:882: ##sys#update-errno */
((C_proc2)C_fast_retrieve_proc(*((C_word*)lf[7]+1)))(2,*((C_word*)lf[7]+1),t4);}}

/* a6163 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_6164(C_word c,C_word t0,C_word t1,...){
C_word tmp;
C_word t2;
va_list v;
C_word *a,c2=c;
C_save_rest(t1,c2,2);
if(!C_demand(c*C_SIZEOF_PAIR+0)){
C_save_and_reclaim((void*)tr2r,(void*)f_6164r,2,t0,t1);}
else{
a=C_alloc((c-2)*3);
t2=C_restore_rest(a,C_rest_count(0));
f_6164r(t0,t1,t2);}}

static void C_ccall f_6164r(C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
t3=C_i_nullp(t2);
t4=(C_truep(t3)?C_SCHEME_FALSE:C_i_car(t2));
t5=(C_truep(t4)?C_i_check_exact_2(t4,lf[101]):C_SCHEME_UNDEFINED);
if(C_truep(t4)){
t6=C_umask(t4);
if(C_truep(t4)){
t7=t1;
((C_proc2)(void*)(*((C_word*)t7+1)))(2,t7,t6);}
else{
t7=C_umask(t6);
t8=t1;
((C_proc2)(void*)(*((C_word*)t8+1)))(2,t8,t6);}}
else{
t6=C_umask(C_fix(0));
if(C_truep(t4)){
t7=t1;
((C_proc2)(void*)(*((C_word*)t7+1)))(2,t7,t6);}
else{
t7=C_umask(t6);
t8=t1;
((C_proc2)(void*)(*((C_word*)t8+1)))(2,t8,t6);}}}

/* for-each-loop751 in k3913 in k3905 in create-directory in k3893 in k3523 in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_fcall f_3966(C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word ab[5],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)trf_3966,NULL,3,t0,t1,t2);}
if(C_truep(C_i_pairp(t2))){
t3=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_3976,a[2]=t2,a[3]=((C_word*)t0)[2],a[4]=t1,tmp=(C_word)a,a+=5,tmp);
t4=C_slot(t2,C_fix(0));
/* posixwin.scm:904: g752 */
t5=((C_word*)t0)[3];
f_3919(t5,t3,t4);}
else{
t3=C_SCHEME_UNDEFINED;
t4=t1;
((C_proc2)(void*)(*((C_word*)t4+1)))(2,t4,t3);}}

/* a6113 in k3523 in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_6114(C_word c,C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word t4;
C_word t5;
C_word ab[8],*a=ab;
if(c!=3) C_bad_argc_2(c,3,t0);
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr3,(void*)f_6114,3,t0,t1,t2);}
t3=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_6118,a[2]=t1,a[3]=t2,tmp=(C_word)a,a+=4,tmp);
t4=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_6130,a[2]=t2,a[3]=t3,tmp=(C_word)a,a+=4,tmp);
/* posixwin.scm:863: port? */
t5=*((C_word*)lf[168]+1);
((C_proc3)(void*)(*((C_word*)t5+1)))(3,t5,t4,t2);}

/* k6116 in a6113 in k3523 in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_6118(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word ab[4],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_6118,2,t0,t1);}
t2=t1;
t3=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_6121,a[2]=((C_word*)t0)[2],a[3]=t2,tmp=(C_word)a,a+=4,tmp);
if(C_truep(C_i_lessp(t2,C_fix(0)))){
/* posixwin.scm:872: posix-error */
t4=lf[2];
f_2245(6,t4,t3,lf[10],lf[171],lf[399],((C_word*)t0)[3]);}
else{
t4=((C_word*)t0)[2];
((C_proc2)(void*)(*((C_word*)t4+1)))(2,t4,t2);}}

/* set-file-position! in k3523 in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_3839(C_word c,C_word t0,C_word t1,C_word t2,C_word t3,...){
C_word tmp;
C_word t4;
va_list v;
C_word *a,c2=c;
C_save_rest(t3,c2,4);
if(c<4) C_bad_min_argc_2(c,4,t0);
if(!C_demand(c*C_SIZEOF_PAIR+5)){
C_save_and_reclaim((void*)tr4r,(void*)f_3839r,4,t0,t1,t2,t3);}
else{
a=C_alloc((c-4)*3);
t4=C_restore_rest(a,C_rest_count(0));
f_3839r(t0,t1,t2,t3,t4);}}

static void C_ccall f_3839r(C_word t0,C_word t1,C_word t2,C_word t3,C_word t4){
C_word tmp;
C_word t5;
C_word t6;
C_word t7;
C_word *a=C_alloc(5);
t5=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_3843,a[2]=t3,a[3]=t1,a[4]=t2,tmp=(C_word)a,a+=5,tmp);
if(C_truep(C_i_pairp(t4))){
t6=t4;
t7=t5;
f_3843(t7,C_u_i_car(t6));}
else{
t6=t5;
f_3843(t6,C_fix((C_word)SEEK_SET));}}

/* fifo? in k3893 in k3523 in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_6104(C_word c,C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr3,(void*)f_6104,3,t0,t1,t2);}
t3=t1;
((C_proc2)(void*)(*((C_word*)t3+1)))(2,t3,C_SCHEME_FALSE);}

/* k6128 in a6113 in k3523 in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_6130(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word *a;
if(C_truep(t1)){
t2=C_slot(((C_word*)t0)[2],C_fix(7));
t3=C_eqp(t2,lf[55]);
if(C_truep(t3)){
t4=C_ftell(((C_word*)t0)[2]);
t5=((C_word*)t0)[3];
f_6118(2,t5,t4);}
else{
t4=((C_word*)t0)[3];
f_6118(2,t4,C_fix(-1));}}
else{
if(C_truep(C_fixnump(((C_word*)t0)[2]))){
t2=C_lseek(((C_word*)t0)[2],C_fix(0),C_fix((C_word)SEEK_CUR));
t3=((C_word*)t0)[3];
f_6118(2,t3,t2);}
else{
/* posixwin.scm:870: ##sys#signal-hook */
t2=*((C_word*)lf[3]+1);
((C_proc6)(void*)(*((C_word*)t2+1)))(6,t2,((C_word*)t0)[3],lf[15],lf[171],lf[400],((C_word*)t0)[2]);}}}

/* k6119 in k6116 in a6113 in k3523 in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_6121(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word *a;
t2=((C_word*)t0)[2];
((C_proc2)(void*)(*((C_word*)t2+1)))(2,t2,((C_word*)t0)[3]);}

/* unmap-file-from-memory in k3893 in k3523 in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_5815(C_word c,C_word t0,C_word t1,C_word t2,...){
C_word tmp;
C_word t3;
va_list v;
C_word *a,c2=c;
C_save_rest(t2,c2,3);
if(c<3) C_bad_min_argc_2(c,3,t0);
if(!C_demand(c*C_SIZEOF_PAIR+4)){
C_save_and_reclaim((void*)tr3r,(void*)f_5815r,3,t0,t1,t2);}
else{
a=C_alloc((c-3)*3);
t3=C_restore_rest(a,C_rest_count(0));
f_5815r(t0,t1,t2,t3);}}

static void C_ccall f_5815r(C_word t0,C_word t1,C_word t2,C_word t3){
C_word tmp;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word *a=C_alloc(4);
t4=C_i_check_structure_2(t2,lf[342],lf[346]);
t5=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_5822,a[2]=t2,a[3]=t1,tmp=(C_word)a,a+=4,tmp);
if(C_truep(C_i_pairp(t3))){
t6=t3;
t7=t5;
f_5822(t7,C_u_i_car(t6));}
else{
t6=t5;
f_5822(t6,C_slot(t2,C_fix(2)));}}

/* create-directory in k3893 in k3523 in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_3897(C_word c,C_word t0,C_word t1,C_word t2,...){
C_word tmp;
C_word t3;
va_list v;
C_word *a,c2=c;
C_save_rest(t2,c2,3);
if(c<3) C_bad_min_argc_2(c,3,t0);
if(!C_demand(c*C_SIZEOF_PAIR+4)){
C_save_and_reclaim((void*)tr3r,(void*)f_3897r,3,t0,t1,t2);}
else{
a=C_alloc((c-3)*3);
t3=C_restore_rest(a,C_rest_count(0));
f_3897r(t0,t1,t2,t3);}}

static void C_ccall f_3897r(C_word t0,C_word t1,C_word t2,C_word t3){
C_word tmp;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word *a=C_alloc(4);
t4=C_i_nullp(t3);
t5=(C_truep(t4)?C_SCHEME_FALSE:C_i_car(t3));
t6=t5;
t7=C_i_check_string_2(t2,lf[172]);
t8=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_3907,a[2]=t1,a[3]=t6,tmp=(C_word)a,a+=4,tmp);
/* posixwin.scm:902: ##sys#expand-home-path */
((C_proc3)C_fast_retrieve_proc(*((C_word*)lf[14]+1)))(3,*((C_word*)lf[14]+1),t8,t2);}

/* k3893 in k3523 in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_3895(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word t11;
C_word t12;
C_word t13;
C_word t14;
C_word t15;
C_word t16;
C_word t17;
C_word t18;
C_word t19;
C_word t20;
C_word t21;
C_word t22;
C_word t23;
C_word t24;
C_word t25;
C_word t26;
C_word t27;
C_word t28;
C_word t29;
C_word t30;
C_word t31;
C_word t32;
C_word t33;
C_word t34;
C_word t35;
C_word t36;
C_word t37;
C_word t38;
C_word t39;
C_word t40;
C_word t41;
C_word t42;
C_word t43;
C_word t44;
C_word t45;
C_word t46;
C_word t47;
C_word t48;
C_word t49;
C_word t50;
C_word t51;
C_word t52;
C_word t53;
C_word t54;
C_word t55;
C_word t56;
C_word t57;
C_word t58;
C_word t59;
C_word t60;
C_word t61;
C_word t62;
C_word t63;
C_word t64;
C_word t65;
C_word t66;
C_word t67;
C_word t68;
C_word t69;
C_word t70;
C_word t71;
C_word t72;
C_word t73;
C_word t74;
C_word t75;
C_word t76;
C_word t77;
C_word t78;
C_word t79;
C_word t80;
C_word t81;
C_word t82;
C_word t83;
C_word t84;
C_word t85;
C_word t86;
C_word t87;
C_word t88;
C_word t89;
C_word t90;
C_word t91;
C_word t92;
C_word t93;
C_word t94;
C_word t95;
C_word t96;
C_word t97;
C_word t98;
C_word t99;
C_word t100;
C_word t101;
C_word t102;
C_word t103;
C_word t104;
C_word t105;
C_word t106;
C_word t107;
C_word t108;
C_word t109;
C_word t110;
C_word t111;
C_word t112;
C_word t113;
C_word t114;
C_word t115;
C_word t116;
C_word t117;
C_word t118;
C_word t119;
C_word t120;
C_word t121;
C_word t122;
C_word t123;
C_word t124;
C_word t125;
C_word t126;
C_word t127;
C_word t128;
C_word t129;
C_word t130;
C_word t131;
C_word t132;
C_word t133;
C_word t134;
C_word t135;
C_word t136;
C_word t137;
C_word t138;
C_word t139;
C_word t140;
C_word t141;
C_word t142;
C_word t143;
C_word t144;
C_word t145;
C_word t146;
C_word t147;
C_word t148;
C_word t149;
C_word t150;
C_word t151;
C_word t152;
C_word t153;
C_word t154;
C_word t155;
C_word t156;
C_word t157;
C_word t158;
C_word t159;
C_word t160;
C_word t161;
C_word t162;
C_word t163;
C_word t164;
C_word t165;
C_word t166;
C_word t167;
C_word t168;
C_word t169;
C_word t170;
C_word t171;
C_word t172;
C_word t173;
C_word t174;
C_word t175;
C_word t176;
C_word t177;
C_word t178;
C_word t179;
C_word t180;
C_word t181;
C_word t182;
C_word t183;
C_word t184;
C_word t185;
C_word t186;
C_word t187;
C_word t188;
C_word t189;
C_word t190;
C_word t191;
C_word t192;
C_word t193;
C_word t194;
C_word ab[327],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_3895,2,t0,t1);}
t2=C_mutate2((C_word*)lf[171]+1 /* (set! file-position ...) */,t1);
t3=C_mutate2((C_word*)lf[172]+1 /* (set! create-directory ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_3897,a[2]=((C_word)li75),tmp=(C_word)a,a+=3,tmp));
t4=C_mutate2((C_word*)lf[66]+1 /* (set! change-directory ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_4020,a[2]=((C_word)li76),tmp=(C_word)a,a+=3,tmp));
t5=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_4064,a[2]=((C_word)li77),tmp=(C_word)a,a+=3,tmp);
t6=C_mutate2((C_word*)lf[181]+1 /* (set! open-input-pipe ...) */,(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_4082,a[2]=t5,a[3]=((C_word)li78),tmp=(C_word)a,a+=4,tmp));
t7=C_mutate2((C_word*)lf[185]+1 /* (set! open-output-pipe ...) */,(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_4122,a[2]=t5,a[3]=((C_word)li79),tmp=(C_word)a,a+=4,tmp));
t8=C_mutate2((C_word*)lf[186]+1 /* (set! close-input-pipe ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_4162,a[2]=((C_word)li80),tmp=(C_word)a,a+=3,tmp));
t9=C_mutate2((C_word*)lf[188]+1 /* (set! close-output-pipe ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_4180,a[2]=((C_word)li81),tmp=(C_word)a,a+=3,tmp));
t10=C_mutate2((C_word*)lf[190]+1 /* (set! call-with-input-pipe ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_4198,a[2]=((C_word)li84),tmp=(C_word)a,a+=3,tmp));
t11=C_mutate2((C_word*)lf[191]+1 /* (set! call-with-output-pipe ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_4222,a[2]=((C_word)li87),tmp=(C_word)a,a+=3,tmp));
t12=C_mutate2((C_word*)lf[192]+1 /* (set! with-input-from-pipe ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_4246,a[2]=((C_word)li92),tmp=(C_word)a,a+=3,tmp));
t13=C_mutate2((C_word*)lf[194]+1 /* (set! with-output-to-pipe ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_4280,a[2]=((C_word)li97),tmp=(C_word)a,a+=3,tmp));
t14=C_mutate2((C_word*)lf[196]+1 /* (set! create-pipe ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_4314,a[2]=((C_word)li98),tmp=(C_word)a,a+=3,tmp));
t15=C_mutate2((C_word*)lf[198]+1 /* (set! signal/term ...) */,C_fix((C_word)SIGTERM));
t16=C_mutate2((C_word*)lf[199]+1 /* (set! signal/int ...) */,C_fix((C_word)SIGINT));
t17=C_mutate2((C_word*)lf[200]+1 /* (set! signal/fpe ...) */,C_fix((C_word)SIGFPE));
t18=C_mutate2((C_word*)lf[201]+1 /* (set! signal/ill ...) */,C_fix((C_word)SIGILL));
t19=C_mutate2((C_word*)lf[202]+1 /* (set! signal/segv ...) */,C_fix((C_word)SIGSEGV));
t20=C_mutate2((C_word*)lf[203]+1 /* (set! signal/abrt ...) */,C_fix((C_word)SIGABRT));
t21=C_mutate2((C_word*)lf[204]+1 /* (set! signal/break ...) */,C_fix((C_word)SIGBREAK));
t22=C_set_block_item(lf[205] /* signal/alrm */,0,C_fix(0));
t23=C_set_block_item(lf[206] /* signal/chld */,0,C_fix(0));
t24=C_set_block_item(lf[207] /* signal/cont */,0,C_fix(0));
t25=C_set_block_item(lf[208] /* signal/hup */,0,C_fix(0));
t26=C_set_block_item(lf[209] /* signal/io */,0,C_fix(0));
t27=C_set_block_item(lf[210] /* signal/kill */,0,C_fix(0));
t28=C_set_block_item(lf[211] /* signal/pipe */,0,C_fix(0));
t29=C_set_block_item(lf[212] /* signal/prof */,0,C_fix(0));
t30=C_set_block_item(lf[213] /* signal/quit */,0,C_fix(0));
t31=C_set_block_item(lf[214] /* signal/stop */,0,C_fix(0));
t32=C_set_block_item(lf[215] /* signal/trap */,0,C_fix(0));
t33=C_set_block_item(lf[216] /* signal/tstp */,0,C_fix(0));
t34=C_set_block_item(lf[217] /* signal/urg */,0,C_fix(0));
t35=C_set_block_item(lf[218] /* signal/usr1 */,0,C_fix(0));
t36=C_set_block_item(lf[219] /* signal/usr2 */,0,C_fix(0));
t37=C_set_block_item(lf[220] /* signal/vtalrm */,0,C_fix(0));
t38=C_set_block_item(lf[221] /* signal/winch */,0,C_fix(0));
t39=C_set_block_item(lf[222] /* signal/xcpu */,0,C_fix(0));
t40=C_set_block_item(lf[223] /* signal/xfsz */,0,C_fix(0));
t41=C_a_i_list7(&a,7,*((C_word*)lf[198]+1),*((C_word*)lf[199]+1),*((C_word*)lf[200]+1),*((C_word*)lf[201]+1),*((C_word*)lf[202]+1),*((C_word*)lf[203]+1),*((C_word*)lf[204]+1));
t42=C_mutate2((C_word*)lf[224]+1 /* (set! signals-list ...) */,t41);
t43=C_mutate2((C_word*)lf[225]+1 /* (set! errno/perm ...) */,C_fix((C_word)EPERM));
t44=C_mutate2((C_word*)lf[226]+1 /* (set! errno/noent ...) */,C_fix((C_word)ENOENT));
t45=C_mutate2((C_word*)lf[227]+1 /* (set! errno/srch ...) */,C_fix((C_word)ESRCH));
t46=C_mutate2((C_word*)lf[228]+1 /* (set! errno/intr ...) */,C_fix((C_word)EINTR));
t47=C_mutate2((C_word*)lf[229]+1 /* (set! errno/io ...) */,C_fix((C_word)EIO));
t48=C_mutate2((C_word*)lf[230]+1 /* (set! errno/noexec ...) */,C_fix((C_word)ENOEXEC));
t49=C_mutate2((C_word*)lf[231]+1 /* (set! errno/badf ...) */,C_fix((C_word)EBADF));
t50=C_mutate2((C_word*)lf[232]+1 /* (set! errno/child ...) */,C_fix((C_word)ECHILD));
t51=C_mutate2((C_word*)lf[233]+1 /* (set! errno/nomem ...) */,C_fix((C_word)ENOMEM));
t52=C_mutate2((C_word*)lf[234]+1 /* (set! errno/acces ...) */,C_fix((C_word)EACCES));
t53=C_mutate2((C_word*)lf[235]+1 /* (set! errno/fault ...) */,C_fix((C_word)EFAULT));
t54=C_mutate2((C_word*)lf[236]+1 /* (set! errno/busy ...) */,C_fix((C_word)EBUSY));
t55=C_mutate2((C_word*)lf[237]+1 /* (set! errno/exist ...) */,C_fix((C_word)EEXIST));
t56=C_mutate2((C_word*)lf[238]+1 /* (set! errno/notdir ...) */,C_fix((C_word)ENOTDIR));
t57=C_mutate2((C_word*)lf[239]+1 /* (set! errno/isdir ...) */,C_fix((C_word)EISDIR));
t58=C_mutate2((C_word*)lf[240]+1 /* (set! errno/inval ...) */,C_fix((C_word)EINVAL));
t59=C_mutate2((C_word*)lf[241]+1 /* (set! errno/mfile ...) */,C_fix((C_word)EMFILE));
t60=C_mutate2((C_word*)lf[242]+1 /* (set! errno/nospc ...) */,C_fix((C_word)ENOSPC));
t61=C_mutate2((C_word*)lf[243]+1 /* (set! errno/spipe ...) */,C_fix((C_word)ESPIPE));
t62=C_mutate2((C_word*)lf[244]+1 /* (set! errno/pipe ...) */,C_fix((C_word)EPIPE));
t63=C_mutate2((C_word*)lf[245]+1 /* (set! errno/again ...) */,C_fix((C_word)EAGAIN));
t64=C_mutate2((C_word*)lf[246]+1 /* (set! errno/rofs ...) */,C_fix((C_word)EROFS));
t65=C_mutate2((C_word*)lf[247]+1 /* (set! errno/nxio ...) */,C_fix((C_word)ENXIO));
t66=C_mutate2((C_word*)lf[248]+1 /* (set! errno/2big ...) */,C_fix((C_word)E2BIG));
t67=C_mutate2((C_word*)lf[249]+1 /* (set! errno/xdev ...) */,C_fix((C_word)EXDEV));
t68=C_mutate2((C_word*)lf[250]+1 /* (set! errno/nodev ...) */,C_fix((C_word)ENODEV));
t69=C_mutate2((C_word*)lf[251]+1 /* (set! errno/nfile ...) */,C_fix((C_word)ENFILE));
t70=C_mutate2((C_word*)lf[252]+1 /* (set! errno/notty ...) */,C_fix((C_word)ENOTTY));
t71=C_mutate2((C_word*)lf[253]+1 /* (set! errno/fbig ...) */,C_fix((C_word)EFBIG));
t72=C_mutate2((C_word*)lf[254]+1 /* (set! errno/mlink ...) */,C_fix((C_word)EMLINK));
t73=C_mutate2((C_word*)lf[255]+1 /* (set! errno/dom ...) */,C_fix((C_word)EDOM));
t74=C_mutate2((C_word*)lf[256]+1 /* (set! errno/range ...) */,C_fix((C_word)ERANGE));
t75=C_mutate2((C_word*)lf[257]+1 /* (set! errno/deadlk ...) */,C_fix((C_word)EDEADLK));
t76=C_mutate2((C_word*)lf[258]+1 /* (set! errno/nametoolong ...) */,C_fix((C_word)ENAMETOOLONG));
t77=C_mutate2((C_word*)lf[259]+1 /* (set! errno/nolck ...) */,C_fix((C_word)ENOLCK));
t78=C_mutate2((C_word*)lf[260]+1 /* (set! errno/nosys ...) */,C_fix((C_word)ENOSYS));
t79=C_mutate2((C_word*)lf[261]+1 /* (set! errno/notempty ...) */,C_fix((C_word)ENOTEMPTY));
t80=C_mutate2((C_word*)lf[262]+1 /* (set! errno/ilseq ...) */,C_fix((C_word)EILSEQ));
t81=C_mutate2((C_word*)lf[263]+1 /* (set! change-file-mode ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_4413,a[2]=((C_word)li99),tmp=(C_word)a,a+=3,tmp));
t82=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_4443,a[2]=((C_word)li100),tmp=(C_word)a,a+=3,tmp);
t83=C_mutate2((C_word*)lf[265]+1 /* (set! file-read-access? ...) */,(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_4467,a[2]=t82,a[3]=((C_word)li101),tmp=(C_word)a,a+=4,tmp));
t84=C_mutate2((C_word*)lf[266]+1 /* (set! file-write-access? ...) */,(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_4473,a[2]=t82,a[3]=((C_word)li102),tmp=(C_word)a,a+=4,tmp));
t85=C_mutate2((C_word*)lf[267]+1 /* (set! file-execute-access? ...) */,(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_4479,a[2]=t82,a[3]=((C_word)li103),tmp=(C_word)a,a+=4,tmp));
t86=C_mutate2((C_word*)lf[41]+1 /* (set! fileno/stdin ...) */,C_fix((C_word)0));
t87=C_mutate2((C_word*)lf[42]+1 /* (set! fileno/stdout ...) */,C_fix((C_word)1));
t88=C_mutate2((C_word*)lf[43]+1 /* (set! fileno/stderr ...) */,C_fix((C_word)2));
t89=C_SCHEME_UNDEFINED;
t90=(*a=C_VECTOR_TYPE|1,a[1]=t89,tmp=(C_word)a,a+=2,tmp);
t91=C_SCHEME_UNDEFINED;
t92=(*a=C_VECTOR_TYPE|1,a[1]=t91,tmp=(C_word)a,a+=2,tmp);
t93=C_set_block_item(t90,0,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_4488,a[2]=((C_word)li104),tmp=(C_word)a,a+=3,tmp));
t94=C_set_block_item(t92,0,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_4525,a[2]=((C_word)li105),tmp=(C_word)a,a+=3,tmp));
t95=C_mutate2((C_word*)lf[56]+1 /* (set! open-input-file* ...) */,(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_4543,a[2]=t92,a[3]=t90,a[4]=((C_word)li106),tmp=(C_word)a,a+=5,tmp));
t96=C_mutate2((C_word*)lf[57]+1 /* (set! open-output-file* ...) */,(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_4557,a[2]=t92,a[3]=t90,a[4]=((C_word)li107),tmp=(C_word)a,a+=5,tmp));
t97=C_mutate2((C_word*)lf[58]+1 /* (set! port->fileno ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_4571,a[2]=((C_word)li108),tmp=(C_word)a,a+=3,tmp));
t98=C_mutate2((C_word*)lf[63]+1 /* (set! duplicate-fileno ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_4605,a[2]=((C_word)li109),tmp=(C_word)a,a+=3,tmp));
t99=C_mutate2((C_word*)lf[278]+1 /* (set! setenv ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_4635,a[2]=((C_word)li110),tmp=(C_word)a,a+=3,tmp));
t100=C_mutate2((C_word*)lf[279]+1 /* (set! unsetenv ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_4652,a[2]=((C_word)li111),tmp=(C_word)a,a+=3,tmp));
t101=C_mutate2((C_word*)lf[281]+1 /* (set! get-environment-variables ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_4676,a[2]=((C_word)li114),tmp=(C_word)a,a+=3,tmp));
t102=C_mutate2((C_word*)lf[283]+1 /* (set! local-timezone-abbreviation ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_4742,a[2]=((C_word)li115),tmp=(C_word)a,a+=3,tmp));
t103=C_mutate2((C_word*)lf[284]+1 /* (set! _exit ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_4755,a[2]=((C_word)li116),tmp=(C_word)a,a+=3,tmp));
t104=C_mutate2((C_word*)lf[285]+1 /* (set! terminal-port? ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_4769,a[2]=((C_word)li117),tmp=(C_word)a,a+=3,tmp));
t105=C_mutate2((C_word*)lf[286]+1 /* (set! terminal-size ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_4787,a[2]=((C_word)li118),tmp=(C_word)a,a+=3,tmp));
t106=C_mutate2((C_word*)lf[288]+1 /* (set! set-buffering-mode! ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_4802,a[2]=((C_word)li119),tmp=(C_word)a,a+=3,tmp));
t107=C_mutate2((C_word*)lf[294]+1 /* (set! spawn/overlay ...) */,C_fix((C_word)P_OVERLAY));
t108=C_mutate2((C_word*)lf[295]+1 /* (set! spawn/wait ...) */,C_fix((C_word)P_WAIT));
t109=C_mutate2((C_word*)lf[296]+1 /* (set! spawn/nowait ...) */,C_fix((C_word)P_NOWAIT));
t110=C_mutate2((C_word*)lf[297]+1 /* (set! spawn/nowaito ...) */,C_fix((C_word)P_NOWAITO));
t111=C_mutate2((C_word*)lf[298]+1 /* (set! spawn/detach ...) */,C_fix((C_word)P_DETACH));
t112=C_mutate2(&lf[299] /* (set! $quote-args-list ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_4869,a[2]=((C_word)li122),tmp=(C_word)a,a+=3,tmp));
t113=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_4946,a[2]=((C_word)li123),tmp=(C_word)a,a+=3,tmp);
t114=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_4967,a[2]=((C_word)li124),tmp=(C_word)a,a+=3,tmp);
t115=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_4988,a[2]=((C_word)li126),tmp=(C_word)a,a+=3,tmp);
t116=C_mutate2(&lf[303] /* (set! $exec-setup ...) */,(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_5036,a[2]=t115,a[3]=t114,a[4]=t113,a[5]=((C_word)li127),tmp=(C_word)a,a+=6,tmp));
t117=C_mutate2(&lf[305] /* (set! $exec-teardown ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_5072,a[2]=((C_word)li128),tmp=(C_word)a,a+=3,tmp));
t118=C_mutate2((C_word*)lf[306]+1 /* (set! process-execute ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_5087,a[2]=((C_word)li129),tmp=(C_word)a,a+=3,tmp));
t119=C_mutate2((C_word*)lf[308]+1 /* (set! process-spawn ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_5154,a[2]=((C_word)li130),tmp=(C_word)a,a+=3,tmp));
t120=C_mutate2((C_word*)lf[310]+1 /* (set! ##sys#shell-command ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_5221,a[2]=((C_word)li131),tmp=(C_word)a,a+=3,tmp));
t121=C_mutate2((C_word*)lf[314]+1 /* (set! ##sys#shell-command-arguments ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_5242,a[2]=((C_word)li132),tmp=(C_word)a,a+=3,tmp));
t122=C_mutate2((C_word*)lf[316]+1 /* (set! process-run ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_5248,a[2]=((C_word)li133),tmp=(C_word)a,a+=3,tmp));
t123=C_mutate2((C_word*)lf[317]+1 /* (set! ##sys#process ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_5338,a[2]=((C_word)li134),tmp=(C_word)a,a+=3,tmp));
t124=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_5432,a[2]=((C_word)li140),tmp=(C_word)a,a+=3,tmp);
t125=C_mutate2((C_word*)lf[322]+1 /* (set! process ...) */,(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_5516,a[2]=t124,a[3]=((C_word)li141),tmp=(C_word)a,a+=4,tmp));
t126=C_mutate2((C_word*)lf[323]+1 /* (set! process* ...) */,(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_5576,a[2]=t124,a[3]=((C_word)li142),tmp=(C_word)a,a+=4,tmp));
t127=C_mutate2((C_word*)lf[122]+1 /* (set! ##sys#process-wait ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_5636,a[2]=((C_word)li143),tmp=(C_word)a,a+=3,tmp));
t128=C_mutate2((C_word*)lf[324]+1 /* (set! sleep ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_5648,a[2]=((C_word)li144),tmp=(C_word)a,a+=3,tmp));
t129=C_mutate2((C_word*)lf[325]+1 /* (set! get-host-name ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_5654,a[2]=((C_word)li145),tmp=(C_word)a,a+=3,tmp));
t130=C_mutate2((C_word*)lf[327]+1 /* (set! system-information ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_5666,a[2]=((C_word)li146),tmp=(C_word)a,a+=3,tmp));
t131=C_mutate2((C_word*)lf[330]+1 /* (set! current-user-name ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_5697,a[2]=((C_word)li147),tmp=(C_word)a,a+=3,tmp));
t132=C_mutate2((C_word*)lf[332]+1 /* (set! prot/none ...) */,C_fix((C_word)PROT_NONE));
t133=C_mutate2((C_word*)lf[333]+1 /* (set! prot/read ...) */,C_fix((C_word)PROT_READ));
t134=C_mutate2((C_word*)lf[334]+1 /* (set! prot/write ...) */,C_fix((C_word)PROT_WRITE));
t135=C_mutate2((C_word*)lf[335]+1 /* (set! prot/exec ...) */,C_fix((C_word)PROT_EXEC));
t136=C_mutate2((C_word*)lf[336]+1 /* (set! map/file ...) */,C_fix((C_word)MAP_FILE));
t137=C_mutate2((C_word*)lf[337]+1 /* (set! map/shared ...) */,C_fix((C_word)MAP_SHARED));
t138=C_mutate2((C_word*)lf[338]+1 /* (set! map/private ...) */,C_fix((C_word)MAP_PRIVATE));
t139=C_mutate2((C_word*)lf[339]+1 /* (set! map/fixed ...) */,C_fix((C_word)MAP_FIXED));
t140=C_mutate2((C_word*)lf[340]+1 /* (set! map/anonymous ...) */,C_fix((C_word)MAP_ANONYMOUS));
t141=C_mutate2((C_word*)lf[341]+1 /* (set! map-file-to-memory ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_5759,a[2]=((C_word)li148),tmp=(C_word)a,a+=3,tmp));
t142=C_mutate2((C_word*)lf[346]+1 /* (set! unmap-file-from-memory ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_5815,a[2]=((C_word)li149),tmp=(C_word)a,a+=3,tmp));
t143=C_mutate2((C_word*)lf[348]+1 /* (set! memory-mapped-file-pointer ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_5848,a[2]=((C_word)li150),tmp=(C_word)a,a+=3,tmp));
t144=C_mutate2((C_word*)lf[349]+1 /* (set! memory-mapped-file? ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_5857,a[2]=((C_word)li151),tmp=(C_word)a,a+=3,tmp));
t145=C_mutate2((C_word*)lf[350]+1 /* (set! change-directory* ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_5863,a[2]=((C_word)li152),tmp=(C_word)a,a+=3,tmp));
t146=C_mutate2((C_word*)lf[352]+1 /* (set! change-file-owner ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_5869,a[2]=((C_word)li153),tmp=(C_word)a,a+=3,tmp));
t147=C_mutate2((C_word*)lf[353]+1 /* (set! create-fifo ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_5875,a[2]=((C_word)li154),tmp=(C_word)a,a+=3,tmp));
t148=C_mutate2((C_word*)lf[354]+1 /* (set! create-session ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_5881,a[2]=((C_word)li155),tmp=(C_word)a,a+=3,tmp));
t149=C_mutate2((C_word*)lf[355]+1 /* (set! create-symbolic-link ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_5887,a[2]=((C_word)li156),tmp=(C_word)a,a+=3,tmp));
t150=C_mutate2((C_word*)lf[356]+1 /* (set! current-effective-group-id ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_5893,a[2]=((C_word)li157),tmp=(C_word)a,a+=3,tmp));
t151=C_mutate2((C_word*)lf[357]+1 /* (set! current-effective-user-id ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_5899,a[2]=((C_word)li158),tmp=(C_word)a,a+=3,tmp));
t152=C_mutate2((C_word*)lf[358]+1 /* (set! current-effective-user-name ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_5905,a[2]=((C_word)li159),tmp=(C_word)a,a+=3,tmp));
t153=C_mutate2((C_word*)lf[359]+1 /* (set! current-group-id ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_5911,a[2]=((C_word)li160),tmp=(C_word)a,a+=3,tmp));
t154=C_mutate2((C_word*)lf[360]+1 /* (set! current-user-id ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_5917,a[2]=((C_word)li161),tmp=(C_word)a,a+=3,tmp));
t155=C_mutate2((C_word*)lf[361]+1 /* (set! file-link ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_5923,a[2]=((C_word)li162),tmp=(C_word)a,a+=3,tmp));
t156=C_mutate2((C_word*)lf[362]+1 /* (set! file-lock ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_5929,a[2]=((C_word)li163),tmp=(C_word)a,a+=3,tmp));
t157=C_mutate2((C_word*)lf[363]+1 /* (set! file-lock/blocking ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_5935,a[2]=((C_word)li164),tmp=(C_word)a,a+=3,tmp));
t158=C_mutate2((C_word*)lf[364]+1 /* (set! file-select ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_5941,a[2]=((C_word)li165),tmp=(C_word)a,a+=3,tmp));
t159=C_mutate2((C_word*)lf[365]+1 /* (set! file-test-lock ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_5947,a[2]=((C_word)li166),tmp=(C_word)a,a+=3,tmp));
t160=C_mutate2((C_word*)lf[366]+1 /* (set! file-truncate ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_5953,a[2]=((C_word)li167),tmp=(C_word)a,a+=3,tmp));
t161=C_mutate2((C_word*)lf[367]+1 /* (set! file-unlock ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_5959,a[2]=((C_word)li168),tmp=(C_word)a,a+=3,tmp));
t162=C_mutate2((C_word*)lf[368]+1 /* (set! get-groups ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_5965,a[2]=((C_word)li169),tmp=(C_word)a,a+=3,tmp));
t163=C_mutate2((C_word*)lf[369]+1 /* (set! group-information ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_5971,a[2]=((C_word)li170),tmp=(C_word)a,a+=3,tmp));
t164=C_mutate2((C_word*)lf[370]+1 /* (set! initialize-groups ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_5977,a[2]=((C_word)li171),tmp=(C_word)a,a+=3,tmp));
t165=C_mutate2((C_word*)lf[371]+1 /* (set! parent-process-id ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_5983,a[2]=((C_word)li172),tmp=(C_word)a,a+=3,tmp));
t166=C_mutate2((C_word*)lf[372]+1 /* (set! process-fork ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_5989,a[2]=((C_word)li173),tmp=(C_word)a,a+=3,tmp));
t167=C_mutate2((C_word*)lf[373]+1 /* (set! process-group-id ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_5995,a[2]=((C_word)li174),tmp=(C_word)a,a+=3,tmp));
t168=C_mutate2((C_word*)lf[374]+1 /* (set! process-signal ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_6001,a[2]=((C_word)li175),tmp=(C_word)a,a+=3,tmp));
t169=C_mutate2((C_word*)lf[375]+1 /* (set! read-symbolic-link ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_6007,a[2]=((C_word)li176),tmp=(C_word)a,a+=3,tmp));
t170=C_mutate2((C_word*)lf[376]+1 /* (set! set-alarm! ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_6013,a[2]=((C_word)li177),tmp=(C_word)a,a+=3,tmp));
t171=C_mutate2((C_word*)lf[377]+1 /* (set! set-group-id! ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_6019,a[2]=((C_word)li178),tmp=(C_word)a,a+=3,tmp));
t172=C_mutate2((C_word*)lf[378]+1 /* (set! set-groups! ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_6025,a[2]=((C_word)li179),tmp=(C_word)a,a+=3,tmp));
t173=C_mutate2((C_word*)lf[379]+1 /* (set! set-process-group-id! ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_6031,a[2]=((C_word)li180),tmp=(C_word)a,a+=3,tmp));
t174=C_mutate2((C_word*)lf[380]+1 /* (set! set-root-directory! ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_6037,a[2]=((C_word)li181),tmp=(C_word)a,a+=3,tmp));
t175=C_mutate2((C_word*)lf[381]+1 /* (set! set-signal-mask! ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_6043,a[2]=((C_word)li182),tmp=(C_word)a,a+=3,tmp));
t176=C_mutate2((C_word*)lf[382]+1 /* (set! set-user-id! ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_6049,a[2]=((C_word)li183),tmp=(C_word)a,a+=3,tmp));
t177=C_mutate2((C_word*)lf[383]+1 /* (set! signal-mask ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_6055,a[2]=((C_word)li184),tmp=(C_word)a,a+=3,tmp));
t178=C_mutate2((C_word*)lf[384]+1 /* (set! signal-mask! ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_6061,a[2]=((C_word)li185),tmp=(C_word)a,a+=3,tmp));
t179=C_mutate2((C_word*)lf[385]+1 /* (set! signal-masked? ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_6067,a[2]=((C_word)li186),tmp=(C_word)a,a+=3,tmp));
t180=C_mutate2((C_word*)lf[386]+1 /* (set! signal-unmask! ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_6073,a[2]=((C_word)li187),tmp=(C_word)a,a+=3,tmp));
t181=C_mutate2((C_word*)lf[387]+1 /* (set! terminal-name ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_6079,a[2]=((C_word)li188),tmp=(C_word)a,a+=3,tmp));
t182=C_mutate2((C_word*)lf[388]+1 /* (set! user-information ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_6085,a[2]=((C_word)li189),tmp=(C_word)a,a+=3,tmp));
t183=C_mutate2((C_word*)lf[389]+1 /* (set! utc-time->seconds ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_6091,a[2]=((C_word)li190),tmp=(C_word)a,a+=3,tmp));
t184=C_mutate2((C_word*)lf[390]+1 /* (set! string->time ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_6097,a[2]=((C_word)li191),tmp=(C_word)a,a+=3,tmp));
t185=C_set_block_item(lf[391] /* errno/wouldblock */,0,C_fix(0));
t186=C_mutate2((C_word*)lf[38]+1 /* (set! fifo? ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_6104,a[2]=((C_word)li192),tmp=(C_word)a,a+=3,tmp));
t187=C_set_block_item(lf[392] /* open/fsync */,0,C_fix(0));
t188=C_set_block_item(lf[393] /* open/noctty */,0,C_fix(0));
t189=C_set_block_item(lf[394] /* open/nonblock */,0,C_fix(0));
t190=C_set_block_item(lf[395] /* open/sync */,0,C_fix(0));
t191=C_set_block_item(lf[396] /* perm/isgid */,0,C_fix(0));
t192=C_set_block_item(lf[397] /* perm/isuid */,0,C_fix(0));
t193=C_set_block_item(lf[398] /* perm/isvtx */,0,C_fix(0));
t194=((C_word*)t0)[2];
((C_proc2)(void*)(*((C_word*)t194+1)))(2,t194,C_SCHEME_UNDEFINED);}

/* a6194 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_6195(C_word c,C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word t4;
C_word ab[3],*a=ab;
if(c!=3) C_bad_argc_2(c,3,t0);
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr3,(void*)f_6195,3,t0,t1,t2);}
t3=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_6199,a[2]=t1,tmp=(C_word)a,a+=3,tmp);
/* posix-common.scm:217: ##sys#stat */
f_2263(t3,t2,C_SCHEME_FALSE,C_SCHEME_TRUE,lf[20]);}

/* k6197 in a6194 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_6199(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word ab[4],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_6199,2,t0,t1);}
t2=((C_word*)t0)[2];
((C_proc2)(void*)(*((C_word*)t2+1)))(2,t2,C_flonum(&a,C_statbuf.st_mtime));}

/* time->string in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_3448(C_word c,C_word t0,C_word t1,C_word t2,...){
C_word tmp;
C_word t3;
va_list v;
C_word *a,c2=c;
C_save_rest(t2,c2,3);
if(c<3) C_bad_min_argc_2(c,3,t0);
if(!C_demand(c*C_SIZEOF_PAIR+6)){
C_save_and_reclaim((void*)tr3r,(void*)f_3448r,3,t0,t1,t2);}
else{
a=C_alloc((c-3)*3);
t3=C_restore_rest(a,C_rest_count(0));
f_3448r(t0,t1,t2,t3);}}

static void C_ccall f_3448r(C_word t0,C_word t1,C_word t2,C_word t3){
C_word tmp;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word *a=C_alloc(6);
t4=C_i_nullp(t3);
t5=(C_truep(t4)?C_SCHEME_FALSE:C_i_car(t3));
t6=t5;
t7=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_3455,a[2]=t6,a[3]=t1,a[4]=t2,a[5]=((C_word*)t0)[2],tmp=(C_word)a,a+=6,tmp);
/* posix-common.scm:516: check-time-vector */
f_3294(t7,lf[114],t2);}

/* k5820 in unmap-file-from-memory in k3893 in k3523 in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_fcall f_5822(C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word *a;
t2=C_slot(((C_word*)t0)[2],C_fix(1));
t3=(C_truep(t2)?C_i_foreign_pointer_argumentp(t2):C_SCHEME_FALSE);
t4=C_i_foreign_integer_argumentp(t1);
t5=stub1460(C_SCHEME_UNDEFINED,t3,t4);
t6=C_eqp(C_fix(0),t5);
if(C_truep(t6)){
t7=C_SCHEME_UNDEFINED;
t8=((C_word*)t0)[3];
((C_proc2)(void*)(*((C_word*)t8+1)))(2,t8,t7);}
else{
/* posixwin.scm:1646: posix-error */
t7=lf[2];
f_2245(7,t7,((C_word*)t0)[3],lf[10],lf[346],lf[347],((C_word*)t0)[2],t1);}}

/* a6188 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_6189(C_word c,C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word t4;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr3,(void*)f_6189,3,t0,t1,t2);}
t3=C_i_check_exact_2(t2,lf[101]);
t4=t1;
((C_proc2)(void*)(*((C_word*)t4+1)))(2,t4,C_umask(t2));}

/* k3696 in file-read in k3523 in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_3698(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word ab[6],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_3698,2,t0,t1);}
t2=t1;
t3=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_3701,a[2]=((C_word*)t0)[2],a[3]=t2,a[4]=((C_word*)t0)[3],a[5]=((C_word*)t0)[4],tmp=(C_word)a,a+=6,tmp);
if(C_truep(C_blockp(t2))){
if(C_truep(C_byteblockp(t2))){
t4=t3;
f_3701(2,t4,C_SCHEME_UNDEFINED);}
else{
/* posixwin.scm:788: ##sys#signal-hook */
t4=*((C_word*)lf[3]+1);
((C_proc6)(void*)(*((C_word*)t4+1)))(6,t4,t3,lf[15],lf[154],lf[156],t2);}}
else{
/* posixwin.scm:788: ##sys#signal-hook */
t4=*((C_word*)lf[3]+1);
((C_proc6)(void*)(*((C_word*)t4+1)))(6,t4,t3,lf[15],lf[154],lf[156],t2);}}

/* k3800 in k3777 in file-mkstemp in k3523 in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_3802(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word *a;
/* posixwin.scm:816: ##sys#signal-hook */
t2=*((C_word*)lf[3]+1);
((C_proc6)(void*)(*((C_word*)t2+1)))(6,t2,((C_word*)t0)[2],lf[10],lf[160],lf[161],((C_word*)t0)[3]);}

/* k3199 in k3192 in k3081 in loop in k3060 in k3053 in k3050 in k3258 in k3255 in k3252 in k3249 in k3246 in k3243 in find-files in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_3201(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word *a;
/* posix-common.scm:451: loop */
t2=((C_word*)((C_word*)t0)[2])[1];
f_3064(t2,((C_word*)t0)[3],((C_word*)t0)[4],t1);}

/* create-symbolic-link in k3893 in k3523 in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_5887(C_word c,C_word t0,C_word t1,...){
C_word tmp;
C_word t2;
C_word *a;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_5887,2,t0,t1);}
/* posixwin.scm:1667: error */
t2=*((C_word*)lf[351]+1);
((C_proc4)(void*)(*((C_word*)t2+1)))(4,t2,t1,lf[355],lf[0]);}

/* create-session in k3893 in k3523 in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_5881(C_word c,C_word t0,C_word t1,...){
C_word tmp;
C_word t2;
C_word *a;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_5881,2,t0,t1);}
/* posixwin.scm:1666: error */
t2=*((C_word*)lf[351]+1);
((C_proc4)(void*)(*((C_word*)t2+1)))(4,t2,t1,lf[354],lf[0]);}

/* k3206 in k3053 in k3050 in k3258 in k3255 in k3252 in k3249 in k3246 in k3243 in find-files in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_3208(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word *a;
/* posix-common.scm:435: glob */
t2=*((C_word*)lf[79]+1);
((C_proc3)(void*)(*((C_word*)t2+1)))(3,t2,((C_word*)t0)[2],t1);}

/* file-read in k3523 in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_3688(C_word c,C_word t0,C_word t1,C_word t2,C_word t3,...){
C_word tmp;
C_word t4;
va_list v;
C_word *a,c2=c;
C_save_rest(t3,c2,4);
if(c<4) C_bad_min_argc_2(c,4,t0);
if(!C_demand(c*C_SIZEOF_PAIR+5)){
C_save_and_reclaim((void*)tr4r,(void*)f_3688r,4,t0,t1,t2,t3);}
else{
a=C_alloc((c-4)*3);
t4=C_restore_rest(a,C_rest_count(0));
f_3688r(t0,t1,t2,t3,t4);}}

static void C_ccall f_3688r(C_word t0,C_word t1,C_word t2,C_word t3,C_word t4){
C_word tmp;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word *a=C_alloc(5);
t5=C_i_check_exact_2(t2,lf[154]);
t6=C_i_check_exact_2(t3,lf[154]);
t7=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_3698,a[2]=t2,a[3]=t3,a[4]=t1,tmp=(C_word)a,a+=5,tmp);
if(C_truep(C_i_pairp(t4))){
t8=t4;
t9=t7;
f_3698(2,t9,C_u_i_car(t8));}
else{
t8=t3;
/* ##sys#make-string */
((C_proc4)C_fast_retrieve_proc(*((C_word*)lf[69]+1)))(4,*((C_word*)lf[69]+1),t7,t8,C_make_character(32));}}

/* k3680 in file-close in k3523 in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_3682(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word *a;
/* posixwin.scm:780: ##sys#signal-hook */
t2=*((C_word*)lf[3]+1);
((C_proc6)(void*)(*((C_word*)t2+1)))(6,t2,((C_word*)t0)[2],lf[10],lf[152],lf[153],((C_word*)t0)[3]);}

/* current-effective-group-id in k3893 in k3523 in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_5893(C_word c,C_word t0,C_word t1,...){
C_word tmp;
C_word t2;
C_word *a;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_5893,2,t0,t1);}
/* posixwin.scm:1668: error */
t2=*((C_word*)lf[351]+1);
((C_proc4)(void*)(*((C_word*)t2+1)))(4,t2,t1,lf[356],lf[0]);}

/* k3632 in file-open in k3523 in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_fcall f_3634(C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word ab[9],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)trf_3634,NULL,2,t0,t1);}
t2=t1;
t3=C_i_check_string_2(((C_word*)t0)[2],lf[150]);
t4=C_i_check_exact_2(((C_word*)t0)[3],lf[150]);
t5=C_i_check_exact_2(t2,lf[150]);
t6=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_3647,a[2]=((C_word*)t0)[3],a[3]=t2,a[4]=((C_word*)t0)[4],a[5]=((C_word*)t0)[2],tmp=(C_word)a,a+=6,tmp);
t7=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_3663,a[2]=t6,tmp=(C_word)a,a+=3,tmp);
/* posixwin.scm:769: ##sys#expand-home-path */
((C_proc3)C_fast_retrieve_proc(*((C_word*)lf[14]+1)))(3,*((C_word*)lf[14]+1),t7,((C_word*)t0)[2]);}

/* file-open in k3523 in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_3630(C_word c,C_word t0,C_word t1,C_word t2,C_word t3,...){
C_word tmp;
C_word t4;
va_list v;
C_word *a,c2=c;
C_save_rest(t3,c2,4);
if(c<4) C_bad_min_argc_2(c,4,t0);
if(!C_demand(c*C_SIZEOF_PAIR+5)){
C_save_and_reclaim((void*)tr4r,(void*)f_3630r,4,t0,t1,t2,t3);}
else{
a=C_alloc((c-4)*3);
t4=C_restore_rest(a,C_rest_count(0));
f_3630r(t0,t1,t2,t3,t4);}}

static void C_ccall f_3630r(C_word t0,C_word t1,C_word t2,C_word t3,C_word t4){
C_word tmp;
C_word t5;
C_word t6;
C_word t7;
C_word *a=C_alloc(5);
t5=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_3634,a[2]=t2,a[3]=t3,a[4]=t1,tmp=(C_word)a,a+=5,tmp);
if(C_truep(C_i_pairp(t4))){
t6=t4;
t7=t5;
f_3634(t7,C_u_i_car(t6));}
else{
t6=t5;
f_3634(t6,((C_word*)t0)[2]);}}

/* current-effective-user-id in k3893 in k3523 in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_5899(C_word c,C_word t0,C_word t1,...){
C_word tmp;
C_word t2;
C_word *a;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_5899,2,t0,t1);}
/* posixwin.scm:1669: error */
t2=*((C_word*)lf[351]+1);
((C_proc4)(void*)(*((C_word*)t2+1)))(4,t2,t1,lf[357],lf[0]);}

/* change-directory* in k3893 in k3523 in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_5863(C_word c,C_word t0,C_word t1,...){
C_word tmp;
C_word t2;
C_word *a;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_5863,2,t0,t1);}
/* posixwin.scm:1663: error */
t2=*((C_word*)lf[351]+1);
((C_proc4)(void*)(*((C_word*)t2+1)))(4,t2,t1,lf[350],lf[0]);}

/* change-file-owner in k3893 in k3523 in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_5869(C_word c,C_word t0,C_word t1,...){
C_word tmp;
C_word t2;
C_word *a;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_5869,2,t0,t1);}
/* posixwin.scm:1664: error */
t2=*((C_word*)lf[351]+1);
((C_proc4)(void*)(*((C_word*)t2+1)))(4,t2,t1,lf[352],lf[0]);}

/* create-fifo in k3893 in k3523 in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_5875(C_word c,C_word t0,C_word t1,...){
C_word tmp;
C_word t2;
C_word *a;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_5875,2,t0,t1);}
/* posixwin.scm:1665: error */
t2=*((C_word*)lf[351]+1);
((C_proc4)(void*)(*((C_word*)t2+1)))(4,t2,t1,lf[353],lf[0]);}

/* get-host-name in k3893 in k3523 in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_5654(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word ab[3],*a=ab;
if(c!=2) C_bad_argc_2(c,2,t0);
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_5654,2,t0,t1);}
if(C_truep(C_get_hostname())){
/* ##sys#peek-c-string */
t2=*((C_word*)lf[6]+1);
((C_proc4)(void*)(*((C_word*)t2+1)))(4,t2,t1,C_mpointer(&a,(void*)C_hostname),C_fix(0));}
else{
/* posixwin.scm:1468: ##sys#error */
t2=*((C_word*)lf[45]+1);
((C_proc4)(void*)(*((C_word*)t2+1)))(4,t2,t1,lf[325],lf[326]);}}

/* k3654 in k3645 in k3632 in file-open in k3523 in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_3656(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word *a;
/* posixwin.scm:772: ##sys#signal-hook */
t2=*((C_word*)lf[3]+1);
((C_proc8)(void*)(*((C_word*)t2+1)))(8,t2,((C_word*)t0)[2],lf[10],lf[150],lf[151],((C_word*)t0)[3],((C_word*)t0)[4],((C_word*)t0)[5]);}

/* k3648 in k3645 in k3632 in file-open in k3523 in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_3650(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word *a;
t2=((C_word*)t0)[2];
((C_proc2)(void*)(*((C_word*)t2+1)))(2,t2,((C_word*)t0)[3]);}

/* system-information in k3893 in k3523 in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_5666(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word ab[6],*a=ab;
if(c!=2) C_bad_argc_2(c,2,t0);
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_5666,2,t0,t1);}
if(C_truep(C_sysinfo())){
t2=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_5677,a[2]=t1,tmp=(C_word)a,a+=3,tmp);
/* ##sys#peek-c-string */
t3=*((C_word*)lf[6]+1);
((C_proc4)(void*)(*((C_word*)t3+1)))(4,t3,t2,C_mpointer(&a,(void*)C_hostname),C_fix(0));}
else{
t2=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_5692,a[2]=t1,tmp=(C_word)a,a+=3,tmp);
/* posixwin.scm:1478: ##sys#update-errno */
((C_proc2)C_fast_retrieve_proc(*((C_word*)lf[7]+1)))(2,*((C_word*)lf[7]+1),t2);}}

/* k3453 in time->string in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_3455(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word ab[9],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_3455,2,t0,t1);}
if(C_truep(((C_word*)t0)[2])){
t2=C_i_check_string_2(((C_word*)t0)[2],lf[114]);
t3=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_3464,a[2]=((C_word*)t0)[3],a[3]=((C_word*)t0)[4],tmp=(C_word)a,a+=4,tmp);
t4=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_3474,a[2]=((C_word*)t0)[4],a[3]=t3,a[4]=((C_word*)t0)[5],tmp=(C_word)a,a+=5,tmp);
/* posix-common.scm:520: ##sys#make-c-string */
((C_proc4)C_fast_retrieve_proc(*((C_word*)lf[12]+1)))(4,*((C_word*)lf[12]+1),t4,((C_word*)t0)[2],lf[114]);}
else{
t2=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_3481,a[2]=((C_word*)t0)[3],a[3]=((C_word*)t0)[4],tmp=(C_word)a,a+=4,tmp);
t3=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_3502,a[2]=((C_word*)t0)[4],a[3]=t2,tmp=(C_word)a,a+=4,tmp);
/* posix-common.scm:522: ##sys#make-string */
((C_proc4)C_fast_retrieve_proc(*((C_word*)lf[69]+1)))(4,*((C_word*)lf[69]+1),t3,((C_word*)t0)[5],C_make_character(0));}}

/* k3645 in k3632 in file-open in k3523 in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_3647(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word ab[10],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_3647,2,t0,t1);}
t2=C_open(t1,((C_word*)t0)[2],((C_word*)t0)[3]);
t3=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_3650,a[2]=((C_word*)t0)[4],a[3]=t2,tmp=(C_word)a,a+=4,tmp);
t4=C_eqp(C_fix(-1),t2);
if(C_truep(t4)){
t5=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_3656,a[2]=t3,a[3]=((C_word*)t0)[5],a[4]=((C_word*)t0)[2],a[5]=((C_word*)t0)[3],tmp=(C_word)a,a+=6,tmp);
/* posixwin.scm:771: ##sys#update-errno */
((C_proc2)C_fast_retrieve_proc(*((C_word*)lf[7]+1)))(2,*((C_word*)lf[7]+1),t5);}
else{
t5=((C_word*)t0)[4];
((C_proc2)(void*)(*((C_word*)t5+1)))(2,t5,t2);}}

/* local-time->seconds in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_3403(C_word c,C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word t4;
C_word ab[5],*a=ab;
if(c!=3) C_bad_argc_2(c,3,t0);
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr3,(void*)f_3403,3,t0,t1,t2);}
t3=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_3407,a[2]=t2,a[3]=t1,a[4]=((C_word*)t0)[2],tmp=(C_word)a,a+=5,tmp);
/* posix-common.scm:505: check-time-vector */
f_3294(t3,lf[110],t2);}

/* k3405 in local-time->seconds in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_3407(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word ab[4],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_3407,2,t0,t1);}
t2=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_3411,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],tmp=(C_word)a,a+=4,tmp);
/* posix-common.scm:506: ##sys#make-string */
((C_proc4)C_fast_retrieve_proc(*((C_word*)lf[69]+1)))(4,*((C_word*)lf[69]+1),t2,((C_word*)t0)[4],C_make_character(0));}

/* ##sys#process-wait in k3893 in k3523 in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_5636(C_word c,C_word t0,C_word t1,C_word t2,C_word t3){
C_word tmp;
C_word t4;
C_word *a;
if(c!=4) C_bad_argc_2(c,4,t0);
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr4,(void*)f_5636,4,t0,t1,t2,t3);}
if(C_truep(C_process_wait(t2,t3))){
/* posixwin.scm:1452: values */
C_values(5,0,t1,t2,C_SCHEME_TRUE,C_fix((C_word)C_exstatus));}
else{
/* posixwin.scm:1453: values */
C_values(5,0,t1,C_fix(-1),C_SCHEME_FALSE,C_SCHEME_FALSE);}}

/* sleep in k3893 in k3523 in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_5648(C_word c,C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word t4;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr3,(void*)f_5648,3,t0,t1,t2);}
t3=C_i_check_exact_2(t2,lf[324]);
t4=t1;
((C_proc2)(void*)(*((C_word*)t4+1)))(2,t4,C_sleep(t2));}

/* k3472 in k3453 in time->string in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_3474(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word ab[5],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_3474,2,t0,t1);}
t2=t1;
t3=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_3478,a[2]=((C_word*)t0)[2],a[3]=t2,a[4]=((C_word*)t0)[3],tmp=(C_word)a,a+=5,tmp);
/* posix-common.scm:520: ##sys#make-string */
((C_proc4)C_fast_retrieve_proc(*((C_word*)lf[69]+1)))(4,*((C_word*)lf[69]+1),t3,((C_word*)t0)[4],C_make_character(0));}

/* k3476 in k3472 in k3453 in time->string in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_3478(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word ab[5],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_3478,2,t0,t1);}
t2=((C_word*)t0)[2];
t3=C_a_i_bytevector(&a,1,C_fix(3));
if(C_truep(t1)){
t4=C_i_foreign_block_argumentp(t1);
t5=stub526(t3,t2,((C_word*)t0)[3],t4);
/* posix-common.scm:513: ##sys#peek-c-string */
t6=*((C_word*)lf[6]+1);
((C_proc4)(void*)(*((C_word*)t6+1)))(4,t6,((C_word*)t0)[4],t5,C_fix(0));}
else{
t4=stub526(t3,t2,((C_word*)t0)[3],C_SCHEME_FALSE);
/* posix-common.scm:513: ##sys#peek-c-string */
t5=*((C_word*)lf[6]+1);
((C_proc4)(void*)(*((C_word*)t5+1)))(4,t5,((C_word*)t0)[4],t4,C_fix(0));}}

/* toplevel */
static C_TLS int toplevel_initialized=0;
C_noret_decl(toplevel_trampoline)
static void C_fcall toplevel_trampoline(void *dummy) C_regparm C_noret;
C_regparm static void C_fcall toplevel_trampoline(void *dummy){
C_posix_toplevel(2,C_SCHEME_UNDEFINED,C_restore);}

void C_ccall C_posix_toplevel(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word *a;
if(toplevel_initialized) C_kontinue(t1,C_SCHEME_UNDEFINED);
else C_toplevel_entry(C_text("posix_toplevel"));
C_check_nursery_minimum(3);
if(!C_demand(3)){
C_save(t1);
C_reclaim((void*)toplevel_trampoline,NULL);}
toplevel_initialized=1;
if(!C_demand_2(3124)){
C_save(t1);
C_rereclaim2(3124*sizeof(C_word), 1);
t1=C_restore;}
a=C_alloc(3);
C_initialize_lf(lf,407);
lf[1]=C_decode_literal(C_heaptop,"\376B\000\000/this function is not available on this platform");
lf[3]=C_h_intern(&lf[3],15,"\003syssignal-hook");
lf[4]=C_h_intern(&lf[4],13,"string-append");
lf[5]=C_decode_literal(C_heaptop,"\376B\000\000\003 - ");
lf[6]=C_h_intern(&lf[6],17,"\003syspeek-c-string");
lf[7]=C_h_intern(&lf[7],16,"\003sysupdate-errno");
lf[8]=C_h_intern(&lf[8],15,"\003sysposix-error");
lf[10]=C_h_intern(&lf[10],11,"\000file-error");
lf[11]=C_decode_literal(C_heaptop,"\376B\000\000\022cannot access file");
lf[12]=C_h_intern(&lf[12],17,"\003sysmake-c-string");
lf[13]=C_h_intern(&lf[13],27,"\003sysplatform-fixup-pathname");
lf[14]=C_h_intern(&lf[14],20,"\003sysexpand-home-path");
lf[15]=C_h_intern(&lf[15],11,"\000type-error");
lf[16]=C_decode_literal(C_heaptop,"\376B\000\000\052bad argument type - not a fixnum or string");
lf[17]=C_h_intern(&lf[17],9,"file-stat");
lf[18]=C_h_intern(&lf[18],16,"_stat_st_blksize");
lf[19]=C_h_intern(&lf[19],15,"_stat_st_blocks");
lf[20]=C_h_intern(&lf[20],22,"file-modification-time");
lf[21]=C_h_intern(&lf[21],16,"file-access-time");
lf[22]=C_h_intern(&lf[22],16,"file-change-time");
lf[23]=C_h_intern(&lf[23],10,"file-owner");
lf[24]=C_h_intern(&lf[24],16,"file-permissions");
lf[25]=C_h_intern(&lf[25],9,"file-size");
lf[26]=C_h_intern(&lf[26],9,"file-type");
lf[27]=C_h_intern(&lf[27],12,"regular-file");
lf[28]=C_h_intern(&lf[28],13,"symbolic-link");
lf[29]=C_h_intern(&lf[29],9,"directory");
lf[30]=C_h_intern(&lf[30],16,"character-device");
lf[31]=C_h_intern(&lf[31],12,"block-device");
lf[32]=C_h_intern(&lf[32],4,"fifo");
lf[33]=C_h_intern(&lf[33],6,"socket");
lf[34]=C_h_intern(&lf[34],13,"regular-file\077");
lf[35]=C_h_intern(&lf[35],14,"symbolic-link\077");
lf[36]=C_h_intern(&lf[36],13,"block-device\077");
lf[37]=C_h_intern(&lf[37],17,"character-device\077");
lf[38]=C_h_intern(&lf[38],5,"fifo\077");
lf[39]=C_h_intern(&lf[39],7,"socket\077");
lf[40]=C_h_intern(&lf[40],10,"directory\077");
lf[41]=C_h_intern(&lf[41],12,"fileno/stdin");
lf[42]=C_h_intern(&lf[42],13,"fileno/stdout");
lf[43]=C_h_intern(&lf[43],13,"fileno/stderr");
lf[44]=C_h_intern(&lf[44],7,"\000append");
lf[45]=C_h_intern(&lf[45],9,"\003syserror");
lf[46]=C_decode_literal(C_heaptop,"\376B\000\000\033invalid mode for input file");
lf[47]=C_decode_literal(C_heaptop,"\376B\000\000\001a");
lf[48]=C_decode_literal(C_heaptop,"\376B\000\000\025invalid mode argument");
lf[49]=C_decode_literal(C_heaptop,"\376B\000\000\001r");
lf[50]=C_decode_literal(C_heaptop,"\376B\000\000\001w");
lf[51]=C_decode_literal(C_heaptop,"\376B\000\000\020cannot open file");
lf[52]=C_h_intern(&lf[52],13,"\003sysmake-port");
lf[53]=C_h_intern(&lf[53],21,"\003sysstream-port-class");
lf[54]=C_decode_literal(C_heaptop,"\376B\000\000\010(fdport)");
lf[55]=C_h_intern(&lf[55],6,"stream");
lf[56]=C_h_intern(&lf[56],16,"open-input-file\052");
lf[57]=C_h_intern(&lf[57],17,"open-output-file\052");
lf[58]=C_h_intern(&lf[58],12,"port->fileno");
lf[59]=C_h_intern(&lf[59],13,"\003sysport-data");
lf[60]=C_decode_literal(C_heaptop,"\376B\000\000\031port has no attached file");
lf[61]=C_decode_literal(C_heaptop,"\376B\000\000%cannot access file-descriptor of port");
lf[62]=C_h_intern(&lf[62],25,"\003syspeek-unsigned-integer");
lf[63]=C_h_intern(&lf[63],16,"duplicate-fileno");
lf[64]=C_decode_literal(C_heaptop,"\376B\000\000 cannot duplicate file-descriptor");
lf[65]=C_h_intern(&lf[65],17,"current-directory");
lf[66]=C_h_intern(&lf[66],16,"change-directory");
lf[67]=C_h_intern(&lf[67],13,"\003syssubstring");
lf[68]=C_decode_literal(C_heaptop,"\376B\000\000!cannot retrieve current directory");
lf[69]=C_h_intern(&lf[69],15,"\003sysmake-string");
lf[70]=C_h_intern(&lf[70],16,"delete-directory");
lf[71]=C_decode_literal(C_heaptop,"\376B\000\000\027cannot delete directory");
lf[72]=C_h_intern(&lf[72],11,"delete-file");
lf[73]=C_h_intern(&lf[73],8,"for-each");
lf[74]=C_h_intern(&lf[74],10,"find-files");
lf[75]=C_h_intern(&lf[75],9,"\000dotfiles");
lf[76]=C_h_intern(&lf[76],16,"\000follow-symlinks");
lf[77]=C_decode_literal(C_heaptop,"\376B\000\000\025cannot open directory");
lf[78]=C_h_intern(&lf[78],16,"\003sysmake-pointer");
lf[79]=C_h_intern(&lf[79],4,"glob");
lf[80]=C_h_intern(&lf[80],18,"decompose-pathname");
lf[81]=C_h_intern(&lf[81],13,"make-pathname");
lf[82]=C_h_intern(&lf[82],23,"irregex-match-substring");
lf[83]=C_h_intern(&lf[83],13,"irregex-match");
lf[84]=C_decode_literal(C_heaptop,"\376B\000\000\001.");
lf[85]=C_h_intern(&lf[85],16,"\003sysglob->regexp");
lf[86]=C_decode_literal(C_heaptop,"\376B\000\000\001\052");
lf[87]=C_decode_literal(C_heaptop,"\376B\000\000\001.");
lf[88]=C_decode_literal(C_heaptop,"\376B\000\000\002..");
lf[89]=C_decode_literal(C_heaptop,"\376B\000\000\002\077\052");
lf[90]=C_decode_literal(C_heaptop,"\376B\000\000\001\052");
lf[91]=C_h_intern(&lf[91],16,"\003sysdynamic-wind");
lf[92]=C_h_intern(&lf[92],13,"pathname-file");
lf[93]=C_decode_literal(C_heaptop,"\376B\000\000\002\077\052");
lf[94]=C_decode_literal(C_heaptop,"\376B\000\000\001\052");
lf[95]=C_h_intern(&lf[95],7,"irregex");
lf[96]=C_h_intern(&lf[96],15,"\003sysget-keyword");
lf[97]=C_h_intern(&lf[97],6,"\000limit");
lf[98]=C_h_intern(&lf[98],5,"\000seed");
lf[99]=C_h_intern(&lf[99],7,"\000action");
lf[100]=C_h_intern(&lf[100],5,"\000test");
lf[101]=C_h_intern(&lf[101],18,"file-creation-mode");
lf[103]=C_decode_literal(C_heaptop,"\376B\000\000\025time vector too short");
lf[104]=C_h_intern(&lf[104],19,"seconds->local-time");
lf[105]=C_h_intern(&lf[105],18,"\003sysdecode-seconds");
lf[106]=C_h_intern(&lf[106],15,"current-seconds");
lf[107]=C_h_intern(&lf[107],17,"seconds->utc-time");
lf[108]=C_h_intern(&lf[108],15,"seconds->string");
lf[109]=C_decode_literal(C_heaptop,"\376B\000\000 cannot convert seconds to string");
lf[110]=C_h_intern(&lf[110],19,"local-time->seconds");
lf[111]=C_decode_literal(C_heaptop,"\376B\000\000%cannot convert time vector to seconds");
lf[112]=C_h_intern(&lf[112],3,"fp=");
lf[113]=C_decode_literal(C_heaptop,"\376U-1.0\000");
lf[114]=C_h_intern(&lf[114],12,"time->string");
lf[115]=C_decode_literal(C_heaptop,"\376B\000\000 time formatting overflows buffer");
lf[116]=C_decode_literal(C_heaptop,"\376B\000\000$cannot convert time vector to string");
lf[117]=C_h_intern(&lf[117],19,"set-signal-handler!");
lf[118]=C_h_intern(&lf[118],17,"\003syssignal-vector");
lf[119]=C_h_intern(&lf[119],14,"signal-handler");
lf[120]=C_h_intern(&lf[120],18,"current-process-id");
lf[121]=C_h_intern(&lf[121],12,"process-wait");
lf[122]=C_h_intern(&lf[122],16,"\003sysprocess-wait");
lf[123]=C_h_intern(&lf[123],14,"\000process-error");
lf[124]=C_decode_literal(C_heaptop,"\376B\000\000 waiting for child process failed");
lf[125]=C_h_intern(&lf[125],8,"pipe/buf");
lf[126]=C_h_intern(&lf[126],11,"open/rdonly");
lf[127]=C_h_intern(&lf[127],11,"open/wronly");
lf[128]=C_h_intern(&lf[128],9,"open/rdwr");
lf[129]=C_h_intern(&lf[129],9,"open/read");
lf[130]=C_h_intern(&lf[130],10,"open/write");
lf[131]=C_h_intern(&lf[131],10,"open/creat");
lf[132]=C_h_intern(&lf[132],11,"open/append");
lf[133]=C_h_intern(&lf[133],9,"open/excl");
lf[134]=C_h_intern(&lf[134],10,"open/trunc");
lf[135]=C_h_intern(&lf[135],11,"open/binary");
lf[136]=C_h_intern(&lf[136],9,"open/text");
lf[137]=C_h_intern(&lf[137],14,"open/noinherit");
lf[138]=C_h_intern(&lf[138],10,"perm/irusr");
lf[139]=C_h_intern(&lf[139],10,"perm/iwusr");
lf[140]=C_h_intern(&lf[140],10,"perm/ixusr");
lf[141]=C_h_intern(&lf[141],10,"perm/irgrp");
lf[142]=C_h_intern(&lf[142],10,"perm/iwgrp");
lf[143]=C_h_intern(&lf[143],10,"perm/ixgrp");
lf[144]=C_h_intern(&lf[144],10,"perm/iroth");
lf[145]=C_h_intern(&lf[145],10,"perm/iwoth");
lf[146]=C_h_intern(&lf[146],10,"perm/ixoth");
lf[147]=C_h_intern(&lf[147],10,"perm/irwxu");
lf[148]=C_h_intern(&lf[148],10,"perm/irwxg");
lf[149]=C_h_intern(&lf[149],10,"perm/irwxo");
lf[150]=C_h_intern(&lf[150],9,"file-open");
lf[151]=C_decode_literal(C_heaptop,"\376B\000\000\020cannot open file");
lf[152]=C_h_intern(&lf[152],10,"file-close");
lf[153]=C_decode_literal(C_heaptop,"\376B\000\000\021cannot close file");
lf[154]=C_h_intern(&lf[154],9,"file-read");
lf[155]=C_decode_literal(C_heaptop,"\376B\000\000\025cannot read from file");
lf[156]=C_decode_literal(C_heaptop,"\376B\000\000(bad argument type - not a string or blob");
lf[157]=C_h_intern(&lf[157],10,"file-write");
lf[158]=C_decode_literal(C_heaptop,"\376B\000\000\024cannot write to file");
lf[159]=C_decode_literal(C_heaptop,"\376B\000\000(bad argument type - not a string or blob");
lf[160]=C_h_intern(&lf[160],12,"file-mkstemp");
lf[161]=C_decode_literal(C_heaptop,"\376B\000\000\034cannot create temporary file");
lf[162]=C_h_intern(&lf[162],8,"seek/set");
lf[163]=C_h_intern(&lf[163],8,"seek/end");
lf[164]=C_h_intern(&lf[164],8,"seek/cur");
lf[165]=C_h_intern(&lf[165],18,"set-file-position!");
lf[166]=C_decode_literal(C_heaptop,"\376B\000\000\030cannot set file position");
lf[167]=C_decode_literal(C_heaptop,"\376B\000\000\014invalid file");
lf[168]=C_h_intern(&lf[168],5,"port\077");
lf[169]=C_h_intern(&lf[169],13,"\000bounds-error");
lf[170]=C_decode_literal(C_heaptop,"\376B\000\000\036invalid negative port position");
lf[171]=C_h_intern(&lf[171],13,"file-position");
lf[172]=C_h_intern(&lf[172],16,"create-directory");
lf[173]=C_decode_literal(C_heaptop,"\376B\000\000\027cannot create directory");
lf[174]=C_h_intern(&lf[174],16,"\003sysfile-exists\077");
lf[175]=C_decode_literal(C_heaptop,"\376B\000\000\001/");
lf[176]=C_h_intern(&lf[176],12,"string-split");
lf[177]=C_decode_literal(C_heaptop,"\376B\000\000\002/\134");
lf[178]=C_decode_literal(C_heaptop,"\376B\000\000\037cannot change current directory");
lf[179]=C_decode_literal(C_heaptop,"\376B\000\000\020cannot open pipe");
lf[180]=C_decode_literal(C_heaptop,"\376B\000\000\006(pipe)");
lf[181]=C_h_intern(&lf[181],15,"open-input-pipe");
lf[182]=C_h_intern(&lf[182],5,"\000text");
lf[183]=C_h_intern(&lf[183],7,"\000binary");
lf[184]=C_decode_literal(C_heaptop,"\376B\000\000#illegal input/output mode specifier");
lf[185]=C_h_intern(&lf[185],16,"open-output-pipe");
lf[186]=C_h_intern(&lf[186],16,"close-input-pipe");
lf[187]=C_decode_literal(C_heaptop,"\376B\000\000\030error while closing pipe");
lf[188]=C_h_intern(&lf[188],17,"close-output-pipe");
lf[189]=C_decode_literal(C_heaptop,"\376B\000\000\030error while closing pipe");
lf[190]=C_h_intern(&lf[190],20,"call-with-input-pipe");
lf[191]=C_h_intern(&lf[191],21,"call-with-output-pipe");
lf[192]=C_h_intern(&lf[192],20,"with-input-from-pipe");
lf[193]=C_h_intern(&lf[193],18,"\003sysstandard-input");
lf[194]=C_h_intern(&lf[194],19,"with-output-to-pipe");
lf[195]=C_h_intern(&lf[195],19,"\003sysstandard-output");
lf[196]=C_h_intern(&lf[196],11,"create-pipe");
lf[197]=C_decode_literal(C_heaptop,"\376B\000\000\022cannot create pipe");
lf[198]=C_h_intern(&lf[198],11,"signal/term");
lf[199]=C_h_intern(&lf[199],10,"signal/int");
lf[200]=C_h_intern(&lf[200],10,"signal/fpe");
lf[201]=C_h_intern(&lf[201],10,"signal/ill");
lf[202]=C_h_intern(&lf[202],11,"signal/segv");
lf[203]=C_h_intern(&lf[203],11,"signal/abrt");
lf[204]=C_h_intern(&lf[204],12,"signal/break");
lf[205]=C_h_intern(&lf[205],11,"signal/alrm");
lf[206]=C_h_intern(&lf[206],11,"signal/chld");
lf[207]=C_h_intern(&lf[207],11,"signal/cont");
lf[208]=C_h_intern(&lf[208],10,"signal/hup");
lf[209]=C_h_intern(&lf[209],9,"signal/io");
lf[210]=C_h_intern(&lf[210],11,"signal/kill");
lf[211]=C_h_intern(&lf[211],11,"signal/pipe");
lf[212]=C_h_intern(&lf[212],11,"signal/prof");
lf[213]=C_h_intern(&lf[213],11,"signal/quit");
lf[214]=C_h_intern(&lf[214],11,"signal/stop");
lf[215]=C_h_intern(&lf[215],11,"signal/trap");
lf[216]=C_h_intern(&lf[216],11,"signal/tstp");
lf[217]=C_h_intern(&lf[217],10,"signal/urg");
lf[218]=C_h_intern(&lf[218],11,"signal/usr1");
lf[219]=C_h_intern(&lf[219],11,"signal/usr2");
lf[220]=C_h_intern(&lf[220],13,"signal/vtalrm");
lf[221]=C_h_intern(&lf[221],12,"signal/winch");
lf[222]=C_h_intern(&lf[222],11,"signal/xcpu");
lf[223]=C_h_intern(&lf[223],11,"signal/xfsz");
lf[224]=C_h_intern(&lf[224],12,"signals-list");
lf[225]=C_h_intern(&lf[225],10,"errno/perm");
lf[226]=C_h_intern(&lf[226],11,"errno/noent");
lf[227]=C_h_intern(&lf[227],10,"errno/srch");
lf[228]=C_h_intern(&lf[228],10,"errno/intr");
lf[229]=C_h_intern(&lf[229],8,"errno/io");
lf[230]=C_h_intern(&lf[230],12,"errno/noexec");
lf[231]=C_h_intern(&lf[231],10,"errno/badf");
lf[232]=C_h_intern(&lf[232],11,"errno/child");
lf[233]=C_h_intern(&lf[233],11,"errno/nomem");
lf[234]=C_h_intern(&lf[234],11,"errno/acces");
lf[235]=C_h_intern(&lf[235],11,"errno/fault");
lf[236]=C_h_intern(&lf[236],10,"errno/busy");
lf[237]=C_h_intern(&lf[237],11,"errno/exist");
lf[238]=C_h_intern(&lf[238],12,"errno/notdir");
lf[239]=C_h_intern(&lf[239],11,"errno/isdir");
lf[240]=C_h_intern(&lf[240],11,"errno/inval");
lf[241]=C_h_intern(&lf[241],11,"errno/mfile");
lf[242]=C_h_intern(&lf[242],11,"errno/nospc");
lf[243]=C_h_intern(&lf[243],11,"errno/spipe");
lf[244]=C_h_intern(&lf[244],10,"errno/pipe");
lf[245]=C_h_intern(&lf[245],11,"errno/again");
lf[246]=C_h_intern(&lf[246],10,"errno/rofs");
lf[247]=C_h_intern(&lf[247],10,"errno/nxio");
lf[248]=C_h_intern(&lf[248],10,"errno/2big");
lf[249]=C_h_intern(&lf[249],10,"errno/xdev");
lf[250]=C_h_intern(&lf[250],11,"errno/nodev");
lf[251]=C_h_intern(&lf[251],11,"errno/nfile");
lf[252]=C_h_intern(&lf[252],11,"errno/notty");
lf[253]=C_h_intern(&lf[253],10,"errno/fbig");
lf[254]=C_h_intern(&lf[254],11,"errno/mlink");
lf[255]=C_h_intern(&lf[255],9,"errno/dom");
lf[256]=C_h_intern(&lf[256],11,"errno/range");
lf[257]=C_h_intern(&lf[257],12,"errno/deadlk");
lf[258]=C_h_intern(&lf[258],17,"errno/nametoolong");
lf[259]=C_h_intern(&lf[259],11,"errno/nolck");
lf[260]=C_h_intern(&lf[260],11,"errno/nosys");
lf[261]=C_h_intern(&lf[261],14,"errno/notempty");
lf[262]=C_h_intern(&lf[262],11,"errno/ilseq");
lf[263]=C_h_intern(&lf[263],16,"change-file-mode");
lf[264]=C_decode_literal(C_heaptop,"\376B\000\000\027cannot change file mode");
lf[265]=C_h_intern(&lf[265],17,"file-read-access\077");
lf[266]=C_h_intern(&lf[266],18,"file-write-access\077");
lf[267]=C_h_intern(&lf[267],20,"file-execute-access\077");
lf[268]=C_decode_literal(C_heaptop,"\376B\000\000\033invalid mode for input file");
lf[269]=C_decode_literal(C_heaptop,"\376B\000\000\001a");
lf[270]=C_decode_literal(C_heaptop,"\376B\000\000\025invalid mode argument");
lf[271]=C_decode_literal(C_heaptop,"\376B\000\000\001r");
lf[272]=C_decode_literal(C_heaptop,"\376B\000\000\001w");
lf[273]=C_decode_literal(C_heaptop,"\376B\000\000\020cannot open file");
lf[274]=C_decode_literal(C_heaptop,"\376B\000\000\010(fdport)");
lf[275]=C_decode_literal(C_heaptop,"\376B\000\000\031port has no attached file");
lf[276]=C_decode_literal(C_heaptop,"\376B\000\000%cannot access file-descriptor of port");
lf[277]=C_decode_literal(C_heaptop,"\376B\000\000 cannot duplicate file descriptor");
lf[278]=C_h_intern(&lf[278],6,"setenv");
lf[279]=C_h_intern(&lf[279],8,"unsetenv");
lf[280]=C_decode_literal(C_heaptop,"\376B\000\000\000");
lf[281]=C_h_intern(&lf[281],25,"get-environment-variables");
lf[282]=C_h_intern(&lf[282],9,"substring");
lf[283]=C_h_intern(&lf[283],27,"local-timezone-abbreviation");
lf[284]=C_h_intern(&lf[284],5,"_exit");
lf[285]=C_h_intern(&lf[285],14,"terminal-port\077");
lf[286]=C_h_intern(&lf[286],13,"terminal-size");
lf[287]=C_decode_literal(C_heaptop,"\376B\000\000#port is not connected to a terminal");
lf[288]=C_h_intern(&lf[288],19,"set-buffering-mode!");
lf[289]=C_decode_literal(C_heaptop,"\376B\000\000\031cannot set buffering mode");
lf[290]=C_h_intern(&lf[290],5,"\000full");
lf[291]=C_h_intern(&lf[291],5,"\000line");
lf[292]=C_h_intern(&lf[292],5,"\000none");
lf[293]=C_decode_literal(C_heaptop,"\376B\000\000\026invalid buffering-mode");
lf[294]=C_h_intern(&lf[294],13,"spawn/overlay");
lf[295]=C_h_intern(&lf[295],10,"spawn/wait");
lf[296]=C_h_intern(&lf[296],12,"spawn/nowait");
lf[297]=C_h_intern(&lf[297],13,"spawn/nowaito");
lf[298]=C_h_intern(&lf[298],12,"spawn/detach");
lf[300]=C_h_intern(&lf[300],16,"\003sysfast-reverse");
lf[301]=C_decode_literal(C_heaptop,"\376B\000\000\001\042");
lf[302]=C_decode_literal(C_heaptop,"\376B\000\000\001\042");
lf[304]=C_h_intern(&lf[304],24,"pathname-strip-directory");
lf[306]=C_h_intern(&lf[306],15,"process-execute");
lf[307]=C_decode_literal(C_heaptop,"\376B\000\000\026cannot execute process");
lf[308]=C_h_intern(&lf[308],13,"process-spawn");
lf[309]=C_decode_literal(C_heaptop,"\376B\000\000\024cannot spawn process");
lf[310]=C_h_intern(&lf[310],17,"\003sysshell-command");
lf[311]=C_decode_literal(C_heaptop,"\376B\000\000 cannot retrieve system directory");
lf[312]=C_h_intern(&lf[312],24,"get-environment-variable");
lf[313]=C_decode_literal(C_heaptop,"\376B\000\000\007COMSPEC");
lf[314]=C_h_intern(&lf[314],27,"\003sysshell-command-arguments");
lf[315]=C_decode_literal(C_heaptop,"\376B\000\000\002/c");
lf[316]=C_h_intern(&lf[316],11,"process-run");
lf[317]=C_h_intern(&lf[317],11,"\003sysprocess");
lf[318]=C_decode_literal(C_heaptop,"\376B\000\000\026cannot execute process");
lf[319]=C_h_intern(&lf[319],17,"\003sysmake-locative");
lf[320]=C_h_intern(&lf[320],8,"location");
lf[321]=C_h_intern(&lf[321],18,"string-intersperse");
lf[322]=C_h_intern(&lf[322],7,"process");
lf[323]=C_h_intern(&lf[323],8,"process\052");
lf[324]=C_h_intern(&lf[324],5,"sleep");
lf[325]=C_h_intern(&lf[325],13,"get-host-name");
lf[326]=C_decode_literal(C_heaptop,"\376B\000\000\031cannot retrieve host-name");
lf[327]=C_h_intern(&lf[327],18,"system-information");
lf[328]=C_decode_literal(C_heaptop,"\376B\000\000\007windows");
lf[329]=C_decode_literal(C_heaptop,"\376B\000\000\042cannot retrieve system-information");
lf[330]=C_h_intern(&lf[330],17,"current-user-name");
lf[331]=C_decode_literal(C_heaptop,"\376B\000\000!cannot retrieve current user-name");
lf[332]=C_h_intern(&lf[332],9,"prot/none");
lf[333]=C_h_intern(&lf[333],9,"prot/read");
lf[334]=C_h_intern(&lf[334],10,"prot/write");
lf[335]=C_h_intern(&lf[335],9,"prot/exec");
lf[336]=C_h_intern(&lf[336],8,"map/file");
lf[337]=C_h_intern(&lf[337],10,"map/shared");
lf[338]=C_h_intern(&lf[338],11,"map/private");
lf[339]=C_h_intern(&lf[339],9,"map/fixed");
lf[340]=C_h_intern(&lf[340],13,"map/anonymous");
lf[341]=C_h_intern(&lf[341],18,"map-file-to-memory");
lf[342]=C_h_intern(&lf[342],4,"mmap");
lf[343]=C_decode_literal(C_heaptop,"\376B\000\000\031cannot map file to memory");
lf[344]=C_decode_literal(C_heaptop,"\376B\000\000)bad argument type - not a foreign pointer");
lf[345]=C_h_intern(&lf[345],16,"\003sysnull-pointer");
lf[346]=C_h_intern(&lf[346],22,"unmap-file-from-memory");
lf[347]=C_decode_literal(C_heaptop,"\376B\000\000\035cannot unmap file from memory");
lf[348]=C_h_intern(&lf[348],26,"memory-mapped-file-pointer");
lf[349]=C_h_intern(&lf[349],19,"memory-mapped-file\077");
lf[350]=C_h_intern(&lf[350],17,"change-directory\052");
lf[351]=C_h_intern(&lf[351],5,"error");
lf[352]=C_h_intern(&lf[352],17,"change-file-owner");
lf[353]=C_h_intern(&lf[353],11,"create-fifo");
lf[354]=C_h_intern(&lf[354],14,"create-session");
lf[355]=C_h_intern(&lf[355],20,"create-symbolic-link");
lf[356]=C_h_intern(&lf[356],26,"current-effective-group-id");
lf[357]=C_h_intern(&lf[357],25,"current-effective-user-id");
lf[358]=C_h_intern(&lf[358],27,"current-effective-user-name");
lf[359]=C_h_intern(&lf[359],16,"current-group-id");
lf[360]=C_h_intern(&lf[360],15,"current-user-id");
lf[361]=C_h_intern(&lf[361],9,"file-link");
lf[362]=C_h_intern(&lf[362],9,"file-lock");
lf[363]=C_h_intern(&lf[363],18,"file-lock/blocking");
lf[364]=C_h_intern(&lf[364],11,"file-select");
lf[365]=C_h_intern(&lf[365],14,"file-test-lock");
lf[366]=C_h_intern(&lf[366],13,"file-truncate");
lf[367]=C_h_intern(&lf[367],11,"file-unlock");
lf[368]=C_h_intern(&lf[368],10,"get-groups");
lf[369]=C_h_intern(&lf[369],17,"group-information");
lf[370]=C_h_intern(&lf[370],17,"initialize-groups");
lf[371]=C_h_intern(&lf[371],17,"parent-process-id");
lf[372]=C_h_intern(&lf[372],12,"process-fork");
lf[373]=C_h_intern(&lf[373],16,"process-group-id");
lf[374]=C_h_intern(&lf[374],14,"process-signal");
lf[375]=C_h_intern(&lf[375],18,"read-symbolic-link");
lf[376]=C_h_intern(&lf[376],10,"set-alarm!");
lf[377]=C_h_intern(&lf[377],13,"set-group-id!");
lf[378]=C_h_intern(&lf[378],11,"set-groups!");
lf[379]=C_h_intern(&lf[379],21,"set-process-group-id!");
lf[380]=C_h_intern(&lf[380],19,"set-root-directory!");
lf[381]=C_h_intern(&lf[381],16,"set-signal-mask!");
lf[382]=C_h_intern(&lf[382],12,"set-user-id!");
lf[383]=C_h_intern(&lf[383],11,"signal-mask");
lf[384]=C_h_intern(&lf[384],12,"signal-mask!");
lf[385]=C_h_intern(&lf[385],14,"signal-masked\077");
lf[386]=C_h_intern(&lf[386],14,"signal-unmask!");
lf[387]=C_h_intern(&lf[387],13,"terminal-name");
lf[388]=C_h_intern(&lf[388],16,"user-information");
lf[389]=C_h_intern(&lf[389],17,"utc-time->seconds");
lf[390]=C_h_intern(&lf[390],12,"string->time");
lf[391]=C_h_intern(&lf[391],16,"errno/wouldblock");
lf[392]=C_h_intern(&lf[392],10,"open/fsync");
lf[393]=C_h_intern(&lf[393],11,"open/noctty");
lf[394]=C_h_intern(&lf[394],13,"open/nonblock");
lf[395]=C_h_intern(&lf[395],9,"open/sync");
lf[396]=C_h_intern(&lf[396],10,"perm/isgid");
lf[397]=C_h_intern(&lf[397],10,"perm/isuid");
lf[398]=C_h_intern(&lf[398],10,"perm/isvtx");
lf[399]=C_decode_literal(C_heaptop,"\376B\000\000%cannot retrieve file position of port");
lf[400]=C_decode_literal(C_heaptop,"\376B\000\000\014invalid file");
lf[401]=C_h_intern(&lf[401],18,"getter-with-setter");
lf[402]=C_decode_literal(C_heaptop,"\376B\000\000\024(file-position port)");
lf[403]=C_decode_literal(C_heaptop,"\376B\000\000\031(file-creation-mode mode)");
lf[404]=C_h_intern(&lf[404],26,"set-file-modification-time");
lf[405]=C_decode_literal(C_heaptop,"\376B\000\000!cannot set file modification-time");
lf[406]=C_decode_literal(C_heaptop,"\376B\000\000\032(file-modification-time f)");
C_register_lf2(lf,407,create_ptable());
t2=C_mutate2(&lf[0] /* (set! c1510 ...) */,lf[1]);
t3=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_2221,a[2]=t1,tmp=(C_word)a,a+=3,tmp);
C_scheduler_toplevel(2,C_SCHEME_UNDEFINED,t3);}

/* a4206 in k4200 in call-with-input-pipe in k3893 in k3523 in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_4207(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word *a;
if(c!=2) C_bad_argc_2(c,2,t0);
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_4207,2,t0,t1);}
/* posixwin.scm:972: proc */
t2=((C_word*)t0)[2];
((C_proc3)C_fast_retrieve_proc(t2))(3,t2,t1,((C_word*)t0)[3]);}

/* current-user-name in k3893 in k3523 in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_5697(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word ab[3],*a=ab;
if(c!=2) C_bad_argc_2(c,2,t0);
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_5697,2,t0,t1);}
if(C_truep(C_get_user_name())){
/* ##sys#peek-c-string */
t2=*((C_word*)lf[6]+1);
((C_proc4)(void*)(*((C_word*)t2+1)))(4,t2,t1,C_mpointer(&a,(void*)C_username),C_fix(0));}
else{
t2=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_5707,a[2]=t1,tmp=(C_word)a,a+=3,tmp);
/* posixwin.scm:1487: ##sys#update-errno */
((C_proc2)C_fast_retrieve_proc(*((C_word*)lf[7]+1)))(2,*((C_word*)lf[7]+1),t2);}}

/* k5690 in system-information in k3893 in k3523 in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_5692(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word *a;
/* posixwin.scm:1479: ##sys#error */
t2=*((C_word*)lf[45]+1);
((C_proc4)(void*)(*((C_word*)t2+1)))(4,t2,((C_word*)t0)[2],lf[327],lf[329]);}

/* k3462 in k3453 in time->string in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_3464(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word *a;
if(C_truep(t1)){
t2=((C_word*)t0)[2];
((C_proc2)(void*)(*((C_word*)t2+1)))(2,t2,t1);}
else{
/* posix-common.scm:521: ##sys#error */
t2=*((C_word*)lf[45]+1);
((C_proc5)(void*)(*((C_word*)t2+1)))(5,t2,((C_word*)t0)[2],lf[114],lf[115],((C_word*)t0)[3]);}}

/* k3415 in k3409 in k3405 in local-time->seconds in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_3417(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word *a;
if(C_truep(t1)){
/* posix-common.scm:508: ##sys#error */
t2=*((C_word*)lf[45]+1);
((C_proc5)(void*)(*((C_word*)t2+1)))(5,t2,((C_word*)t0)[2],lf[110],lf[111],((C_word*)t0)[3]);}
else{
t2=((C_word*)t0)[2];
((C_proc2)(void*)(*((C_word*)t2+1)))(2,t2,((C_word*)t0)[4]);}}

/* k3409 in k3405 in local-time->seconds in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_3411(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word ab[9],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_3411,2,t0,t1);}
t2=C_a_mktime(&a,2,((C_word*)t0)[2],t1);
t3=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_3417,a[2]=((C_word*)t0)[3],a[3]=((C_word*)t0)[2],a[4]=t2,tmp=(C_word)a,a+=5,tmp);
/* posix-common.scm:507: fp= */
t4=*((C_word*)lf[112]+1);
((C_proc4)(void*)(*((C_word*)t4+1)))(4,t4,t3,lf[113],t2);}

/* symbolic-link? in k3523 in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_3810(C_word c,C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word t4;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr3,(void*)f_3810,3,t0,t1,t2);}
t3=C_i_check_string_2(t2,lf[35]);
t4=t1;
((C_proc2)(void*)(*((C_word*)t4+1)))(2,t4,C_SCHEME_FALSE);}

/* k5675 in system-information in k3893 in k3523 in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_5677(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word ab[7],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_5677,2,t0,t1);}
t2=t1;
t3=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_5681,a[2]=((C_word*)t0)[2],a[3]=t2,tmp=(C_word)a,a+=4,tmp);
/* ##sys#peek-c-string */
t4=*((C_word*)lf[6]+1);
((C_proc4)(void*)(*((C_word*)t4+1)))(4,t4,t3,C_mpointer(&a,(void*)C_osrel),C_fix(0));}

/* k3479 in k3453 in time->string in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_3481(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word *a;
if(C_truep(t1)){
t2=C_block_size(t1);
t3=C_fixnum_difference(t2,C_fix(1));
/* posix-common.scm:524: ##sys#substring */
((C_proc5)C_fast_retrieve_proc(*((C_word*)lf[67]+1)))(5,*((C_word*)lf[67]+1),((C_word*)t0)[2],t1,C_fix(0),t3);}
else{
/* posix-common.scm:525: ##sys#error */
t2=*((C_word*)lf[45]+1);
((C_proc5)(void*)(*((C_word*)t2+1)))(5,t2,((C_word*)t0)[2],lf[114],lf[116],((C_word*)t0)[3]);}}

/* k5683 in k5679 in k5675 in system-information in k3893 in k3523 in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_5685(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word ab[9],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_5685,2,t0,t1);}
t2=t1;
t3=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_5689,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[4],a[5]=t2,tmp=(C_word)a,a+=6,tmp);
/* ##sys#peek-c-string */
t4=*((C_word*)lf[6]+1);
((C_proc4)(void*)(*((C_word*)t4+1)))(4,t4,t3,C_mpointer(&a,(void*)C_processor),C_fix(0));}

/* k5679 in k5675 in system-information in k3893 in k3523 in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_5681(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word ab[8],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_5681,2,t0,t1);}
t2=t1;
t3=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_5685,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=t2,tmp=(C_word)a,a+=5,tmp);
/* ##sys#peek-c-string */
t4=*((C_word*)lf[6]+1);
((C_proc4)(void*)(*((C_word*)t4+1)))(4,t4,t3,C_mpointer(&a,(void*)C_osver),C_fix(0));}

/* f_2466 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_2466(C_word c,C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word t4;
C_word ab[3],*a=ab;
if(c!=3) C_bad_argc_2(c,3,t0);
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr3,(void*)f_2466,3,t0,t1,t2);}
t3=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_2474,a[2]=t1,tmp=(C_word)a,a+=3,tmp);
/* posix-common.scm:253: file-type */
t4=*((C_word*)lf[26]+1);
((C_proc5)(void*)(*((C_word*)t4+1)))(5,t4,t3,t2,C_SCHEME_FALSE,C_SCHEME_FALSE);}

/* k2462 */
static void C_ccall f_2464(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word *a;
t2=((C_word*)t0)[2];
((C_proc2)(void*)(*((C_word*)t2+1)))(2,t2,C_eqp(lf[28],t1));}

/* k5687 in k5683 in k5679 in k5675 in system-information in k3893 in k3523 in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_5689(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word ab[15],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_5689,2,t0,t1);}
t2=((C_word*)t0)[2];
((C_proc2)(void*)(*((C_word*)t2+1)))(2,t2,C_a_i_list5(&a,5,lf[328],((C_word*)t0)[3],((C_word*)t0)[4],((C_word*)t0)[5],t1));}

/* f_2456 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_2456(C_word c,C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word t4;
C_word ab[3],*a=ab;
if(c!=3) C_bad_argc_2(c,3,t0);
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr3,(void*)f_2456,3,t0,t1,t2);}
t3=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_2464,a[2]=t1,tmp=(C_word)a,a+=3,tmp);
/* posix-common.scm:250: file-type */
t4=*((C_word*)lf[26]+1);
((C_proc5)(void*)(*((C_word*)t4+1)))(5,t4,t3,t2,C_SCHEME_TRUE,C_SCHEME_FALSE);}

/* k2452 in regular-file? in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_2454(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word *a;
t2=((C_word*)t0)[2];
((C_proc2)(void*)(*((C_word*)t2+1)))(2,t2,C_eqp(lf[27],t1));}

/* f_3227 in k3258 in k3255 in k3252 in k3249 in k3246 in k3243 in find-files in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_3227(C_word c,C_word t0,C_word t1,...){
C_word tmp;
C_word t2;
C_word *a;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_3227,2,t0,t1);}
t2=t1;
((C_proc2)(void*)(*((C_word*)t2+1)))(2,t2,C_SCHEME_TRUE);}

/* memory-mapped-file-pointer in k3893 in k3523 in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_5848(C_word c,C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word t4;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr3,(void*)f_5848,3,t0,t1,t2);}
t3=C_i_check_structure_2(t2,lf[342],lf[348]);
t4=t1;
((C_proc2)(void*)(*((C_word*)t4+1)))(2,t4,C_slot(t2,C_fix(1)));}

/* f_3219 in k3216 in k3050 in k3258 in k3255 in k3252 in k3249 in k3246 in k3243 in find-files in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_3219(C_word c,C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr3,(void*)f_3219,3,t0,t1,t2);}
/* posix-common.scm:434: irregex-match */
t3=*((C_word*)lf[83]+1);
((C_proc4)(void*)(*((C_word*)t3+1)))(4,t3,t1,((C_word*)t0)[2],t2);}

/* k3216 in k3050 in k3258 in k3255 in k3252 in k3249 in k3246 in k3243 in find-files in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_3218(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word ab[4],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_3218,2,t0,t1);}
t2=t1;
t3=((C_word*)t0)[2];
f_3055(t3,(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_3219,a[2]=t2,a[3]=((C_word)li39),tmp=(C_word)a,a+=4,tmp));}

/* memory-mapped-file? in k3893 in k3523 in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_5857(C_word c,C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr3,(void*)f_5857,3,t0,t1,t2);}
t3=t1;
((C_proc2)(void*)(*((C_word*)t3+1)))(2,t3,C_i_structurep(t2,lf[342]));}

/* k3243 in find-files in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_3245(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word ab[9],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_3245,2,t0,t1);}
t2=t1;
t3=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_3248,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=t2,a[5]=((C_word*)t0)[4],tmp=(C_word)a,a+=6,tmp);
t4=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_3277,a[2]=((C_word)li47),tmp=(C_word)a,a+=3,tmp);
/* posix-common.scm:454: ##sys#get-keyword */
((C_proc5)C_fast_retrieve_proc(*((C_word*)lf[96]+1)))(5,*((C_word*)lf[96]+1),t3,lf[99],((C_word*)t0)[4],t4);}

/* k3246 in k3243 in find-files in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_3248(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word ab[10],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_3248,2,t0,t1);}
t2=t1;
t3=(*a=C_CLOSURE_TYPE|6,a[1]=(C_word)f_3251,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[4],a[5]=t2,a[6]=((C_word*)t0)[5],tmp=(C_word)a,a+=7,tmp);
t4=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_3274,a[2]=((C_word)li45),tmp=(C_word)a,a+=3,tmp);
/* posix-common.scm:454: ##sys#get-keyword */
((C_proc5)C_fast_retrieve_proc(*((C_word*)lf[96]+1)))(5,*((C_word*)lf[96]+1),t3,lf[98],((C_word*)t0)[5],t4);}

/* find-files in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_3241(C_word c,C_word t0,C_word t1,C_word t2,...){
C_word tmp;
C_word t3;
va_list v;
C_word *a,c2=c;
C_save_rest(t2,c2,3);
if(c<3) C_bad_min_argc_2(c,3,t0);
if(!C_demand(c*C_SIZEOF_PAIR+8)){
C_save_and_reclaim((void*)tr3r,(void*)f_3241r,3,t0,t1,t2);}
else{
a=C_alloc((c-3)*3);
t3=C_restore_rest(a,C_rest_count(0));
f_3241r(t0,t1,t2,t3);}}

static void C_ccall f_3241r(C_word t0,C_word t1,C_word t2,C_word t3){
C_word tmp;
C_word t4;
C_word t5;
C_word t6;
C_word *a=C_alloc(8);
t4=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_3245,a[2]=t1,a[3]=t2,a[4]=t3,tmp=(C_word)a,a+=5,tmp);
t5=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_3285,a[2]=((C_word)li49),tmp=(C_word)a,a+=3,tmp);
/* posix-common.scm:454: ##sys#get-keyword */
((C_proc5)C_fast_retrieve_proc(*((C_word*)lf[96]+1)))(5,*((C_word*)lf[96]+1),t4,lf[100],t3,t5);}

/* file-close in k3523 in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_3669(C_word c,C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word ab[4],*a=ab;
if(c!=3) C_bad_argc_2(c,3,t0);
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr3,(void*)f_3669,3,t0,t1,t2);}
t3=C_i_check_exact_2(t2,lf[152]);
t4=C_close(t2);
if(C_truep(C_fixnum_lessp(t4,C_fix(0)))){
t5=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_3682,a[2]=t1,a[3]=t2,tmp=(C_word)a,a+=4,tmp);
/* posixwin.scm:779: ##sys#update-errno */
((C_proc2)C_fast_retrieve_proc(*((C_word*)lf[7]+1)))(2,*((C_word*)lf[7]+1),t5);}
else{
t5=C_SCHEME_UNDEFINED;
t6=t1;
((C_proc2)(void*)(*((C_word*)t6+1)))(2,t6,t5);}}

/* k2502 */
static void C_ccall f_2504(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word *a;
t2=((C_word*)t0)[2];
((C_proc2)(void*)(*((C_word*)t2+1)))(2,t2,C_eqp(lf[33],t1));}

/* k3661 in k3632 in file-open in k3523 in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_3663(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word *a;
/* posixwin.scm:769: ##sys#make-c-string */
((C_proc4)C_fast_retrieve_proc(*((C_word*)lf[12]+1)))(4,*((C_word*)lf[12]+1),((C_word*)t0)[2],t1,lf[150]);}

/* directory? in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_2506(C_word c,C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word t4;
C_word ab[3],*a=ab;
if(c!=3) C_bad_argc_2(c,3,t0);
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr3,(void*)f_2506,3,t0,t1,t2);}
t3=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_2514,a[2]=t1,tmp=(C_word)a,a+=3,tmp);
/* posix-common.scm:265: file-type */
t4=*((C_word*)lf[26]+1);
((C_proc5)(void*)(*((C_word*)t4+1)))(5,t4,t3,t2,C_SCHEME_FALSE,C_SCHEME_FALSE);}

/* k2492 */
static void C_ccall f_2494(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word *a;
t2=((C_word*)t0)[2];
((C_proc2)(void*)(*((C_word*)t2+1)))(2,t2,C_eqp(lf[32],t1));}

/* f_2496 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_2496(C_word c,C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word t4;
C_word ab[3],*a=ab;
if(c!=3) C_bad_argc_2(c,3,t0);
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr3,(void*)f_2496,3,t0,t1,t2);}
t3=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_2504,a[2]=t1,tmp=(C_word)a,a+=3,tmp);
/* posix-common.scm:262: file-type */
t4=*((C_word*)lf[26]+1);
((C_proc5)(void*)(*((C_word*)t4+1)))(5,t4,t3,t2,C_SCHEME_FALSE,C_SCHEME_FALSE);}

/* k2300 in stat in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_2302(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word *a;
/* posix-common.scm:191: ##sys#platform-fixup-pathname */
((C_proc3)C_fast_retrieve_proc(*((C_word*)lf[13]+1)))(3,*((C_word*)lf[13]+1),((C_word*)t0)[2],t1);}

/* file-stat in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_2307(C_word c,C_word t0,C_word t1,C_word t2,...){
C_word tmp;
C_word t3;
va_list v;
C_word *a,c2=c;
C_save_rest(t2,c2,3);
if(c<3) C_bad_min_argc_2(c,3,t0);
if(!C_demand(c*C_SIZEOF_PAIR+3)){
C_save_and_reclaim((void*)tr3r,(void*)f_2307r,3,t0,t1,t2);}
else{
a=C_alloc((c-3)*3);
t3=C_restore_rest(a,C_rest_count(0));
f_2307r(t0,t1,t2,t3);}}

static void C_ccall f_2307r(C_word t0,C_word t1,C_word t2,C_word t3){
C_word tmp;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word *a=C_alloc(3);
t4=C_i_nullp(t3);
t5=(C_truep(t4)?C_SCHEME_FALSE:C_i_car(t3));
t6=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_2314,a[2]=t1,tmp=(C_word)a,a+=3,tmp);
/* posix-common.scm:207: ##sys#stat */
f_2263(t6,t2,t5,C_SCHEME_TRUE,lf[17]);}

/* k2289 in stat in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_2291(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word *a;
t2=((C_word*)t0)[2];
f_2267(2,t2,(C_truep(((C_word*)t0)[3])?C_lstat(t1):C_stat(t1)));}

/* k2296 in stat in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_2298(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word *a;
/* posix-common.scm:190: ##sys#make-c-string */
((C_proc4)C_fast_retrieve_proc(*((C_word*)lf[12]+1)))(4,*((C_word*)lf[12]+1),((C_word*)t0)[2],t1,((C_word*)t0)[3]);}

/* mode in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_fcall f_2519(C_word t1,C_word t2,C_word t3,C_word t4){
C_word tmp;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word ab[4],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)trf_2519,NULL,4,t1,t2,t3,t4);}
t5=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_2527,a[2]=t1,a[3]=t4,tmp=(C_word)a,a+=4,tmp);
if(C_truep(C_i_pairp(t3))){
t6=t3;
t7=C_u_i_car(t6);
t8=C_eqp(t7,lf[44]);
if(C_truep(t8)){
t9=t2;
if(C_truep(t9)){
/* posix-common.scm:284: ##sys#error */
t10=*((C_word*)lf[45]+1);
((C_proc4)(void*)(*((C_word*)t10+1)))(4,t10,t5,lf[46],t7);}
else{
/* posix-common.scm:280: ##sys#make-c-string */
((C_proc4)C_fast_retrieve_proc(*((C_word*)lf[12]+1)))(4,*((C_word*)lf[12]+1),t1,lf[47],t4);}}
else{
/* posix-common.scm:285: ##sys#error */
t9=*((C_word*)lf[45]+1);
((C_proc4)(void*)(*((C_word*)t9+1)))(4,t9,t5,lf[48],t7);}}
else{
if(C_truep(t2)){
/* posix-common.scm:280: ##sys#make-c-string */
((C_proc4)C_fast_retrieve_proc(*((C_word*)lf[12]+1)))(4,*((C_word*)lf[12]+1),t1,lf[49],t4);}
else{
/* posix-common.scm:280: ##sys#make-c-string */
((C_proc4)C_fast_retrieve_proc(*((C_word*)lf[12]+1)))(4,*((C_word*)lf[12]+1),t1,lf[50],t4);}}}

/* k2512 in directory? in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_2514(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word *a;
t2=((C_word*)t0)[2];
((C_proc2)(void*)(*((C_word*)t2+1)))(2,t2,C_eqp(lf[29],t1));}

/* a3273 in k3246 in k3243 in find-files in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_3274(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word *a;
if(c!=2) C_bad_argc_2(c,2,t0);
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_3274,2,t0,t1);}
t2=t1;
((C_proc2)(void*)(*((C_word*)t2+1)))(2,t2,C_SCHEME_END_OF_LIST);}

/* a3276 in k3243 in find-files in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_3277(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word ab[3],*a=ab;
if(c!=2) C_bad_argc_2(c,2,t0);
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_3277,2,t0,t1);}
t2=t1;
((C_proc2)(void*)(*((C_word*)t2+1)))(2,t2,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_3279,a[2]=((C_word)li46),tmp=(C_word)a,a+=3,tmp));}

/* f_3279 in a3276 in k3243 in find-files in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_3279(C_word c,C_word t0,C_word t1,C_word t2,C_word t3){
C_word tmp;
C_word t4;
C_word ab[3],*a=ab;
if(c!=4) C_bad_argc_2(c,4,t0);
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr4,(void*)f_3279,4,t0,t1,t2,t3);}
t4=t1;
((C_proc2)(void*)(*((C_word*)t4+1)))(2,t4,C_a_i_cons(&a,2,t2,t3));}

/* a3270 in k3249 in k3246 in k3243 in find-files in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_3271(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word *a;
if(c!=2) C_bad_argc_2(c,2,t0);
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_3271,2,t0,t1);}
t2=t1;
((C_proc2)(void*)(*((C_word*)t2+1)))(2,t2,C_SCHEME_FALSE);}

/* k2265 in stat in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_2267(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word *a;
if(C_truep(C_fixnum_lessp(t1,C_fix(0)))){
if(C_truep(((C_word*)t0)[2])){
/* posix-common.scm:202: posix-error */
t2=lf[2];
f_2245(6,t2,((C_word*)t0)[3],lf[10],((C_word*)t0)[4],lf[11],((C_word*)t0)[5]);}
else{
t2=((C_word*)t0)[3];
((C_proc2)(void*)(*((C_word*)t2+1)))(2,t2,C_SCHEME_FALSE);}}
else{
t2=((C_word*)t0)[3];
((C_proc2)(void*)(*((C_word*)t2+1)))(2,t2,C_SCHEME_TRUE);}}

/* a4259 in k4248 in with-input-from-pipe in k3893 in k3523 in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_4260(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word ab[4],*a=ab;
if(c!=2) C_bad_argc_2(c,2,t0);
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_4260,2,t0,t1);}
t2=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_4266,a[2]=((C_word*)t0)[2],a[3]=((C_word)li89),tmp=(C_word)a,a+=4,tmp);
/* posixwin.scm:990: ##sys#call-with-values */
C_call_with_values(4,0,t1,((C_word*)t0)[3],t2);}

/* k2258 in k2247 in posix-error in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_2260(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word *a;
/* posix-common.scm:149: string-append */
t2=*((C_word*)lf[4]+1);
((C_proc5)(void*)(*((C_word*)t2+1)))(5,t2,((C_word*)t0)[2],((C_word*)t0)[3],lf[5],t1);}

/* ##sys#stat in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_fcall f_2263(C_word t1,C_word t2,C_word t3,C_word t4,C_word t5){
C_word tmp;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word ab[17],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)trf_2263,NULL,5,t1,t2,t3,t4,t5);}
t6=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_2267,a[2]=t4,a[3]=t1,a[4]=t5,a[5]=t2,tmp=(C_word)a,a+=6,tmp);
if(C_truep(C_fixnump(t2))){
t7=t6;
f_2267(2,t7,C_fstat(t2));}
else{
if(C_truep(C_i_stringp(t2))){
t7=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_2291,a[2]=t6,a[3]=t3,tmp=(C_word)a,a+=4,tmp);
t8=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_2298,a[2]=t7,a[3]=t5,tmp=(C_word)a,a+=4,tmp);
t9=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_2302,a[2]=t8,tmp=(C_word)a,a+=3,tmp);
/* posix-common.scm:192: ##sys#expand-home-path */
((C_proc3)C_fast_retrieve_proc(*((C_word*)lf[14]+1)))(3,*((C_word*)lf[14]+1),t9,t2);}
else{
/* posix-common.scm:198: ##sys#signal-hook */
t7=*((C_word*)lf[3]+1);
((C_proc6)(void*)(*((C_word*)t7+1)))(6,t7,t6,lf[15],t5,lf[16],t2);}}}

/* k2525 in mode in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_2527(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word *a;
/* posix-common.scm:280: ##sys#make-c-string */
((C_proc4)C_fast_retrieve_proc(*((C_word*)lf[12]+1)))(4,*((C_word*)lf[12]+1),((C_word*)t0)[2],t1,((C_word*)t0)[3]);}

/* k5473 in %process in k3893 in k3523 in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_5475(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word ab[9],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_5475,2,t0,t1);}
t2=(*a=C_CLOSURE_TYPE|8,a[1]=(C_word)f_5478,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[4],a[5]=((C_word*)t0)[5],a[6]=((C_word*)t0)[6],a[7]=((C_word*)t0)[7],a[8]=((C_word*)t0)[8],tmp=(C_word)a,a+=9,tmp);
if(C_truep(((C_word*)t0)[5])){
/* posixwin.scm:1436: chkstrlst */
t3=((C_word*)t0)[9];
f_5434(t3,t2,((C_word*)t0)[5]);}
else{
t3=t2;
f_5478(2,t3,C_SCHEME_UNDEFINED);}}

/* k5476 in k5473 in %process in k3893 in k3523 in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_5478(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word ab[13],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_5478,2,t0,t1);}
t2=(*a=C_CLOSURE_TYPE|8,a[1]=(C_word)f_5483,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[4],a[5]=((C_word*)t0)[5],a[6]=((C_word*)t0)[6],a[7]=((C_word*)t0)[7],a[8]=((C_word)li138),tmp=(C_word)a,a+=9,tmp);
t3=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_5489,a[2]=((C_word*)t0)[6],a[3]=((C_word)li139),tmp=(C_word)a,a+=4,tmp);
/* posixwin.scm:1437: ##sys#call-with-values */
C_call_with_values(4,0,((C_word*)t0)[8],t2,t3);}

/* regular-file? in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_2446(C_word c,C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word t4;
C_word ab[3],*a=ab;
if(c!=3) C_bad_argc_2(c,3,t0);
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr3,(void*)f_2446,3,t0,t1,t2);}
t3=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_2454,a[2]=t1,tmp=(C_word)a,a+=3,tmp);
/* posix-common.scm:247: file-type */
t4=*((C_word*)lf[26]+1);
((C_proc5)(void*)(*((C_word*)t4+1)))(5,t4,t3,t2,C_SCHEME_FALSE,C_SCHEME_FALSE);}

/* k4248 in with-input-from-pipe in k3893 in k3523 in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_4250(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word ab[19],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_4250,2,t0,t1);}
t2=t1;
t3=t2;
t4=(*a=C_VECTOR_TYPE|1,a[1]=t3,tmp=(C_word)a,a+=2,tmp);
t5=C_SCHEME_FALSE;
t6=(*a=C_VECTOR_TYPE|1,a[1]=t5,tmp=(C_word)a,a+=2,tmp);
t7=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_4255,a[2]=t6,a[3]=t4,a[4]=((C_word)li88),tmp=(C_word)a,a+=5,tmp);
t8=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_4260,a[2]=t2,a[3]=((C_word*)t0)[2],a[4]=((C_word)li90),tmp=(C_word)a,a+=5,tmp);
t9=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_4275,a[2]=t4,a[3]=t6,a[4]=((C_word)li91),tmp=(C_word)a,a+=5,tmp);
/* posixwin.scm:987: ##sys#dynamic-wind */
t10=*((C_word*)lf[91]+1);
((C_proc5)(void*)(*((C_word*)t10+1)))(5,t10,((C_word*)t0)[3],t7,t8,t9);}

/* a4254 in k4248 in with-input-from-pipe in k3893 in k3523 in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_4255(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word *a;
if(c!=2) C_bad_argc_2(c,2,t0);
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_4255,2,t0,t1);}
t2=C_mutate2(((C_word *)((C_word*)t0)[2])+1,*((C_word*)lf[193]+1));
t3=C_mutate2((C_word*)lf[193]+1 /* (set! ##sys#standard-input ...) */,((C_word*)((C_word*)t0)[3])[1]);
t4=t1;
((C_proc2)(void*)(*((C_word*)t4+1)))(2,t4,C_SCHEME_UNDEFINED);}

/* check-time-vector in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_fcall f_3294(C_word t1,C_word t2,C_word t3){
C_word tmp;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word *a;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)trf_3294,NULL,3,t1,t2,t3);}
t4=C_i_check_vector_2(t3,t2);
t5=C_block_size(t3);
if(C_truep(C_fixnum_lessp(t5,C_fix(10)))){
/* posix-common.scm:483: ##sys#error */
t6=*((C_word*)lf[45]+1);
((C_proc5)(void*)(*((C_word*)t6+1)))(5,t6,t1,t2,lf[103],t3);}
else{
t6=C_SCHEME_UNDEFINED;
t7=t1;
((C_proc2)(void*)(*((C_word*)t7+1)))(2,t7,t6);}}

/* a4265 in a4259 in k4248 in with-input-from-pipe in k3893 in k3523 in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_4266(C_word c,C_word t0,C_word t1,...){
C_word tmp;
C_word t2;
va_list v;
C_word *a,c2=c;
C_save_rest(t1,c2,2);
if(!C_demand(c*C_SIZEOF_PAIR+4)){
C_save_and_reclaim((void*)tr2r,(void*)f_4266r,2,t0,t1);}
else{
a=C_alloc((c-2)*3);
t2=C_restore_rest(a,C_rest_count(0));
f_4266r(t0,t1,t2);}}

static void C_ccall f_4266r(C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word t4;
C_word *a=C_alloc(4);
t3=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_4270,a[2]=t1,a[3]=t2,tmp=(C_word)a,a+=4,tmp);
/* posixwin.scm:993: close-input-pipe */
t4=*((C_word*)lf[186]+1);
((C_proc3)(void*)(*((C_word*)t4+1)))(3,t4,t3,((C_word*)t0)[2]);}

/* k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_3292(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word t11;
C_word t12;
C_word t13;
C_word t14;
C_word ab[29],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_3292,2,t0,t1);}
t2=C_mutate2((C_word*)lf[101]+1 /* (set! file-creation-mode ...) */,t1);
t3=C_mutate2(&lf[102] /* (set! check-time-vector ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_3294,a[2]=((C_word)li51),tmp=(C_word)a,a+=3,tmp));
t4=C_mutate2((C_word*)lf[104]+1 /* (set! seconds->local-time ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_3313,a[2]=((C_word)li52),tmp=(C_word)a,a+=3,tmp));
t5=C_mutate2((C_word*)lf[107]+1 /* (set! seconds->utc-time ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_3334,a[2]=((C_word)li53),tmp=(C_word)a,a+=3,tmp));
t6=C_mutate2((C_word*)lf[108]+1 /* (set! seconds->string ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_3365,a[2]=((C_word)li54),tmp=(C_word)a,a+=3,tmp));
t7=C_fix((C_word)sizeof(struct tm));
t8=C_mutate2((C_word*)lf[110]+1 /* (set! local-time->seconds ...) */,(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_3403,a[2]=t7,a[3]=((C_word)li55),tmp=(C_word)a,a+=4,tmp));
t9=C_fix((C_word)sizeof(struct tm));
t10=C_mutate2((C_word*)lf[114]+1 /* (set! time->string ...) */,(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_3448,a[2]=t9,a[3]=((C_word)li56),tmp=(C_word)a,a+=4,tmp));
t11=C_mutate2((C_word*)lf[117]+1 /* (set! set-signal-handler! ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_3510,a[2]=((C_word)li57),tmp=(C_word)a,a+=3,tmp));
t12=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_3525,a[2]=((C_word*)t0)[2],tmp=(C_word)a,a+=3,tmp);
t13=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_6155,a[2]=((C_word)li194),tmp=(C_word)a,a+=3,tmp);
/* posix-common.scm:536: getter-with-setter */
t14=*((C_word*)lf[401]+1);
((C_proc4)(void*)(*((C_word*)t14+1)))(4,t14,t12,t13,*((C_word*)lf[117]+1));}

/* check in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_fcall f_2556(C_word t1,C_word t2,C_word t3,C_word t4,C_word t5){
C_word tmp;
C_word t6;
C_word t7;
C_word ab[4],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)trf_2556,NULL,5,t1,t2,t3,t4,t5);}
if(C_truep(C_null_pointerp(t5))){
/* posix-common.scm:291: posix-error */
t6=lf[2];
f_2245(6,t6,t1,lf[10],t2,lf[51],t3);}
else{
t6=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_2569,a[2]=t5,a[3]=t1,tmp=(C_word)a,a+=4,tmp);
/* posix-common.scm:292: ##sys#make-port */
((C_proc6)C_fast_retrieve_proc(*((C_word*)lf[52]+1)))(6,*((C_word*)lf[52]+1),t6,t4,*((C_word*)lf[53]+1),lf[54],lf[55]);}}

/* a5482 in k5476 in k5473 in %process in k3893 in k3523 in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_5483(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word *a;
if(c!=2) C_bad_argc_2(c,2,t0);
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_5483,2,t0,t1);}
/* posixwin.scm:1437: ##sys#process */
t2=*((C_word*)lf[317]+1);
((C_proc10)(void*)(*((C_word*)t2+1)))(10,t2,t1,((C_word*)t0)[2],((C_word*)((C_word*)t0)[3])[1],((C_word*)((C_word*)t0)[4])[1],((C_word*)t0)[5],C_SCHEME_TRUE,C_SCHEME_TRUE,((C_word*)t0)[6],((C_word*)((C_word*)t0)[7])[1]);}

/* a5488 in k5476 in k5473 in %process in k3893 in k3523 in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_5489(C_word c,C_word t0,C_word t1,C_word t2,C_word t3,C_word t4,C_word t5){
C_word tmp;
C_word t6;
C_word *a;
if(c!=6) C_bad_argc_2(c,6,t0);
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr6,(void*)f_5489,6,t0,t1,t2,t3,t4,t5);}
if(C_truep(((C_word*)t0)[2])){
/* posixwin.scm:1439: values */
C_values(6,0,t1,t2,t3,t4,t5);}
else{
/* posixwin.scm:1440: values */
C_values(5,0,t1,t2,t3,t4);}}

/* with-output-to-pipe in k3893 in k3523 in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_4280(C_word c,C_word t0,C_word t1,C_word t2,C_word t3,...){
C_word tmp;
C_word t4;
va_list v;
C_word *a,c2=c;
C_save_rest(t3,c2,4);
if(c<4) C_bad_min_argc_2(c,4,t0);
if(!C_demand(c*C_SIZEOF_PAIR+4)){
C_save_and_reclaim((void*)tr4r,(void*)f_4280r,4,t0,t1,t2,t3);}
else{
a=C_alloc((c-4)*3);
t4=C_restore_rest(a,C_rest_count(0));
f_4280r(t0,t1,t2,t3,t4);}}

static void C_ccall f_4280r(C_word t0,C_word t1,C_word t2,C_word t3,C_word t4){
C_word tmp;
C_word t5;
C_word t6;
C_word *a=C_alloc(4);
t5=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_4284,a[2]=t3,a[3]=t1,tmp=(C_word)a,a+=4,tmp);
C_apply(5,0,t5,*((C_word*)lf[185]+1),t2,t4);}

/* k4282 in with-output-to-pipe in k3893 in k3523 in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_4284(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word ab[19],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_4284,2,t0,t1);}
t2=t1;
t3=t2;
t4=(*a=C_VECTOR_TYPE|1,a[1]=t3,tmp=(C_word)a,a+=2,tmp);
t5=C_SCHEME_FALSE;
t6=(*a=C_VECTOR_TYPE|1,a[1]=t5,tmp=(C_word)a,a+=2,tmp);
t7=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_4289,a[2]=t6,a[3]=t4,a[4]=((C_word)li93),tmp=(C_word)a,a+=5,tmp);
t8=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_4294,a[2]=t2,a[3]=((C_word*)t0)[2],a[4]=((C_word)li95),tmp=(C_word)a,a+=5,tmp);
t9=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_4309,a[2]=t4,a[3]=t6,a[4]=((C_word)li96),tmp=(C_word)a,a+=5,tmp);
/* posixwin.scm:997: ##sys#dynamic-wind */
t10=*((C_word*)lf[91]+1);
((C_proc5)(void*)(*((C_word*)t10+1)))(5,t10,((C_word*)t0)[3],t7,t8,t9);}

/* k2906 in k2823 in k2820 in k2817 in k2802 in directory in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_2908(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word *a;
/* posix-common.scm:379: ##sys#make-c-string */
((C_proc4)C_fast_retrieve_proc(*((C_word*)lf[12]+1)))(4,*((C_word*)lf[12]+1),((C_word*)t0)[2],t1,lf[29]);}

/* f_2585 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_2585(C_word c,C_word t0,C_word t1,C_word t2,...){
C_word tmp;
C_word t3;
va_list v;
C_word *a,c2=c;
C_save_rest(t2,c2,3);
if(c<3) C_bad_min_argc_2(c,3,t0);
if(!C_demand(c*C_SIZEOF_PAIR+5)){
C_save_and_reclaim((void*)tr3r,(void*)f_2585r,3,t0,t1,t2);}
else{
a=C_alloc((c-3)*3);
t3=C_restore_rest(a,C_rest_count(0));
f_2585r(t0,t1,t2,t3);}}

static void C_ccall f_2585r(C_word t0,C_word t1,C_word t2,C_word t3){
C_word tmp;
C_word t4;
C_word t5;
C_word t6;
C_word *a=C_alloc(5);
t4=C_i_check_exact_2(t2,lf[57]);
t5=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_2597,a[2]=t2,a[3]=((C_word*)t0)[2],a[4]=t1,tmp=(C_word)a,a+=5,tmp);
/* posix-common.scm:302: mode */
f_2519(t5,C_SCHEME_FALSE,t3,lf[57]);}

/* k2581 */
static void C_ccall f_2583(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word ab[2],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_2583,2,t0,t1);}
t2=C_fdopen(&a,2,((C_word*)t0)[2],t1);
/* posix-common.scm:298: check */
f_2556(((C_word*)t0)[4],lf[56],((C_word*)t0)[2],C_SCHEME_TRUE,t2);}

/* f_3235 in k3258 in k3255 in k3252 in k3249 in k3246 in k3243 in find-files in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_3235(C_word c,C_word t0,C_word t1,...){
C_word tmp;
C_word t2;
C_word *a;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_3235,2,t0,t1);}
t2=t1;
((C_proc2)(void*)(*((C_word*)t2+1)))(2,t2,C_fixnum_lessp(((C_word*)((C_word*)t0)[2])[1],((C_word*)t0)[3]));}

/* a3264 in k3255 in k3252 in k3249 in k3246 in k3243 in find-files in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_3265(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word *a;
if(c!=2) C_bad_argc_2(c,2,t0);
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_3265,2,t0,t1);}
t2=t1;
((C_proc2)(void*)(*((C_word*)t2+1)))(2,t2,C_SCHEME_FALSE);}

/* a3267 in k3252 in k3249 in k3246 in k3243 in find-files in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_3268(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word *a;
if(c!=2) C_bad_argc_2(c,2,t0);
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_3268,2,t0,t1);}
t2=t1;
((C_proc2)(void*)(*((C_word*)t2+1)))(2,t2,C_SCHEME_FALSE);}

/* k3258 in k3255 in k3252 in k3249 in k3246 in k3243 in find-files in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_3260(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word t11;
C_word t12;
C_word t13;
C_word t14;
C_word t15;
C_word ab[17],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_3260,2,t0,t1);}
t2=((C_word*)t0)[2];
t3=((C_word*)t0)[3];
t4=((C_word*)t0)[4];
t5=((C_word*)t0)[5];
t6=((C_word*)t0)[6];
t7=((C_word*)t0)[7];
t8=t1;
t9=((C_word*)t0)[8];
t10=C_i_check_string_2(t3,lf[74]);
t11=C_fix(0);
t12=(*a=C_VECTOR_TYPE|1,a[1]=t11,tmp=(C_word)a,a+=2,tmp);
t13=(*a=C_CLOSURE_TYPE|9,a[1]=(C_word)f_3052,a[2]=t8,a[3]=t5,a[4]=t12,a[5]=t9,a[6]=t2,a[7]=t6,a[8]=t3,a[9]=t4,tmp=(C_word)a,a+=10,tmp);
if(C_truep(t7)){
if(C_truep(C_fixnump(t7))){
t14=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_3235,a[2]=t12,a[3]=t7,a[4]=((C_word)li40),tmp=(C_word)a,a+=5,tmp);
t15=t13;
f_3052(t15,t14);}
else{
t14=t13;
f_3052(t14,t7);}}
else{
t14=t13;
f_3052(t14,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_3227,a[2]=((C_word)li41),tmp=(C_word)a,a+=3,tmp));}}

/* mode in k3893 in k3523 in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_fcall f_4488(C_word t1,C_word t2,C_word t3,C_word t4){
C_word tmp;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word ab[4],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)trf_4488,NULL,4,t1,t2,t3,t4);}
t5=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_4496,a[2]=t1,a[3]=t4,tmp=(C_word)a,a+=4,tmp);
if(C_truep(C_i_pairp(t3))){
t6=t3;
t7=C_u_i_car(t6);
t8=C_eqp(t7,lf[44]);
if(C_truep(t8)){
t9=t2;
if(C_truep(t9)){
/* posixwin.scm:1147: ##sys#error */
t10=*((C_word*)lf[45]+1);
((C_proc4)(void*)(*((C_word*)t10+1)))(4,t10,t5,lf[268],t7);}
else{
/* posixwin.scm:1143: ##sys#make-c-string */
((C_proc4)C_fast_retrieve_proc(*((C_word*)lf[12]+1)))(4,*((C_word*)lf[12]+1),t1,lf[269],t4);}}
else{
/* posixwin.scm:1148: ##sys#error */
t9=*((C_word*)lf[45]+1);
((C_proc4)(void*)(*((C_word*)t9+1)))(4,t9,t5,lf[270],t7);}}
else{
if(C_truep(t2)){
/* posixwin.scm:1143: ##sys#make-c-string */
((C_proc4)C_fast_retrieve_proc(*((C_word*)lf[12]+1)))(4,*((C_word*)lf[12]+1),t1,lf[271],t4);}
else{
/* posixwin.scm:1143: ##sys#make-c-string */
((C_proc4)C_fast_retrieve_proc(*((C_word*)lf[12]+1)))(4,*((C_word*)lf[12]+1),t1,lf[272],t4);}}}

/* k2567 in check in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_2569(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word *a;
t2=C_set_file_ptr(t1,((C_word*)t0)[2]);
t3=t1;
t4=((C_word*)t0)[3];
((C_proc2)(void*)(*((C_word*)t4+1)))(2,t4,t3);}

/* f_2486 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_2486(C_word c,C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word t4;
C_word ab[3],*a=ab;
if(c!=3) C_bad_argc_2(c,3,t0);
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr3,(void*)f_2486,3,t0,t1,t2);}
t3=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_2494,a[2]=t1,tmp=(C_word)a,a+=3,tmp);
/* posix-common.scm:259: file-type */
t4=*((C_word*)lf[26]+1);
((C_proc5)(void*)(*((C_word*)t4+1)))(5,t4,t3,t2,C_SCHEME_FALSE,C_SCHEME_FALSE);}

/* k5250 in process-run in k3893 in k3523 in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_fcall f_5252(C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word ab[4],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)trf_5252,NULL,2,t0,t1);}
if(C_truep(t1)){
/* posixwin.scm:1372: process-spawn */
t2=*((C_word*)lf[308]+1);
((C_proc5)(void*)(*((C_word*)t2+1)))(5,t2,((C_word*)t0)[2],*((C_word*)lf[296]+1),((C_word*)t0)[3],t1);}
else{
t2=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_5265,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],tmp=(C_word)a,a+=4,tmp);
/* posixwin.scm:1373: ##sys#shell-command */
t3=*((C_word*)lf[310]+1);
((C_proc2)(void*)(*((C_word*)t3+1)))(2,t3,t2);}}

/* k2482 */
static void C_ccall f_2484(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word *a;
t2=((C_word*)t0)[2];
((C_proc2)(void*)(*((C_word*)t2+1)))(2,t2,C_eqp(lf[30],t1));}

/* a4293 in k4282 in with-output-to-pipe in k3893 in k3523 in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_4294(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word ab[4],*a=ab;
if(c!=2) C_bad_argc_2(c,2,t0);
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_4294,2,t0,t1);}
t2=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_4300,a[2]=((C_word*)t0)[2],a[3]=((C_word)li94),tmp=(C_word)a,a+=4,tmp);
/* posixwin.scm:1000: ##sys#call-with-values */
C_call_with_values(4,0,t1,((C_word*)t0)[3],t2);}

/* k3252 in k3249 in k3246 in k3243 in find-files in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_3254(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word ab[12],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_3254,2,t0,t1);}
t2=t1;
t3=(*a=C_CLOSURE_TYPE|8,a[1]=(C_word)f_3257,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[4],a[5]=((C_word*)t0)[5],a[6]=((C_word*)t0)[6],a[7]=t2,a[8]=((C_word*)t0)[7],tmp=(C_word)a,a+=9,tmp);
t4=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_3268,a[2]=((C_word)li43),tmp=(C_word)a,a+=3,tmp);
/* posix-common.scm:454: ##sys#get-keyword */
((C_proc5)C_fast_retrieve_proc(*((C_word*)lf[96]+1)))(5,*((C_word*)lf[96]+1),t3,lf[75],((C_word*)t0)[7],t4);}

/* k3255 in k3252 in k3249 in k3246 in k3243 in find-files in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_3257(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word ab[12],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_3257,2,t0,t1);}
t2=t1;
t3=(*a=C_CLOSURE_TYPE|8,a[1]=(C_word)f_3260,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[4],a[5]=((C_word*)t0)[5],a[6]=((C_word*)t0)[6],a[7]=((C_word*)t0)[7],a[8]=t2,tmp=(C_word)a,a+=9,tmp);
t4=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_3265,a[2]=((C_word)li42),tmp=(C_word)a,a+=3,tmp);
/* posix-common.scm:454: ##sys#get-keyword */
((C_proc5)C_fast_retrieve_proc(*((C_word*)lf[96]+1)))(5,*((C_word*)lf[96]+1),t3,lf[76],((C_word*)t0)[8],t4);}

/* k3249 in k3246 in k3243 in find-files in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_3251(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word ab[11],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_3251,2,t0,t1);}
t2=t1;
t3=(*a=C_CLOSURE_TYPE|7,a[1]=(C_word)f_3254,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[4],a[5]=((C_word*)t0)[5],a[6]=t2,a[7]=((C_word*)t0)[6],tmp=(C_word)a,a+=8,tmp);
t4=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_3271,a[2]=((C_word)li44),tmp=(C_word)a,a+=3,tmp);
/* posix-common.scm:454: ##sys#get-keyword */
((C_proc5)C_fast_retrieve_proc(*((C_word*)lf[96]+1)))(5,*((C_word*)lf[96]+1),t3,lf[97],((C_word*)t0)[6],t4);}

/* file-execute-access? in k3893 in k3523 in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_4479(C_word c,C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr3,(void*)f_4479,3,t0,t1,t2);}
/* posixwin.scm:1127: check */
f_4443(t1,t2,C_fix((C_word)2),lf[267]);}

/* f_2599 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_2599(C_word c,C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word ab[4],*a=ab;
if(c!=3) C_bad_argc_2(c,3,t0);
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr3,(void*)f_2599,3,t0,t1,t2);}
t3=t2;
t4=C_i_check_port_2(t3,C_fix(0),C_SCHEME_TRUE,lf[58]);
t5=C_slot(t2,C_fix(7));
t6=C_eqp(lf[33],t5);
if(C_truep(t6)){
t7=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_2615,a[2]=t1,tmp=(C_word)a,a+=3,tmp);
/* posix-common.scm:312: ##sys#port-data */
((C_proc3)C_fast_retrieve_proc(*((C_word*)lf[59]+1)))(3,*((C_word*)lf[59]+1),t7,t2);}
else{
t7=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_2641,a[2]=t1,a[3]=t2,tmp=(C_word)a,a+=4,tmp);
/* posix-common.scm:313: ##sys#peek-unsigned-integer */
((C_proc4)C_fast_retrieve_proc(*((C_word*)lf[62]+1)))(4,*((C_word*)lf[62]+1),t7,t2,C_fix(0));}}

/* k2595 */
static void C_ccall f_2597(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word ab[2],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_2597,2,t0,t1);}
t2=C_fdopen(&a,2,((C_word*)t0)[2],t1);
/* posix-common.scm:302: check */
f_2556(((C_word*)t0)[4],lf[57],((C_word*)t0)[2],C_SCHEME_FALSE,t2);}

/* f_2476 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_2476(C_word c,C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word t4;
C_word ab[3],*a=ab;
if(c!=3) C_bad_argc_2(c,3,t0);
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr3,(void*)f_2476,3,t0,t1,t2);}
t3=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_2484,a[2]=t1,tmp=(C_word)a,a+=3,tmp);
/* posix-common.scm:256: file-type */
t4=*((C_word*)lf[26]+1);
((C_proc5)(void*)(*((C_word*)t4+1)))(5,t4,t3,t2,C_SCHEME_FALSE,C_SCHEME_FALSE);}

/* k5263 in k5250 in process-run in k3893 in k3523 in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_5265(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word ab[4],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_5265,2,t0,t1);}
t2=t1;
t3=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_5269,a[2]=((C_word*)t0)[2],a[3]=t2,tmp=(C_word)a,a+=4,tmp);
/* posixwin.scm:1373: ##sys#shell-command-arguments */
t4=*((C_word*)lf[314]+1);
((C_proc3)(void*)(*((C_word*)t4+1)))(3,t4,t3,((C_word*)t0)[3]);}

/* k2472 */
static void C_ccall f_2474(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word *a;
t2=((C_word*)t0)[2];
((C_proc2)(void*)(*((C_word*)t2+1)))(2,t2,C_eqp(lf[31],t1));}

/* k5267 in k5263 in k5250 in process-run in k3893 in k3523 in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_5269(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word *a;
/* posixwin.scm:1373: process-spawn */
t2=*((C_word*)lf[308]+1);
((C_proc5)(void*)(*((C_word*)t2+1)))(5,t2,((C_word*)t0)[2],*((C_word*)lf[296]+1),((C_word*)t0)[3],t1);}

/* file-write-access? in k3893 in k3523 in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_4473(C_word c,C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr3,(void*)f_4473,3,t0,t1,t2);}
/* posixwin.scm:1126: check */
f_4443(t1,t2,C_fix((C_word)4),lf[266]);}

/* a3284 in find-files in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_3285(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word ab[3],*a=ab;
if(c!=2) C_bad_argc_2(c,2,t0);
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_3285,2,t0,t1);}
t2=t1;
((C_proc2)(void*)(*((C_word*)t2+1)))(2,t2,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_3287,a[2]=((C_word)li48),tmp=(C_word)a,a+=3,tmp));}

/* f_3287 in a3284 in find-files in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_3287(C_word c,C_word t0,C_word t1,...){
C_word tmp;
C_word t2;
C_word *a;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_3287,2,t0,t1);}
t2=t1;
((C_proc2)(void*)(*((C_word*)t2+1)))(2,t2,C_SCHEME_TRUE);}

/* a4230 in k4224 in call-with-output-pipe in k3893 in k3523 in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_4231(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word *a;
if(c!=2) C_bad_argc_2(c,2,t0);
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_4231,2,t0,t1);}
/* posixwin.scm:981: proc */
t2=((C_word*)t0)[2];
((C_proc3)C_fast_retrieve_proc(t2))(3,t2,t1,((C_word*)t0)[3]);}

/* with-input-from-pipe in k3893 in k3523 in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_4246(C_word c,C_word t0,C_word t1,C_word t2,C_word t3,...){
C_word tmp;
C_word t4;
va_list v;
C_word *a,c2=c;
C_save_rest(t3,c2,4);
if(c<4) C_bad_min_argc_2(c,4,t0);
if(!C_demand(c*C_SIZEOF_PAIR+4)){
C_save_and_reclaim((void*)tr4r,(void*)f_4246r,4,t0,t1,t2,t3);}
else{
a=C_alloc((c-4)*3);
t4=C_restore_rest(a,C_rest_count(0));
f_4246r(t0,t1,t2,t3,t4);}}

static void C_ccall f_4246r(C_word t0,C_word t1,C_word t2,C_word t3,C_word t4){
C_word tmp;
C_word t5;
C_word t6;
C_word *a=C_alloc(4);
t5=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_4250,a[2]=t3,a[3]=t1,tmp=(C_word)a,a+=4,tmp);
C_apply(5,0,t5,*((C_word*)lf[181]+1),t2,t4);}

/* k2355 in file-size in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_2357(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word ab[4],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_2357,2,t0,t1);}
t2=((C_word*)t0)[2];
((C_proc2)(void*)(*((C_word*)t2+1)))(2,t2,C_a_double_to_num(&a,C_statbuf.st_size));}

/* file-type in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_2359(C_word c,C_word t0,C_word t1,C_word t2,...){
C_word tmp;
C_word t3;
va_list v;
C_word *a,c2=c;
C_save_rest(t2,c2,3);
if(c<3) C_bad_min_argc_2(c,3,t0);
if(!C_demand(c*C_SIZEOF_PAIR+3)){
C_save_and_reclaim((void*)tr3r,(void*)f_2359r,3,t0,t1,t2);}
else{
a=C_alloc((c-3)*3);
t3=C_restore_rest(a,C_rest_count(0));
f_2359r(t0,t1,t2,t3);}}

static void C_ccall f_2359r(C_word t0,C_word t1,C_word t2,C_word t3){
C_word tmp;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word t11;
C_word t12;
C_word t13;
C_word *a=C_alloc(3);
t4=C_i_nullp(t3);
t5=(C_truep(t4)?C_SCHEME_FALSE:C_i_car(t3));
t6=C_i_nullp(t3);
t7=(C_truep(t6)?C_SCHEME_END_OF_LIST:C_i_cdr(t3));
t8=C_i_nullp(t7);
t9=(C_truep(t8)?C_SCHEME_TRUE:C_i_car(t7));
t10=C_i_nullp(t7);
t11=(C_truep(t10)?C_SCHEME_END_OF_LIST:C_i_cdr(t7));
t12=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_2378,a[2]=t1,tmp=(C_word)a,a+=3,tmp);
/* posix-common.scm:235: ##sys#stat */
f_2263(t12,t2,t5,t9,lf[26]);}

/* f_2571 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_2571(C_word c,C_word t0,C_word t1,C_word t2,...){
C_word tmp;
C_word t3;
va_list v;
C_word *a,c2=c;
C_save_rest(t2,c2,3);
if(c<3) C_bad_min_argc_2(c,3,t0);
if(!C_demand(c*C_SIZEOF_PAIR+5)){
C_save_and_reclaim((void*)tr3r,(void*)f_2571r,3,t0,t1,t2);}
else{
a=C_alloc((c-3)*3);
t3=C_restore_rest(a,C_rest_count(0));
f_2571r(t0,t1,t2,t3);}}

static void C_ccall f_2571r(C_word t0,C_word t1,C_word t2,C_word t3){
C_word tmp;
C_word t4;
C_word t5;
C_word t6;
C_word *a=C_alloc(5);
t4=C_i_check_exact_2(t2,lf[56]);
t5=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_2583,a[2]=t2,a[3]=((C_word*)t0)[2],a[4]=t1,tmp=(C_word)a,a+=5,tmp);
/* posix-common.scm:298: mode */
f_2519(t5,C_SCHEME_TRUE,t3,lf[56]);}

/* k2349 in file-permissions in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_2351(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word *a;
t2=((C_word*)t0)[2];
((C_proc2)(void*)(*((C_word*)t2+1)))(2,t2,C_fix(C_MOST_POSITIVE_FIXNUM&(C_word)C_statbuf.st_mode));}

/* file-size in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_2353(C_word c,C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word t4;
C_word ab[3],*a=ab;
if(c!=3) C_bad_argc_2(c,3,t0);
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr3,(void*)f_2353,3,t0,t1,t2);}
t3=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_2357,a[2]=t1,tmp=(C_word)a,a+=3,tmp);
/* posix-common.scm:232: ##sys#stat */
f_2263(t3,t2,C_SCHEME_FALSE,C_SCHEME_TRUE,lf[25]);}

/* k5419 in process in k3893 in k3523 in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_5421(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word *a;
/* posixwin.scm:1402: string-intersperse */
t2=*((C_word*)lf[321]+1);
((C_proc3)(void*)(*((C_word*)t2+1)))(3,t2,((C_word*)t0)[2],t1);}

/* k4494 in mode in k3893 in k3523 in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_4496(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word *a;
/* posixwin.scm:1143: ##sys#make-c-string */
((C_proc4)C_fast_retrieve_proc(*((C_word*)lf[12]+1)))(4,*((C_word*)lf[12]+1),((C_word*)t0)[2],t1,((C_word*)t0)[3]);}

/* a4236 in k4224 in call-with-output-pipe in k3893 in k3523 in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_4237(C_word c,C_word t0,C_word t1,...){
C_word tmp;
C_word t2;
va_list v;
C_word *a,c2=c;
C_save_rest(t1,c2,2);
if(!C_demand(c*C_SIZEOF_PAIR+4)){
C_save_and_reclaim((void*)tr2r,(void*)f_4237r,2,t0,t1);}
else{
a=C_alloc((c-2)*3);
t2=C_restore_rest(a,C_rest_count(0));
f_4237r(t0,t1,t2);}}

static void C_ccall f_4237r(C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word t4;
C_word *a=C_alloc(4);
t3=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_4241,a[2]=t1,a[3]=t2,tmp=(C_word)a,a+=4,tmp);
/* posixwin.scm:983: close-output-pipe */
t4=*((C_word*)lf[188]+1);
((C_proc3)(void*)(*((C_word*)t4+1)))(3,t4,t3,((C_word*)t0)[2]);}

/* k2254 in k2247 in posix-error in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_2256(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word *a;
C_apply(7,0,((C_word*)t0)[2],*((C_word*)lf[3]+1),((C_word*)t0)[3],((C_word*)t0)[4],t1,((C_word*)t0)[5]);}

/* k5399 in k5395 in k5391 in k5387 in k5343 in process in k3893 in k3523 in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_5401(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word ab[9],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_5401,2,t0,t1);}
t2=t1;
t3=(*a=C_CLOSURE_TYPE|8,a[1]=(C_word)f_5405,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[4],a[5]=((C_word*)t0)[5],a[6]=((C_word*)t0)[6],a[7]=((C_word*)t0)[7],a[8]=t2,tmp=(C_word)a,a+=9,tmp);
t4=(C_truep(((C_word*)t0)[8])?C_fix(0):C_fix(1));
t5=(C_truep(((C_word*)t0)[9])?C_fix(0):C_fix(2));
if(C_truep(((C_word*)t0)[10])){
/* posixwin.scm:1409: + */
C_plus(5,0,t3,t4,t5,C_fix(0));}
else{
/* posixwin.scm:1409: + */
C_plus(5,0,t3,t4,t5,C_fix(4));}}

/* k5403 in k5399 in k5395 in k5391 in k5387 in k5343 in process in k3893 in k3523 in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_5405(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word t11;
C_word t12;
C_word ab[9],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_5405,2,t0,t1);}
t2=((C_word*)t0)[2];
t3=((C_word*)t0)[3];
t4=((C_word*)t0)[4];
t5=((C_word*)t0)[5];
t6=((C_word*)t0)[6];
t7=((C_word*)t0)[7];
t8=((C_word*)t0)[8];
t9=t1;
t10=(*a=C_CLOSURE_TYPE|8,a[1]=(C_word)f_5280,a[2]=t5,a[3]=t6,a[4]=t7,a[5]=t8,a[6]=t9,a[7]=t2,a[8]=t4,tmp=(C_word)a,a+=9,tmp);
if(C_truep(t3)){
t11=C_i_foreign_string_argumentp(t3);
/* posixwin.scm:1396: ##sys#make-c-string */
((C_proc3)C_fast_retrieve_proc(*((C_word*)lf[12]+1)))(3,*((C_word*)lf[12]+1),t10,t11);}
else{
t11=t10;
f_5280(2,t11,C_SCHEME_FALSE);}}

/* k4200 in call-with-input-pipe in k3893 in k3523 in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_4202(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word ab[9],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_4202,2,t0,t1);}
t2=t1;
t3=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_4207,a[2]=((C_word*)t0)[2],a[3]=t2,a[4]=((C_word)li82),tmp=(C_word)a,a+=5,tmp);
t4=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_4213,a[2]=t2,a[3]=((C_word)li83),tmp=(C_word)a,a+=4,tmp);
/* posixwin.scm:971: ##sys#call-with-values */
C_call_with_values(4,0,((C_word*)t0)[3],t3,t4);}

/* k2247 in posix-error in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_2249(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word ab[15],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_2249,2,t0,t1);}
t2=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_2256,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[4],a[5]=((C_word*)t0)[5],tmp=(C_word)a,a+=6,tmp);
t3=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_2260,a[2]=t2,a[3]=((C_word*)t0)[6],tmp=(C_word)a,a+=4,tmp);
t4=C_a_i_bytevector(&a,1,C_fix(3));
t5=C_i_foreign_fixnum_argumentp(t1);
t6=stub67(t4,t5);
/* posix-common.scm:145: ##sys#peek-c-string */
t7=*((C_word*)lf[6]+1);
((C_proc4)(void*)(*((C_word*)t7+1)))(4,t7,t3,t6,C_fix(0));}

/* posix-error in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_2245(C_word c,C_word t0,C_word t1,C_word t2,C_word t3,C_word t4,...){
C_word tmp;
C_word t5;
va_list v;
C_word *a,c2=c;
C_save_rest(t4,c2,5);
if(c<5) C_bad_min_argc_2(c,5,t0);
if(!C_demand(c*C_SIZEOF_PAIR+7)){
C_save_and_reclaim((void*)tr5r,(void*)f_2245r,5,t0,t1,t2,t3,t4);}
else{
a=C_alloc((c-5)*3);
t5=C_restore_rest(a,C_rest_count(0));
f_2245r(t0,t1,t2,t3,t4,t5);}}

static void C_ccall f_2245r(C_word t0,C_word t1,C_word t2,C_word t3,C_word t4,C_word t5){
C_word tmp;
C_word t6;
C_word t7;
C_word *a=C_alloc(7);
t6=(*a=C_CLOSURE_TYPE|6,a[1]=(C_word)f_2249,a[2]=t1,a[3]=t2,a[4]=t3,a[5]=t5,a[6]=t4,tmp=(C_word)a,a+=7,tmp);
/* posix-common.scm:148: ##sys#update-errno */
((C_proc2)C_fast_retrieve_proc(*((C_word*)lf[7]+1)))(2,*((C_word*)lf[7]+1),t6);}

/* k4268 in a4265 in a4259 in k4248 in with-input-from-pipe in k3893 in k3523 in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_4270(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word *a;
C_apply_values(3,0,((C_word*)t0)[2],((C_word*)t0)[3]);}

/* a4274 in k4248 in with-input-from-pipe in k3893 in k3523 in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_4275(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word *a;
if(c!=2) C_bad_argc_2(c,2,t0);
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_4275,2,t0,t1);}
t2=C_mutate2(((C_word *)((C_word*)t0)[2])+1,*((C_word*)lf[193]+1));
t3=C_mutate2((C_word*)lf[193]+1 /* (set! ##sys#standard-input ...) */,((C_word*)((C_word*)t0)[3])[1]);
t4=t1;
((C_proc2)(void*)(*((C_word*)t4+1)))(2,t4,C_SCHEME_UNDEFINED);}

/* k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_2233(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word ab[18],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_2233,2,t0,t1);}
t2=C_mutate2(&lf[2] /* (set! posix-error ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_2245,a[2]=((C_word)li0),tmp=(C_word)a,a+=3,tmp));
t3=C_mutate2((C_word*)lf[8]+1 /* (set! ##sys#posix-error ...) */,lf[2]);
t4=C_mutate2(&lf[9] /* (set! ##sys#stat ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_2263,a[2]=((C_word)li1),tmp=(C_word)a,a+=3,tmp));
t5=C_mutate2((C_word*)lf[17]+1 /* (set! file-stat ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_2307,a[2]=((C_word)li2),tmp=(C_word)a,a+=3,tmp));
t6=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_2327,a[2]=((C_word*)t0)[2],tmp=(C_word)a,a+=3,tmp);
t7=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_6195,a[2]=((C_word)li197),tmp=(C_word)a,a+=3,tmp);
t8=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_6201,a[2]=((C_word)li198),tmp=(C_word)a,a+=3,tmp);
/* posix-common.scm:215: getter-with-setter */
t9=*((C_word*)lf[401]+1);
((C_proc5)(void*)(*((C_word*)t9+1)))(5,t9,t6,t7,t8,lf[406]);}

/* k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_2230(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word ab[3],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_2230,2,t0,t1);}
t2=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_2233,a[2]=((C_word*)t0)[2],tmp=(C_word)a,a+=3,tmp);
C_ports_toplevel(2,C_SCHEME_UNDEFINED,t2);}

/* a4288 in k4282 in with-output-to-pipe in k3893 in k3523 in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_4289(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word *a;
if(c!=2) C_bad_argc_2(c,2,t0);
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_4289,2,t0,t1);}
t2=C_mutate2(((C_word *)((C_word*)t0)[2])+1,*((C_word*)lf[195]+1));
t3=C_mutate2((C_word*)lf[195]+1 /* (set! ##sys#standard-output ...) */,((C_word*)((C_word*)t0)[3])[1]);
t4=t1;
((C_proc2)(void*)(*((C_word*)t4+1)))(2,t4,C_SCHEME_UNDEFINED);}

/* k2225 in k2222 in k2219 */
static void C_ccall f_2227(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word ab[3],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_2227,2,t0,t1);}
t2=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_2230,a[2]=((C_word*)t0)[2],tmp=(C_word)a,a+=3,tmp);
C_files_toplevel(2,C_SCHEME_UNDEFINED,t2);}

/* call-with-output-pipe in k3893 in k3523 in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_4222(C_word c,C_word t0,C_word t1,C_word t2,C_word t3,...){
C_word tmp;
C_word t4;
va_list v;
C_word *a,c2=c;
C_save_rest(t3,c2,4);
if(c<4) C_bad_min_argc_2(c,4,t0);
if(!C_demand(c*C_SIZEOF_PAIR+4)){
C_save_and_reclaim((void*)tr4r,(void*)f_4222r,4,t0,t1,t2,t3);}
else{
a=C_alloc((c-4)*3);
t4=C_restore_rest(a,C_rest_count(0));
f_4222r(t0,t1,t2,t3,t4);}}

static void C_ccall f_4222r(C_word t0,C_word t1,C_word t2,C_word t3,C_word t4){
C_word tmp;
C_word t5;
C_word t6;
C_word *a=C_alloc(4);
t5=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_4226,a[2]=t3,a[3]=t1,tmp=(C_word)a,a+=4,tmp);
C_apply(5,0,t5,*((C_word*)lf[185]+1),t2,t4);}

/* k2222 in k2219 */
static void C_ccall f_2224(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word ab[3],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_2224,2,t0,t1);}
t2=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_2227,a[2]=((C_word*)t0)[2],tmp=(C_word)a,a+=3,tmp);
C_extras_toplevel(2,C_SCHEME_UNDEFINED,t2);}

/* k2219 */
static void C_ccall f_2221(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word ab[3],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_2221,2,t0,t1);}
t2=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_2224,a[2]=((C_word*)t0)[2],tmp=(C_word)a,a+=3,tmp);
C_irregex_toplevel(2,C_SCHEME_UNDEFINED,t2);}

/* %process in k3893 in k3523 in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_fcall f_5432(C_word t1,C_word t2,C_word t3,C_word t4,C_word t5,C_word t6,C_word t7){
C_word tmp;
C_word t8;
C_word t9;
C_word t10;
C_word t11;
C_word t12;
C_word t13;
C_word t14;
C_word t15;
C_word t16;
C_word ab[25],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)trf_5432,NULL,7,t1,t2,t3,t4,t5,t6,t7);}
t8=(*a=C_VECTOR_TYPE|1,a[1]=t4,tmp=(C_word)a,a+=2,tmp);
t9=(*a=C_VECTOR_TYPE|1,a[1]=t5,tmp=(C_word)a,a+=2,tmp);
t10=(*a=C_VECTOR_TYPE|1,a[1]=t7,tmp=(C_word)a,a+=2,tmp);
t11=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_5434,a[2]=t2,a[3]=((C_word)li137),tmp=(C_word)a,a+=4,tmp);
t12=C_i_check_string_2(((C_word*)t8)[1],t2);
t13=(*a=C_CLOSURE_TYPE|9,a[1]=(C_word)f_5475,a[2]=t2,a[3]=t8,a[4]=t9,a[5]=t6,a[6]=t3,a[7]=t10,a[8]=t1,a[9]=t11,tmp=(C_word)a,a+=10,tmp);
if(C_truep(((C_word*)t9)[1])){
/* posixwin.scm:1431: chkstrlst */
t14=t11;
f_5434(t14,t13,((C_word*)t9)[1]);}
else{
t14=C_set_block_item(t10,0,C_SCHEME_TRUE);
t15=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_5510,a[2]=t9,a[3]=t8,a[4]=t13,tmp=(C_word)a,a+=5,tmp);
/* posixwin.scm:1434: ##sys#shell-command-arguments */
t16=*((C_word*)lf[314]+1);
((C_proc3)(void*)(*((C_word*)t16+1)))(3,t16,t15,((C_word*)t8)[1]);}}

/* chkstrlst in %process in k3893 in k3523 in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_fcall f_5434(C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word ab[8],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)trf_5434,NULL,3,t0,t1,t2);}
t3=C_i_check_list_2(t2,((C_word*)t0)[2]);
t4=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_5439,a[2]=((C_word*)t0)[2],a[3]=((C_word)li135),tmp=(C_word)a,a+=4,tmp);
t5=t2;
t6=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_5448,a[2]=t4,a[3]=((C_word)li136),tmp=(C_word)a,a+=4,tmp);
t7=t1;
((C_proc2)(void*)(*((C_word*)t7+1)))(2,t7,f_5448(t6,t5));}

/* a4212 in k4200 in call-with-input-pipe in k3893 in k3523 in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_4213(C_word c,C_word t0,C_word t1,...){
C_word tmp;
C_word t2;
va_list v;
C_word *a,c2=c;
C_save_rest(t1,c2,2);
if(!C_demand(c*C_SIZEOF_PAIR+4)){
C_save_and_reclaim((void*)tr2r,(void*)f_4213r,2,t0,t1);}
else{
a=C_alloc((c-2)*3);
t2=C_restore_rest(a,C_rest_count(0));
f_4213r(t0,t1,t2);}}

static void C_ccall f_4213r(C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word t4;
C_word *a=C_alloc(4);
t3=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_4217,a[2]=t1,a[3]=t2,tmp=(C_word)a,a+=4,tmp);
/* posixwin.scm:974: close-input-pipe */
t4=*((C_word*)lf[186]+1);
((C_proc3)(void*)(*((C_word*)t4+1)))(3,t4,t3,((C_word*)t0)[2]);}

/* k4224 in call-with-output-pipe in k3893 in k3523 in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_4226(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word ab[9],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_4226,2,t0,t1);}
t2=t1;
t3=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_4231,a[2]=((C_word*)t0)[2],a[3]=t2,a[4]=((C_word)li85),tmp=(C_word)a,a+=5,tmp);
t4=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_4237,a[2]=t2,a[3]=((C_word)li86),tmp=(C_word)a,a+=4,tmp);
/* posixwin.scm:980: ##sys#call-with-values */
C_call_with_values(4,0,((C_word*)t0)[3],t3,t4);}

/* g1327 in chkstrlst in %process in k3893 in k3523 in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static C_word C_fcall f_5439(C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_stack_overflow_check;
return(C_i_check_string_2(t1,((C_word*)t0)[2]));}

/* for-each-loop1326 in chkstrlst in %process in k3893 in k3523 in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static C_word C_fcall f_5448(C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_stack_overflow_check;
loop:
if(C_truep(C_i_pairp(t1))){
t2=C_slot(t1,C_fix(0));
t3=f_5439(((C_word*)t0)[2],t2);
t4=C_slot(t1,C_fix(1));
t7=t4;
t1=t7;
goto loop;}
else{
t2=C_SCHEME_UNDEFINED;
return(t2);}}

/* k4239 in a4236 in k4224 in call-with-output-pipe in k3893 in k3523 in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_4241(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word *a;
C_apply_values(3,0,((C_word*)t0)[2],((C_word*)t0)[3]);}

/* k4215 in a4212 in k4200 in call-with-input-pipe in k3893 in k3523 in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_4217(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word *a;
C_apply_values(3,0,((C_word*)t0)[2],((C_word*)t0)[3]);}

/* k4427 in k4435 in change-file-mode in k3893 in k3523 in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_4429(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word *a;
/* posixwin.scm:1113: ##sys#signal-hook */
t2=*((C_word*)lf[3]+1);
((C_proc7)(void*)(*((C_word*)t2+1)))(7,t2,((C_word*)t0)[2],lf[10],lf[263],lf[264],((C_word*)t0)[3],((C_word*)t0)[4]);}

/* k4539 in k4527 in check in k3893 in k3523 in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_4541(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word *a;
t2=C_set_file_ptr(t1,((C_word*)t0)[2]);
t3=t1;
t4=((C_word*)t0)[3];
((C_proc2)(void*)(*((C_word*)t4+1)))(2,t4,t3);}

/* open-input-file* in k3893 in k3523 in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_4543(C_word c,C_word t0,C_word t1,C_word t2,...){
C_word tmp;
C_word t3;
va_list v;
C_word *a,c2=c;
C_save_rest(t2,c2,3);
if(c<3) C_bad_min_argc_2(c,3,t0);
if(!C_demand(c*C_SIZEOF_PAIR+5)){
C_save_and_reclaim((void*)tr3r,(void*)f_4543r,3,t0,t1,t2);}
else{
a=C_alloc((c-3)*3);
t3=C_restore_rest(a,C_rest_count(0));
f_4543r(t0,t1,t2,t3);}}

static void C_ccall f_4543r(C_word t0,C_word t1,C_word t2,C_word t3){
C_word tmp;
C_word t4;
C_word t5;
C_word t6;
C_word *a=C_alloc(5);
t4=C_i_check_exact_2(t2,lf[56]);
t5=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_4555,a[2]=t2,a[3]=((C_word*)t0)[2],a[4]=t1,tmp=(C_word)a,a+=5,tmp);
/* posixwin.scm:1162: mode */
f_4488(t5,C_SCHEME_TRUE,t3,lf[56]);}

/* k5235 in k5223 in shell-command in k3893 in k3523 in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_5237(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word *a;
/* posixwin.scm:1363: ##sys#error */
t2=*((C_word*)lf[45]+1);
((C_proc4)(void*)(*((C_word*)t2+1)))(4,t2,((C_word*)t0)[2],lf[310],lf[311]);}

/* k2716 in rmdir in delete-directory in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_2718(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word *a;
t2=C_rmdir(t1);
t3=C_eqp(C_fix(0),t2);
if(C_truep(t3)){
t4=C_SCHEME_UNDEFINED;
t5=((C_word*)t0)[2];
((C_proc2)(void*)(*((C_word*)t5+1)))(2,t5,t4);}
else{
/* posix-common.scm:353: posix-error */
t4=lf[2];
f_2245(6,t4,((C_word*)t0)[2],lf[10],lf[70],lf[71],((C_word*)t0)[3]);}}

/* rmdir in delete-directory in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_fcall f_2714(C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word t4;
C_word ab[4],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)trf_2714,NULL,2,t1,t2);}
t3=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_2718,a[2]=t1,a[3]=t2,tmp=(C_word)a,a+=4,tmp);
/* posix-common.scm:351: ##sys#make-c-string */
((C_proc3)C_fast_retrieve_proc(*((C_word*)lf[12]+1)))(3,*((C_word*)lf[12]+1),t3,t2);}

/* process-run in k3893 in k3523 in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_5248(C_word c,C_word t0,C_word t1,C_word t2,...){
C_word tmp;
C_word t3;
va_list v;
C_word *a,c2=c;
C_save_rest(t2,c2,3);
if(c<3) C_bad_min_argc_2(c,3,t0);
if(!C_demand(c*C_SIZEOF_PAIR+4)){
C_save_and_reclaim((void*)tr3r,(void*)f_5248r,3,t0,t1,t2);}
else{
a=C_alloc((c-3)*3);
t3=C_restore_rest(a,C_rest_count(0));
f_5248r(t0,t1,t2,t3);}}

static void C_ccall f_5248r(C_word t0,C_word t1,C_word t2,C_word t3){
C_word tmp;
C_word t4;
C_word t5;
C_word t6;
C_word *a=C_alloc(4);
t4=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_5252,a[2]=t1,a[3]=t2,tmp=(C_word)a,a+=4,tmp);
if(C_truep(C_i_pairp(t3))){
t5=t3;
t6=t4;
f_5252(t6,C_u_i_car(t5));}
else{
t5=t4;
f_5252(t5,C_SCHEME_FALSE);}}

/* ##sys#shell-command-arguments in k3893 in k3523 in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_5242(C_word c,C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word ab[6],*a=ab;
if(c!=3) C_bad_argc_2(c,3,t0);
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr3,(void*)f_5242,3,t0,t1,t2);}
t3=t1;
((C_proc2)(void*)(*((C_word*)t3+1)))(2,t3,C_a_i_list2(&a,2,lf[315],t2));}

/* change-file-mode in k3893 in k3523 in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_4413(C_word c,C_word t0,C_word t1,C_word t2,C_word t3){
C_word tmp;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word ab[8],*a=ab;
if(c!=4) C_bad_argc_2(c,4,t0);
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr4,(void*)f_4413,4,t0,t1,t2,t3);}
t4=C_i_check_string_2(t2,lf[263]);
t5=C_i_check_exact_2(t3,lf[263]);
t6=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_4437,a[2]=t3,a[3]=t1,a[4]=t2,tmp=(C_word)a,a+=5,tmp);
t7=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_4441,a[2]=t6,tmp=(C_word)a,a+=3,tmp);
/* posixwin.scm:1111: ##sys#expand-home-path */
((C_proc3)C_fast_retrieve_proc(*((C_word*)lf[14]+1)))(3,*((C_word*)lf[14]+1),t7,t2);}

/* delete-directory in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_2708(C_word c,C_word t0,C_word t1,C_word t2,...){
C_word tmp;
C_word t3;
va_list v;
C_word *a,c2=c;
C_save_rest(t2,c2,3);
if(c<3) C_bad_min_argc_2(c,3,t0);
if(!C_demand(c*C_SIZEOF_PAIR+8)){
C_save_and_reclaim((void*)tr3r,(void*)f_2708r,3,t0,t1,t2);}
else{
a=C_alloc((c-3)*3);
t3=C_restore_rest(a,C_rest_count(0));
f_2708r(t0,t1,t2,t3);}}

static void C_ccall f_2708r(C_word t0,C_word t1,C_word t2,C_word t3){
C_word tmp;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word *a=C_alloc(8);
t4=C_i_nullp(t3);
t5=(C_truep(t4)?C_SCHEME_FALSE:C_i_car(t3));
t6=t5;
t7=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_2714,a[2]=((C_word)li23),tmp=(C_word)a,a+=3,tmp);
t8=C_i_check_string_2(t2,lf[70]);
t9=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_2734,a[2]=t6,a[3]=t7,a[4]=t1,tmp=(C_word)a,a+=5,tmp);
/* posix-common.scm:355: ##sys#expand-home-path */
((C_proc3)C_fast_retrieve_proc(*((C_word*)lf[14]+1)))(3,*((C_word*)lf[14]+1),t9,t2);}

/* k4302 in a4299 in a4293 in k4282 in with-output-to-pipe in k3893 in k3523 in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_4304(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word *a;
C_apply_values(3,0,((C_word*)t0)[2],((C_word*)t0)[3]);}

/* file-permissions in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_2347(C_word c,C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word t4;
C_word ab[3],*a=ab;
if(c!=3) C_bad_argc_2(c,3,t0);
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr3,(void*)f_2347,3,t0,t1,t2);}
t3=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_2351,a[2]=t1,tmp=(C_word)a,a+=3,tmp);
/* posix-common.scm:231: ##sys#stat */
f_2263(t3,t2,C_SCHEME_FALSE,C_SCHEME_TRUE,lf[24]);}

/* k2343 in file-owner in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_2345(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word *a;
t2=((C_word*)t0)[2];
((C_proc2)(void*)(*((C_word*)t2+1)))(2,t2,C_fix(C_MOST_POSITIVE_FIXNUM&(C_word)C_statbuf.st_uid));}

/* a4308 in k4282 in with-output-to-pipe in k3893 in k3523 in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_4309(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word *a;
if(c!=2) C_bad_argc_2(c,2,t0);
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_4309,2,t0,t1);}
t2=C_mutate2(((C_word *)((C_word*)t0)[2])+1,*((C_word*)lf[195]+1));
t3=C_mutate2((C_word*)lf[195]+1 /* (set! ##sys#standard-output ...) */,((C_word*)((C_word*)t0)[3])[1]);
t4=t1;
((C_proc2)(void*)(*((C_word*)t4+1)))(2,t4,C_SCHEME_UNDEFINED);}

/* file-owner in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_2341(C_word c,C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word t4;
C_word ab[3],*a=ab;
if(c!=3) C_bad_argc_2(c,3,t0);
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr3,(void*)f_2341,3,t0,t1,t2);}
t3=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_2345,a[2]=t1,tmp=(C_word)a,a+=3,tmp);
/* posix-common.scm:230: ##sys#stat */
f_2263(t3,t2,C_SCHEME_FALSE,C_SCHEME_TRUE,lf[23]);}

/* k4439 in change-file-mode in k3893 in k3523 in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_4441(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word *a;
/* posixwin.scm:1111: ##sys#make-c-string */
((C_proc4)C_fast_retrieve_proc(*((C_word*)lf[12]+1)))(4,*((C_word*)lf[12]+1),((C_word*)t0)[2],t1,lf[263]);}

/* check in k3893 in k3523 in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_fcall f_4443(C_word t1,C_word t2,C_word t3,C_word t4){
C_word tmp;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word ab[8],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)trf_4443,NULL,4,t1,t2,t3,t4);}
t5=C_i_check_string_2(t2,t4);
t6=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_4461,a[2]=t3,a[3]=t1,tmp=(C_word)a,a+=4,tmp);
t7=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_4465,a[2]=t6,a[3]=t4,tmp=(C_word)a,a+=4,tmp);
/* posixwin.scm:1122: ##sys#expand-home-path */
((C_proc3)C_fast_retrieve_proc(*((C_word*)lf[14]+1)))(3,*((C_word*)lf[14]+1),t7,t2);}

/* a4299 in a4293 in k4282 in with-output-to-pipe in k3893 in k3523 in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_4300(C_word c,C_word t0,C_word t1,...){
C_word tmp;
C_word t2;
va_list v;
C_word *a,c2=c;
C_save_rest(t1,c2,2);
if(!C_demand(c*C_SIZEOF_PAIR+4)){
C_save_and_reclaim((void*)tr2r,(void*)f_4300r,2,t0,t1);}
else{
a=C_alloc((c-2)*3);
t2=C_restore_rest(a,C_rest_count(0));
f_4300r(t0,t1,t2);}}

static void C_ccall f_4300r(C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word t4;
C_word *a=C_alloc(4);
t3=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_4304,a[2]=t1,a[3]=t2,tmp=(C_word)a,a+=4,tmp);
/* posixwin.scm:1003: close-output-pipe */
t4=*((C_word*)lf[188]+1);
((C_proc3)(void*)(*((C_word*)t4+1)))(3,t4,t3,((C_word*)t0)[2]);}

/* loop in $quote-args-list in k3893 in k3523 in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_fcall f_4912(C_word t0,C_word t1,C_word t2,C_word t3){
C_word tmp;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word t11;
C_word t12;
C_word t13;
C_word t14;
C_word t15;
C_word t16;
C_word t17;
C_word *a;
loop:
a=C_alloc(14);
if(!C_stack_probe(a)){
C_save_and_reclaim((void*)trf_4912,NULL,4,t0,t1,t2,t3);}
if(C_truep(C_i_nullp(t2))){
/* posixwin.scm:1302: ##sys#fast-reverse */
((C_proc3)C_fast_retrieve_proc(*((C_word*)lf[300]+1)))(3,*((C_word*)lf[300]+1),t1,t3);}
else{
t4=C_i_car(t2);
t5=t2;
t6=C_u_i_cdr(t5);
t7=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_4938,a[2]=t3,a[3]=((C_word*)t0)[2],a[4]=t1,a[5]=t6,tmp=(C_word)a,a+=6,tmp);
t8=t4;
t9=C_i_string_length(t8);
t10=t9;
t11=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_4883,a[2]=t10,a[3]=t8,a[4]=((C_word)li120),tmp=(C_word)a,a+=5,tmp);
t12=f_4883(t11,C_fix(0));
if(C_truep(t12)){
/* posixwin.scm:1307: string-append */
t13=*((C_word*)lf[4]+1);
((C_proc5)(void*)(*((C_word*)t13+1)))(5,t13,t7,lf[301],t4,lf[302]);}
else{
t13=C_a_i_cons(&a,2,t4,t3);
/* posixwin.scm:1304: loop */
t15=t1;
t16=t6;
t17=t13;
t1=t15;
t2=t16;
t3=t17;
goto loop;}}}

/* k4567 in open-output-file* in k3893 in k3523 in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_4569(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word ab[2],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_4569,2,t0,t1);}
t2=C_fdopen(&a,2,((C_word*)t0)[2],t1);
/* posixwin.scm:1166: check */
f_4525(((C_word*)t0)[4],((C_word*)t0)[2],C_SCHEME_FALSE,t2);}

/* k4435 in change-file-mode in k3893 in k3523 in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_4437(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word ab[5],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_4437,2,t0,t1);}
t2=C_chmod(t1,((C_word*)t0)[2]);
if(C_truep(C_fixnum_lessp(t2,C_fix(0)))){
t3=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_4429,a[2]=((C_word*)t0)[3],a[3]=((C_word*)t0)[4],a[4]=((C_word*)t0)[2],tmp=(C_word)a,a+=5,tmp);
/* posixwin.scm:1112: ##sys#update-errno */
((C_proc2)C_fast_retrieve_proc(*((C_word*)lf[7]+1)))(2,*((C_word*)lf[7]+1),t3);}
else{
t3=C_SCHEME_UNDEFINED;
t4=((C_word*)t0)[3];
((C_proc2)(void*)(*((C_word*)t4+1)))(2,t4,t3);}}

/* k2337 in file-change-time in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_2339(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word ab[4],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_2339,2,t0,t1);}
t2=((C_word*)t0)[2];
((C_proc2)(void*)(*((C_word*)t2+1)))(2,t2,C_flonum(&a,C_statbuf.st_ctime));}

/* file-change-time in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_2335(C_word c,C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word t4;
C_word ab[3],*a=ab;
if(c!=3) C_bad_argc_2(c,3,t0);
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr3,(void*)f_2335,3,t0,t1,t2);}
t3=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_2339,a[2]=t1,tmp=(C_word)a,a+=3,tmp);
/* posix-common.scm:229: ##sys#stat */
f_2263(t3,t2,C_SCHEME_FALSE,C_SCHEME_TRUE,lf[22]);}

/* k2331 in file-access-time in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_2333(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word ab[4],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_2333,2,t0,t1);}
t2=((C_word*)t0)[2];
((C_proc2)(void*)(*((C_word*)t2+1)))(2,t2,C_flonum(&a,C_statbuf.st_atime));}

/* k4553 in open-input-file* in k3893 in k3523 in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_4555(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word ab[2],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_4555,2,t0,t1);}
t2=C_fdopen(&a,2,((C_word*)t0)[2],t1);
/* posixwin.scm:1162: check */
f_4525(((C_word*)t0)[4],((C_word*)t0)[2],C_SCHEME_TRUE,t2);}

/* for-each-loop270 in k2738 in k2732 in delete-directory in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_fcall f_2768(C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word ab[5],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)trf_2768,NULL,3,t0,t1,t2);}
if(C_truep(C_i_pairp(t2))){
t3=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_2778,a[2]=t2,a[3]=((C_word*)t0)[2],a[4]=t1,tmp=(C_word)a,a+=5,tmp);
t4=C_slot(t2,C_fix(0));
/* posix-common.scm:357: g271 */
t5=((C_word*)t0)[3];
f_2741(t5,t3,t4);}
else{
t3=C_SCHEME_UNDEFINED;
t4=t1;
((C_proc2)(void*)(*((C_word*)t4+1)))(2,t4,t3);}}

/* k5223 in shell-command in k3893 in k3523 in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_5225(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word ab[3],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_5225,2,t0,t1);}
if(C_truep(t1)){
t2=t1;
t3=((C_word*)t0)[2];
((C_proc2)(void*)(*((C_word*)t3+1)))(2,t3,t2);}
else{
if(C_truep(C_get_shlcmd())){
/* ##sys#peek-c-string */
t2=*((C_word*)lf[6]+1);
((C_proc4)(void*)(*((C_word*)t2+1)))(4,t2,((C_word*)t0)[2],C_mpointer(&a,(void*)C_shlcmd),C_fix(0));}
else{
t2=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_5237,a[2]=((C_word*)t0)[2],tmp=(C_word)a,a+=3,tmp);
/* posixwin.scm:1362: ##sys#update-errno */
((C_proc2)C_fast_retrieve_proc(*((C_word*)lf[7]+1)))(2,*((C_word*)lf[7]+1),t2);}}}

/* k2761 in k2738 in k2732 in delete-directory in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_2763(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word *a;
/* posix-common.scm:368: rmdir */
f_2714(((C_word*)t0)[3],((C_word*)t0)[4]);}

/* ##sys#shell-command in k3893 in k3523 in k3290 in k2325 in k2231 in k2228 in k2225 in k2222 in k2219 */
static void C_ccall f_5221(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word ab[3],*a=ab;
if(c!=2) C_bad_argc_2(c,2,t0);
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_5221,2,t0,t1);}
t2=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_5225,a[2]=t1,tmp=(C_word)a,a+=3,tmp);
/* posixwin.scm:1358: get-environment-variable */
t3=*((C_word*)lf[312]+1);
((C_proc3)(void*)(*((C_word*)t3+1)))(3,t3,t2,lf[313]);}

#ifdef C_ENABLE_PTABLES
static C_PTABLE_ENTRY ptable[447] = {
{"f_4557:posixwin_2escm",(void*)f_4557},
{"f_4467:posixwin_2escm",(void*)f_4467},
{"f_2329:posixwin_2escm",(void*)f_2329},
{"f_2327:posixwin_2escm",(void*)f_2327},
{"f_4321:posixwin_2escm",(void*)f_4321},
{"f_4583:posixwin_2escm",(void*)f_4583},
{"f_2757:posixwin_2escm",(void*)f_2757},
{"f_2751:posixwin_2escm",(void*)f_2751},
{"f_4461:posixwin_2escm",(void*)f_4461},
{"f_4465:posixwin_2escm",(void*)f_4465},
{"f_4589:posixwin_2escm",(void*)f_4589},
{"f_4712:posixwin_2escm",(void*)f_4712},
{"f_4314:posixwin_2escm",(void*)f_4314},
{"f_2965:posixwin_2escm",(void*)f_2965},
{"f_2314:posixwin_2escm",(void*)f_2314},
{"f_4571:posixwin_2escm",(void*)f_4571},
{"f_5284:posixwin_2escm",(void*)f_5284},
{"f_2969:posixwin_2escm",(void*)f_2969},
{"f_2740:posixwin_2escm",(void*)f_2740},
{"f_2741:posixwin_2escm",(void*)f_2741},
{"f_5280:posixwin_2escm",(void*)f_5280},
{"f_4453:posixwin_2escm",(void*)f_4453},
{"f_4787:posixwin_2escm",(void*)f_4787},
{"f_2959:posixwin_2escm",(void*)f_2959},
{"f_2734:posixwin_2escm",(void*)f_2734},
{"f_2378:posixwin_2escm",(void*)f_2378},
{"f_2944:posixwin_2escm",(void*)f_2944},
{"f_4330:posixwin_2escm",(void*)f_4330},
{"f_4720:posixwin_2escm",(void*)f_4720},
{"f_4724:posixwin_2escm",(void*)f_4724},
{"f_2938:posixwin_2escm",(void*)f_2938},
{"f_4755:posixwin_2escm",(void*)f_4755},
{"f_2995:posixwin_2escm",(void*)f_2995},
{"f_2999:posixwin_2escm",(void*)f_2999},
{"f_2778:posixwin_2escm",(void*)f_2778},
{"f_4775:posixwin_2escm",(void*)f_4775},
{"f_4769:posixwin_2escm",(void*)f_4769},
{"f_2976:posixwin_2escm",(void*)f_2976},
{"f_2978:posixwin_2escm",(void*)f_2978},
{"f_4794:posixwin_2escm",(void*)f_4794},
{"f_3779:posixwin_2escm",(void*)f_3779},
{"f_3772:posixwin_2escm",(void*)f_3772},
{"f_4525:posixwin_2escm",(void*)f_4525},
{"f_4529:posixwin_2escm",(void*)f_4529},
{"f_3754:posixwin_2escm",(void*)f_3754},
{"f_3742:posixwin_2escm",(void*)f_3742},
{"f_3748:posixwin_2escm",(void*)f_3748},
{"f_3732:posixwin_2escm",(void*)f_3732},
{"f_3739:posixwin_2escm",(void*)f_3739},
{"f_4742:posixwin_2escm",(void*)f_4742},
{"f_3907:posixwin_2escm",(void*)f_3907},
{"f_3919:posixwin_2escm",(void*)f_3919},
{"f_3910:posixwin_2escm",(void*)f_3910},
{"f_3915:posixwin_2escm",(void*)f_3915},
{"f_4946:posixwin_2escm",(void*)f_4946},
{"f_3924:posixwin_2escm",(void*)f_3924},
{"f_4938:posixwin_2escm",(void*)f_4938},
{"f_6234:posixwin_2escm",(void*)f_6234},
{"f_3502:posixwin_2escm",(void*)f_3502},
{"f_4967:posixwin_2escm",(void*)f_4967},
{"f_3510:posixwin_2escm",(void*)f_3510},
{"f_3932:posixwin_2escm",(void*)f_3932},
{"f_6221:posixwin_2escm",(void*)f_6221},
{"f_4955:posixwin_2escm",(void*)f_4955},
{"f_3943:posixwin_2escm",(void*)f_3943},
{"f_6211:posixwin_2escm",(void*)f_6211},
{"f_4988:posixwin_2escm",(void*)f_4988},
{"f_3338:posixwin_2escm",(void*)f_3338},
{"f_3334:posixwin_2escm",(void*)f_3334},
{"f_3105:posixwin_2escm",(void*)f_3105},
{"f_3108:posixwin_2escm",(void*)f_3108},
{"f_4976:posixwin_2escm",(void*)f_4976},
{"f_5707:posixwin_2escm",(void*)f_5707},
{"f_3317:posixwin_2escm",(void*)f_3317},
{"f_3313:posixwin_2escm",(void*)f_3313},
{"f_3792:posixwin_2escm",(void*)f_3792},
{"f_3064:posixwin_2escm",(void*)f_3064},
{"f_3062:posixwin_2escm",(void*)f_3062},
{"f_6091:posixwin_2escm",(void*)f_6091},
{"f_6097:posixwin_2escm",(void*)f_6097},
{"f_3785:posixwin_2escm",(void*)f_3785},
{"f_3055:posixwin_2escm",(void*)f_3055},
{"f_3052:posixwin_2escm",(void*)f_3052},
{"f_6085:posixwin_2escm",(void*)f_6085},
{"f_6079:posixwin_2escm",(void*)f_6079},
{"f_6073:posixwin_2escm",(void*)f_6073},
{"f_3039:posixwin_2escm",(void*)f_3039},
{"f_5516:posixwin_2escm",(void*)f_5516},
{"f_5514:posixwin_2escm",(void*)f_5514},
{"f_5510:posixwin_2escm",(void*)f_5510},
{"f_5775:posixwin_2escm",(void*)f_5775},
{"f_6201:posixwin_2escm",(void*)f_6201},
{"f_3563:posixwin_2escm",(void*)f_3563},
{"f_5911:posixwin_2escm",(void*)f_5911},
{"f_5917:posixwin_2escm",(void*)f_5917},
{"f_4068:posixwin_2escm",(void*)f_4068},
{"f_5781:posixwin_2escm",(void*)f_5781},
{"f_4064:posixwin_2escm",(void*)f_4064},
{"f_3365:posixwin_2escm",(void*)f_3365},
{"f_3369:posixwin_2escm",(void*)f_3369},
{"f_3083:posixwin_2escm",(void*)f_3083},
{"f_5923:posixwin_2escm",(void*)f_5923},
{"f_5929:posixwin_2escm",(void*)f_5929},
{"f_5576:posixwin_2escm",(void*)f_5576},
{"f6899:posixwin_2escm",(void*)f6899},
{"f_5046:posixwin_2escm",(void*)f_5046},
{"f_5043:posixwin_2escm",(void*)f_5043},
{"f_6025:posixwin_2escm",(void*)f_6025},
{"f_5049:posixwin_2escm",(void*)f_5049},
{"f_5769:posixwin_2escm",(void*)f_5769},
{"f_5766:posixwin_2escm",(void*)f_5766},
{"f_5763:posixwin_2escm",(void*)f_5763},
{"f_4009:posixwin_2escm",(void*)f_4009},
{"f_4001:posixwin_2escm",(void*)f_4001},
{"f_5076:posixwin_2escm",(void*)f_5076},
{"f_5905:posixwin_2escm",(void*)f_5905},
{"f_5072:posixwin_2escm",(void*)f_5072},
{"f_6013:posixwin_2escm",(void*)f_6013},
{"f_6019:posixwin_2escm",(void*)f_6019},
{"f_3375:posixwin_2escm",(void*)f_3375},
{"f_5063:posixwin_2escm",(void*)f_5063},
{"f_6007:posixwin_2escm",(void*)f_6007},
{"f_6001:posixwin_2escm",(void*)f_6001},
{"f_5019:posixwin_2escm",(void*)f_5019},
{"f_4096:posixwin_2escm",(void*)f_4096},
{"f_3704:posixwin_2escm",(void*)f_3704},
{"f_3701:posixwin_2escm",(void*)f_3701},
{"f_5087:posixwin_2escm",(void*)f_5087},
{"f_6061:posixwin_2escm",(void*)f_6061},
{"f_6067:posixwin_2escm",(void*)f_6067},
{"f_4044:posixwin_2escm",(void*)f_4044},
{"f_3713:posixwin_2escm",(void*)f_3713},
{"f_6055:posixwin_2escm",(void*)f_6055},
{"f_6043:posixwin_2escm",(void*)f_6043},
{"f_2800:posixwin_2escm",(void*)f_2800},
{"f_6049:posixwin_2escm",(void*)f_6049},
{"f_2804:posixwin_2escm",(void*)f_2804},
{"f_3557:posixwin_2escm",(void*)f_3557},
{"f_5052:posixwin_2escm",(void*)f_5052},
{"f_6037:posixwin_2escm",(void*)f_6037},
{"f_5059:posixwin_2escm",(void*)f_5059},
{"f_6031:posixwin_2escm",(void*)f_6031},
{"f_5759:posixwin_2escm",(void*)f_5759},
{"f_4103:posixwin_2escm",(void*)f_4103},
{"f_4082:posixwin_2escm",(void*)f_4082},
{"f_4080:posixwin_2escm",(void*)f_4080},
{"f_3533:posixwin_2escm",(void*)f_3533},
{"f_2819:posixwin_2escm",(void*)f_2819},
{"f_3525:posixwin_2escm",(void*)f_3525},
{"f_3527:posixwin_2escm",(void*)f_3527},
{"f_2615:posixwin_2escm",(void*)f_2615},
{"f_2843:posixwin_2escm",(void*)f_2843},
{"f_3149:posixwin_2escm",(void*)f_3149},
{"f_3146:posixwin_2escm",(void*)f_3146},
{"f_3142:posixwin_2escm",(void*)f_3142},
{"f_2875:posixwin_2escm",(void*)f_2875},
{"f_5109:posixwin_2escm",(void*)f_5109},
{"f_3134:posixwin_2escm",(void*)f_3134},
{"f_2829:posixwin_2escm",(void*)f_2829},
{"f_2822:posixwin_2escm",(void*)f_2822},
{"f_2825:posixwin_2escm",(void*)f_2825},
{"f_3129:posixwin_2escm",(void*)f_3129},
{"f_3127:posixwin_2escm",(void*)f_3127},
{"f_2853:posixwin_2escm",(void*)f_2853},
{"f_3117:posixwin_2escm",(void*)f_3117},
{"f_4612:posixwin_2escm",(void*)f_4612},
{"f_5397:posixwin_2escm",(void*)f_5397},
{"f_5393:posixwin_2escm",(void*)f_5393},
{"f_3188:posixwin_2escm",(void*)f_3188},
{"f_4615:posixwin_2escm",(void*)f_4615},
{"f_3172:posixwin_2escm",(void*)f_3172},
{"f_3175:posixwin_2escm",(void*)f_3175},
{"f_2865:posixwin_2escm",(void*)f_2865},
{"f_5370:posixwin_2escm",(void*)f_5370},
{"f_4605:posixwin_2escm",(void*)f_4605},
{"f_4603:posixwin_2escm",(void*)f_4603},
{"f_3162:posixwin_2escm",(void*)f_3162},
{"f_4811:posixwin_2escm",(void*)f_4811},
{"f_2624:posixwin_2escm",(void*)f_2624},
{"f_5382:posixwin_2escm",(void*)f_5382},
{"f_5389:posixwin_2escm",(void*)f_5389},
{"f_3156:posixwin_2escm",(void*)f_3156},
{"f_4650:posixwin_2escm",(void*)f_4650},
{"f_4652:posixwin_2escm",(void*)f_4652},
{"f_2690:posixwin_2escm",(void*)f_2690},
{"f_5959:posixwin_2escm",(void*)f_5959},
{"f_5953:posixwin_2escm",(void*)f_5953},
{"f_2687:posixwin_2escm",(void*)f_2687},
{"f_5965:posixwin_2escm",(void*)f_5965},
{"f_2674:posixwin_2escm",(void*)f_2674},
{"f_5154:posixwin_2escm",(void*)f_5154},
{"f_4646:posixwin_2escm",(void*)f_4646},
{"f_5935:posixwin_2escm",(void*)f_5935},
{"f_3181:posixwin_2escm",(void*)f_3181},
{"f_4664:posixwin_2escm",(void*)f_4664},
{"f6911:posixwin_2escm",(void*)f6911},
{"f_4660:posixwin_2escm",(void*)f_4660},
{"f_5941:posixwin_2escm",(void*)f_5941},
{"f_5947:posixwin_2escm",(void*)f_5947},
{"f_4676:posixwin_2escm",(void*)f_4676},
{"f_3011:posixwin_2escm",(void*)f_3011},
{"f_3194:posixwin_2escm",(void*)f_3194},
{"f_4808:posixwin_2escm",(void*)f_4808},
{"f_4162:posixwin_2escm",(void*)f_4162},
{"f_3019:posixwin_2escm",(void*)f_3019},
{"f_4169:posixwin_2escm",(void*)f_4169},
{"f_4802:posixwin_2escm",(void*)f_4802},
{"f_4694:posixwin_2escm",(void*)f_4694},
{"f_5995:posixwin_2escm",(void*)f_5995},
{"f_4153:posixwin_2escm",(void*)f_4153},
{"f_3007:posixwin_2escm",(void*)f_3007},
{"f_4682:posixwin_2escm",(void*)f_4682},
{"f_4820:posixwin_2escm",(void*)f_4820},
{"f_5971:posixwin_2escm",(void*)f_5971},
{"f_5977:posixwin_2escm",(void*)f_5977},
{"f_4686:posixwin_2escm",(void*)f_4686},
{"f_5983:posixwin_2escm",(void*)f_5983},
{"f_5989:posixwin_2escm",(void*)f_5989},
{"f_4027:posixwin_2escm",(void*)f_4027},
{"f_5352:posixwin_2escm",(void*)f_5352},
{"f_4020:posixwin_2escm",(void*)f_4020},
{"f_4190:posixwin_2escm",(void*)f_4190},
{"f_4198:posixwin_2escm",(void*)f_4198},
{"f_5362:posixwin_2escm",(void*)f_5362},
{"f_5366:posixwin_2escm",(void*)f_5366},
{"f_5000:posixwin_2escm",(void*)f_5000},
{"f_4869:posixwin_2escm",(void*)f_4869},
{"f_4143:posixwin_2escm",(void*)f_4143},
{"f_5338:posixwin_2escm",(void*)f_5338},
{"f_5036:posixwin_2escm",(void*)f_5036},
{"f_4036:posixwin_2escm",(void*)f_4036},
{"f_4136:posixwin_2escm",(void*)f_4136},
{"f_5345:posixwin_2escm",(void*)f_5345},
{"f_4030:posixwin_2escm",(void*)f_4030},
{"f_2657:posixwin_2escm",(void*)f_2657},
{"f_4883:posixwin_2escm",(void*)f_4883},
{"f_2654:posixwin_2escm",(void*)f_2654},
{"f_2647:posixwin_2escm",(void*)f_2647},
{"f_2641:posixwin_2escm",(void*)f_2641},
{"f_4180:posixwin_2escm",(void*)f_4180},
{"f_4187:posixwin_2escm",(void*)f_4187},
{"f_4635:posixwin_2escm",(void*)f_4635},
{"f_4172:posixwin_2escm",(void*)f_4172},
{"f_4621:posixwin_2escm",(void*)f_4621},
{"f_4122:posixwin_2escm",(void*)f_4122},
{"f_5176:posixwin_2escm",(void*)f_5176},
{"f_4113:posixwin_2escm",(void*)f_4113},
{"f6917:posixwin_2escm",(void*)f6917},
{"f_3852:posixwin_2escm",(void*)f_3852},
{"f_3858:posixwin_2escm",(void*)f_3858},
{"f_3843:posixwin_2escm",(void*)f_3843},
{"f_6155:posixwin_2escm",(void*)f_6155},
{"f6905:posixwin_2escm",(void*)f6905},
{"f_3864:posixwin_2escm",(void*)f_3864},
{"f_3976:posixwin_2escm",(void*)f_3976},
{"f_3951:posixwin_2escm",(void*)f_3951},
{"f_6164:posixwin_2escm",(void*)f_6164},
{"f_3966:posixwin_2escm",(void*)f_3966},
{"f_6114:posixwin_2escm",(void*)f_6114},
{"f_6118:posixwin_2escm",(void*)f_6118},
{"f_3839:posixwin_2escm",(void*)f_3839},
{"f_6104:posixwin_2escm",(void*)f_6104},
{"f_6130:posixwin_2escm",(void*)f_6130},
{"f_6121:posixwin_2escm",(void*)f_6121},
{"f_5815:posixwin_2escm",(void*)f_5815},
{"f_3897:posixwin_2escm",(void*)f_3897},
{"f_3895:posixwin_2escm",(void*)f_3895},
{"f_6195:posixwin_2escm",(void*)f_6195},
{"f_6199:posixwin_2escm",(void*)f_6199},
{"f_3448:posixwin_2escm",(void*)f_3448},
{"f_5822:posixwin_2escm",(void*)f_5822},
{"f_6189:posixwin_2escm",(void*)f_6189},
{"f_3698:posixwin_2escm",(void*)f_3698},
{"f_3802:posixwin_2escm",(void*)f_3802},
{"f_3201:posixwin_2escm",(void*)f_3201},
{"f_5887:posixwin_2escm",(void*)f_5887},
{"f_5881:posixwin_2escm",(void*)f_5881},
{"f_3208:posixwin_2escm",(void*)f_3208},
{"f_3688:posixwin_2escm",(void*)f_3688},
{"f_3682:posixwin_2escm",(void*)f_3682},
{"f_5893:posixwin_2escm",(void*)f_5893},
{"f_3634:posixwin_2escm",(void*)f_3634},
{"f_3630:posixwin_2escm",(void*)f_3630},
{"f_5899:posixwin_2escm",(void*)f_5899},
{"f_5863:posixwin_2escm",(void*)f_5863},
{"f_5869:posixwin_2escm",(void*)f_5869},
{"f_5875:posixwin_2escm",(void*)f_5875},
{"f_5654:posixwin_2escm",(void*)f_5654},
{"f_3656:posixwin_2escm",(void*)f_3656},
{"f_3650:posixwin_2escm",(void*)f_3650},
{"f_5666:posixwin_2escm",(void*)f_5666},
{"f_3455:posixwin_2escm",(void*)f_3455},
{"f_3647:posixwin_2escm",(void*)f_3647},
{"f_3403:posixwin_2escm",(void*)f_3403},
{"f_3407:posixwin_2escm",(void*)f_3407},
{"f_5636:posixwin_2escm",(void*)f_5636},
{"f_5648:posixwin_2escm",(void*)f_5648},
{"f_3474:posixwin_2escm",(void*)f_3474},
{"f_3478:posixwin_2escm",(void*)f_3478},
{"toplevel:posixwin_2escm",(void*)C_posix_toplevel},
{"f_4207:posixwin_2escm",(void*)f_4207},
{"f_5697:posixwin_2escm",(void*)f_5697},
{"f_5692:posixwin_2escm",(void*)f_5692},
{"f_3464:posixwin_2escm",(void*)f_3464},
{"f_3417:posixwin_2escm",(void*)f_3417},
{"f_3411:posixwin_2escm",(void*)f_3411},
{"f_3810:posixwin_2escm",(void*)f_3810},
{"f_5677:posixwin_2escm",(void*)f_5677},
{"f_3481:posixwin_2escm",(void*)f_3481},
{"f_5685:posixwin_2escm",(void*)f_5685},
{"f_5681:posixwin_2escm",(void*)f_5681},
{"f_2466:posixwin_2escm",(void*)f_2466},
{"f_2464:posixwin_2escm",(void*)f_2464},
{"f_5689:posixwin_2escm",(void*)f_5689},
{"f_2456:posixwin_2escm",(void*)f_2456},
{"f_2454:posixwin_2escm",(void*)f_2454},
{"f_3227:posixwin_2escm",(void*)f_3227},
{"f_5848:posixwin_2escm",(void*)f_5848},
{"f_3219:posixwin_2escm",(void*)f_3219},
{"f_3218:posixwin_2escm",(void*)f_3218},
{"f_5857:posixwin_2escm",(void*)f_5857},
{"f_3245:posixwin_2escm",(void*)f_3245},
{"f_3248:posixwin_2escm",(void*)f_3248},
{"f_3241:posixwin_2escm",(void*)f_3241},
{"f_3669:posixwin_2escm",(void*)f_3669},
{"f_2504:posixwin_2escm",(void*)f_2504},
{"f_3663:posixwin_2escm",(void*)f_3663},
{"f_2506:posixwin_2escm",(void*)f_2506},
{"f_2494:posixwin_2escm",(void*)f_2494},
{"f_2496:posixwin_2escm",(void*)f_2496},
{"f_2302:posixwin_2escm",(void*)f_2302},
{"f_2307:posixwin_2escm",(void*)f_2307},
{"f_2291:posixwin_2escm",(void*)f_2291},
{"f_2298:posixwin_2escm",(void*)f_2298},
{"f_2519:posixwin_2escm",(void*)f_2519},
{"f_2514:posixwin_2escm",(void*)f_2514},
{"f_3274:posixwin_2escm",(void*)f_3274},
{"f_3277:posixwin_2escm",(void*)f_3277},
{"f_3279:posixwin_2escm",(void*)f_3279},
{"f_3271:posixwin_2escm",(void*)f_3271},
{"f_2267:posixwin_2escm",(void*)f_2267},
{"f_4260:posixwin_2escm",(void*)f_4260},
{"f_2260:posixwin_2escm",(void*)f_2260},
{"f_2263:posixwin_2escm",(void*)f_2263},
{"f_2527:posixwin_2escm",(void*)f_2527},
{"f_5475:posixwin_2escm",(void*)f_5475},
{"f_5478:posixwin_2escm",(void*)f_5478},
{"f_2446:posixwin_2escm",(void*)f_2446},
{"f_4250:posixwin_2escm",(void*)f_4250},
{"f_4255:posixwin_2escm",(void*)f_4255},
{"f_3294:posixwin_2escm",(void*)f_3294},
{"f_4266:posixwin_2escm",(void*)f_4266},
{"f_3292:posixwin_2escm",(void*)f_3292},
{"f_2556:posixwin_2escm",(void*)f_2556},
{"f_5483:posixwin_2escm",(void*)f_5483},
{"f_5489:posixwin_2escm",(void*)f_5489},
{"f_4280:posixwin_2escm",(void*)f_4280},
{"f_4284:posixwin_2escm",(void*)f_4284},
{"f_2908:posixwin_2escm",(void*)f_2908},
{"f_2585:posixwin_2escm",(void*)f_2585},
{"f_2583:posixwin_2escm",(void*)f_2583},
{"f_3235:posixwin_2escm",(void*)f_3235},
{"f_3265:posixwin_2escm",(void*)f_3265},
{"f_3268:posixwin_2escm",(void*)f_3268},
{"f_3260:posixwin_2escm",(void*)f_3260},
{"f_4488:posixwin_2escm",(void*)f_4488},
{"f_2569:posixwin_2escm",(void*)f_2569},
{"f_2486:posixwin_2escm",(void*)f_2486},
{"f_5252:posixwin_2escm",(void*)f_5252},
{"f_2484:posixwin_2escm",(void*)f_2484},
{"f_4294:posixwin_2escm",(void*)f_4294},
{"f_3254:posixwin_2escm",(void*)f_3254},
{"f_3257:posixwin_2escm",(void*)f_3257},
{"f_3251:posixwin_2escm",(void*)f_3251},
{"f_4479:posixwin_2escm",(void*)f_4479},
{"f_2599:posixwin_2escm",(void*)f_2599},
{"f_2597:posixwin_2escm",(void*)f_2597},
{"f_2476:posixwin_2escm",(void*)f_2476},
{"f_5265:posixwin_2escm",(void*)f_5265},
{"f_2474:posixwin_2escm",(void*)f_2474},
{"f_5269:posixwin_2escm",(void*)f_5269},
{"f_4473:posixwin_2escm",(void*)f_4473},
{"f_3285:posixwin_2escm",(void*)f_3285},
{"f_3287:posixwin_2escm",(void*)f_3287},
{"f_4231:posixwin_2escm",(void*)f_4231},
{"f_4246:posixwin_2escm",(void*)f_4246},
{"f_2357:posixwin_2escm",(void*)f_2357},
{"f_2359:posixwin_2escm",(void*)f_2359},
{"f_2571:posixwin_2escm",(void*)f_2571},
{"f_2351:posixwin_2escm",(void*)f_2351},
{"f_2353:posixwin_2escm",(void*)f_2353},
{"f_5421:posixwin_2escm",(void*)f_5421},
{"f_4496:posixwin_2escm",(void*)f_4496},
{"f_4237:posixwin_2escm",(void*)f_4237},
{"f_2256:posixwin_2escm",(void*)f_2256},
{"f_5401:posixwin_2escm",(void*)f_5401},
{"f_5405:posixwin_2escm",(void*)f_5405},
{"f_4202:posixwin_2escm",(void*)f_4202},
{"f_2249:posixwin_2escm",(void*)f_2249},
{"f_2245:posixwin_2escm",(void*)f_2245},
{"f_4270:posixwin_2escm",(void*)f_4270},
{"f_4275:posixwin_2escm",(void*)f_4275},
{"f_2233:posixwin_2escm",(void*)f_2233},
{"f_2230:posixwin_2escm",(void*)f_2230},
{"f_4289:posixwin_2escm",(void*)f_4289},
{"f_2227:posixwin_2escm",(void*)f_2227},
{"f_4222:posixwin_2escm",(void*)f_4222},
{"f_2224:posixwin_2escm",(void*)f_2224},
{"f_2221:posixwin_2escm",(void*)f_2221},
{"f_5432:posixwin_2escm",(void*)f_5432},
{"f_5434:posixwin_2escm",(void*)f_5434},
{"f_4213:posixwin_2escm",(void*)f_4213},
{"f_4226:posixwin_2escm",(void*)f_4226},
{"f_5439:posixwin_2escm",(void*)f_5439},
{"f_5448:posixwin_2escm",(void*)f_5448},
{"f_4241:posixwin_2escm",(void*)f_4241},
{"f_4217:posixwin_2escm",(void*)f_4217},
{"f_4429:posixwin_2escm",(void*)f_4429},
{"f_4541:posixwin_2escm",(void*)f_4541},
{"f_4543:posixwin_2escm",(void*)f_4543},
{"f_5237:posixwin_2escm",(void*)f_5237},
{"f_2718:posixwin_2escm",(void*)f_2718},
{"f_2714:posixwin_2escm",(void*)f_2714},
{"f_5248:posixwin_2escm",(void*)f_5248},
{"f_5242:posixwin_2escm",(void*)f_5242},
{"f_4413:posixwin_2escm",(void*)f_4413},
{"f_2708:posixwin_2escm",(void*)f_2708},
{"f_4304:posixwin_2escm",(void*)f_4304},
{"f_2347:posixwin_2escm",(void*)f_2347},
{"f_2345:posixwin_2escm",(void*)f_2345},
{"f_4309:posixwin_2escm",(void*)f_4309},
{"f_2341:posixwin_2escm",(void*)f_2341},
{"f_4441:posixwin_2escm",(void*)f_4441},
{"f_4443:posixwin_2escm",(void*)f_4443},
{"f_4300:posixwin_2escm",(void*)f_4300},
{"f_4912:posixwin_2escm",(void*)f_4912},
{"f_4569:posixwin_2escm",(void*)f_4569},
{"f_4437:posixwin_2escm",(void*)f_4437},
{"f_2339:posixwin_2escm",(void*)f_2339},
{"f_2335:posixwin_2escm",(void*)f_2335},
{"f_2333:posixwin_2escm",(void*)f_2333},
{"f_4555:posixwin_2escm",(void*)f_4555},
{"f_2768:posixwin_2escm",(void*)f_2768},
{"f_5225:posixwin_2escm",(void*)f_5225},
{"f_2763:posixwin_2escm",(void*)f_2763},
{"f_5221:posixwin_2escm",(void*)f_5221},
{NULL,NULL}};
#endif

static C_PTABLE_ENTRY *create_ptable(void){
#ifdef C_ENABLE_PTABLES
return ptable;
#else
return NULL;
#endif
}

/*
S|applied compiler syntax:
S|  for-each		3
o|eliminated procedure checks: 157 
o|specializations:
o|  1 (##sys#check-list (or pair list) *)
o|  4 (##sys#foreign-fixnum-argument fixnum)
o|  1 (##sys#check-output-port * * *)
o|  1 (##sys#check-input-port * * *)
o|  1 (negative? fixnum)
o|  4 (cdr pair)
o|  1 (string-ref string fixnum)
o|  3 (make-string fixnum)
o|  4 (##sys#check-open-port * *)
o|  9 (eqv? * (not float))
o|  11 (car pair)
o|dropping redundant toplevel assignment: process 
o|dropping redundant toplevel assignment: process* 
o|safe globals: (file-stat ##sys#stat ##sys#posix-error posix-error c1510) 
o|Removed `not' forms: 7 
o|contracted procedure: "(posix-common.scm:149) strerror64" 
o|inlining procedure: k2268 
o|inlining procedure: k2268 
o|inlining procedure: k2283 
o|inlining procedure: k2283 
o|inlining procedure: k2373 
o|inlining procedure: k2385 
o|inlining procedure: k2385 
o|inlining procedure: k2397 
o|inlining procedure: k2397 
o|inlining procedure: k2409 
o|inlining procedure: k2409 
o|inlining procedure: k2373 
o|inlining procedure: k2525 
o|contracted procedure: k2541 
o|inlining procedure: k2538 
o|inlining procedure: k2538 
o|substituted constant variable: a2551 
o|inlining procedure: k2525 
o|inlining procedure: k2558 
o|inlining procedure: k2558 
o|substituted constant variable: a2602 
o|inlining procedure: k2603 
o|inlining procedure: k2603 
o|contracted procedure: k2619 
o|inlining procedure: k2622 
o|inlining procedure: k2622 
o|inlining procedure: k2655 
o|inlining procedure: k2655 
o|inlining procedure: k2679 
o|inlining procedure: k2679 
o|substituted constant variable: a2700 
o|inlining procedure: k2719 
o|inlining procedure: k2719 
o|inlining procedure: k2743 
o|propagated global variable: r27446269 delete-file 
o|inlining procedure: k2743 
o|inlining procedure: k2735 
o|inlining procedure: k2770 
o|inlining procedure: k2770 
o|inlining procedure: k2735 
o|inlining procedure: k2830 
o|inlining procedure: k2830 
o|inlining procedure: k2845 
o|inlining procedure: k2845 
o|inlining procedure: k2882 
o|inlining procedure: k2882 
o|substituted constant variable: a2904 
o|substituted constant variable: a2909 
o|inlining procedure: k2946 
o|inlining procedure: k2946 
o|inlining procedure: k2980 
o|inlining procedure: k2980 
o|inlining procedure: k3033 
o|inlining procedure: k3033 
o|inlining procedure: k3041 
o|inlining procedure: k3041 
o|contracted procedure: "(posix-common.scm:460) find-files" 
o|inlining procedure: k3066 
o|inlining procedure: k3066 
o|inlining procedure: k3084 
o|inlining procedure: k3084 
o|inlining procedure: k3103 
o|inlining procedure: k3103 
o|inlining procedure: k3112 
o|inlining procedure: k3144 
o|inlining procedure: k3144 
o|inlining procedure: k3158 
o|inlining procedure: k3158 
o|inlining procedure: k3112 
o|inlining procedure: k3170 
o|inlining procedure: k3170 
o|inlining procedure: k3189 
o|inlining procedure: k3189 
o|inlining procedure: k3210 
o|inlining procedure: k3210 
o|contracted procedure: k3224 
o|inlining procedure: k3229 
o|inlining procedure: k3229 
o|inlining procedure: k3299 
o|inlining procedure: k3299 
o|inlining procedure: k3376 
o|inlining procedure: k3376 
o|contracted procedure: "(posix-common.scm:497) ctime485" 
o|inlining procedure: k3412 
o|inlining procedure: k3412 
o|inlining procedure: k3456 
o|contracted procedure: "(posix-common.scm:520) strftime512" 
o|inlining procedure: k3442 
o|inlining procedure: k3442 
o|inlining procedure: k3456 
o|contracted procedure: "(posix-common.scm:522) asctime511" 
o|inlining procedure: k3429 
o|inlining procedure: k3429 
o|inlining procedure: k3565 
o|inlining procedure: k3565 
o|inlining procedure: k3648 
o|inlining procedure: k3648 
o|inlining procedure: k3674 
o|inlining procedure: k3674 
o|inlining procedure: k3702 
o|inlining procedure: k3702 
o|inlining procedure: k3746 
o|inlining procedure: k3746 
o|inlining procedure: k3853 
o|inlining procedure: k3853 
o|inlining procedure: k3865 
o|inlining procedure: k3865 
o|inlining procedure: k3875 
o|inlining procedure: k3875 
o|inlining procedure: k3908 
o|contracted procedure: "(posixwin.scm:904) g744745" 
o|contracted procedure: "(posixwin.scm:896) g762763" 
o|inlining procedure: k3927 
o|inlining procedure: k3927 
o|contracted procedure: "(posixwin.scm:888) g765766" 
o|inlining procedure: k3935 
o|inlining procedure: k3935 
o|inlining procedure: k3968 
o|inlining procedure: k3968 
o|inlining procedure: k3908 
o|contracted procedure: "(posixwin.scm:905) g775776" 
o|inlining procedure: k3993 
o|inlining procedure: k3993 
o|inlining procedure: k4028 
o|inlining procedure: k4028 
o|inlining procedure: k4048 
o|inlining procedure: k4048 
o|inlining procedure: k4069 
o|inlining procedure: k4069 
o|inlining procedure: k4094 
o|inlining procedure: k4094 
o|inlining procedure: "(posixwin.scm:940) badmode788" 
o|substituted constant variable: a4118 
o|substituted constant variable: a4120 
o|inlining procedure: k4134 
o|inlining procedure: k4134 
o|inlining procedure: "(posixwin.scm:950) badmode788" 
o|substituted constant variable: a4158 
o|substituted constant variable: a4160 
o|substituted constant variable: a4165 
o|substituted constant variable: a4166 
o|inlining procedure: k4170 
o|inlining procedure: k4170 
o|substituted constant variable: a4183 
o|substituted constant variable: a4184 
o|inlining procedure: k4188 
o|inlining procedure: k4188 
o|inlining procedure: k4319 
o|inlining procedure: k4319 
o|inlining procedure: k4421 
o|inlining procedure: k4421 
o|inlining procedure: k4451 
o|inlining procedure: k4451 
o|inlining procedure: k4494 
o|contracted procedure: k4510 
o|inlining procedure: k4507 
o|inlining procedure: k4507 
o|substituted constant variable: a4520 
o|inlining procedure: k4494 
o|inlining procedure: k4530 
o|inlining procedure: k4530 
o|substituted constant variable: a4574 
o|contracted procedure: k4578 
o|inlining procedure: k4575 
o|inlining procedure: k4575 
o|inlining procedure: k4613 
o|inlining procedure: k4613 
o|inlining procedure: k4687 
o|inlining procedure: k4696 
o|inlining procedure: k4696 
o|inlining procedure: k4687 
o|contracted procedure: "(posixwin.scm:1214) get1040" 
o|contracted procedure: "(posixwin.scm:1236) ex01058" 
o|substituted constant variable: a4772 
o|contracted procedure: k4779 
o|inlining procedure: k4776 
o|inlining procedure: k4776 
o|inlining procedure: k4789 
o|inlining procedure: k4789 
o|substituted constant variable: a4805 
o|inlining procedure: k4815 
o|inlining procedure: k4815 
o|inlining procedure: k4825 
o|inlining procedure: k4825 
o|inlining procedure: k4838 
o|inlining procedure: k4838 
o|substituted constant variable: a4854 
o|substituted constant variable: a4856 
o|substituted constant variable: a4858 
o|inlining procedure: k4871 
o|inlining procedure: k4871 
o|inlining procedure: k4914 
o|inlining procedure: k4914 
o|inlining procedure: k4936 
o|inlining procedure: k4936 
o|contracted procedure: "(posixwin.scm:1307) needs-quoting?1093" 
o|inlining procedure: k4885 
o|inlining procedure: k4885 
o|inlining procedure: k4990 
o|inlining procedure: k5002 
o|inlining procedure: k5002 
o|inlining procedure: k4990 
o|inlining procedure: k5061 
o|inlining procedure: k5061 
o|inlining procedure: k5077 
o|inlining procedure: k5077 
o|inlining procedure: k5114 
o|inlining procedure: k5114 
o|inlining procedure: k5181 
o|inlining procedure: k5181 
o|inlining procedure: k5226 
o|inlining procedure: k5226 
o|inlining procedure: k5253 
o|inlining procedure: k5253 
o|substituted constant variable: g127212731280 
o|substituted constant variable: g127212731280 
o|substituted constant variable: g127212731280 
o|substituted constant variable: g127412751281 
o|substituted constant variable: g127412751281 
o|substituted constant variable: g127412751281 
o|substituted constant variable: g127612771282 
o|substituted constant variable: g127612771282 
o|substituted constant variable: g127612771282 
o|substituted constant variable: g127812791283 
o|substituted constant variable: g127812791283 
o|substituted constant variable: g127812791283 
o|inlining procedure: k5353 
o|inlining procedure: k5368 
o|inlining procedure: k5368 
o|inlining procedure: k5353 
o|contracted procedure: "(posixwin.scm:1406) c-process1220" 
o|inlining procedure: k5415 
o|inlining procedure: k5415 
o|inlining procedure: k5450 
o|inlining procedure: k5450 
o|inlining procedure: k5491 
o|inlining procedure: k5491 
o|inlining procedure: k5638 
o|inlining procedure: k5638 
o|inlining procedure: k5656 
o|inlining procedure: k5656 
o|inlining procedure: k5668 
o|inlining procedure: k5668 
o|inlining procedure: k5699 
o|inlining procedure: k5699 
o|contracted procedure: "(posixwin.scm:1636) bad-mmap?1420" 
o|inlining procedure: k5753 
o|inlining procedure: k5753 
o|contracted procedure: "(posixwin.scm:1635) mmap1419" 
o|contracted procedure: k5795 
o|inlining procedure: k5823 
o|inlining procedure: k5823 
o|contracted procedure: "(posixwin.scm:1645) munmap1457" 
o|inlining procedure: k6119 
o|inlining procedure: k6119 
o|inlining procedure: k6131 
o|inlining procedure: k6131 
o|inlining procedure: k6141 
o|inlining procedure: k6141 
o|inlining procedure: k6176 
o|inlining procedure: k6176 
o|inlining procedure: k6222 
o|inlining procedure: k6222 
o|contracted procedure: "(posix-common.scm:220) g116117" 
o|inlining procedure: k6209 
o|inlining procedure: k6209 
o|replaced variables: 611 
o|removed binding forms: 458 
o|substituted constant variable: r22696236 
o|substituted constant variable: r23866240 
o|substituted constant variable: r23986242 
o|substituted constant variable: r24106244 
o|substituted constant variable: r23746246 
o|inlining procedure: k2525 
o|substituted constant variable: r25396250 
o|inlining procedure: k2525 
o|inlining procedure: k2525 
o|propagated global variable: g2812826270 delete-file 
o|inlining procedure: k2743 
o|inlining procedure: k2743 
o|propagated global variable: r27446560 delete-file 
o|propagated global variable: r27446560 delete-file 
o|converted assignments to bindings: (rmdir263) 
o|substituted constant variable: r28466285 
o|substituted constant variable: r29476289 
o|substituted constant variable: r30346295 
o|substituted constant variable: r30346295 
o|substituted constant variable: r30426299 
o|substituted constant variable: r30426299 
o|substituted constant variable: r31596314 
o|substituted constant variable: r31596314 
o|substituted constant variable: r31596316 
o|substituted constant variable: r31596316 
o|substituted constant variable: r32116325 
o|substituted constant variable: r32116325 
o|substituted constant variable: r32116327 
o|substituted constant variable: r32116327 
o|substituted constant variable: loc379 
o|substituted constant variable: r34436341 
o|substituted constant variable: r34436341 
o|substituted constant variable: r34306348 
o|substituted constant variable: r34306348 
o|substituted constant variable: r38666376 
o|substituted constant variable: r40496396 
o|removed side-effect free assignment to unused variable: badmode788 
o|inlining procedure: k4094 
o|inlining procedure: k4134 
o|inlining procedure: k4494 
o|substituted constant variable: r45086444 
o|inlining procedure: k4494 
o|inlining procedure: k4494 
o|inlining procedure: k4581 
o|substituted constant variable: r46886458 
o|substituted constant variable: r47776459 
o|substituted constant variable: r48266467 
o|substituted constant variable: r48266467 
o|folded constant expression: (fx< (quote -1) (quote 0)) 
o|substituted constant variable: r48866479 
o|substituted constant variable: r50626487 
o|substituted constant variable: r50626487 
o|substituted constant variable: r53696506 
o|substituted constant variable: r53696506 
o|substituted constant variable: c-pointer12231240 
o|substituted constant variable: c-pointer12231240 
o|substituted constant variable: c-pointer12231240 
o|substituted constant variable: r54166509 
o|substituted constant variable: r54166509 
o|substituted constant variable: r54166511 
o|substituted constant variable: r54166511 
o|inlining procedure: k5773 
o|substituted constant variable: r57546527 
o|substituted constant variable: r57546527 
o|converted assignments to bindings: (check967) 
o|substituted constant variable: r61326536 
o|substituted constant variable: r62106547 
o|substituted constant variable: r62106547 
o|simplifications: ((let . 2)) 
o|replaced variables: 42 
o|removed binding forms: 636 
o|removed conditional forms: 1 
o|inlining procedure: k2885 
o|inlining procedure: k3516 
o|inlining procedure: k3516 
o|inlining procedure: k3717 
o|inlining procedure: k3717 
o|inlining procedure: k3765 
o|inlining procedure: k3765 
o|contracted procedure: k5286 
o|inlining procedure: k5533 
o|inlining procedure: k5593 
o|inlining procedure: k5785 
o|inlining procedure: k5785 
o|replaced variables: 19 
o|removed binding forms: 114 
o|substituted constant variable: r25266549 
o|substituted constant variable: r25266551 
o|substituted constant variable: r25266553 
o|substituted constant variable: r28866631 
o|substituted constant variable: r28866631 
o|substituted constant variable: r35176642 
o|substituted constant variable: r37186645 
o|substituted constant variable: r37666647 
o|substituted constant variable: r44956592 
o|substituted constant variable: r44956594 
o|substituted constant variable: r44956596 
o|substituted constant variable: r5287 
o|substituted constant variable: r57866665 
o|inlining procedure: k6173 
o|inlining procedure: k6173 
o|simplifications: ((let . 3)) 
o|replaced variables: 2 
o|removed binding forms: 19 
o|removed conditional forms: 4 
o|inlining procedure: k4761 
o|inlining procedure: k4761 
o|substituted constant variable: a5285 
o|substituted constant variable: r61746693 
o|replaced variables: 1 
o|removed binding forms: 15 
o|substituted constant variable: r47626717 
o|removed binding forms: 4 
o|removed binding forms: 1 
o|simplifications: ((if . 57) (##core#call . 382)) 
o|  call simplifications:
o|    bitwise-ior
o|    <
o|    ##sys#structure?
o|    ##sys#check-structure	2
o|    ##sys#make-structure	2
o|    +	2
o|    ##sys#foreign-pointer-argument	7
o|    ##sys#foreign-string-argument	5
o|    char-whitespace?
o|    char=?
o|    fxior	2
o|    string-length	2
o|    list	5
o|    values	11
o|    ##sys#fudge
o|    vector-set!	2
o|    ##sys#foreign-block-argument	2
o|    ##sys#foreign-integer-argument	4
o|    fx-	3
o|    ##sys#check-number	4
o|    ##sys#check-vector
o|    ##sys#size	7
o|    procedure?
o|    member
o|    fx+	6
o|    ##sys#call-with-values	7
o|    string-ref	2
o|    fx>
o|    not	4
o|    cons	8
o|    ##sys#check-string	21
o|    ##sys#check-list	4
o|    fx=	8
o|    zero?	2
o|    ##sys#slot	18
o|    ##sys#check-exact	25
o|    ##sys#null-pointer?	5
o|    pair?	15
o|    eq?	31
o|    cdr	20
o|    ##sys#eqv?	7
o|    null?	54
o|    car	36
o|    vector
o|    fixnum?	4
o|    string?
o|    fx<	12
o|    ##sys#foreign-fixnum-argument	12
o|    apply	9
o|contracted procedure: k2242 
o|contracted procedure: k2271 
o|contracted procedure: k2280 
o|contracted procedure: k2286 
o|contracted procedure: k2318 
o|contracted procedure: k2309 
o|contracted procedure: k2439 
o|contracted procedure: k2361 
o|contracted procedure: k2433 
o|contracted procedure: k2364 
o|contracted procedure: k2427 
o|contracted procedure: k2367 
o|contracted procedure: k2421 
o|contracted procedure: k2370 
o|contracted procedure: k2382 
o|contracted procedure: k2388 
o|contracted procedure: k2394 
o|contracted procedure: k2400 
o|contracted procedure: k2406 
o|contracted procedure: k2412 
o|contracted procedure: k2418 
o|contracted procedure: k2528 
o|contracted procedure: k2535 
o|contracted procedure: k2561 
o|contracted procedure: k2573 
o|contracted procedure: k2587 
o|contracted procedure: k2643 
o|contracted procedure: k2606 
o|contracted procedure: k2635 
o|contracted procedure: k2625 
o|contracted procedure: k2649 
o|contracted procedure: k2658 
o|contracted procedure: k2664 
o|contracted procedure: k2667 
o|contracted procedure: k2670 
o|contracted procedure: k2701 
o|contracted procedure: k2676 
o|contracted procedure: k2793 
o|contracted procedure: k2710 
o|contracted procedure: k2722 
o|contracted procedure: k2729 
o|contracted procedure: k2758 
o|contracted procedure: k2773 
o|contracted procedure: k2783 
o|contracted procedure: k2787 
o|contracted procedure: k2922 
o|contracted procedure: k2805 
o|contracted procedure: k2916 
o|contracted procedure: k2808 
o|contracted procedure: k2910 
o|contracted procedure: k2811 
o|contracted procedure: k2814 
o|contracted procedure: k2833 
o|contracted procedure: k2848 
o|contracted procedure: k2854 
o|contracted procedure: k2900 
o|contracted procedure: k2857 
o|contracted procedure: k2876 
o|contracted procedure: k2879 
o|contracted procedure: k2894 
o|contracted procedure: k2885 
o|contracted procedure: k2928 
o|contracted procedure: k2949 
o|contracted procedure: k2952 
o|contracted procedure: k2983 
o|contracted procedure: k2990 
o|contracted procedure: k3013 
o|contracted procedure: k3029 
o|contracted procedure: k3047 
o|contracted procedure: k3069 
o|contracted procedure: k3072 
o|contracted procedure: k3075 
o|contracted procedure: k3087 
o|contracted procedure: k3096 
o|contracted procedure: k3122 
o|contracted procedure: k3213 
o|contracted procedure: k3232 
o|contracted procedure: k3296 
o|contracted procedure: k3309 
o|contracted procedure: k3302 
o|contracted procedure: k3318 
o|contracted procedure: k3324 
o|contracted procedure: k3339 
o|contracted procedure: k3345 
o|contracted procedure: k3370 
o|contracted procedure: k3387 
o|contracted procedure: k3383 
o|contracted procedure: k3362 
o|contracted procedure: k3393 
o|contracted procedure: k3503 
o|contracted procedure: k3450 
o|contracted procedure: k3459 
o|contracted procedure: k3442 
o|contracted procedure: k3493 
o|contracted procedure: k3489 
o|contracted procedure: k3429 
o|contracted procedure: k3512 
o|contracted procedure: k3595 
o|contracted procedure: k3535 
o|contracted procedure: k3589 
o|contracted procedure: k3538 
o|contracted procedure: k3583 
o|contracted procedure: k3541 
o|contracted procedure: k3577 
o|contracted procedure: k3544 
o|contracted procedure: k3547 
o|contracted procedure: k3550 
o|contracted procedure: k3568 
o|contracted procedure: k6151 
o|contracted procedure: k3627 
o|contracted procedure: k3635 
o|contracted procedure: k3638 
o|contracted procedure: k3641 
o|contracted procedure: k3651 
o|contracted procedure: k3664 
o|contracted procedure: k3671 
o|contracted procedure: k3677 
o|contracted procedure: k3690 
o|contracted procedure: k3693 
o|contracted procedure: k3708 
o|contracted procedure: k3723 
o|contracted procedure: k3734 
o|contracted procedure: k3743 
o|contracted procedure: k3749 
o|contracted procedure: k3758 
o|contracted procedure: k3774 
o|contracted procedure: k3780 
o|contracted procedure: k3794 
o|contracted procedure: k3797 
o|contracted procedure: k3812 
o|contracted procedure: k3819 
o|contracted procedure: k3844 
o|contracted procedure: k3847 
o|contracted procedure: k3872 
o|contracted procedure: k3868 
o|contracted procedure: k3878 
o|contracted procedure: k3888 
o|contracted procedure: k4013 
o|contracted procedure: k3899 
o|contracted procedure: k3902 
o|contracted procedure: k3916 
o|contracted procedure: k3938 
o|contracted procedure: k3959 
o|contracted procedure: k3971 
o|contracted procedure: k3981 
o|contracted procedure: k3985 
o|contracted procedure: k3996 
o|contracted procedure: k4022 
o|contracted procedure: k4031 
o|contracted procedure: k4051 
o|contracted procedure: k4072 
o|contracted procedure: k4084 
o|contracted procedure: k4097 
o|contracted procedure: k4107 
o|contracted procedure: k4124 
o|contracted procedure: k4137 
o|contracted procedure: k4147 
o|contracted procedure: k4173 
o|contracted procedure: k4191 
o|contracted procedure: k4335 
o|contracted procedure: k4316 
o|contracted procedure: k4325 
o|contracted procedure: k4371 
o|contracted procedure: k4415 
o|contracted procedure: k4418 
o|contracted procedure: k4424 
o|contracted procedure: k4445 
o|contracted procedure: k4448 
o|contracted procedure: k4497 
o|contracted procedure: k4504 
o|contracted procedure: k4533 
o|contracted procedure: k4545 
o|contracted procedure: k4559 
o|contracted procedure: k4597 
o|contracted procedure: k4584 
o|contracted procedure: k4607 
o|contracted procedure: k4616 
o|contracted procedure: k4625 
o|contracted procedure: k4628 
o|contracted procedure: k4631 
o|contracted procedure: k4637 
o|contracted procedure: k4640 
o|contracted procedure: k4654 
o|contracted procedure: k4699 
o|contracted procedure: k4706 
o|contracted procedure: k4714 
o|contracted procedure: k4726 
o|contracted procedure: k4730 
o|contracted procedure: k4737 
o|contracted procedure: k4673 
o|contracted procedure: k4764 
o|contracted procedure: k47526716 
o|contracted procedure: k47526721 
o|contracted procedure: k4783 
o|contracted procedure: k4812 
o|contracted procedure: k4832 
o|contracted procedure: k4828 
o|contracted procedure: k4835 
o|contracted procedure: k4841 
o|contracted procedure: k4847 
o|contracted procedure: k4859 
o|contracted procedure: k4917 
o|contracted procedure: k4923 
o|inlining procedure: k4932 
o|inlining procedure: k4932 
o|contracted procedure: k4876 
o|contracted procedure: k4888 
o|contracted procedure: k4905 
o|contracted procedure: k4894 
o|contracted procedure: k4901 
o|contracted procedure: k4949 
o|contracted procedure: k4957 
o|contracted procedure: k4964 
o|contracted procedure: k4970 
o|contracted procedure: k4978 
o|contracted procedure: k4985 
o|contracted procedure: k4993 
o|contracted procedure: k5005 
o|contracted procedure: k5011 
o|contracted procedure: k5014 
o|contracted procedure: k5026 
o|contracted procedure: k5030 
o|contracted procedure: k5038 
o|contracted procedure: k5068 
o|contracted procedure: k5080 
o|contracted procedure: k5147 
o|contracted procedure: k5089 
o|contracted procedure: k5141 
o|contracted procedure: k5092 
o|contracted procedure: k5135 
o|contracted procedure: k5095 
o|contracted procedure: k5129 
o|contracted procedure: k5098 
o|contracted procedure: k5123 
o|contracted procedure: k5101 
o|contracted procedure: k5117 
o|contracted procedure: k5104 
o|contracted procedure: k5214 
o|contracted procedure: k5156 
o|contracted procedure: k5208 
o|contracted procedure: k5159 
o|contracted procedure: k5202 
o|contracted procedure: k5162 
o|contracted procedure: k5196 
o|contracted procedure: k5165 
o|contracted procedure: k5190 
o|contracted procedure: k5168 
o|contracted procedure: k5184 
o|contracted procedure: k5171 
o|contracted procedure: k5270 
o|contracted procedure: k5426 
o|contracted procedure: k5340 
o|contracted procedure: k5290 
o|contracted procedure: k5294 
o|contracted procedure: k5298 
o|contracted procedure: k5302 
o|contracted procedure: k5306 
o|contracted procedure: k5328 
o|contracted procedure: k5335 
o|contracted procedure: k5407 
o|contracted procedure: k5411 
o|contracted procedure: k5423 
o|contracted procedure: k5436 
o|contracted procedure: k5453 
o|contracted procedure: k5463 
o|contracted procedure: k5467 
o|contracted procedure: k5470 
o|contracted procedure: k5569 
o|contracted procedure: k5518 
o|contracted procedure: k5563 
o|contracted procedure: k5521 
o|contracted procedure: k5557 
o|contracted procedure: k5524 
o|contracted procedure: k5551 
o|contracted procedure: k5527 
o|contracted procedure: k5545 
o|contracted procedure: k5530 
o|contracted procedure: k5539 
o|contracted procedure: k5533 
o|contracted procedure: k5629 
o|contracted procedure: k5578 
o|contracted procedure: k5623 
o|contracted procedure: k5581 
o|contracted procedure: k5617 
o|contracted procedure: k5584 
o|contracted procedure: k5611 
o|contracted procedure: k5587 
o|contracted procedure: k5605 
o|contracted procedure: k5590 
o|contracted procedure: k5599 
o|contracted procedure: k5593 
o|contracted procedure: k5650 
o|contracted procedure: k5753 
o|contracted procedure: k5724 
o|contracted procedure: k5728 
o|contracted procedure: k5732 
o|contracted procedure: k5736 
o|contracted procedure: k5740 
o|contracted procedure: k5744 
o|contracted procedure: k5791 
o|contracted procedure: k5817 
o|contracted procedure: k5826 
o|contracted procedure: k5837 
o|contracted procedure: k5805 
o|contracted procedure: k5809 
o|contracted procedure: k5840 
o|contracted procedure: k5850 
o|contracted procedure: k6122 
o|contracted procedure: k6138 
o|contracted procedure: k6134 
o|contracted procedure: k6144 
o|contracted procedure: k6157 
o|contracted procedure: k6182 
o|contracted procedure: k6166 
o|contracted procedure: k6169 
o|contracted procedure: k6191 
o|contracted procedure: k6203 
o|contracted procedure: k6225 
o|contracted procedure: k6216 
o|simplifications: ((if . 1) (let . 60)) 
o|removed binding forms: 317 
o|inlining procedure: k3315 
o|inlining procedure: k3336 
o|inlining procedure: "(posixwin.scm:934) mode787" 
o|inlining procedure: "(posixwin.scm:944) mode787" 
o|inlining procedure: k4953 
o|inlining procedure: k4974 
o|inlining procedure: "(posixwin.scm:842) stat-type702" 
o|inlining procedure: "(posixwin.scm:841) stat-type702" 
o|inlining procedure: "(posixwin.scm:840) stat-type702" 
o|inlining procedure: "(posixwin.scm:839) stat-type702" 
o|replaced variables: 190 
o|removed binding forms: 1 
o|removed side-effect free assignment to unused variable: mode787 
o|substituted constant variable: r49546885 
o|substituted constant variable: r49546885 
o|substituted constant variable: r49756888 
o|substituted constant variable: r49756888 
o|substituted constant variable: name7036896 
o|substituted constant variable: name7036902 
o|substituted constant variable: name7036908 
o|substituted constant variable: name7036914 
o|replaced variables: 14 
o|removed binding forms: 91 
o|contracted procedure: k5770 
o|contracted procedure: k5833 
o|converted assignments to bindings: (check789) 
o|simplifications: ((let . 1)) 
o|removed binding forms: 22 
o|contracted procedure: k3823 
o|contracted procedure: k3827 
o|contracted procedure: k3831 
o|contracted procedure: k3835 
o|contracted procedure: k4087 
o|contracted procedure: k4127 
o|replaced variables: 2 
o|removed binding forms: 6 
o|removed binding forms: 1 
o|direct leaf routine/allocation: loop1096 0 
o|direct leaf routine/allocation: g13271334 0 
o|contracted procedure: k4939 
o|converted assignments to bindings: (loop1096) 
o|contracted procedure: "(posixwin.scm:1428) k5456" 
o|simplifications: ((let . 1)) 
o|removed binding forms: 2 
o|replaced variables: 3 
o|removed binding forms: 1 
o|direct leaf routine/allocation: for-each-loop13261344 0 
o|converted assignments to bindings: (for-each-loop13261344) 
o|simplifications: ((let . 1)) 
o|customizable procedures: (k5820 k5764 k5779 %process1315 chkstrlst1322 k5250 $exec-setup $exec-teardown $quote-args-list build-exec-argvec1111 doloop11361137 loop1103 k4806 k4818 scan1049 loop1046 k4610 mode983 check984 check967 check789 g752759 for-each-loop751770 k3841 k3740 k3632 check-time-vector k3050 k3053 loop391 g363364 loop355 conc-loop336 k2863 loop315 g271278 for-each-loop270287 rmdir263 k2652 mode183 check184 ##sys#stat) 
o|calls to known targets: 153 
o|unused rest argument: _387 f_3235 
o|unused rest argument: _386 f_3227 
o|unused rest argument: _426 f_3287 
o|identified direct recursive calls: f_4694 1 
o|identified direct recursive calls: f_4883 1 
o|identified direct recursive calls: f_4912 1 
o|identified direct recursive calls: f_5448 1 
o|unused rest argument: _15051509 f_5863 
o|unused rest argument: _15121516 f_5869 
o|unused rest argument: _15181522 f_5875 
o|unused rest argument: _15241528 f_5881 
o|unused rest argument: _15301534 f_5887 
o|unused rest argument: _15361540 f_5893 
o|unused rest argument: _15421546 f_5899 
o|unused rest argument: _15481552 f_5905 
o|unused rest argument: _15541558 f_5911 
o|unused rest argument: _15601564 f_5917 
o|unused rest argument: _15661570 f_5923 
o|unused rest argument: _15721576 f_5929 
o|unused rest argument: _15781582 f_5935 
o|unused rest argument: _15841588 f_5941 
o|unused rest argument: _15901594 f_5947 
o|unused rest argument: _15961600 f_5953 
o|unused rest argument: _16021606 f_5959 
o|unused rest argument: _16081612 f_5965 
o|unused rest argument: _16141618 f_5971 
o|unused rest argument: _16201624 f_5977 
o|unused rest argument: _16261630 f_5983 
o|unused rest argument: _16321636 f_5989 
o|unused rest argument: _16381642 f_5995 
o|unused rest argument: _16441648 f_6001 
o|unused rest argument: _16501654 f_6007 
o|unused rest argument: _16561660 f_6013 
o|unused rest argument: _16621666 f_6019 
o|unused rest argument: _16681672 f_6025 
o|unused rest argument: _16741678 f_6031 
o|unused rest argument: _16801684 f_6037 
o|unused rest argument: _16861690 f_6043 
o|unused rest argument: _16921696 f_6049 
o|unused rest argument: _16981702 f_6055 
o|unused rest argument: _17041708 f_6061 
o|unused rest argument: _17101714 f_6067 
o|unused rest argument: _17161720 f_6073 
o|unused rest argument: _17221726 f_6079 
o|unused rest argument: _17281732 f_6085 
o|unused rest argument: _17341738 f_6091 
o|unused rest argument: _17401744 f_6097 
o|fast box initializations: 14 
o|fast global references: 72 
o|fast global assignments: 7 
o|dropping unused closure argument: f_4525 
o|dropping unused closure argument: f_4988 
o|dropping unused closure argument: f_4064 
o|dropping unused closure argument: f_5072 
o|dropping unused closure argument: f_4869 
o|dropping unused closure argument: f_2519 
o|dropping unused closure argument: f_2263 
o|dropping unused closure argument: f_3294 
o|dropping unused closure argument: f_2556 
o|dropping unused closure argument: f_4488 
o|dropping unused closure argument: f_5432 
o|dropping unused closure argument: f_2714 
o|dropping unused closure argument: f_4443 
*/
/* end of file */
